Object.assign(window.search, {"doc_urls":["intro.html#introduction","intro.html#what-it-is","intro.html#what-it-is-not-yet","intro.html#what-it-will-never-be","getting_started/main.html#getting-started","getting_started/docker.html#docker","getting_started/docker.html#testing--local-evaluation","getting_started/docker.html#production-setup","getting_started/k8s.html#kubernetes","getting_started/k8s.html#single-instance","getting_started/k8s.html#create-namespace","getting_started/k8s.html#create-and-apply-the-config","getting_started/k8s.html#create-and-apply-secrets","getting_started/k8s.html#create-and-apply-the-stateful-set","getting_started/k8s.html#ingress","getting_started/k8s.html#deploy","getting_started/k8s.html#production-setup","getting_started/k8s.html#config","getting_started/first_start.html#first-start","getting_started/first_start.html#initial-admin-password-and-login","getting_started/first_start.html#logs-with-docker","getting_started/first_start.html#logs-with-kubernetes","getting_started/first_start.html#custom-rauthy-admin-user","getting_started/first_start.html#rauthy_admin-user-role","config/argon2.html#argon-2-setup","config/fido.html#fido-2--webauthn","config/fido.html#rp_id","config/fido.html#rp_origin","config/fido.html#rp_name","config/fido.html#webauthn_renew_exp","config/encryption.html#encryption","config/encryption.html#key-rotation","config/db_migration.html#database-migrations","config/backup.html#backups","config/backup.html#sqlite","config/backup.html#postgres","config/ha.html#high-availability","config/ha.html#configuration","config/ha.html#ha_mode","config/ha.html#ha_hosts","config/ha.html#cache_auth_token","config/ha.html#tls","config/tls.html#tls","config/tls.html#generate-certificates","config/tls.html#config","config/tls.html#cache","config/tls.html#server","config/tls.html#kubernetes","config/config.html#reference-config"],"index":{"documentStore":{"docInfo":{"0":{"body":23,"breadcrumbs":2,"title":1},"1":{"body":315,"breadcrumbs":1,"title":0},"10":{"body":16,"breadcrumbs":5,"title":2},"11":{"body":76,"breadcrumbs":6,"title":3},"12":{"body":170,"breadcrumbs":6,"title":3},"13":{"body":423,"breadcrumbs":7,"title":4},"14":{"body":55,"breadcrumbs":4,"title":1},"15":{"body":18,"breadcrumbs":4,"title":1},"16":{"body":0,"breadcrumbs":5,"title":2},"17":{"body":142,"breadcrumbs":4,"title":1},"18":{"body":0,"breadcrumbs":6,"title":2},"19":{"body":46,"breadcrumbs":8,"title":4},"2":{"body":145,"breadcrumbs":1,"title":0},"20":{"body":4,"breadcrumbs":6,"title":2},"21":{"body":68,"breadcrumbs":6,"title":2},"22":{"body":52,"breadcrumbs":8,"title":4},"23":{"body":54,"breadcrumbs":7,"title":3},"24":{"body":190,"breadcrumbs":5,"title":3},"25":{"body":20,"breadcrumbs":5,"title":3},"26":{"body":31,"breadcrumbs":3,"title":1},"27":{"body":31,"breadcrumbs":3,"title":1},"28":{"body":31,"breadcrumbs":3,"title":1},"29":{"body":118,"breadcrumbs":3,"title":1},"3":{"body":62,"breadcrumbs":2,"title":1},"30":{"body":46,"breadcrumbs":2,"title":1},"31":{"body":229,"breadcrumbs":3,"title":2},"32":{"body":125,"breadcrumbs":4,"title":2},"33":{"body":0,"breadcrumbs":2,"title":1},"34":{"body":102,"breadcrumbs":2,"title":1},"35":{"body":13,"breadcrumbs":2,"title":1},"36":{"body":161,"breadcrumbs":4,"title":2},"37":{"body":18,"breadcrumbs":3,"title":1},"38":{"body":5,"breadcrumbs":3,"title":1},"39":{"body":176,"breadcrumbs":3,"title":1},"4":{"body":7,"breadcrumbs":4,"title":2},"40":{"body":24,"breadcrumbs":3,"title":1},"41":{"body":37,"breadcrumbs":3,"title":1},"42":{"body":8,"breadcrumbs":2,"title":1},"43":{"body":209,"breadcrumbs":3,"title":2},"44":{"body":7,"breadcrumbs":2,"title":1},"45":{"body":147,"breadcrumbs":2,"title":1},"46":{"body":38,"breadcrumbs":2,"title":1},"47":{"body":153,"breadcrumbs":2,"title":1},"48":{"body":1151,"breadcrumbs":4,"title":2},"5":{"body":0,"breadcrumbs":4,"title":1},"6":{"body":108,"breadcrumbs":6,"title":3},"7":{"body":264,"breadcrumbs":5,"title":2},"8":{"body":18,"breadcrumbs":4,"title":1},"9":{"body":37,"breadcrumbs":5,"title":2}},"docs":{"0":{"body":"Caution There has not been any third party security audit for this project. Use this software at your own risk! Info This project is currently pre v1.0, which means, even though it is not expected, breaking changes might come with new versions.","breadcrumbs":"Introduction » Introduction","id":"0","title":"Introduction"},"1":{"body":"Rauthy is an OpenID Connect (OIDC) Provider and Single Sign-On solution written in Rust. Secure by default It tries to be as secure as possible by default while still providing all the options needed to be compatible with older systems. For instance, if you create a new OIDC client, it activates ed25519 as the default algorithm for token signing and S256 PKCE flow. This will not work with old clients, which do not support it, but you can of course deactivate this to your liking. MFA and Passwordless Login Rauthy provides FIDO 2 / Webauthn login flows. If you once logged in on a new client with your username + password, you will get an encrypted cookie which will allow you to log in without a password from that moment on. You only need to have a FIDO compliant Passkey being registered for your account. The reason why it requests your password on a new host at least once is pretty simple. Even though most browsers have full support even for user verification, it is possible that in some scenarios a set PIN oder biometric fingerprint reader will just be ignored by some browsers, which would reduce the strong MFA login to only a single factor again. As long as the full support does not exist on every device out there, Rauthy will not allow a \"Passkey only Login flow\" for security reasons. An Example for a not correctly working combination would be Firefox on Mac OS, Firefox pre v114 on Linux, or almost every browser on Android. Fast and efficient The main goal was to provide an SSO solution like Keycloak and others while using a way lower footprint and being more efficient with resources. For instance, Rauthy can easily run a fully blown SSO provider on just a Raspberry Pi. It makes extensive use of caching to be as fast as possible in cases where your database is further away or just a bit slower, because it is maybe running on an SBC from an SD card. Most things are even cached for several hours (config options will come in the future) and special care has been taken into account in case of cache eviction and invalidation. For achieving this speed and efficiency, some additional design tradeoffs werde made. For instance, some things you configure statically via config file and not dynamically via UI, while most of them are configured once and then never touched again. Highly Available Even though it makes extensive use of caching, you can run it in HA mode. It uses its own embedded distributed HA cache called redhac , which cares about cache eviction on remote hosts. You can choose between a SQLite for single instance deployments and a Postgres , if you need HA. MySQL support might come in the future. Client Branding You have a simple way to create some kind of branding or stylized look for the Login page for each client. The whole color theme can be changed and each client can have its own custom logo. Additionally, if you modify the branding for the default rauthy client, it will not only change the look for the Login page, but also for the Account and Admin page. Already in production Rauthy is already being used in production, and it works with all typical OIDC clients (so far). It was just not an open source project for quite some time. Keycloak was a rough inspiration in certain places and if something is working with Keycloak, it does with rauthy too (again, so far).","breadcrumbs":"Introduction » What it is","id":"1","title":"What it is"},"10":{"body":"For the purpose of this documentation, we assume that rauthy will be deployed in the rauthy namespace. If this is not the case for you, change the following commands accordingly. kubectl create ns rauthy","breadcrumbs":"Getting Started » Kubernetes » Create Namespace","id":"10","title":"Create Namespace"},"11":{"body":"This documentation will manage the Kubernetes files in a folder called rauthy. mkdir rauthy && cd rauthy Create the config file, paste the reference config and adjust it to your needs. There is no \"nice 1-liner\" available yet. echo 'apiVersion: v1\nkind: ConfigMap\nmetadata: name: rauthy-config namespace: rauthy\ndata: rauthy.cfg: |+ PASTE CONFIG HERE - WATCH THE INDENTATION' > config.yaml Open the config with your favorite editor and paste the reference config in place. Make sure to watch the indentation. Caution Do not include sensitive information like for instance the ENC_KEYS inside the normal Config. Use the secrets from the next step for this. If you use SQLite, you can include the DATABASE_URL in the config, since it does not contain a password, but never do this for Postgres!","breadcrumbs":"Getting Started » Kubernetes » Create and apply the config","id":"11","title":"Create and apply the config"},"12":{"body":"touch secrets.yaml Paste the following content into the secrets.yaml file: apiVersion: v1\nkind: Secret\nmetadata: name: rauthy-secrets namespace: rauthy\ntype: Opaque\ndata: # The CACHE_AUTH_TOKEN is only needed for a deployment with HA_MODE == true # Secret token, which is used to authenticate the cache members #CACHE_AUTH_TOKEN: # The database driver will be chosen at runtime depending on the given DATABASE_URL format. Examples: # Sqlite: 'sqlite:data/rauthy.db' or 'sqlite::memory:' # Postgres: 'postgresql://User:PasswordWithoutSpecialCharacters@localhost:5432/DatabaseName' DATABASE_URL: # Format: \"key_id/enc_key another_key_id/another_enc_key\" - the enc_key itself must be exactly 32 characters long and # and should not contain special characters. # The ID must match '[a-zA-Z0-9]{2,20}' ENC_KEYS: # Needed for sending E-Mails for password resets and so on SMTP_PASSWORD: The secrets need to be base64 encoded. If you are on Linux, you can do this in the shell easily. If not, use any tool you like. Make sure that things like CACHE_AUTH_TOKEN (only needed with HA_MODE == true) and ENC_KEYS are generated in a secure random way. The DATABASE_URL with SQLite, like used in this example, does not contain sensitive information, but we will create it as a secret anyway to have an easier optional migration to postgres later on. echo 'sqlite:data/rauthy.db' | base64 Generate a new encryption key with ID in the correct format. echo \"$(cat /dev/urandom | tr -dc 'a-zA-Z0-9' | head -c8)/$(cat /dev/urandom | tr -dc 'a-zA-Z0-9' | head -c32)\" | base64 Paste the base64 String in the secrets for ENC_KEYS. To extract the ENC_KEY_ID, which needs to be added to the config from Step 2: echo PasteTheGeneratedBase64Here | base64 -d | cut -d/ -f1 And finally, the SMTP_PASSWORD echo 'PasteYourSMTPPasswordHere' | base64 Paste all the generated secrets into the secrets.yaml file and the ENC_KEY_ID into the config.yaml from the step before.","breadcrumbs":"Getting Started » Kubernetes » Create and apply secrets","id":"12","title":"Create and apply secrets"},"13":{"body":"touch sts.yaml Paste the following content into the sts.yaml file: apiVersion: v1\nkind: Service\nmetadata: name: rauthy namespace: rauthy\nspec: selector: app: rauthy ports: # If you use the HA feature later on, the port over which the cache layer does # communicate. - name: cache port: 8000 targetPort: 8000 # Assuming that this example file will run behind a Kubernetes ingress and does # use HTTP internally. - name: http port: 8080 targetPort: 8080 # Uncomment, if you change to direct HTTPS without a reverse proxy #- name: https # port: 8443 # targetPort: 8443\n---\napiVersion: apps/v1\nkind: StatefulSet\nmetadata: name: rauthy namespace: rauthy labels: app: rauthy\nspec: serviceName: rauthy # Do not just scale up replicas without a proper HA Setup replicas: 1 selector: matchLabels: app: rauthy template: metadata: labels: app: rauthy spec: securityContext: fsGroup: 10001 containers: - name: rauthy # This example uses the version tag. # In production, I would highly recommend to actually use SHA # hashes to prevent someone from overwriting the image tag on your possibly # own container registry with malicious content. # # Take a look at https://hub.docker.com/r/sdobedev/rauthy to see all tags # and if you go into the details for # a tag, you find the SHA hash like in # this example: # https://hub.docker.com/layers/sdobedev/rauthy/0.12.0/images/sha256-4d0a3977f4fda68e848b45899d3b8a1b63c09c80dca0cc737be7338876194c40?context=explore # directly under the image name on the top -> DIGEST: sha256:.... # Then adopt the image name to something like: # sdobedev/rauthy@sha256:4d0a3977f4fda68e848b45899d3b8a1b63c09c80dca0cc737be7338876194c40 # # Because of a chicken and egg problem, I cannot document the correct sha # hash for the latest version at this # point. The latest image with the correct hash will always be shown for the # [Github Releases](https://github.com/sebadob/rauthy/releases) image: sdobedev/rauthy:0.13.1 imagePullPolicy: IfNotPresent securityContext: # User ID 10001 is actually built into the container at the creation for # better security runAsUser: 10001 runAsGroup: 10001 allowPrivilegeEscalation: false ports: - containerPort: 8000 # You may need to adjust this, if you decide to start in https only mode # or use another port - containerPort: 8080 - containerPort: 8443 env: - name: DATABASE_URL valueFrom: secretKeyRef: name: rauthy-secrets key: DATABASE_URL - name: ENC_KEYS valueFrom: secretKeyRef: name: rauthy-secrets key: ENC_KEYS - name: SMTP_PASSWORD valueFrom: secretKeyRef: name: rauthy-secrets key: SMTP_PASSWORD volumeMounts: - mountPath: /app/data name: rauthy-data readOnly: false - mountPath: /app/rauthy.cfg subPath: rauthy.cfg name: rauthy-config readOnly: true readinessProbe: httpGet: # You may need to adjust this, if you decide to start in https only # mode or use another port scheme: HTTP port: 8080 #scheme: HTTPS #port: 8443 path: /auth/v1/ping initialDelaySeconds: 1 periodSeconds: 10 livenessProbe: httpGet: # You may need to adjust this, if you decide to start in https only # mode or use another port scheme: HTTP port: 8080 #scheme: HTTPS #port: 8443 path: /auth/v1/health initialDelaySeconds: 1 periodSeconds: 30 resources: requests: # Tune the memory requests value carefully. Make sure, that the # pods request at least: # `ARGON2_M_COST` / 1024 * `MAX_HASH_THREADS` Mi # With SQLite: for small deployments, add additional ~20-30Mi for # \"the rest\", for larger ones ~50-70 Mi should be enough. memory: 64Mi # The CPU needs to be adjusted during runtime. This heavily # depends on your use case. cpu: 100m limits: # Be careful with the memory limit. You must make sure, that the # (very costly) password hashing has enough memory available. If not, # the application will crash. You do not really need a memory limit, # since Rust is not a garbage collected language. Better take a close # look at what the container actually needs during # prime time and set the requested resources above properly. #memory: # A CPU limit may make sense in case of DDoS attacks or something # like this, if you do not have external rate limiting or other # mechanisms. Otherwise, `MAX_HASH_THREADS` is the main mechanism # to limit resources. cpu: 1000m volumes: - name: rauthy-config configMap: name: rauthy-config volumeClaimTemplates: - metadata: name: rauthy-data spec: accessModes: - \"ReadWriteOnce\" resources: requests: storage: 128Mi #storageClassName: provideIfYouHaveMultipleOnes","breadcrumbs":"Getting Started » Kubernetes » Create and apply the stateful set","id":"13","title":"Create and apply the stateful set"},"14":{"body":"This example assumes, that the deployment will run behind a Kubernetes ingress resource of your choice. It uses Traefik with the IngressRoute CRD. Nevertheless, the ingress is really simple, and it should be very easy to adopt anything else. Create the ingress.yaml touch ingress.yaml Paste the following content into the ingress.yaml file and adjust to your needs apiVersion: traefik.containo.us/v1alpha1\nkind: IngressRoute\nmetadata: name: rauthy-https namespace: rauthy\nspec: entryPoints: - websecure routes: - match: Host(`auth.example.com`) kind: Rule services: - name: rauthy port: 8080","breadcrumbs":"Getting Started » Kubernetes » Ingress","id":"14","title":"Ingress"},"15":{"body":"We are now ready to deploy: kubectl apply -f . And then to observe the deployment: kubectl -n rauthy get pod -w You can now proceed with the First Start steps.","breadcrumbs":"Getting Started » Kubernetes » Deploy","id":"15","title":"Deploy"},"16":{"body":"","breadcrumbs":"Getting Started » Kubernetes » Production Setup","id":"16","title":"Production Setup"},"17":{"body":"Going to production does not need too many additional steps. TLS Certificates The thing you need will be valid TLS certificates, of course. To get these, there are a lot of existing mechanisms. If you use an internal Certificate Authority (CA), you do have you own tools to work with this anyway. If, however, you want to use something like Let's Encrypt , I suggest to use the cert-manager , which is easy and straight forward to use. An example, how to add a certificate for the Traefik IngressRoute from above: apiVersion: traefik.containo.us/v1alpha1\nkind: IngressRoute\nmetadata: name: rauthy-https namespace: rauthy\nspec: entryPoints: - websecure tls: # Paste the name of the TLS secret here secretName: secret-name-of-your-tls-certificate routes: - match: Host(`auth.example.com`) kind: Rule services: - name: rauthy port: 8080 You may want to add an HTTPS redirect as well: apiVersion: traefik.containo.us/v1alpha1\nkind: Middleware\nmetadata: name: https-only namespace: rauthy\nspec: redirectScheme: scheme: https permanent: true\n---\napiVersion: traefik.containo.us/v1alpha1\nkind: IngressRoute\nmetadata: name: rauthy-https namespace: rauthy\nspec: entryPoints: - web routes: - match: Host(`auth.example.com`) kind: Rule middlewares: - name: https-only services: - name: rauthy port: 8080 Additional steps There are a few more things to do when going into production, but these are the same for Kubernetes and Docker and will be explained in later chapters. You can now proceed with the First Start steps.","breadcrumbs":"Getting Started » Kubernetes » Config","id":"17","title":"Config"},"18":{"body":"","breadcrumbs":"Getting Started » First Start » First Start","id":"18","title":"First Start"},"19":{"body":"With the very first start of rauthy, or better with an empty database, when rauthy is starting, it does not only create all the necessary schemas and initial data, but also some sensitive information will be generated safely. This includes a set of Json Web Keys (JWKS) for the token signing and some secrets. The most important of these newly generated secrets is the default admin user's password. When this is securely generated with the very first start, it will be logged into the console. This will only happen once and never again.","breadcrumbs":"Getting Started » First Start » Initial admin password and login","id":"19","title":"Initial admin password and login"},"2":{"body":"Since Rauthy is currently pre v1.0, it might be missing some nice to have features. Some of them will never be implemented (see below), while others might come or are even planned already. Currently missing features: UI translation The Admin UI will most probably never be translated, but a basic translation for the Login and Account page may come. Rauthy Name Override The idea of this feature is, that one may be able to override the Rauthy name in different places like E-Mail notifications or the Admin UI. This would make it possible to not confuse external users, when they expect some other deployment name. Rauthy Authenticator MFA App Even though things like OTP codes will never be implemented, it is not set in stone yet that there will never be Rauthy's own Authenticator App, which then basically acts as a Webauthn Software Authenticator. There are already existing solutions out there to serve this purpose. In the current version, deprecated artifacts of a first approach for its own Authenticator App do exist, but they will be cleaned up in the near future. Customizable E-Mail templates It is unsure, if this feature will come. OIDC Client Rauthy will most probably have the option to be an OIDC Client itself as well. With this feature, you would be able to do things like \"Login with Github\" to Rauthy and then use Rauthy for the extended management and features. MySQL Support At the time of writing it is not clear yet, if MySQL / MariaDB databases will be added. The Foundation is there, it just is the case that some specific queries need to be rewritten / added in a few places to match the new SQL dialect.","breadcrumbs":"Introduction » What it is not (yet?)","id":"2","title":"What it is not (yet?)"},"20":{"body":"docker logs -f rauthy","breadcrumbs":"Getting Started » First Start » Logs with docker","id":"20","title":"Logs with docker"},"21":{"body":"kubectl -n rauthy logs -f rauthy-0 Note If you do a Kubernets HA deployment directly, only the Pod rauthy-0 will log the initial password. Note If you missed this log entry, you will not be able to log in. If this is the case, you can delete the database / volume and just restart rauthy. The log message contains a link to the accounts page, where you then should log in to immediately set a new password. Follow the link, use as the default admin admin@localhost.de and as password the copied value from the log. When logged into the account, click EDIT and CHANGE PASSWORD to set a new password Log out of the account and try to log in to the admin ui with the new password","breadcrumbs":"Getting Started » First Start » Logs with Kubernetes","id":"21","title":"Logs with Kubernetes"},"22":{"body":"It is a good idea, to either keep the admin@localhost.de as a fallback user with just a very long password, or disable it, after a custom admin has been added. When logged in to the admin UI, you can add a new user. When the SMTP settings are correctly configured in the config, which we can test right now, you will receive an E-Mail with the very first password reset. Note If you do not receive an E-Mail after the first user registration, chances are you may have a problem with the SMTP setup. To debug this, you can set LOG_LEVEL=debug in the config and then watch the logs after a restart.","breadcrumbs":"Getting Started » First Start » Custom rauthy admin user","id":"22","title":"Custom rauthy admin user"},"23":{"body":"The role, which allows a user to access the admin UI, is the rauthy_admin. If the user has this role assigned, he will be seen as an admin. Under the hood, rauthy itself uses the OIDC roles and groups in the same way, as all clients would do. This means you should not neither delete the rauthy default client, nor the rauthy_admin role. There are mechanisms to prevents this happening by accident via UI, but you could possibly do this via a direct API call. There are some anti-lockout mechanisms in place in the backend, which will be executed with every start, but being careful at this point is a good idea anyway.","breadcrumbs":"Getting Started » First Start » rauthy_admin user role","id":"23","title":"rauthy_admin user role"},"24":{"body":"Even though the options and tools in the Admin UI should be fully documented, I wanted to mention argon2id tuning here anyway. Rauthy uses the argon2id hashing algorithm for passwords. This is the most expensive and compute-heavy operation beging done by the application and the variables need to be tuned for every deployment to provide the best compromise of security, resource usage and user experience. The default values are way too low for a real production deployment. They should only be used for testing. The Admin UI provides a utility which helps you find the values for your deployment quickly. What and how to do is described in the Admin UI itself, I just want to guide you to this utility especially, since it is an important step security wise. When you are logged in to the Admin UI, please navigate to Config -> Argon2 Parameters to find your values. After they have been found, apply them to the rauthy config and restart the deployment. Keep in mind, that if you run the application in a way, where memory is limited, for instance inside Kubernetes with resource limits set too low, that it will crash, if either ARGON2_M_COST is set too high or the memory limit too low. There is one additional, really important config variable need to be taken into account for the tuning. Since this operation is really ressource intense, you can limit the amount of threads, which can run in parallel doing hashing operations. This is really important when we think about constrained memory again. MAX_HASH_THREADS limits the maximum amount of parallel password hashes at the exact same time to never exceed system memory while still allowing a good amount of memory. The default value is 2 . The rule is simple: Allow as many resources as possible for hashing to have the maximum amount of security, while restricting it as much as necessary. For smaller deployments, set MAX_HASH_THREADS=1, which will technically allows only one user login at the exact same time. This value makes an external rate limiting for the login obsolete (while you may add some for the others).","breadcrumbs":"Argon 2 » Argon 2 Setup","id":"24","title":"Argon 2 Setup"},"25":{"body":"You should use FIDO 2 in production for 2FA / MFA. To make sure it works, you need to check your the config. Set / check some variables in your config, to make sure it works correctly.","breadcrumbs":"2FA / MFA » FIDO 2 / WebAuthn","id":"25","title":"FIDO 2 / WebAuthn"},"26":{"body":"This usually is the 'Relaying Party (RP) ID', which should be your effective domain name. For the above example, since our application is available under 'auth.example.com', this should also be: RP_ID=auth.example.com Caution When the RP_ID changes, already registered devices will stop working and users cannot log in anymore! Be very careful, if you want / need to do this in production.","breadcrumbs":"2FA / MFA » RP_ID","id":"26","title":"RP_ID"},"27":{"body":"The seconds important variable for FIDO 2 is the RP_ORIGIN. This needs to be set to the URL containing the effective domain name. Caution The RP_ORIGIN must always include the port number, even it is just the default 443 for HTTPS. In this example, assuming rauthy will be available at port 443, correct would be: RP_ORIGIN=https://auth.example.com:443","breadcrumbs":"2FA / MFA » RP_ORIGIN","id":"27","title":"RP_ORIGIN"},"28":{"body":"This variable can be set to anything \"nice\". This may be shown to the user in a way like \"RP_BNAE requests your security key ...\". If this is shown depends on the OS and the browser the client uses. Firefox, for instance, does not show this at the time of writing. You can change the RP_NAME later on without affecting the validation of already registered keys.","breadcrumbs":"2FA / MFA » RP_NAME","id":"28","title":"RP_NAME"},"29":{"body":"In my opinion, passwordless login with WebAuthn is the best thing for the user experience and the safest too. However, not all operating systems and browsers have caught up fully yet until a point, where I would use only WebAuthn on its own. Firefox for instance is a good example. On Linux and Mac OS, it does not work with a PIN or any other second factor on your device, which basically downgrades the login to a (strong) single factor again. For this reason, Rauthy will always prompt a user at least once for the password on a new machine, even with active security keys. The keys are used either as a strong second factor, when they do not work with a PIN, or bump up the whole login to real MFA, if the OS / Browser / Key does support this. When a user as logged in successfully on a new device and active 2FA / MFA, he will get an encrypted cookie. The lifetime of this cookie can be configured with WEBAUTHN_RENEW_EXP. The default of this value is 2160 hours . As long as this cookie is present, non-expired and can be encrypted by the backend, the user can log in from this very device with his FIDO 2 key only, which makes a very good user experience for the whole login flow. The E-Mail will already be filled automatically and only a single click on the login button is necessary.","breadcrumbs":"2FA / MFA » WEBAUTHN_RENEW_EXP","id":"29","title":"WEBAUTHN_RENEW_EXP"},"3":{"body":"Rauthy does not try to just replicate already existing, great software. For instance, if you need way more flexibility regarding federated users, fully customizable login flows or things like SAML or LDAP, then you might want to take a look at solutions like Keycloak. Rauthy wants to do just a few things, but these things good, fast, efficient and secure. This means it will never implement (if not contributed from someone): Insecure OIDC flows like the Implicit Flow SAML 2.0 / LDAP Other (older, more insecure or just annoying) 2FA mechanisms than the existing ones No fully customizable themes in addition to the existing branding.","breadcrumbs":"Introduction » What it will never be","id":"3","title":"What it will never be"},"30":{"body":"In the Getting Started, we have set up the ENC_KEYS and ENC_KEY_ACTIVE. The ENC_KEYS defines the static keys used for additional data encryption in a few places. This values may contain multiple keys, if you want to rotate them at some point without breaking the decryption of all already existing secrets. ENC_KEY_ACTIVE defines the key inside ENC_KEYS which will be used as the default. This means that all new / current encryptions performed by the backend will use the key with the given ID.","breadcrumbs":"Encryption » Encryption","id":"30","title":"Encryption"},"31":{"body":"1. Add a new key to the ENC_KEYS in you secrets Fail You must not remove a current key, before the migration has been done via the UI. If the old key is gone, the migration will fail. 2. Generate a new key + id echo \"$(cat /dev/urandom | tr -dc 'a-zA-Z0-9' | head -c8)/$(cat /dev/urandom | tr -dc 'a-zA-Z0-9' | head -c32)\" Keep in mind, you need to ADD this to your existing keys and not just replace them! If you just replace them, almost all things will break and fall apart. The final format of the ENC_KEYS should look something like this, for instance: ENC_KEYS=\"bVCyTsGaggVy5yqQ/S9n7oCen53xSJLzcsmfdnBDvNrqQ63r4 q6u26onRvXVG4427/3CEC8RJWBcMkrBMkRXgx65AmJsNTghSA\" Help If you are inside Kubernetes and (hopefully) use a Kubernetes secret for this, you need to base64 encode the whole value: echo 'PutTheWholeValueHere' | base64 3. Set the ENC_KEY_ACTIVE to the ID of your newly generated key This will make sure, that all new encryptions will use the new key. If you do not care about removing the old keys, because you maybe just want to rotate because its good practice, the secrets will migrate \"by themselves\" over time. If Rauthy finds any secrets during its normal operation, that have been encrypted with an older key than the current ENC_KEY_ACTIVE, it will re-encrypt these secrets and update the values. This means, you may just stop at this point, if this is good enough for you. 4. Migrate Keys If you however want to trigger a re-encryption of all existing secrets on purpose, there is a small tool in the Admin UI which helps you with this. Log in to the Admin UI and navigate to Config -> Encryption Keys. You will see the currently recognized keys and the currently active ID. You can then make sure, that the ID you want to migrate secrets to is selected and execute the migrations. Please keep in mind, that if you have a lot of data, it might take a few seconds to perform this operation. This will migrate all encrypted data for existing OIDC clients and all JWKs used for JWT token singing with the new key. 5. Remove old keys After a successful migration via the UI tool, you may remove old keys from the ENC_KEYS value. Caution The MFA cookies, which are set for a client with an active security after a successful login, are encrypted with the ENC_KEY_ACTIVE too. This means, if you remove something from the ENC_KEYS which was used to encrypt one of these MFA cookies, the user will be prompted for the password again, even if the cookie has not expired yet.","breadcrumbs":"Encryption » Key Rotation","id":"31","title":"Key Rotation"},"32":{"body":"You can migrate easily between SQLite and Postgres, or just between different instances of them. Let's say you started out by evaluating Rauthy with a SQLite and a single instance deployment. Later on, you want to migrate to a HA setup, which requires you to use a Postgres. Solution: MIGRATE_DB_FROM If you set the MIGRATE_DB_FROM in Rauthy's config, it will perform a migration at the next restart. The way it works is the following: At startup, have a look if MIGRATE_DB_FROM is configured If yes, then connect to the given database At the same time, connect to the database specified in the DATABASE_URL Overwrite all existing data in DATABASE_URL with the data from the MIGRATE_DB_FROM database Close the connection to MIGRATE_DB_FROM Use the DATABASE_URL as the new database and start normal operation Danger MIGRATE_DB_FROM overwrites any data in the target database! Be very careful with this option. If you do not remove the MIGRATE_DB_FROM after the migration has been done, it will overwrite the target again with the next restart of the application. Remove the config variable immediately after the migration has finished. Hint The easiest to do is to just set MIGRATE_DB_FROM as an environmant variable, which is easier and quicker to remove again afterwards. Info In some cases and specific environments, this feature is currently a bit bugged. The problems are hard or almost impossible to reproduce. If you encounter a problem using this, please let me know as much details about it as possible.","breadcrumbs":"Database Migrations » Database Migrations","id":"32","title":"Database Migrations"},"33":{"body":"","breadcrumbs":"Backups » Backups","id":"33","title":"Backups"},"34":{"body":"If Rauthy is using a SQLite, it does automatic backups, which can be configured with: # Cron job for automatic data store backups (default: \"0 0 4 * * * *\")\n# sec min hour day_of_month month day_of_week year\nBACKUP_TASK=\"0 0 4 * * * *\" # The name for the data store backups. The current timestamp will always be appended automatically.\n# default: rauthy-backup-\nBACKUP_NAME=\"rauthy-backup-\" # All backups older than the specified hours will be cleaned up automatically (default: 720)\nBACKUP_RETENTION_LOCAL=24 All these backups are written inside the pod / container into /app/data/backup. The database itself will be saved in /app/data by default. This difference makes it possible, that you could add a second volume mount to the container. You then have the database itself on a different disk than the backups, which is the most simple and straight forward approach to have a basic backup strategy. Info The SQLite backups are done with VACUUM, which means you can just use the backups as a normal database again. This makes it possible, to just use the Database Migration feature to apply backups very easily.","breadcrumbs":"Backups » SQLite","id":"34","title":"SQLite"},"35":{"body":"If you are using Postgres as the main database, Rauthy does not do any backups. There are a lot of way better tools out there to handle this task.","breadcrumbs":"Backups » Postgres","id":"35","title":"Postgres"},"36":{"body":"Rauthy is capable of running in a High Availability Mode (HA). Some values, like authentication codes for instance, do live in the cache only. Additionally, there might come an option with a future version which offers a special in-memory only mode in some situations. Because of this, all instances create and share a single HA cache layer, which means at the same time, that you cannot just scale up the replicas infinitely. The optimal amount of replicas for a HA mode would be 3, or if you need even higher resilience 5. More replicas should work just fine, but this has never been really tested and the performance will degrade at some point. To achieve the HA caching layer embedded directly into the application, I created a library (or crate in Rust terms) called redhac. This crate will create each a gRPC server and a client part and each node will connect to all other ones. Once quorum has been reached, a leader will be elected, which then will execute all insert requests by default to avoid overlaps or inconsistencies and to guarantee a configured level of safety. Different so called AckLevel are available, like Quorum, Once and Leader in addition to a direct cache put without any safeties. Rauthy uses different levels in different situations to provide real HA and sync all caches between the pods. This means that you can loose a pod and still have the in-cache-only values available on the other ones. This syncing of the cache is the reason why write performance will degrade, if you scale up too many replicas, which should not really be necessary anyway. The best HA performance will be achieved with 3 replicas and then scaling up the resources for each pod before adding more replicas.","breadcrumbs":"High Availability » High Availability","id":"36","title":"High Availability"},"37":{"body":"The way to configure the HA_MODE is optimized for a Kubernetes deployment but may seem a bit odd at the same time, if you deploy somewhere else. You need to the following values in the config file:","breadcrumbs":"High Availability » Configuration","id":"37","title":"Configuration"},"38":{"body":"The first one is easy, just set HA_MODE=true","breadcrumbs":"High Availability » HA_MODE","id":"38","title":"HA_MODE"},"39":{"body":"The HA_HOSTS is working in a way, that it is really easy inside Kubernetes to configure it, as long as a StatefulSet is used for the deployment. The way a cache node finds its members is by the HA_HOSTS and its own HOSTNAME. In the HA_HOSTS, add every cache member. For instance, if you want to use 3 replicas in HA mode which are running and are deployed as a StatefulSet with the name rauthy again: HA_HOSTS=\"http://rauthy-0.rauthy:8000, http://rauthy-1.rauthy:8000, http://rauthy-2.rauthy:8000\" The way it works: A node gets its own hostname from the OS This is the reason, why you use a StatefulSet for the deployment, even without any volumes attached. For StatefulSet called rauthy, the replicas will always have the names rauthy-0, rauthy-1, ..., which are at the same time the hostnames inside the pod. Find \"me\" inside the HA_HOSTS variable If the hostname cannot be found in the HA_HOSTS, the application will panic and exit because of a misconfiguration. Use the port from the \"me\"-Entry that was found for the server part This means you do not need to specify the port in another variable which eliminates the risk of having inconsistencies or a bad config in that case. Extract \"me\" from the HA_HOSTS, take the leftover nodes as all cache members and connect to them Once a quorum has been reached, a leader will be elected From that point on, the cache will start accepting requests If the leader is lost - elect a new one - No values will be lost If quorum is lost, the cache will be invalidated This happens for security reasons to provide cache inconsistencies. Better invalidate the cache and fetch the values fresh from the DB or other cache members than working with possibly invalid values, which is especially true in an authn / authz situation. Hint If you are in an environment where the described mechanism with extracting the hostname would not work, for instance you want a HA deployment with just different docker hosts, you can set the HOSTNAME_OVERWRITE for each instance to match one of the HA_HOSTS entries.","breadcrumbs":"High Availability » HA_HOSTS","id":"39","title":"HA_HOSTS"},"4":{"body":"At the time of writing, you can run Rauthy either with Docker or inside Kubernetes .","breadcrumbs":"Getting Started » Getting Started","id":"4","title":"Getting Started"},"40":{"body":"You need to set a secret for the CACHE_AUTH_TOKEN which was left out in the Getting Started Just create a secret and add it in the same way: echo \"$(cat /dev/urandom | tr -dc 'a-zA-Z0-9' | head -c48)\" | base64","breadcrumbs":"High Availability » CACHE_AUTH_TOKEN","id":"40","title":"CACHE_AUTH_TOKEN"},"41":{"body":"If you are using a service mesh like for instance linkerd which creates mTLS connections between all pods by default, you can use the HA cache with just plain HTTP, since linkerd will encapsulate the traffic anyway. You may then set CACHE_TLS=false to disable the use of TLS certificates between cache member. However, if you do not have encryption between pods by default, I would highly recommend, that you use TLS .","breadcrumbs":"High Availability » TLS","id":"41","title":"TLS"},"42":{"body":"If you do have TLS certificates from another source already, skip directly to Config .","breadcrumbs":"TLS » TLS","id":"42","title":"TLS"},"43":{"body":"Hint The tools provided in the rauthy repository are very basic and have a terrible user experience. They should only be used, if you do not have an already existing TLS setup or workflow. A project specifically tailored to TLS CA and certificates is in the making. As mentioned, the tools are very basic. If you for instance type in a bad password during CA / intermediate generation, they will just throw an error, and you need to clean up again. They should only get you started and be used for testing. There are a lot of good tools out there which can get you started with TLS and there is no real benefit in creating just another one that does the same stuff. The scripts can be found here (TODO add link to tools). You need to have openssl and a BASH shell available on your system. They have not been tested with Windows. The cache layer does validate the CA for mTLS connections, which is why you can generate a full set of certificates. 1. Certificate Authority (CA) Execute ./build_ca.sh and enter an at least 4 character password for the private key file for the CA 3 times. 2. Intermediate CA Execute ./build_intermediate.sh and enter an at least 4 character password for the private key file for the CA 3 times. The 4. password needs to be the one from the CA private key file from step 1. Type y 2 times to verify the signing of the new certificate On success, you will see intermediate/certs/intermediate.cert.pem: OK as the last line 3. End Entity Certificates These are the certificates used by the cache, rauthy itself, or any other server / client. The end entity script needs the common name for the certificate as the 1. option when you execute it: ./build_end_entity.sh redhac.local Enter the password for the Intermediate CA private key from step 2 and verify the signing. On success, you will see intermediate/certs/redhac.local.cert.pem: OK as the last line Generate another set of certificates for rauthy itself and add your domain name as argument ./build_end_entity.sh auth.example.com You should have 5 files in the ../ folder: auth.example.com.cert.pem\nauth.example.com.key.pem\nca-chain.pem\nredhac.local.cert.pem\nredhac.local.key.pem Info This is not a tutorial about TLS certificates. As mentioned above already, another dedicated TLS project is in the making.","breadcrumbs":"TLS » Generate Certificates","id":"43","title":"Generate Certificates"},"44":{"body":"The reference config contains a TLS section with all the values you can set.","breadcrumbs":"TLS » Config","id":"44","title":"Config"},"45":{"body":"The cache layer (optionally) creates an mTLS connection and validates client certificates, if they are configured. To enable TLS at all, set CACHE_TLS=true By default, redhac expects certificates to be in /app/tls/ with the common name / SNI redhac.local. The certificates need to be in the PEM format and you can provide different certificates for the server and client part, if you like. If this differs from your setup, you can set the following config variables: # The path to the server TLS certificate PEM file (default: tls/redhac.local.cert.pem)\nCACHE_TLS_SERVER_CERT=tls/redhac.local.cert.pem\n# The path to the server TLS key PEM file (default: tls/redhac.local.key.pem)\nCACHE_TLS_SERVER_KEY=tls/redhac.local.key.pem\n# If not empty, the PEM file from the specified location will be added as the CA certificate chain for validating\n# the servers TLS certificate (default: tls/ca-chain.cert.pem)\nCACHE_TLS_CA_SERVER=tls/ca-chain.cert.pem # The path to the client mTLS certificate PEM file (default: tls/redhac.local.cert.pem)\nCACHE_TLS_CLIENT_CERT=tls/redhac.local.cert.pem\n# The path to the client mTLS key PEM file (default: tls/redhac.local.key.pem)\nCACHE_TLS_CLIENT_KEY=tls/redhac.local.key.pem\n# If not empty, the PEM file from the specified location will be added as the CA certificate chain for validating\n# the clients mTLS certificate (default: tls/ca-chain.cert.pem)\nCACHE_TLS_CA_CLIENT=tls/ca-chain.cert.pem # The domain / CN the client should validate the certificate against. This domain MUST be inside the\n# 'X509v3 Subject Alternative Name' when you take a look at the servers certificate with the openssl tool.\n# default: redhac.local\nCACHE_TLS_CLIENT_VALIDATE_DOMAIN=redhac.local # Can be used, if you need to overwrite the SNI when the client connects to the server, for instance if you are behind\n# a loadbalancer which combines multiple certificates. (default: \"\")\n#CACHE_TLS_SNI_OVERWRITE=","breadcrumbs":"TLS » Cache","id":"45","title":"Cache"},"46":{"body":"The TLS configuration for the REST API is much simpler. By default, rauthy will expect a certificate and a key file in /app/tls/tls.key and /app/tls/tls.crt, which is the default naming for a Kubernetes TLS secret. The expected format is PEM, but you could provide the key in DER format too, if you rename the file-ending to *.der. You can change the default path for the files with the config variables TLS_CERT and TLS_KEY.","breadcrumbs":"TLS » Server","id":"46","title":"Server"},"47":{"body":"If you did not follow the above procedure to generate the CA and certificates, you may need to rename the files in the following command, to create the Kubernetes secrets. Secrets - REST API kubectl -n rauthy create secret tls rauthy-tls --key=\"../auth.example.com.key.pem\" --cert=\"../auth.example.com.cert.pem\" && \\ Secrets - redhac cache kubectl -n rauthy create secret tls redhac-tls-server --key=\"../redhac.local.key.pem\" --cert=\"../redhac.local.cert.pem\" && \\\nkubectl -n rauthy create secret generic redhac-server-ca --from-file ../ca-chain.pem Config Adjustements - REST API We need to configure the newly created Kubernetes secrets in the std.yaml from the Kubernetes setup. In the spec.template.spec.volumes section, we need to mount the volumes from secrets: REST API : - name: rauthy-tls secret: secretName: rauthy-tls redhac cache : - name: redhac-tls-server secret: secretName: redhac-tls-server\n- name: redhac-server-ca secret: secretName: redhac-server-ca In the spec.template.spec.containers.[rauthy].volumeMounts section, add:: REST API : - mountPath: /app/tls/ name: rauthy-tls readOnly: true redhac cache : - mountPath: /app/tls/redhac/certs name: redhac-tls-server readOnly: true\n- mountPath: /app/tls/redhac/ca name: redhac-server-ca readOnly: true After having modified the config from above and the sts.yaml now, just apply both: kubectl apply -f config.yaml\nkubectl apply -f sts.yaml The rauthy pods should restart now and TLS is configured.","breadcrumbs":"TLS » Kubernetes","id":"47","title":"Kubernetes"},"48":{"body":"This shows a full example config with (hopefully) every value nicely described. Caution When you go into production, make sure that you provide the included secrets / sensistive information in this file in an appropriate way. With docker, you can leave them inside this file, but when deploying with Kubernetes, extract these values, create Kubernetes Secrets and provide them as environment variables. #####################################\n############## ACCESS ###############\n##################################### # If the User Registration endpoint should be accessible by anyone. If not, an admin\n# must create each new user. (default: false)\n#OPEN_USER_REG=true # Can be used when 'OPEN_USER_REG=true' to restrict the domains for a registration.\n# For instance, set it to 'USER_REG_DOMAIN_RESTRICTION=gmail.com' to allow only\n# registrations with 'user@gmail.com' (default: '')\n#USER_REG_DOMAIN_RESTRICTION=some-domain.com #####################################\n############# BACKUPS ###############\n##################################### # Cron job for automatic data store backups (default: \"0 0 4 * * * *\")\n# sec min hour day_of_month month day_of_week year\n#BACKUP_TASK=\"0 0 4 * * * *\" # The name for the data store backups. The current timestamp will always be appended\n# automatically. (default: rauthy-backup-)\n#BACKUP_NAME=\"rauthy-backup-\" # All backups older than the specified hours will be cleaned up automatically\n# (default: 720)\n#BACKUP_RETENTION_LOCAL=720 #####################################\n############## CACHE ################\n##################################### # If the cache should start in HA mode or standalone\n# accepts 'true|false', defaults to 'false'\n#HA_MODE=false # The connection strings (with hostnames) of the HA instances as a CSV\n# Format: 'scheme://hostname:port'\n#HA_HOSTS=\"http://rauthy-0.rauthy:8000, http://rauthy-1.rauthy:8000, http://rauthy-2.rauthy:8000\" # Overwrite the hostname which is used to identify each cache member.\n# Useful in scenarios, where for instance all members are on the same host with\n# different ports or for testing.\n#HOSTNAME_OVERWRITE=\"rauthy-0.rauthy:8080\" ## Define buffer sizes for channels between the components\n# Buffer for client requests on the incoming stream - server side (default: 128)\n# Make sense to have the CACHE_BUF_SERVER set to:\n# `(number of total HA cache hosts - 1) * CACHE_BUF_CLIENT`\n# In a non-HA deployment, set the same size for both\n#CACHE_BUF_SERVER=128\n# Buffer for client requests to remote servers for all cache operations\n# (default: 128)\n#CACHE_BUF_CLIENT=128 # Secret token, which is used to authenticate the cache members\n#CACHE_AUTH_TOKEN=SomeSuperSecretAndVerySafeToken1337 ## Connections Timeouts # The Server sends out keepalive pings with configured timeouts\n# The keepalive ping interval in seconds (default: 5)\n#CACHE_KEEPALIVE_INTERVAL=5\n# The keepalive ping timeout in seconds (default: 5)\n#CACHE_KEEPALIVE_TIMEOUT=5 # The timeout for the leader election. If a newly saved leader request has\n# not reached quorum after the timeout, the leader will be reset and a new\n# request will be sent out.\n# CAUTION: This should not be lower than CACHE_RECONNECT_TIMEOUT_UPPER,\n# since cold starts and elections will be problematic in that case.\n# value in seconds, default: 15\n#CACHE_ELECTION_TIMEOUT=15 # These 2 values define the reconnect timeout for the HA Cache Clients.\n# The values are in ms and a random between these 2 will be chosen each\n# time to avoid conflicts and race conditions\n# (default: 2500)\n#CACHE_RECONNECT_TIMEOUT_LOWER=2500\n# (default: 5000)\n#CACHE_RECONNECT_TIMEOUT_UPPER=5000 #####################################\n############ DATABASE ###############\n##################################### # The database driver will be chosen at runtime depending on the given\n# DATABASE_URL format. Examples:\n# Sqlite: 'sqlite:data/rauthy.db' or 'sqlite::memory:'\n# Postgres: 'postgresql://User:PasswordWithoutSpecialCharacters@localhost:5432/DatabaseName'\n#\n# NOTE: The password in this case should be alphanumeric. Special\n# characters could cause problems in the connection string.\n#\n# CAUTION: To make the automatic migrations work with Postgres15, when\n# you do not want to just use the `postgres` user, You need to have a\n# user with the same name as the DB / schema. For instance, the\n# following would work without granting extra access to the `public`\n# schema which is disabled by default since PG15:\n# database: rauthy\n# user: rauthy\n# schema: rauthy with owner rauthy\n#\n#DATABASE_URL=sqlite::memory:\n#DATABASE_URL=sqlite:data/rauthy.db\n#DATABASE_URL=postgresql://rauthy:123SuperSafe@localhost:5432/rauthy # Max DB connections - irrelevant for SQLite (default: 5)\n#DATABASE_MAX_CONN=5 # If specified, the current Database, set with DATABASE_URL, will be\n# DELETED and OVERWRITTEN with a migration from the given database\n# with this variable. Can be used to migrate between different databases.\n# !!! USE WITH CARE !!!\n#MIGRATE_DB_FROM=sqlite:data/rauthy.db # Disables the housekeeping schedulers (default: false)\n#SCHED_DISABLE=true #####################################\n############# E-MAIL ################\n##################################### SMTP_USERNAME=\n#SMTP_PASSWORD=\nSMTP_URL=\n# Format: \"Rauthy <rauthy@localhost.de>\"\nSMTP_FROM= #####################################\n###### Encryption / Hashing #########\n##################################### # Format: \"key_id/enc_key another_key_id/another_enc_key\" - the\n# enc_key itself must be exactly 32 characters long and and\n# should not contain special characters.\n# The ID must match '[a-zA-Z0-9]{2,20}'\n#ENC_KEYS=\"bVCyTsGaggVy5yqQ/S9n7oCen53xSJLzcsmfdnBDvNrqQ63r4 q6u26onRvXVG4427/3CEC8RJWBcMkrBMkRXgx65AmJsNTghSA\"\nENC_KEY_ACTIVE=bVCyTsGaggVy5yqQ # M_COST should never be below 32768 in production\nARGON2_M_COST=32768\n# T_COST should never be below 1 in production\nARGON2_T_COST=3\n# P_COST should never be below 2 in production\nARGON2_P_COST=2 # Limits the maximum amount of parallel password hashes at\n# the exact same time to never exceed system memory while\n# still allowing a good amount of memory for the argon2id\n# algorithm (default: 2)\n# CAUTION: You must make sure, that you have at least\n# (MAX_HASH_THREADS * ARGON2_M_COST / 1024) + 30 MB of memory\n# available.\nMAX_HASH_THREADS=1 # The time in ms when to log a warning, if a request waited\n# longer than this time. This is an indicator, that you have\n# more concurrent logins than allowed and may need config adjustments,\n# if this happens more often. (default: 500)\n#HASH_AWAIT_WARN_TIME=500 #####################################\n####### LIFETIMES / TIMEOUTS ########\n##################################### # Set the grace time in seconds for how long in seconds the\n# refresh token should still be valid after usage. Keep this\n# value small, but do not set it to 0 with an HA deployment\n# to not get issues with small HA cache latencies.\n#\n# If you have an external client, which does concurrent\n# requests, from which the request interceptor wants to refresh\n# the token, you may have multiple hits on the endpoint and all\n# of them should be valid.\n#\n# Caching is done on the endpoint itself, but grace time of 0\n# will only be good for a single instance of rauthy.\n# default: 5\n#REFRESH_TOKEN_GRACE_TIME=5 # Lifetime for offline tokens in hours (default: 720)\n#OFFLINE_TOKEN_LIFETIME=720 # Session lifetime in seconds - the session can not be\n# extended beyond this time and a new login will be forced.\n# This is the session for the authorization code flow. (default: 14400)\n#SESSION_LIFETIME=14400 # If 'true', a 2FA / MFA check will be done with each automatic\n# token generation, even with an active session, which kind of\n# makes the session useless with Webauthn enabled, but provides\n# maximum amount of security.\n# If 'false', the user will not get a MFA prompt with an active\n# session at the authorization endpoint.\n# (default: false)\n#SESSION_RENEW_MFA=false # Session timeout in seconds\n# When a new token / login is requested before this timeout hits\n# the limit, the user will be authenticated without prompting for\n# the credentials again.\n# This is the value which can extend the session, until it hits\n# its maximum lifetime set with SESSION_LIFETIME.\n#SESSION_TIMEOUT=5400 # ML: magic link\n# LT: lifetime\n# Lifetime in minutes for reset password magic links (default: 30)\n#ML_LT_PWD_RESET=30 # Lifetime in minutes for the first password magic link, for\n# setting the initial password. (default: 86400)\n#ML_LT_PWD_FIRST=86400 #####################################\n############# LOGGING ###############\n##################################### # This is the log level for stdout logs\n# Accepts: error, info, debug, trace (default: info)\n#LOG_LEVEL=info # This is a special config which allows the configuration of\n# customized access logs. These logs will be logged with each\n# request in addition to the normal LOG_LEVEL logs.\n# The following values are valid:\n# - Debug\n# CAUTION: The Debug setting logs every information available\n# to the middleware which includes SENSITIVE HEADERS\n# DO NOT use the Debug level in a working production environment!\n# - Verbose\n# Verbose logging without headers - generates huge outputs\n# - Basic\n# Logs access to all endpoints apart from the Frontend ones\n# which all js, css, ...\n# - Modifying\n# Logs only requests to modifying endpoints and skips all GET\n# - Off\n# (default: Modifying)\nLOG_LEVEL_ACCESS=Basic #####################################\n################ MFA ################\n##################################### # If 'true', MFA for an account must be enabled to access the\n# rauthy admin UI (default: true)\nADMIN_FORCE_MFA=false # If set to true, you can access rauthy's admin API only with\n# a valid session + CSRF token. If you need some external access\n# via JWT tokens, since sessions are managed with cookies, set\n# this to false. (default: true)\nADMIN_ACCESS_SESSION_ONLY=true #####################################\n############## POW #################\n##################################### ## Proof of Work (PoW) configuration for Client Endpoints like\n# User Registration. The iteration count for the PoW calculation\n# (default: 1000000)\n#POW_IT=1000000 # The expiration duration in seconds when a saved PoW should be\n# cleaned up (default: 300)\n#POW_EXP=300 #####################################\n############# SERVER ################\n##################################### # The server address to listen on. Can bind to a specific IP.\n# (default: 0.0.0.0)\n#LISTEN_ADDRESS=0.0.0.0 # The listen ports for HTTP / HTTPS, depending on the\n# activated 'LISTEN_SCHEME'\n# default: 8080\n#LISTEN_PORT_HTTP=8080\n# default: 8443\n#LISTEN_PORT_HTTPS=8443 # The scheme to use locally, valid values:\n# http | https | http_https (default: http_https)\nLISTEN_SCHEME=http # The Public URL of the whole deployment\n# The LISTEN_SCHEME + PUB_URL must match the HTTP ORIGIN\n# HEADER later on, which is especially important when running\n# rauthy behind a reverse proxy. In case of a non-standard\n# port (80/443), you need to add the port to the PUB_URL\nPUB_URL=localhost:8080 # default value: number of available physical cores\n#HTTP_WORKERS=1 # When rauthy is running behind a reverse proxy, set to true\n# (default: false)\nPROXY_MODE=false #####################################\n############### TLS #################\n##################################### ## Rauthy TLS # Overwrite the path to the TLS certificate file in PEM\n# format for rauthy (default: tls/tls.crt)\n#TLS_CERT=tls/tls.crt\n# Overwrite the path to the TLS private key file in PEM\n# format for rauthy. If the path / filename ends with\n# '.der', rauthy will parse it as DER, otherwise as PEM.\n# (default: tls/tls.key)\n#TLS_KEY=tls/tls.key ## CACHE TLS # Enable / disable TLS for the cache communication\n# (default: true)\nCACHE_TLS=true\n# The path to the server TLS certificate PEM file\n# (default: tls/redhac.local.cert.pem)\nCACHE_TLS_SERVER_CERT=tls/redhac.local.cert.pem\n# The path to the server TLS key PEM file\n# (default: tls/redhac.local.key.pem)\nCACHE_TLS_SERVER_KEY=tls/redhac.local.key.pem\n# If not empty, the PEM file from the specified location\n# will be added as the CA certificate chain for validating\n# the servers TLS certificate (default: tls/ca-chain.cert.pem)\nCACHE_TLS_CA_SERVER=tls/ca-chain.cert.pem # The path to the client mTLS certificate PEM file\n# (default: tls/redhac.local.cert.pem)\nCACHE_TLS_CLIENT_CERT=tls/redhac.local.cert.pem\n# The path to the client mTLS key PEM file\n# (default: tls/redhac.local.key.pem)\nCACHE_TLS_CLIENT_KEY=tls/redhac.local.key.pem\n# If not empty, the PEM file from the specified location will\n# be added as the CA certificate chain for validating\n# the clients mTLS certificate (default: tls/ca-chain.cert.pem)\nCACHE_TLS_CA_CLIENT=tls/ca-chain.cert.pem # The domain / CN the client should validate the certificate\n# against. This domain MUST be inside the\n# 'X509v3 Subject Alternative Name' when you take a look at the\n# servers certificate with the openssl tool.\n# default: redhac.local\nCACHE_TLS_CLIENT_VALIDATE_DOMAIN=redhac.local # Can be used, if you need to overwrite the SNI when the client\n# connects to the server, for instance if you are behind\n# a loadbalancer which combines multiple certificates. (default: \"\")\n#CACHE_TLS_SNI_OVERWRITE= #####################################\n############# WEBAUTHN ##############\n##################################### # The 'Relaying Party (RP) ID' - effective domain name\n# (default: localhost)\n# CAUTION: When this changes, already registered devices will stop\n# working and users cannot log in anymore!\nRP_ID=localhost # Url containing the effective domain name\n# (default: http://localhost:8080)\n# CAUTION: Must include the port number!\nRP_ORIGIN=http://localhost:8080 # Non critical RP Name\n# Has no security properties and may be changed without issues\n# (default: Rauthy Webauthn)\nRP_NAME='Rauthy Webauthn' # The Cache lifetime in seconds for Webauthn requests. Within\n# this time, a webauthn request must have been validated.\n# (default: 60)\n#WEBAUTHN_REQ_EXP=60 # The Cache lifetime for additional Webauthn Data like auth\n# codes and so on. Should not be lower than WEBAUTHN_REQ_EXP.\n# The value is in seconds (default: 90)\n#WEBAUTHN_DATA_EXP=90 # With webauthn enabled for a user, he needs to enter\n# username / password on a new system. If these credentials are\n# verified, rauthy will set an additional cookie, which will\n# determine how long the user can then use only (safe) MFA\n# passwordless webauthn login with yubikeys, apple touch id,\n# Windows hello, ... until he needs to verify his credentials\n# again.\n# Passwordless login is generally much safer than logging in\n# with a password. But sometimes it is possible, that the\n# Webauthn devices do not force the user to include a second\n# factor, which in that case would be a single factor login\n# again. That is why we should ask for the original password\n# in addition once in a while to set the cookie.\n# The value is in hours (default: 2160)\n#WEBAUTHN_RENEW_EXP=2160","breadcrumbs":"Reference Config » Reference Config","id":"48","title":"Reference Config"},"5":{"body":"","breadcrumbs":"Getting Started » Docker » Docker","id":"5","title":"Docker"},"6":{"body":"For getting a first look at rauthy, you can start it with docker (or any other container runtime) on your localhost. The image contains a basic default config which is sufficient for local testing. docker run --rm \\ -p 8080:8080 \\ --name rauthy \\ sdobedev/rauthy This will start the container in interactive mode with an in-memory SQLite database. Just take a look at the log at the logs to see the URL and first password. If you want to test a bit more in depth, you can change to an on-disk database easily: docker run -d \\ -e DATABASE_URL=sqlite:data/rauthy.db \\ -p 8080:8080 \\ --name rauthy \\ sdobedev/rauthy Note The second command does not start in interactive mode and it does not delete the container on exit. This means the data will be persisted, as long as the container itself is no erased and you can shutdown and restart to your liking without using test data. To see the logs and the new admin password, take a look with docker logs -f rauthy To delete the container, if you do not need it anymore, execute docker stop rauthy && docker rm rauthy To proceed, go to First Start","breadcrumbs":"Getting Started » Docker » Testing / Local Evaluation","id":"6","title":"Testing / Local Evaluation"},"7":{"body":"For going to production or to test more in-depth, you need to apply a config that matches your environment. The first thing you might want to do is to add a volume mount for the database. The second thing is to provide a more custom config. Rauthy can either be configured via environment variables only, or you can provide a config file. You can add environment variables to the startup command with the -e option, like shown in the on-disk SQLite command. A better approach, when you have a bigger config file, would be to have all of them in a config file. Note The following commands will work on Linux and Mac OS (even though not tested on Mac OS). If you are on Windows, you might replace the pwd command and just paste in the path directly. Since I am no Windows user myself, I cannot provide tested commands in this case. 1. We want to create a new directory for rauthy's persistent data mkdir rauthy 2. Add the new config file. This documentation is in an early version and remote links are not available yet, they will be added at a later point. For now, create a new file and paste the reference config vim rauthy/rauthy.cfg 3. Create a sub-directory for the Database files mkdir rauthy/data The rauthy container by default runs everything with user:group 10001:10001 for security reasons. To make this work with the default values, you have 2 options: Change the access rights: chmod 0640 rauthy/rauthy.cfg\nchmod 0700 -R rauthy/data\nsudo chown -R 10001:10001 rauthy The other solution, if you do not have sudo rights, would be to change the owner of the whole directory. chmod a+w rauthy/data This will make the directory writeable for everyone, so rauthy can create the database files inside the container with 10001:10001 again. Note The safest approach would be to change the owner and group for these files on the host system. This needs sudo to edit the config, which may be a bit annoying, but at the same time it makes sure, that you can only read the secrets inside it with sudo too. 4. Adopt the config to your liking. Make sure to adjust the volume mount for the sqlite directory in step 5, if it differs from sqlite:data/rauthy.db 5. Start the container with volume mounts docker run -d \\ -v $(pwd)/rauthy/rauthy.cfg:/app/rauthy.cfg \\ -v $(pwd)/rauthy/data:/app/data \\ -p 8080:8080 \\ --name rauthy \\ sdobedev/rauthy 6. Restrict DB files access even more After rauthy has done the first start, you could harden the access rights of the SQLite files even more. This would make sure, that no one without sudo could just copy and read in the SQLite in some other place. Just execute once more: sudo chmod 0700 -R rauthy/data 7. You can now proceed with the First Start steps.","breadcrumbs":"Getting Started » Docker » Production Setup","id":"7","title":"Production Setup"},"8":{"body":"At the time of writing, there is no Helm Chart or Kustomize files available yet. The whole setup is pretty simple on purpose though, so it should not be a big deal to get it running inside Kubernetes.","breadcrumbs":"Getting Started » Kubernetes » Kubernetes","id":"8","title":"Kubernetes"},"9":{"body":"Since rauthy uses pretty aggressive caching for different reasons, you cannot just have a single deployment and scale up the replicas without enabling HA_MODE. How to deploy a HA version is described below. The steps to deploy on Kubernetes are pretty simple. Create namespace Create and apply the config Create and apply secrets Create and apply the stateful set","breadcrumbs":"Getting Started » Kubernetes » Single Instance","id":"9","title":"Single Instance"}},"length":49,"save":true},"fields":["title","body","breadcrumbs"],"index":{"body":{"root":{"0":{".":{"0":{".":{"0":{".":{"0":{"df":1,"docs":{"48":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{},"r":{"a":{"df":0,"docs":{},"u":{"df":0,"docs":{},"t":{"df":0,"docs":{},"h":{"df":0,"docs":{},"y":{":":{"8":{"0":{"0":{"0":{"df":2,"docs":{"39":{"tf":1.0},"48":{"tf":1.0}}},"df":0,"docs":{}},"8":{"0":{"df":1,"docs":{"48":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}}},"df":0,"docs":{}}},"6":{"4":{"0":{"df":1,"docs":{"7":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}},"7":{"0":{"0":{"df":1,"docs":{"7":{"tf":1.4142135623730951}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":4,"docs":{"21":{"tf":1.4142135623730951},"34":{"tf":1.7320508075688772},"39":{"tf":1.0},"48":{"tf":2.23606797749979}}},"1":{".":{"df":0,"docs":{},"r":{"a":{"df":0,"docs":{},"u":{"df":0,"docs":{},"t":{"df":0,"docs":{},"h":{"df":0,"docs":{},"y":{":":{"8":{"0":{"0":{"0":{"df":2,"docs":{"39":{"tf":1.0},"48":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}}},"df":0,"docs":{}}},"0":{"0":{"0":{"0":{"0":{"0":{"df":1,"docs":{"48":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}},"1":{":":{"1":{"0":{"0":{"0":{"1":{"df":1,"docs":{"7":{"tf":1.7320508075688772}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":1,"docs":{"13":{"tf":2.0}}},"df":0,"docs":{},"m":{"df":1,"docs":{"13":{"tf":1.0}}}},"df":0,"docs":{},"m":{"df":1,"docs":{"13":{"tf":1.0}}}},"2":{"4":{"df":2,"docs":{"13":{"tf":1.0},"48":{"tf":1.0}}},"df":0,"docs":{}},"df":1,"docs":{"13":{"tf":1.0}}},"2":{"8":{"df":1,"docs":{"48":{"tf":1.4142135623730951}},"m":{"df":0,"docs":{},"i":{"df":1,"docs":{"13":{"tf":1.0}}}}},"df":0,"docs":{}},"4":{"4":{"0":{"0":{"df":1,"docs":{"48":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"5":{"df":1,"docs":{"48":{"tf":1.0}}},"df":7,"docs":{"11":{"tf":1.0},"13":{"tf":1.7320508075688772},"31":{"tf":1.0},"39":{"tf":1.0},"43":{"tf":1.7320508075688772},"48":{"tf":1.4142135623730951},"7":{"tf":1.0}}},"2":{".":{"0":{"df":1,"docs":{"3":{"tf":1.0}}},"df":0,"docs":{},"r":{"a":{"df":0,"docs":{},"u":{"df":0,"docs":{},"t":{"df":0,"docs":{},"h":{"df":0,"docs":{},"y":{":":{"8":{"0":{"0":{"0":{"df":2,"docs":{"39":{"tf":1.0},"48":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}}},"df":0,"docs":{}}},"0":{"df":1,"docs":{"13":{"tf":1.0}}},"1":{"6":{"0":{"df":2,"docs":{"29":{"tf":1.0},"48":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}},"5":{"0":{"0":{"df":1,"docs":{"48":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":10,"docs":{"1":{"tf":1.0},"12":{"tf":1.0},"24":{"tf":1.4142135623730951},"25":{"tf":1.4142135623730951},"27":{"tf":1.0},"29":{"tf":1.0},"31":{"tf":1.0},"43":{"tf":1.7320508075688772},"48":{"tf":2.0},"7":{"tf":1.4142135623730951}},"f":{"a":{"df":4,"docs":{"25":{"tf":1.0},"29":{"tf":1.0},"3":{"tf":1.0},"48":{"tf":1.0}}},"df":0,"docs":{}}},"3":{"0":{"0":{"df":1,"docs":{"48":{"tf":1.0}}},"df":2,"docs":{"13":{"tf":1.0},"48":{"tf":1.4142135623730951}},"m":{"df":0,"docs":{},"i":{"df":1,"docs":{"13":{"tf":1.0}}}}},"2":{"7":{"6":{"8":{"df":1,"docs":{"48":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":2,"docs":{"12":{"tf":1.0},"48":{"tf":1.0}}},"df":5,"docs":{"31":{"tf":1.0},"36":{"tf":1.4142135623730951},"39":{"tf":1.0},"43":{"tf":1.7320508075688772},"7":{"tf":1.0}}},"4":{"4":{"3":{"df":1,"docs":{"27":{"tf":1.4142135623730951}}},"df":0,"docs":{}},"d":{"0":{"a":{"3":{"9":{"7":{"7":{"df":0,"docs":{},"f":{"4":{"df":0,"docs":{},"f":{"d":{"a":{"6":{"8":{"df":0,"docs":{},"e":{"8":{"4":{"8":{"b":{"4":{"5":{"8":{"9":{"9":{"d":{"3":{"b":{"8":{"a":{"1":{"b":{"6":{"3":{"c":{"0":{"9":{"c":{"8":{"0":{"d":{"c":{"a":{"0":{"c":{"c":{"7":{"3":{"7":{"b":{"df":0,"docs":{},"e":{"7":{"3":{"3":{"8":{"8":{"7":{"6":{"1":{"9":{"4":{"c":{"4":{"0":{"?":{"c":{"df":0,"docs":{},"o":{"df":0,"docs":{},"n":{"df":0,"docs":{},"t":{"df":0,"docs":{},"e":{"df":0,"docs":{},"x":{"df":0,"docs":{},"t":{"=":{"df":0,"docs":{},"e":{"df":0,"docs":{},"x":{"df":0,"docs":{},"p":{"df":0,"docs":{},"l":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"df":1,"docs":{"13":{"tf":1.0}}}}}}}}},"df":0,"docs":{}}}}}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":5,"docs":{"31":{"tf":1.0},"34":{"tf":1.4142135623730951},"43":{"tf":1.7320508075688772},"48":{"tf":1.4142135623730951},"7":{"tf":1.0}}},"5":{"0":{"0":{"0":{"df":1,"docs":{"48":{"tf":1.0}}},"df":1,"docs":{"48":{"tf":1.0}}},"df":1,"docs":{"13":{"tf":1.0}}},"df":5,"docs":{"31":{"tf":1.0},"36":{"tf":1.0},"43":{"tf":1.0},"48":{"tf":2.0},"7":{"tf":1.4142135623730951}}},"6":{"0":{"df":1,"docs":{"48":{"tf":1.0}}},"4":{"df":0,"docs":{},"m":{"df":0,"docs":{},"i":{"df":1,"docs":{"13":{"tf":1.0}}}}},"df":1,"docs":{"7":{"tf":1.0}}},"7":{"0":{"df":1,"docs":{"13":{"tf":1.0}}},"2":{"0":{"df":2,"docs":{"34":{"tf":1.0},"48":{"tf":1.4142135623730951}}},"df":0,"docs":{}},"df":1,"docs":{"7":{"tf":1.0}}},"8":{"0":{"/":{"4":{"4":{"3":{"df":1,"docs":{"48":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"0":{"0":{"df":1,"docs":{"13":{"tf":1.7320508075688772}}},"df":0,"docs":{}},"8":{"0":{":":{"8":{"0":{"8":{"0":{"df":2,"docs":{"6":{"tf":1.4142135623730951},"7":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":4,"docs":{"13":{"tf":2.23606797749979},"14":{"tf":1.0},"17":{"tf":1.4142135623730951},"48":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}},"4":{"4":{"3":{"df":2,"docs":{"13":{"tf":2.23606797749979},"48":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}},"6":{"4":{"0":{"0":{"df":1,"docs":{"48":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"9":{"0":{"df":1,"docs":{"48":{"tf":1.0}}},"]":{"df":0,"docs":{},"{":{"2":{",":{"2":{"0":{"df":2,"docs":{"12":{"tf":1.0},"48":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}},"df":3,"docs":{"12":{"tf":1.4142135623730951},"31":{"tf":1.4142135623730951},"40":{"tf":1.0}}},"a":{"+":{"df":0,"docs":{},"w":{"df":1,"docs":{"7":{"tf":1.0}}}},"b":{"df":0,"docs":{},"o":{"df":0,"docs":{},"v":{"df":5,"docs":{"13":{"tf":1.0},"17":{"tf":1.0},"26":{"tf":1.0},"43":{"tf":1.0},"47":{"tf":1.4142135623730951}}}}},"c":{"c":{"df":0,"docs":{},"e":{"df":0,"docs":{},"p":{"df":0,"docs":{},"t":{"df":2,"docs":{"39":{"tf":1.0},"48":{"tf":1.4142135623730951}}}},"s":{"df":0,"docs":{},"s":{"df":3,"docs":{"23":{"tf":1.0},"48":{"tf":2.8284271247461903},"7":{"tf":1.7320508075688772}},"m":{"df":0,"docs":{},"o":{"d":{"df":1,"docs":{"13":{"tf":1.0}}},"df":0,"docs":{}}}}}},"i":{"d":{"df":1,"docs":{"23":{"tf":1.0}}},"df":0,"docs":{}},"o":{"df":0,"docs":{},"r":{"d":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"df":0,"docs":{},"g":{"df":0,"docs":{},"l":{"df":0,"docs":{},"i":{"df":1,"docs":{"10":{"tf":1.0}}}}}}}},"df":0,"docs":{}},"u":{"df":0,"docs":{},"n":{"df":0,"docs":{},"t":{"df":5,"docs":{"1":{"tf":1.7320508075688772},"2":{"tf":1.0},"21":{"tf":1.7320508075688772},"24":{"tf":1.0},"48":{"tf":1.0}}}}}}},"df":0,"docs":{},"h":{"df":0,"docs":{},"i":{"df":0,"docs":{},"e":{"df":0,"docs":{},"v":{"df":2,"docs":{"1":{"tf":1.0},"36":{"tf":1.4142135623730951}}}}}},"k":{"df":0,"docs":{},"l":{"df":0,"docs":{},"e":{"df":0,"docs":{},"v":{"df":0,"docs":{},"e":{"df":0,"docs":{},"l":{"df":1,"docs":{"36":{"tf":1.0}}}}}}}},"t":{"df":1,"docs":{"2":{"tf":1.0}},"i":{"df":0,"docs":{},"v":{"df":4,"docs":{"1":{"tf":1.0},"29":{"tf":1.4142135623730951},"31":{"tf":1.4142135623730951},"48":{"tf":1.7320508075688772}}}},"u":{"a":{"df":0,"docs":{},"l":{"df":1,"docs":{"13":{"tf":1.7320508075688772}}}},"df":0,"docs":{}}}},"d":{"d":{"df":12,"docs":{"13":{"tf":1.0},"17":{"tf":1.4142135623730951},"22":{"tf":1.0},"24":{"tf":1.0},"31":{"tf":1.4142135623730951},"34":{"tf":1.0},"39":{"tf":1.0},"40":{"tf":1.0},"43":{"tf":1.4142135623730951},"47":{"tf":1.0},"48":{"tf":1.0},"7":{"tf":1.7320508075688772}},"i":{"df":0,"docs":{},"t":{"df":8,"docs":{"1":{"tf":1.0},"13":{"tf":1.0},"17":{"tf":1.4142135623730951},"24":{"tf":1.0},"3":{"tf":1.0},"30":{"tf":1.0},"36":{"tf":1.0},"48":{"tf":2.0}},"i":{"df":0,"docs":{},"o":{"df":0,"docs":{},"n":{"df":2,"docs":{"1":{"tf":1.0},"36":{"tf":1.0}}}}}}},"r":{"df":0,"docs":{},"e":{"df":0,"docs":{},"s":{"df":0,"docs":{},"s":{"df":1,"docs":{"48":{"tf":1.0}}}}}}},"df":7,"docs":{"12":{"tf":1.0},"2":{"tf":1.4142135623730951},"22":{"tf":1.0},"36":{"tf":1.0},"45":{"tf":1.4142135623730951},"48":{"tf":1.4142135623730951},"7":{"tf":1.0}},"j":{"df":0,"docs":{},"u":{"df":0,"docs":{},"s":{"df":0,"docs":{},"t":{"df":6,"docs":{"11":{"tf":1.0},"13":{"tf":2.0},"14":{"tf":1.0},"47":{"tf":1.0},"48":{"tf":1.0},"7":{"tf":1.0}}}}}},"m":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"@":{"df":0,"docs":{},"l":{"df":0,"docs":{},"o":{"c":{"a":{"df":0,"docs":{},"l":{"df":0,"docs":{},"h":{"df":0,"docs":{},"o":{"df":0,"docs":{},"s":{"df":0,"docs":{},"t":{".":{"d":{"df":2,"docs":{"21":{"tf":1.0},"22":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}}}}}}},"df":0,"docs":{}},"df":0,"docs":{}}}},"_":{"a":{"c":{"c":{"df":0,"docs":{},"e":{"df":0,"docs":{},"s":{"df":0,"docs":{},"s":{"_":{"df":0,"docs":{},"s":{"df":0,"docs":{},"e":{"df":0,"docs":{},"s":{"df":0,"docs":{},"s":{"df":0,"docs":{},"i":{"df":0,"docs":{},"o":{"df":0,"docs":{},"n":{"_":{"df":0,"docs":{},"o":{"df":0,"docs":{},"n":{"df":0,"docs":{},"l":{"df":0,"docs":{},"y":{"=":{"df":0,"docs":{},"t":{"df":0,"docs":{},"r":{"df":0,"docs":{},"u":{"df":1,"docs":{"48":{"tf":1.0}}}}}},"df":0,"docs":{}}}}}},"df":0,"docs":{}}}}}}}}},"df":0,"docs":{}}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{},"f":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"c":{"df":0,"docs":{},"e":{"_":{"df":0,"docs":{},"m":{"df":0,"docs":{},"f":{"a":{"=":{"df":0,"docs":{},"f":{"a":{"df":0,"docs":{},"l":{"df":0,"docs":{},"s":{"df":1,"docs":{"48":{"tf":1.0}}}}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{}}}},"df":0,"docs":{}}},"df":0,"docs":{}}}}},"df":10,"docs":{"1":{"tf":1.0},"19":{"tf":1.4142135623730951},"2":{"tf":1.4142135623730951},"21":{"tf":1.4142135623730951},"22":{"tf":1.7320508075688772},"23":{"tf":1.4142135623730951},"24":{"tf":2.0},"31":{"tf":1.4142135623730951},"48":{"tf":1.7320508075688772},"6":{"tf":1.0}}}}},"o":{"df":0,"docs":{},"p":{"df":0,"docs":{},"t":{"df":3,"docs":{"13":{"tf":1.0},"14":{"tf":1.0},"7":{"tf":1.0}}}}}},"df":0,"docs":{},"f":{"df":0,"docs":{},"f":{"df":0,"docs":{},"e":{"c":{"df":0,"docs":{},"t":{"df":1,"docs":{"28":{"tf":1.0}}}},"df":0,"docs":{}}},"t":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"w":{"a":{"df":0,"docs":{},"r":{"d":{"df":1,"docs":{"32":{"tf":1.0}}},"df":0,"docs":{}}},"df":0,"docs":{}}}}}},"g":{"a":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"df":11,"docs":{"1":{"tf":1.7320508075688772},"19":{"tf":1.0},"24":{"tf":1.0},"29":{"tf":1.0},"31":{"tf":1.0},"32":{"tf":1.4142135623730951},"34":{"tf":1.0},"39":{"tf":1.0},"43":{"tf":1.0},"48":{"tf":1.7320508075688772},"7":{"tf":1.0}},"s":{"df":0,"docs":{},"t":{"df":2,"docs":{"45":{"tf":1.0},"48":{"tf":1.0}}}}}}},"df":0,"docs":{},"g":{"df":0,"docs":{},"r":{"df":0,"docs":{},"e":{"df":0,"docs":{},"s":{"df":0,"docs":{},"s":{"df":1,"docs":{"9":{"tf":1.0}}}}}}}},"l":{"df":0,"docs":{},"g":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"df":0,"docs":{},"i":{"df":0,"docs":{},"t":{"df":0,"docs":{},"h":{"df":0,"docs":{},"m":{"df":3,"docs":{"1":{"tf":1.0},"24":{"tf":1.0},"48":{"tf":1.0}}}}}}}}},"l":{"df":0,"docs":{},"o":{"df":0,"docs":{},"w":{"df":4,"docs":{"1":{"tf":1.4142135623730951},"23":{"tf":1.0},"24":{"tf":1.7320508075688772},"48":{"tf":2.0}},"p":{"df":0,"docs":{},"r":{"df":0,"docs":{},"i":{"df":0,"docs":{},"v":{"df":0,"docs":{},"i":{"df":0,"docs":{},"l":{"df":0,"docs":{},"e":{"df":0,"docs":{},"g":{"df":0,"docs":{},"e":{"df":0,"docs":{},"e":{"df":0,"docs":{},"s":{"c":{"a":{"df":0,"docs":{},"l":{"df":1,"docs":{"13":{"tf":1.0}}}},"df":0,"docs":{}},"df":0,"docs":{}}}}}}}}}}}}}}},"p":{"df":0,"docs":{},"h":{"a":{"df":0,"docs":{},"n":{"df":0,"docs":{},"u":{"df":0,"docs":{},"m":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":1,"docs":{"48":{"tf":1.0}}}}}}}},"df":0,"docs":{}}},"r":{"df":0,"docs":{},"e":{"a":{"d":{"df":0,"docs":{},"i":{"df":10,"docs":{"1":{"tf":1.4142135623730951},"2":{"tf":1.4142135623730951},"26":{"tf":1.0},"28":{"tf":1.0},"29":{"tf":1.0},"3":{"tf":1.0},"30":{"tf":1.0},"42":{"tf":1.0},"43":{"tf":1.4142135623730951},"48":{"tf":1.0}}}},"df":0,"docs":{}},"df":0,"docs":{}}},"t":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"n":{"df":2,"docs":{"45":{"tf":1.0},"48":{"tf":1.0}}}}}},"w":{"a":{"df":0,"docs":{},"y":{"df":6,"docs":{"13":{"tf":1.0},"27":{"tf":1.0},"29":{"tf":1.0},"34":{"tf":1.0},"39":{"tf":1.0},"48":{"tf":1.0}}}},"df":0,"docs":{}}},"m":{"df":0,"docs":{},"o":{"df":0,"docs":{},"u":{"df":0,"docs":{},"n":{"df":0,"docs":{},"t":{"df":3,"docs":{"24":{"tf":2.0},"36":{"tf":1.0},"48":{"tf":1.7320508075688772}}}}}}},"n":{"d":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"i":{"d":{"df":1,"docs":{"1":{"tf":1.0}}},"df":0,"docs":{}}}}},"df":0,"docs":{},"n":{"df":0,"docs":{},"o":{"df":0,"docs":{},"y":{"df":2,"docs":{"3":{"tf":1.0},"7":{"tf":1.0}}}}},"o":{"df":0,"docs":{},"t":{"df":0,"docs":{},"h":{"df":4,"docs":{"13":{"tf":1.7320508075688772},"39":{"tf":1.0},"42":{"tf":1.0},"43":{"tf":1.7320508075688772}},"e":{"df":0,"docs":{},"r":{"_":{"df":0,"docs":{},"k":{"df":0,"docs":{},"e":{"df":0,"docs":{},"y":{"_":{"df":0,"docs":{},"i":{"d":{"/":{"a":{"df":0,"docs":{},"n":{"df":0,"docs":{},"o":{"df":0,"docs":{},"t":{"df":0,"docs":{},"h":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"_":{"df":0,"docs":{},"e":{"df":0,"docs":{},"n":{"c":{"_":{"df":0,"docs":{},"k":{"df":0,"docs":{},"e":{"df":0,"docs":{},"y":{"df":2,"docs":{"12":{"tf":1.0},"48":{"tf":1.0}}}}}},"df":0,"docs":{}},"df":0,"docs":{}}}},"df":0,"docs":{}}}}}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}},"df":0,"docs":{}}}}},"df":0,"docs":{}}}}}},"t":{"df":0,"docs":{},"i":{"df":1,"docs":{"23":{"tf":1.0}}}},"y":{"df":0,"docs":{},"m":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"df":3,"docs":{"26":{"tf":1.0},"48":{"tf":1.0},"6":{"tf":1.0}}}}},"o":{"df":0,"docs":{},"n":{"df":1,"docs":{"48":{"tf":1.0}}}},"t":{"df":0,"docs":{},"h":{"df":2,"docs":{"14":{"tf":1.0},"28":{"tf":1.0}}}},"w":{"a":{"df":0,"docs":{},"y":{"df":6,"docs":{"12":{"tf":1.0},"17":{"tf":1.0},"23":{"tf":1.0},"24":{"tf":1.0},"36":{"tf":1.0},"41":{"tf":1.0}}}},"df":0,"docs":{}}}},"p":{"a":{"df":0,"docs":{},"r":{"df":0,"docs":{},"t":{"df":2,"docs":{"31":{"tf":1.0},"48":{"tf":1.0}}}}},"df":0,"docs":{},"i":{"df":4,"docs":{"23":{"tf":1.0},"46":{"tf":1.0},"47":{"tf":2.0},"48":{"tf":1.0}},"v":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"s":{"df":5,"docs":{"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.4142135623730951},"14":{"tf":1.0},"17":{"tf":1.7320508075688772}}}}}}},"p":{"/":{"d":{"a":{"df":0,"docs":{},"t":{"a":{"/":{"b":{"a":{"c":{"df":0,"docs":{},"k":{"df":0,"docs":{},"u":{"df":0,"docs":{},"p":{"df":1,"docs":{"34":{"tf":1.0}}}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":2,"docs":{"13":{"tf":1.0},"34":{"tf":1.0}}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{},"r":{"a":{"df":0,"docs":{},"u":{"df":0,"docs":{},"t":{"df":0,"docs":{},"h":{"df":0,"docs":{},"y":{".":{"c":{"df":0,"docs":{},"f":{"df":0,"docs":{},"g":{"df":1,"docs":{"13":{"tf":1.0}}}}},"df":0,"docs":{}},"df":0,"docs":{}}}}}},"df":0,"docs":{}},"t":{"df":0,"docs":{},"l":{"df":2,"docs":{"45":{"tf":1.0},"47":{"tf":1.0}},"s":{"/":{"df":0,"docs":{},"r":{"df":0,"docs":{},"e":{"d":{"df":0,"docs":{},"h":{"a":{"c":{"/":{"c":{"a":{"df":1,"docs":{"47":{"tf":1.0}}},"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"t":{"df":1,"docs":{"47":{"tf":1.0}}}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}},"df":0,"docs":{}}},"t":{"df":0,"docs":{},"l":{"df":0,"docs":{},"s":{".":{"c":{"df":0,"docs":{},"r":{"df":0,"docs":{},"t":{"df":1,"docs":{"46":{"tf":1.0}}}}},"df":0,"docs":{},"k":{"df":0,"docs":{},"e":{"df":0,"docs":{},"y":{"df":1,"docs":{"46":{"tf":1.0}}}}}},"df":0,"docs":{}}}}},"df":0,"docs":{}}}}},"df":2,"docs":{"13":{"tf":2.0},"2":{"tf":1.7320508075688772}},"e":{"df":0,"docs":{},"n":{"d":{"df":2,"docs":{"34":{"tf":1.0},"48":{"tf":1.0}}},"df":0,"docs":{}}},"l":{"df":1,"docs":{"48":{"tf":1.0}},"i":{"c":{"df":6,"docs":{"13":{"tf":1.0},"24":{"tf":1.4142135623730951},"26":{"tf":1.0},"32":{"tf":1.0},"36":{"tf":1.0},"39":{"tf":1.0}}},"df":9,"docs":{"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"15":{"tf":1.0},"24":{"tf":1.0},"34":{"tf":1.0},"47":{"tf":1.7320508075688772},"7":{"tf":1.0},"9":{"tf":1.7320508075688772}}}},"r":{"df":0,"docs":{},"o":{"a":{"c":{"df":0,"docs":{},"h":{"df":3,"docs":{"2":{"tf":1.0},"34":{"tf":1.0},"7":{"tf":1.4142135623730951}}}},"df":0,"docs":{}},"df":0,"docs":{},"p":{"df":0,"docs":{},"r":{"df":0,"docs":{},"i":{"df":1,"docs":{"48":{"tf":1.0}}}}}}},"s":{"/":{"df":0,"docs":{},"v":{"1":{"df":1,"docs":{"13":{"tf":1.0}}},"df":0,"docs":{}}},"df":0,"docs":{}}}},"r":{"df":0,"docs":{},"g":{"df":0,"docs":{},"o":{"df":0,"docs":{},"n":{"2":{"_":{"df":0,"docs":{},"m":{"_":{"c":{"df":0,"docs":{},"o":{"df":0,"docs":{},"s":{"df":0,"docs":{},"t":{"=":{"3":{"2":{"7":{"6":{"8":{"df":1,"docs":{"48":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":3,"docs":{"13":{"tf":1.0},"24":{"tf":1.0},"48":{"tf":1.0}}}}}},"df":0,"docs":{}},"df":0,"docs":{}},"p":{"_":{"c":{"df":0,"docs":{},"o":{"df":0,"docs":{},"s":{"df":0,"docs":{},"t":{"=":{"2":{"df":1,"docs":{"48":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}}}}},"df":0,"docs":{}},"df":0,"docs":{}},"t":{"_":{"c":{"df":0,"docs":{},"o":{"df":0,"docs":{},"s":{"df":0,"docs":{},"t":{"=":{"3":{"df":1,"docs":{"48":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}}}}},"df":0,"docs":{}},"df":0,"docs":{}}},"df":1,"docs":{"24":{"tf":1.0}},"i":{"d":{"df":2,"docs":{"24":{"tf":1.4142135623730951},"48":{"tf":1.0}}},"df":0,"docs":{}}},"df":1,"docs":{"24":{"tf":1.0}}}},"u":{"df":0,"docs":{},"m":{"df":0,"docs":{},"e":{"df":0,"docs":{},"n":{"df":0,"docs":{},"t":{"df":1,"docs":{"43":{"tf":1.0}}}}}}}},"t":{"df":0,"docs":{},"i":{"df":0,"docs":{},"f":{"a":{"c":{"df":0,"docs":{},"t":{"df":1,"docs":{"2":{"tf":1.0}}}},"df":0,"docs":{}},"df":0,"docs":{}}}}},"s":{"df":0,"docs":{},"k":{"df":1,"docs":{"48":{"tf":1.0}}},"s":{"df":0,"docs":{},"i":{"df":0,"docs":{},"g":{"df":0,"docs":{},"n":{"df":1,"docs":{"23":{"tf":1.0}}}}},"u":{"df":0,"docs":{},"m":{"df":4,"docs":{"10":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"27":{"tf":1.0}}}}}},"t":{"df":0,"docs":{},"t":{"a":{"c":{"df":0,"docs":{},"h":{"df":1,"docs":{"39":{"tf":1.0}}},"k":{"df":1,"docs":{"13":{"tf":1.0}}}},"df":0,"docs":{}},"df":0,"docs":{}}},"u":{"d":{"df":0,"docs":{},"i":{"df":0,"docs":{},"t":{"df":1,"docs":{"0":{"tf":1.0}}}}},"df":0,"docs":{},"t":{"df":0,"docs":{},"h":{".":{"df":0,"docs":{},"e":{"df":0,"docs":{},"x":{"a":{"df":0,"docs":{},"m":{"df":0,"docs":{},"p":{"df":0,"docs":{},"l":{"df":0,"docs":{},"e":{".":{"c":{"df":0,"docs":{},"o":{"df":0,"docs":{},"m":{".":{"c":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"t":{".":{"df":0,"docs":{},"p":{"df":0,"docs":{},"e":{"df":0,"docs":{},"m":{"df":1,"docs":{"43":{"tf":1.0}}}}}},"df":0,"docs":{}}}}},"df":0,"docs":{},"k":{"df":0,"docs":{},"e":{"df":0,"docs":{},"y":{".":{"df":0,"docs":{},"p":{"df":0,"docs":{},"e":{"df":0,"docs":{},"m":{"df":1,"docs":{"43":{"tf":1.0}}}}}},"df":0,"docs":{}}}}},"df":2,"docs":{"26":{"tf":1.0},"43":{"tf":1.0}}}}},"df":0,"docs":{}},"df":0,"docs":{}}}}}},"df":0,"docs":{}}}},"/":{"df":0,"docs":{},"v":{"1":{"/":{"df":0,"docs":{},"h":{"df":0,"docs":{},"e":{"a":{"df":0,"docs":{},"l":{"df":0,"docs":{},"t":{"df":0,"docs":{},"h":{"df":1,"docs":{"13":{"tf":1.0}}}}}},"df":0,"docs":{}}},"p":{"df":1,"docs":{"13":{"tf":1.0}}}},"df":0,"docs":{}},"df":0,"docs":{}}},"df":1,"docs":{"48":{"tf":1.0}},"e":{"df":0,"docs":{},"n":{"df":0,"docs":{},"t":{"df":4,"docs":{"12":{"tf":1.0},"2":{"tf":2.0},"36":{"tf":1.0},"48":{"tf":1.4142135623730951}}}}},"n":{"df":1,"docs":{"39":{"tf":1.0}}},"o":{"df":0,"docs":{},"r":{"df":3,"docs":{"17":{"tf":1.0},"43":{"tf":1.0},"48":{"tf":1.4142135623730951}}}},"z":{"df":1,"docs":{"39":{"tf":1.0}}}},"o":{"df":0,"docs":{},"m":{"a":{"df":0,"docs":{},"t":{"df":3,"docs":{"29":{"tf":1.0},"34":{"tf":2.0},"48":{"tf":2.23606797749979}}}},"df":0,"docs":{}}}}},"v":{"a":{"df":0,"docs":{},"i":{"df":0,"docs":{},"l":{"df":10,"docs":{"1":{"tf":1.0},"11":{"tf":1.0},"13":{"tf":1.0},"26":{"tf":1.0},"27":{"tf":1.0},"36":{"tf":2.0},"43":{"tf":1.0},"48":{"tf":1.7320508075688772},"7":{"tf":1.0},"8":{"tf":1.0}}}}},"df":0,"docs":{},"o":{"df":0,"docs":{},"i":{"d":{"df":2,"docs":{"36":{"tf":1.0},"48":{"tf":1.0}}},"df":0,"docs":{}}}},"w":{"a":{"df":0,"docs":{},"y":{"df":1,"docs":{"1":{"tf":1.0}}}},"df":0,"docs":{}}},"b":{"a":{"c":{"df":0,"docs":{},"k":{"df":0,"docs":{},"e":{"df":0,"docs":{},"n":{"d":{"df":3,"docs":{"23":{"tf":1.0},"29":{"tf":1.0},"30":{"tf":1.0}}},"df":0,"docs":{}}},"u":{"df":0,"docs":{},"p":{"_":{"df":0,"docs":{},"n":{"a":{"df":0,"docs":{},"m":{"df":0,"docs":{},"e":{"=":{"\"":{"df":0,"docs":{},"r":{"a":{"df":0,"docs":{},"u":{"df":0,"docs":{},"t":{"df":0,"docs":{},"h":{"df":0,"docs":{},"i":{"df":2,"docs":{"34":{"tf":1.0},"48":{"tf":1.0}}}}}}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{}}}},"df":0,"docs":{}},"r":{"df":0,"docs":{},"e":{"df":0,"docs":{},"t":{"df":0,"docs":{},"e":{"df":0,"docs":{},"n":{"df":0,"docs":{},"t":{"df":0,"docs":{},"i":{"df":0,"docs":{},"o":{"df":0,"docs":{},"n":{"_":{"df":0,"docs":{},"l":{"df":0,"docs":{},"o":{"c":{"a":{"df":0,"docs":{},"l":{"=":{"2":{"4":{"df":1,"docs":{"34":{"tf":1.0}}},"df":0,"docs":{}},"7":{"2":{"0":{"df":1,"docs":{"48":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{}}}},"df":0,"docs":{}}}}}}}}}},"t":{"a":{"df":0,"docs":{},"s":{"df":0,"docs":{},"k":{"=":{"\"":{"0":{"df":2,"docs":{"34":{"tf":1.0},"48":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}},"df":0,"docs":{}}},"df":4,"docs":{"33":{"tf":1.0},"34":{"tf":3.4641016151377544},"35":{"tf":1.0},"48":{"tf":2.449489742783178}}}}}},"d":{"df":2,"docs":{"39":{"tf":1.0},"43":{"tf":1.0}}},"df":0,"docs":{},"s":{"df":0,"docs":{},"e":{"6":{"4":{"df":3,"docs":{"12":{"tf":2.449489742783178},"31":{"tf":1.4142135623730951},"40":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}},"h":{"df":1,"docs":{"43":{"tf":1.0}}},"i":{"c":{"df":6,"docs":{"2":{"tf":1.4142135623730951},"29":{"tf":1.0},"34":{"tf":1.0},"43":{"tf":1.4142135623730951},"48":{"tf":1.0},"6":{"tf":1.0}}},"df":0,"docs":{}}}},"df":0,"docs":{},"e":{"df":2,"docs":{"1":{"tf":1.7320508075688772},"23":{"tf":1.0}},"f":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"df":4,"docs":{"12":{"tf":1.0},"31":{"tf":1.0},"36":{"tf":1.0},"48":{"tf":1.0}}}}},"g":{"df":0,"docs":{},"e":{"df":1,"docs":{"24":{"tf":1.0}}}},"h":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"d":{"df":4,"docs":{"13":{"tf":1.0},"14":{"tf":1.0},"45":{"tf":1.0},"48":{"tf":1.7320508075688772}}},"df":0,"docs":{}}}},"l":{"df":0,"docs":{},"o":{"df":0,"docs":{},"w":{"df":3,"docs":{"2":{"tf":1.0},"48":{"tf":1.7320508075688772},"9":{"tf":1.0}}}}},"n":{"df":0,"docs":{},"e":{"df":0,"docs":{},"f":{"df":0,"docs":{},"i":{"df":0,"docs":{},"t":{"df":1,"docs":{"43":{"tf":1.0}}}}}}},"s":{"df":0,"docs":{},"t":{"df":3,"docs":{"24":{"tf":1.0},"29":{"tf":1.0},"36":{"tf":1.0}}}},"t":{"df":0,"docs":{},"t":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":5,"docs":{"13":{"tf":1.4142135623730951},"19":{"tf":1.0},"35":{"tf":1.0},"39":{"tf":1.0},"7":{"tf":1.0}}}}},"w":{"df":0,"docs":{},"e":{"df":0,"docs":{},"e":{"df":0,"docs":{},"n":{"df":5,"docs":{"1":{"tf":1.0},"32":{"tf":1.4142135623730951},"36":{"tf":1.0},"41":{"tf":1.7320508075688772},"48":{"tf":1.7320508075688772}}}}}}},"y":{"df":0,"docs":{},"o":{"df":0,"docs":{},"n":{"d":{"df":1,"docs":{"48":{"tf":1.0}}},"df":0,"docs":{}}}}},"i":{"df":0,"docs":{},"g":{"df":1,"docs":{"8":{"tf":1.0}},"g":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":1,"docs":{"7":{"tf":1.0}}}}}},"n":{"d":{"df":1,"docs":{"48":{"tf":1.0}}},"df":0,"docs":{}},"o":{"df":0,"docs":{},"m":{"df":0,"docs":{},"e":{"df":0,"docs":{},"t":{"df":0,"docs":{},"r":{"df":1,"docs":{"1":{"tf":1.0}}}}}}},"t":{"df":5,"docs":{"1":{"tf":1.0},"32":{"tf":1.0},"37":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0}}}},"l":{"df":0,"docs":{},"o":{"df":0,"docs":{},"w":{"df":0,"docs":{},"n":{"df":1,"docs":{"1":{"tf":1.0}}}}}},"o":{"df":0,"docs":{},"t":{"df":0,"docs":{},"h":{"df":2,"docs":{"47":{"tf":1.0},"48":{"tf":1.0}}}}},"r":{"a":{"df":0,"docs":{},"n":{"d":{"df":2,"docs":{"1":{"tf":1.7320508075688772},"3":{"tf":1.0}}},"df":0,"docs":{}}},"df":0,"docs":{},"e":{"a":{"df":0,"docs":{},"k":{"df":3,"docs":{"0":{"tf":1.0},"30":{"tf":1.0},"31":{"tf":1.0}}}},"df":0,"docs":{}},"o":{"df":0,"docs":{},"w":{"df":0,"docs":{},"s":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":3,"docs":{"1":{"tf":1.7320508075688772},"28":{"tf":1.0},"29":{"tf":1.4142135623730951}}}}}}}},"u":{"df":0,"docs":{},"f":{"df":0,"docs":{},"f":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":1,"docs":{"48":{"tf":1.7320508075688772}}}}}},"g":{"df":1,"docs":{"32":{"tf":1.0}}},"i":{"df":0,"docs":{},"l":{"d":{"_":{"c":{"a":{".":{"df":0,"docs":{},"s":{"df":0,"docs":{},"h":{"df":1,"docs":{"43":{"tf":1.0}}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{},"e":{"df":0,"docs":{},"n":{"d":{"_":{"df":0,"docs":{},"e":{"df":0,"docs":{},"n":{"df":0,"docs":{},"t":{"df":0,"docs":{},"i":{"df":0,"docs":{},"t":{"df":0,"docs":{},"y":{".":{"df":0,"docs":{},"s":{"df":0,"docs":{},"h":{"df":1,"docs":{"43":{"tf":1.4142135623730951}}}}},"df":0,"docs":{}}}}}}}},"df":0,"docs":{}},"df":0,"docs":{}}},"i":{"df":0,"docs":{},"n":{"df":0,"docs":{},"t":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"m":{"df":0,"docs":{},"e":{"d":{"df":0,"docs":{},"i":{"a":{"df":0,"docs":{},"t":{"df":0,"docs":{},"e":{".":{"df":0,"docs":{},"s":{"df":0,"docs":{},"h":{"df":1,"docs":{"43":{"tf":1.0}}}}},"df":0,"docs":{}}}},"df":0,"docs":{}}},"df":0,"docs":{}}}}}}}}},"df":0,"docs":{}},"df":0,"docs":{},"t":{"df":1,"docs":{"13":{"tf":1.0}}}}},"m":{"df":0,"docs":{},"p":{"df":1,"docs":{"29":{"tf":1.0}}}},"t":{"df":0,"docs":{},"t":{"df":0,"docs":{},"o":{"df":0,"docs":{},"n":{"df":1,"docs":{"29":{"tf":1.0}}}}}}}},"c":{"3":{"2":{"df":2,"docs":{"12":{"tf":1.0},"31":{"tf":1.0}}},"df":0,"docs":{}},"4":{"8":{"df":1,"docs":{"40":{"tf":1.0}}},"df":0,"docs":{}},"8":{")":{"/":{"$":{"(":{"c":{"a":{"df":0,"docs":{},"t":{"df":2,"docs":{"12":{"tf":1.0},"31":{"tf":1.0}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"a":{"c":{"df":0,"docs":{},"h":{"df":11,"docs":{"1":{"tf":2.449489742783178},"12":{"tf":1.0},"13":{"tf":1.4142135623730951},"36":{"tf":2.6457513110645907},"39":{"tf":2.8284271247461903},"41":{"tf":1.4142135623730951},"43":{"tf":1.4142135623730951},"45":{"tf":1.4142135623730951},"47":{"tf":1.7320508075688772},"48":{"tf":3.605551275463989},"9":{"tf":1.0}},"e":{"_":{"a":{"df":0,"docs":{},"u":{"df":0,"docs":{},"t":{"df":0,"docs":{},"h":{"_":{"df":0,"docs":{},"t":{"df":0,"docs":{},"o":{"df":0,"docs":{},"k":{"df":0,"docs":{},"e":{"df":0,"docs":{},"n":{"=":{"df":0,"docs":{},"s":{"df":0,"docs":{},"o":{"df":0,"docs":{},"m":{"df":0,"docs":{},"e":{"df":0,"docs":{},"s":{"df":0,"docs":{},"u":{"df":0,"docs":{},"p":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"s":{"df":0,"docs":{},"e":{"c":{"df":0,"docs":{},"r":{"df":0,"docs":{},"e":{"df":0,"docs":{},"t":{"a":{"df":0,"docs":{},"n":{"d":{"df":0,"docs":{},"v":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"y":{"df":0,"docs":{},"s":{"a":{"df":0,"docs":{},"f":{"df":0,"docs":{},"e":{"df":0,"docs":{},"t":{"df":0,"docs":{},"o":{"df":0,"docs":{},"k":{"df":0,"docs":{},"e":{"df":0,"docs":{},"n":{"1":{"3":{"3":{"7":{"df":1,"docs":{"48":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}}}}}},"df":0,"docs":{}}}}}}},"df":0,"docs":{}}},"df":0,"docs":{}}}}},"df":0,"docs":{}}}}}}}}}}}}},"df":2,"docs":{"12":{"tf":1.7320508075688772},"40":{"tf":1.4142135623730951}}}}}}}},"df":0,"docs":{}}}}},"b":{"df":0,"docs":{},"u":{"df":0,"docs":{},"f":{"_":{"c":{"df":0,"docs":{},"l":{"df":0,"docs":{},"i":{"df":1,"docs":{"48":{"tf":1.0}},"e":{"df":0,"docs":{},"n":{"df":0,"docs":{},"t":{"=":{"1":{"2":{"8":{"df":1,"docs":{"48":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}}}},"df":0,"docs":{},"s":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"v":{"df":1,"docs":{"48":{"tf":1.0}},"e":{"df":0,"docs":{},"r":{"=":{"1":{"2":{"8":{"df":1,"docs":{"48":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}}}}},"df":0,"docs":{}}}},"df":0,"docs":{},"e":{"df":0,"docs":{},"l":{"df":0,"docs":{},"e":{"c":{"df":0,"docs":{},"t":{"df":0,"docs":{},"i":{"df":0,"docs":{},"o":{"df":0,"docs":{},"n":{"_":{"df":0,"docs":{},"t":{"df":0,"docs":{},"i":{"df":0,"docs":{},"m":{"df":0,"docs":{},"e":{"df":0,"docs":{},"o":{"df":0,"docs":{},"u":{"df":0,"docs":{},"t":{"=":{"1":{"5":{"df":1,"docs":{"48":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}}}}}},"df":0,"docs":{}}}}}},"df":0,"docs":{}}}},"k":{"df":0,"docs":{},"e":{"df":0,"docs":{},"e":{"df":0,"docs":{},"p":{"a":{"df":0,"docs":{},"l":{"df":0,"docs":{},"i":{"df":0,"docs":{},"v":{"df":0,"docs":{},"e":{"_":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"df":0,"docs":{},"t":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"v":{"a":{"df":0,"docs":{},"l":{"=":{"5":{"df":1,"docs":{"48":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}}},"df":0,"docs":{}}}}}}},"t":{"df":0,"docs":{},"i":{"df":0,"docs":{},"m":{"df":0,"docs":{},"e":{"df":0,"docs":{},"o":{"df":0,"docs":{},"u":{"df":0,"docs":{},"t":{"=":{"5":{"df":1,"docs":{"48":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}}}}}}}}},"df":0,"docs":{}}}}}},"df":0,"docs":{}}}}},"r":{"df":0,"docs":{},"e":{"c":{"df":0,"docs":{},"o":{"df":0,"docs":{},"n":{"df":0,"docs":{},"n":{"df":0,"docs":{},"e":{"c":{"df":0,"docs":{},"t":{"_":{"df":0,"docs":{},"t":{"df":0,"docs":{},"i":{"df":0,"docs":{},"m":{"df":0,"docs":{},"e":{"df":0,"docs":{},"o":{"df":0,"docs":{},"u":{"df":0,"docs":{},"t":{"_":{"df":0,"docs":{},"l":{"df":0,"docs":{},"o":{"df":0,"docs":{},"w":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"=":{"2":{"5":{"0":{"0":{"df":1,"docs":{"48":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}}},"u":{"df":0,"docs":{},"p":{"df":0,"docs":{},"p":{"df":1,"docs":{"48":{"tf":1.0}},"e":{"df":0,"docs":{},"r":{"=":{"5":{"0":{"0":{"0":{"df":1,"docs":{"48":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}}}},"df":0,"docs":{}}}}}}}}},"df":0,"docs":{}}},"df":0,"docs":{}}}}}},"df":0,"docs":{}}},"t":{"df":0,"docs":{},"l":{"df":0,"docs":{},"s":{"=":{"df":0,"docs":{},"f":{"a":{"df":0,"docs":{},"l":{"df":0,"docs":{},"s":{"df":1,"docs":{"41":{"tf":1.0}}}}},"df":0,"docs":{}},"t":{"df":0,"docs":{},"r":{"df":0,"docs":{},"u":{"df":2,"docs":{"45":{"tf":1.0},"48":{"tf":1.0}}}}}},"_":{"c":{"a":{"_":{"c":{"df":0,"docs":{},"l":{"df":0,"docs":{},"i":{"df":0,"docs":{},"e":{"df":0,"docs":{},"n":{"df":0,"docs":{},"t":{"=":{"df":0,"docs":{},"t":{"df":0,"docs":{},"l":{"df":0,"docs":{},"s":{"/":{"c":{"a":{"df":2,"docs":{"45":{"tf":1.0},"48":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}},"df":0,"docs":{}}}}}}},"df":0,"docs":{},"s":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"v":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"=":{"df":0,"docs":{},"t":{"df":0,"docs":{},"l":{"df":0,"docs":{},"s":{"/":{"c":{"a":{"df":2,"docs":{"45":{"tf":1.0},"48":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}},"df":0,"docs":{}}}}}}}},"df":0,"docs":{}},"df":0,"docs":{},"l":{"df":0,"docs":{},"i":{"df":0,"docs":{},"e":{"df":0,"docs":{},"n":{"df":0,"docs":{},"t":{"_":{"c":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"t":{"=":{"df":0,"docs":{},"t":{"df":0,"docs":{},"l":{"df":0,"docs":{},"s":{"/":{"df":0,"docs":{},"r":{"df":0,"docs":{},"e":{"d":{"df":0,"docs":{},"h":{"a":{"c":{".":{"df":0,"docs":{},"l":{"df":0,"docs":{},"o":{"c":{"a":{"df":0,"docs":{},"l":{".":{"c":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"t":{".":{"df":0,"docs":{},"p":{"df":0,"docs":{},"e":{"df":0,"docs":{},"m":{"df":2,"docs":{"45":{"tf":1.0},"48":{"tf":1.0}}}}}},"df":0,"docs":{}}}}},"df":0,"docs":{}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}},"df":0,"docs":{}}}},"df":0,"docs":{}}}}},"df":0,"docs":{}}}}},"df":0,"docs":{},"k":{"df":0,"docs":{},"e":{"df":0,"docs":{},"y":{"=":{"df":0,"docs":{},"t":{"df":0,"docs":{},"l":{"df":0,"docs":{},"s":{"/":{"df":0,"docs":{},"r":{"df":0,"docs":{},"e":{"d":{"df":0,"docs":{},"h":{"a":{"c":{".":{"df":0,"docs":{},"l":{"df":0,"docs":{},"o":{"c":{"a":{"df":0,"docs":{},"l":{".":{"df":0,"docs":{},"k":{"df":0,"docs":{},"e":{"df":0,"docs":{},"y":{".":{"df":0,"docs":{},"p":{"df":0,"docs":{},"e":{"df":0,"docs":{},"m":{"df":2,"docs":{"45":{"tf":1.0},"48":{"tf":1.0}}}}}},"df":0,"docs":{}}}}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}},"df":0,"docs":{}}}},"df":0,"docs":{}}}}},"df":0,"docs":{}}}},"v":{"a":{"df":0,"docs":{},"l":{"df":0,"docs":{},"i":{"d":{"a":{"df":0,"docs":{},"t":{"df":0,"docs":{},"e":{"_":{"d":{"df":0,"docs":{},"o":{"df":0,"docs":{},"m":{"a":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"=":{"df":0,"docs":{},"r":{"df":0,"docs":{},"e":{"d":{"df":0,"docs":{},"h":{"a":{"c":{".":{"df":0,"docs":{},"l":{"df":0,"docs":{},"o":{"c":{"df":2,"docs":{"45":{"tf":1.0},"48":{"tf":1.0}}},"df":0,"docs":{}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}},"df":0,"docs":{}}}},"df":0,"docs":{}}}},"df":0,"docs":{}}}},"df":0,"docs":{}},"df":0,"docs":{}}}},"df":0,"docs":{}},"df":0,"docs":{}}}},"df":0,"docs":{}}},"df":0,"docs":{}}}}}}},"df":0,"docs":{},"s":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"v":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"_":{"c":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"t":{"=":{"df":0,"docs":{},"t":{"df":0,"docs":{},"l":{"df":0,"docs":{},"s":{"/":{"df":0,"docs":{},"r":{"df":0,"docs":{},"e":{"d":{"df":0,"docs":{},"h":{"a":{"c":{".":{"df":0,"docs":{},"l":{"df":0,"docs":{},"o":{"c":{"a":{"df":0,"docs":{},"l":{".":{"c":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"t":{".":{"df":0,"docs":{},"p":{"df":0,"docs":{},"e":{"df":0,"docs":{},"m":{"df":2,"docs":{"45":{"tf":1.0},"48":{"tf":1.0}}}}}},"df":0,"docs":{}}}}},"df":0,"docs":{}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}},"df":0,"docs":{}}}},"df":0,"docs":{}}}}},"df":0,"docs":{}}}}},"df":0,"docs":{},"k":{"df":0,"docs":{},"e":{"df":0,"docs":{},"y":{"=":{"df":0,"docs":{},"t":{"df":0,"docs":{},"l":{"df":0,"docs":{},"s":{"/":{"df":0,"docs":{},"r":{"df":0,"docs":{},"e":{"d":{"df":0,"docs":{},"h":{"a":{"c":{".":{"df":0,"docs":{},"l":{"df":0,"docs":{},"o":{"c":{"a":{"df":0,"docs":{},"l":{".":{"df":0,"docs":{},"k":{"df":0,"docs":{},"e":{"df":0,"docs":{},"y":{".":{"df":0,"docs":{},"p":{"df":0,"docs":{},"e":{"df":0,"docs":{},"m":{"df":2,"docs":{"45":{"tf":1.0},"48":{"tf":1.0}}}}}},"df":0,"docs":{}}}}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}},"df":0,"docs":{}}}},"df":0,"docs":{}}}}},"df":0,"docs":{}}}}},"df":0,"docs":{}}}}}},"n":{"df":0,"docs":{},"i":{"_":{"df":0,"docs":{},"o":{"df":0,"docs":{},"v":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"w":{"df":0,"docs":{},"r":{"df":0,"docs":{},"i":{"df":0,"docs":{},"t":{"df":2,"docs":{"45":{"tf":1.0},"48":{"tf":1.0}}}}}}}}}}},"df":0,"docs":{}}}}},"df":0,"docs":{}}}}},"df":0,"docs":{}}}},"df":5,"docs":{"17":{"tf":1.0},"43":{"tf":3.1622776601683795},"45":{"tf":1.4142135623730951},"47":{"tf":2.449489742783178},"48":{"tf":1.4142135623730951}},"l":{"c":{"df":0,"docs":{},"u":{"df":0,"docs":{},"l":{"df":1,"docs":{"48":{"tf":1.0}}}}},"df":0,"docs":{},"l":{"df":5,"docs":{"1":{"tf":1.0},"11":{"tf":1.0},"23":{"tf":1.0},"36":{"tf":1.4142135623730951},"39":{"tf":1.0}}}},"p":{"a":{"b":{"df":0,"docs":{},"l":{"df":1,"docs":{"36":{"tf":1.0}}}},"df":0,"docs":{}},"df":0,"docs":{}},"r":{"d":{"df":1,"docs":{"1":{"tf":1.0}}},"df":0,"docs":{},"e":{"df":7,"docs":{"1":{"tf":1.4142135623730951},"13":{"tf":1.0},"23":{"tf":1.0},"26":{"tf":1.0},"31":{"tf":1.0},"32":{"tf":1.0},"48":{"tf":1.0}},"f":{"df":0,"docs":{},"u":{"df":0,"docs":{},"l":{"df":0,"docs":{},"l":{"df":0,"docs":{},"i":{"df":1,"docs":{"13":{"tf":1.0}}}}}}}}},"s":{"df":0,"docs":{},"e":{"df":9,"docs":{"1":{"tf":1.4142135623730951},"10":{"tf":1.0},"13":{"tf":1.4142135623730951},"2":{"tf":1.0},"21":{"tf":1.0},"32":{"tf":1.0},"39":{"tf":1.0},"48":{"tf":2.0},"7":{"tf":1.0}}}},"t":{"df":3,"docs":{"12":{"tf":1.0},"31":{"tf":1.0},"40":{"tf":1.0}}},"u":{"df":0,"docs":{},"g":{"df":0,"docs":{},"h":{"df":0,"docs":{},"t":{"df":1,"docs":{"29":{"tf":1.0}}}}},"s":{"df":1,"docs":{"48":{"tf":1.0}}},"t":{"df":0,"docs":{},"i":{"df":0,"docs":{},"o":{"df":0,"docs":{},"n":{"df":6,"docs":{"0":{"tf":1.0},"11":{"tf":1.0},"26":{"tf":1.0},"27":{"tf":1.0},"31":{"tf":1.0},"48":{"tf":2.6457513110645907}}}}}}}},"d":{"df":1,"docs":{"11":{"tf":1.0}}},"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"t":{"=":{"\"":{".":{".":{"/":{"a":{"df":0,"docs":{},"u":{"df":0,"docs":{},"t":{"df":0,"docs":{},"h":{".":{"df":0,"docs":{},"e":{"df":0,"docs":{},"x":{"a":{"df":0,"docs":{},"m":{"df":0,"docs":{},"p":{"df":0,"docs":{},"l":{"df":0,"docs":{},"e":{".":{"c":{"df":0,"docs":{},"o":{"df":0,"docs":{},"m":{".":{"c":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"t":{".":{"df":0,"docs":{},"p":{"df":0,"docs":{},"e":{"df":0,"docs":{},"m":{"df":1,"docs":{"47":{"tf":1.0}}}}}},"df":0,"docs":{}}}}},"df":0,"docs":{}},"df":0,"docs":{}}}},"df":0,"docs":{}},"df":0,"docs":{}}}}}},"df":0,"docs":{}}}},"df":0,"docs":{}}}}},"df":0,"docs":{},"r":{"df":0,"docs":{},"e":{"d":{"df":0,"docs":{},"h":{"a":{"c":{".":{"df":0,"docs":{},"l":{"df":0,"docs":{},"o":{"c":{"a":{"df":0,"docs":{},"l":{".":{"c":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"t":{".":{"df":0,"docs":{},"p":{"df":0,"docs":{},"e":{"df":0,"docs":{},"m":{"df":1,"docs":{"47":{"tf":1.0}}}}}},"df":0,"docs":{}}}}},"df":0,"docs":{}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}},"df":0,"docs":{}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"a":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"df":1,"docs":{"1":{"tf":1.0}}}}},"df":1,"docs":{"17":{"tf":1.0}},"i":{"df":0,"docs":{},"f":{"df":8,"docs":{"17":{"tf":2.23606797749979},"41":{"tf":1.0},"42":{"tf":1.0},"43":{"tf":3.1622776601683795},"45":{"tf":3.605551275463989},"46":{"tf":1.0},"47":{"tf":1.0},"48":{"tf":3.1622776601683795}}}}}}},"h":{"a":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{".":{"c":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"t":{".":{"df":0,"docs":{},"p":{"df":0,"docs":{},"e":{"df":0,"docs":{},"m":{"df":2,"docs":{"45":{"tf":2.0},"48":{"tf":2.0}}}}}},"df":0,"docs":{}}}}},"df":0,"docs":{},"p":{"df":0,"docs":{},"e":{"df":0,"docs":{},"m":{"df":2,"docs":{"43":{"tf":1.0},"47":{"tf":1.0}}}}}},"df":2,"docs":{"45":{"tf":1.4142135623730951},"48":{"tf":1.4142135623730951}}}},"n":{"c":{"df":1,"docs":{"22":{"tf":1.0}}},"df":0,"docs":{},"g":{"df":11,"docs":{"0":{"tf":1.0},"1":{"tf":1.4142135623730951},"10":{"tf":1.0},"13":{"tf":1.0},"21":{"tf":1.0},"26":{"tf":1.0},"28":{"tf":1.0},"46":{"tf":1.0},"48":{"tf":1.4142135623730951},"6":{"tf":1.0},"7":{"tf":1.7320508075688772}}},"n":{"df":0,"docs":{},"e":{"df":0,"docs":{},"l":{"df":1,"docs":{"48":{"tf":1.0}}}}}},"p":{"df":0,"docs":{},"t":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":1,"docs":{"17":{"tf":1.0}}}}}},"r":{"a":{"c":{"df":0,"docs":{},"t":{"df":3,"docs":{"12":{"tf":1.4142135623730951},"43":{"tf":1.4142135623730951},"48":{"tf":1.7320508075688772}}}},"df":0,"docs":{}},"df":0,"docs":{},"t":{"df":1,"docs":{"8":{"tf":1.0}}}}},"df":0,"docs":{},"e":{"c":{"df":0,"docs":{},"k":{"df":2,"docs":{"25":{"tf":1.4142135623730951},"48":{"tf":1.0}}}},"df":0,"docs":{}},"i":{"c":{"df":0,"docs":{},"k":{"df":0,"docs":{},"e":{"df":0,"docs":{},"n":{"df":1,"docs":{"13":{"tf":1.0}}}}}},"df":0,"docs":{}},"m":{"df":0,"docs":{},"o":{"d":{"df":1,"docs":{"7":{"tf":2.0}}},"df":0,"docs":{}}},"o":{"df":0,"docs":{},"i":{"c":{"df":1,"docs":{"14":{"tf":1.0}}},"df":0,"docs":{}},"o":{"df":0,"docs":{},"s":{"df":1,"docs":{"1":{"tf":1.0}}}},"s":{"df":0,"docs":{},"e":{"df":0,"docs":{},"n":{"df":2,"docs":{"12":{"tf":1.0},"48":{"tf":1.4142135623730951}}}}},"w":{"df":0,"docs":{},"n":{"df":1,"docs":{"7":{"tf":1.0}}}}}},"l":{"df":0,"docs":{},"e":{"a":{"df":0,"docs":{},"n":{"df":4,"docs":{"2":{"tf":1.0},"34":{"tf":1.0},"43":{"tf":1.0},"48":{"tf":1.4142135623730951}}},"r":{"df":1,"docs":{"2":{"tf":1.0}}}},"df":0,"docs":{}},"i":{"c":{"df":0,"docs":{},"k":{"df":2,"docs":{"21":{"tf":1.0},"29":{"tf":1.0}}}},"df":0,"docs":{},"e":{"df":0,"docs":{},"n":{"df":0,"docs":{},"t":{"df":9,"docs":{"1":{"tf":2.8284271247461903},"2":{"tf":1.4142135623730951},"23":{"tf":1.4142135623730951},"28":{"tf":1.0},"31":{"tf":1.4142135623730951},"36":{"tf":1.0},"43":{"tf":1.0},"45":{"tf":2.6457513110645907},"48":{"tf":3.1622776601683795}}}}}},"o":{"df":0,"docs":{},"s":{"df":0,"docs":{},"e":{"df":2,"docs":{"13":{"tf":1.0},"32":{"tf":1.0}}}}}},"n":{"df":2,"docs":{"45":{"tf":1.0},"48":{"tf":1.0}}},"o":{"d":{"df":0,"docs":{},"e":{"df":3,"docs":{"2":{"tf":1.0},"36":{"tf":1.0},"48":{"tf":1.4142135623730951}}}},"df":0,"docs":{},"l":{"d":{"df":1,"docs":{"48":{"tf":1.0}}},"df":0,"docs":{},"l":{"df":0,"docs":{},"e":{"c":{"df":0,"docs":{},"t":{"df":1,"docs":{"13":{"tf":1.0}}}},"df":0,"docs":{}}},"o":{"df":0,"docs":{},"r":{"df":1,"docs":{"1":{"tf":1.0}}}}},"m":{"b":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"df":3,"docs":{"1":{"tf":1.0},"45":{"tf":1.0},"48":{"tf":1.0}}}}},"df":0,"docs":{},"e":{"df":4,"docs":{"0":{"tf":1.0},"1":{"tf":1.4142135623730951},"2":{"tf":1.7320508075688772},"36":{"tf":1.0}}},"m":{"a":{"df":0,"docs":{},"n":{"d":{"df":4,"docs":{"10":{"tf":1.0},"47":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":2.23606797749979}}},"df":0,"docs":{}}},"df":0,"docs":{},"o":{"df":0,"docs":{},"n":{"df":2,"docs":{"43":{"tf":1.0},"45":{"tf":1.0}}}},"u":{"df":0,"docs":{},"n":{"df":2,"docs":{"13":{"tf":1.0},"48":{"tf":1.0}}}}},"p":{"a":{"df":0,"docs":{},"t":{"df":1,"docs":{"1":{"tf":1.0}}}},"df":0,"docs":{},"l":{"df":0,"docs":{},"i":{"a":{"df":0,"docs":{},"n":{"df":0,"docs":{},"t":{"df":1,"docs":{"1":{"tf":1.0}}}}},"df":0,"docs":{}}},"o":{"df":0,"docs":{},"n":{"df":1,"docs":{"48":{"tf":1.0}}}},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"m":{"df":0,"docs":{},"i":{"df":0,"docs":{},"s":{"df":1,"docs":{"24":{"tf":1.0}}}}}}},"u":{"df":0,"docs":{},"t":{"df":1,"docs":{"24":{"tf":1.0}}}}}},"n":{"c":{"df":0,"docs":{},"u":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"df":1,"docs":{"48":{"tf":1.4142135623730951}}}}}},"d":{"df":0,"docs":{},"i":{"df":0,"docs":{},"t":{"df":1,"docs":{"48":{"tf":1.0}}}}},"df":0,"docs":{},"f":{"df":0,"docs":{},"i":{"df":0,"docs":{},"g":{".":{"df":0,"docs":{},"y":{"a":{"df":0,"docs":{},"m":{"df":0,"docs":{},"l":{"df":3,"docs":{"11":{"tf":1.0},"12":{"tf":1.0},"47":{"tf":1.0}}}}},"df":0,"docs":{}}},"df":21,"docs":{"1":{"tf":1.4142135623730951},"11":{"tf":3.0},"12":{"tf":1.0},"13":{"tf":1.7320508075688772},"17":{"tf":1.0},"22":{"tf":1.4142135623730951},"24":{"tf":1.7320508075688772},"25":{"tf":1.4142135623730951},"31":{"tf":1.0},"32":{"tf":1.4142135623730951},"37":{"tf":1.0},"39":{"tf":1.0},"42":{"tf":1.0},"44":{"tf":1.4142135623730951},"45":{"tf":1.0},"46":{"tf":1.0},"47":{"tf":1.4142135623730951},"48":{"tf":2.0},"6":{"tf":1.0},"7":{"tf":3.0},"9":{"tf":1.0}},"m":{"a":{"df":0,"docs":{},"p":{"df":2,"docs":{"11":{"tf":1.0},"13":{"tf":1.0}}}},"df":0,"docs":{}},"u":{"df":0,"docs":{},"r":{"df":13,"docs":{"1":{"tf":1.4142135623730951},"22":{"tf":1.0},"29":{"tf":1.0},"32":{"tf":1.0},"34":{"tf":1.0},"36":{"tf":1.0},"37":{"tf":1.4142135623730951},"39":{"tf":1.0},"45":{"tf":1.0},"46":{"tf":1.0},"47":{"tf":1.4142135623730951},"48":{"tf":1.7320508075688772},"7":{"tf":1.0}}}}}},"l":{"df":0,"docs":{},"i":{"c":{"df":0,"docs":{},"t":{"df":1,"docs":{"48":{"tf":1.0}}}},"df":0,"docs":{}}},"u":{"df":0,"docs":{},"s":{"df":1,"docs":{"2":{"tf":1.0}}}}},"n":{"df":0,"docs":{},"e":{"c":{"df":0,"docs":{},"t":{"df":8,"docs":{"1":{"tf":1.0},"32":{"tf":1.7320508075688772},"36":{"tf":1.0},"39":{"tf":1.0},"41":{"tf":1.0},"43":{"tf":1.0},"45":{"tf":1.4142135623730951},"48":{"tf":2.23606797749979}}}},"df":0,"docs":{}}},"s":{"df":0,"docs":{},"o":{"df":0,"docs":{},"l":{"df":1,"docs":{"19":{"tf":1.0}}}},"t":{"df":0,"docs":{},"r":{"a":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"df":1,"docs":{"24":{"tf":1.0}}}}},"df":0,"docs":{}}}},"t":{"a":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"df":11,"docs":{"11":{"tf":1.0},"12":{"tf":1.4142135623730951},"13":{"tf":2.0},"21":{"tf":1.0},"27":{"tf":1.0},"30":{"tf":1.0},"34":{"tf":1.4142135623730951},"44":{"tf":1.0},"48":{"tf":1.4142135623730951},"6":{"tf":2.449489742783178},"7":{"tf":1.7320508075688772}},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"p":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"df":0,"docs":{},"t":{"df":1,"docs":{"13":{"tf":1.7320508075688772}}}}}}}}}}},"df":0,"docs":{},"e":{"df":0,"docs":{},"n":{"df":0,"docs":{},"t":{"df":3,"docs":{"12":{"tf":1.0},"13":{"tf":1.4142135623730951},"14":{"tf":1.0}}}}},"r":{"df":0,"docs":{},"i":{"b":{"df":0,"docs":{},"u":{"df":0,"docs":{},"t":{"df":1,"docs":{"3":{"tf":1.0}}}}},"df":0,"docs":{}}}}},"o":{"df":0,"docs":{},"k":{"df":0,"docs":{},"i":{"df":4,"docs":{"1":{"tf":1.0},"29":{"tf":1.7320508075688772},"31":{"tf":1.7320508075688772},"48":{"tf":1.7320508075688772}}}}},"p":{"df":0,"docs":{},"i":{"df":2,"docs":{"21":{"tf":1.0},"7":{"tf":1.0}}}},"r":{"df":0,"docs":{},"e":{"df":1,"docs":{"48":{"tf":1.0}}},"r":{"df":0,"docs":{},"e":{"c":{"df":0,"docs":{},"t":{"df":3,"docs":{"12":{"tf":1.0},"13":{"tf":1.4142135623730951},"27":{"tf":1.0}},"l":{"df":0,"docs":{},"i":{"df":3,"docs":{"1":{"tf":1.0},"22":{"tf":1.0},"25":{"tf":1.0}}}}}},"df":0,"docs":{}}}},"s":{"df":0,"docs":{},"t":{"df":0,"docs":{},"l":{"df":0,"docs":{},"i":{"df":1,"docs":{"13":{"tf":1.0}}}}}},"u":{"df":0,"docs":{},"n":{"df":0,"docs":{},"t":{"df":1,"docs":{"48":{"tf":1.0}}}},"r":{"df":0,"docs":{},"s":{"df":2,"docs":{"1":{"tf":1.0},"17":{"tf":1.0}}}}}},"p":{"df":0,"docs":{},"u":{"df":1,"docs":{"13":{"tf":2.0}}}},"r":{"a":{"df":0,"docs":{},"s":{"df":0,"docs":{},"h":{"df":2,"docs":{"13":{"tf":1.0},"24":{"tf":1.0}}}},"t":{"df":0,"docs":{},"e":{"df":1,"docs":{"36":{"tf":1.4142135623730951}}}}},"d":{"df":1,"docs":{"14":{"tf":1.0}}},"df":0,"docs":{},"e":{"a":{"df":0,"docs":{},"t":{"df":16,"docs":{"1":{"tf":1.4142135623730951},"10":{"tf":1.4142135623730951},"11":{"tf":1.4142135623730951},"12":{"tf":1.4142135623730951},"13":{"tf":1.0},"14":{"tf":1.0},"19":{"tf":1.0},"36":{"tf":1.7320508075688772},"40":{"tf":1.0},"41":{"tf":1.0},"43":{"tf":1.0},"45":{"tf":1.0},"47":{"tf":2.23606797749979},"48":{"tf":1.4142135623730951},"7":{"tf":2.0},"9":{"tf":2.0}},"i":{"df":0,"docs":{},"o":{"df":0,"docs":{},"n":{"df":1,"docs":{"13":{"tf":1.0}}}}}}},"d":{"df":0,"docs":{},"e":{"df":0,"docs":{},"n":{"df":0,"docs":{},"t":{"df":0,"docs":{},"i":{"df":1,"docs":{"48":{"tf":1.7320508075688772}}}}}}},"df":0,"docs":{}},"i":{"df":0,"docs":{},"t":{"df":0,"docs":{},"i":{"c":{"df":1,"docs":{"48":{"tf":1.0}}},"df":0,"docs":{}}}},"o":{"df":0,"docs":{},"n":{"df":2,"docs":{"34":{"tf":1.0},"48":{"tf":1.0}}}}},"s":{"df":0,"docs":{},"r":{"df":0,"docs":{},"f":{"df":1,"docs":{"48":{"tf":1.0}}}},"s":{"df":1,"docs":{"48":{"tf":1.0}}},"v":{"df":1,"docs":{"48":{"tf":1.0}}}},"u":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"df":0,"docs":{},"e":{"df":0,"docs":{},"n":{"df":0,"docs":{},"t":{"df":7,"docs":{"0":{"tf":1.0},"2":{"tf":1.7320508075688772},"30":{"tf":1.0},"31":{"tf":2.0},"32":{"tf":1.0},"34":{"tf":1.0},"48":{"tf":1.4142135623730951}}}}}}},"s":{"df":0,"docs":{},"t":{"df":0,"docs":{},"o":{"df":0,"docs":{},"m":{"df":4,"docs":{"1":{"tf":1.0},"22":{"tf":1.4142135623730951},"48":{"tf":1.0},"7":{"tf":1.0}},"i":{"df":0,"docs":{},"z":{"df":2,"docs":{"2":{"tf":1.0},"3":{"tf":1.4142135623730951}}}}}}}},"t":{"df":1,"docs":{"12":{"tf":1.0}}}}},"d":{"a":{"df":0,"docs":{},"n":{"df":0,"docs":{},"g":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":1,"docs":{"32":{"tf":1.0}}}}}},"t":{"a":{"b":{"a":{"df":0,"docs":{},"s":{"df":11,"docs":{"1":{"tf":1.0},"12":{"tf":1.0},"19":{"tf":1.0},"2":{"tf":1.0},"21":{"tf":1.0},"32":{"tf":2.449489742783178},"34":{"tf":2.0},"35":{"tf":1.0},"48":{"tf":2.449489742783178},"6":{"tf":1.4142135623730951},"7":{"tf":1.7320508075688772}},"e":{"_":{"df":0,"docs":{},"m":{"a":{"df":0,"docs":{},"x":{"_":{"c":{"df":0,"docs":{},"o":{"df":0,"docs":{},"n":{"df":0,"docs":{},"n":{"=":{"5":{"df":1,"docs":{"48":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}}}}},"df":0,"docs":{}},"df":0,"docs":{}}},"df":0,"docs":{}},"u":{"df":0,"docs":{},"r":{"df":0,"docs":{},"l":{"=":{"df":0,"docs":{},"p":{"df":0,"docs":{},"o":{"df":0,"docs":{},"s":{"df":0,"docs":{},"t":{"df":0,"docs":{},"g":{"df":0,"docs":{},"r":{"df":0,"docs":{},"e":{"df":0,"docs":{},"s":{"df":0,"docs":{},"q":{"df":0,"docs":{},"l":{":":{"/":{"/":{"df":0,"docs":{},"r":{"a":{"df":0,"docs":{},"u":{"df":0,"docs":{},"t":{"df":0,"docs":{},"h":{"df":0,"docs":{},"y":{":":{"1":{"2":{"3":{"df":0,"docs":{},"s":{"df":0,"docs":{},"u":{"df":0,"docs":{},"p":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"s":{"a":{"df":0,"docs":{},"f":{"df":0,"docs":{},"e":{"@":{"df":0,"docs":{},"l":{"df":0,"docs":{},"o":{"c":{"a":{"df":0,"docs":{},"l":{"df":0,"docs":{},"h":{"df":0,"docs":{},"o":{"df":0,"docs":{},"s":{"df":0,"docs":{},"t":{":":{"5":{"4":{"3":{"2":{"/":{"df":0,"docs":{},"r":{"a":{"df":0,"docs":{},"u":{"df":0,"docs":{},"t":{"df":0,"docs":{},"h":{"df":0,"docs":{},"i":{"df":1,"docs":{"48":{"tf":1.0}}}}}}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}}}},"df":0,"docs":{}},"df":0,"docs":{}}}},"df":0,"docs":{}}}},"df":0,"docs":{}}}}}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}}}}}}}},"s":{"df":0,"docs":{},"q":{"df":0,"docs":{},"l":{"df":0,"docs":{},"i":{"df":0,"docs":{},"t":{"df":0,"docs":{},"e":{":":{":":{"df":0,"docs":{},"m":{"df":0,"docs":{},"e":{"df":0,"docs":{},"m":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"df":0,"docs":{},"i":{"df":1,"docs":{"48":{"tf":1.0}}}}}}}}},"d":{"a":{"df":0,"docs":{},"t":{"a":{"/":{"df":0,"docs":{},"r":{"a":{"df":0,"docs":{},"u":{"df":0,"docs":{},"t":{"df":0,"docs":{},"h":{"df":0,"docs":{},"y":{".":{"d":{"b":{"df":2,"docs":{"48":{"tf":1.0},"6":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}}}}},"df":5,"docs":{"11":{"tf":1.0},"12":{"tf":1.7320508075688772},"13":{"tf":1.4142135623730951},"32":{"tf":1.7320508075688772},"48":{"tf":1.4142135623730951}}}}}},"df":0,"docs":{}}}},"df":0,"docs":{}},"df":11,"docs":{"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.4142135623730951},"19":{"tf":1.0},"30":{"tf":1.0},"31":{"tf":1.4142135623730951},"32":{"tf":1.7320508075688772},"34":{"tf":1.4142135623730951},"48":{"tf":1.7320508075688772},"6":{"tf":1.4142135623730951},"7":{"tf":1.0}}},"df":0,"docs":{}},"y":{"_":{"df":0,"docs":{},"o":{"df":0,"docs":{},"f":{"_":{"df":0,"docs":{},"m":{"df":0,"docs":{},"o":{"df":0,"docs":{},"n":{"df":0,"docs":{},"t":{"df":0,"docs":{},"h":{"df":2,"docs":{"34":{"tf":1.0},"48":{"tf":1.0}}}}}}},"w":{"df":0,"docs":{},"e":{"df":0,"docs":{},"e":{"df":0,"docs":{},"k":{"df":2,"docs":{"34":{"tf":1.0},"48":{"tf":1.0}}}}}}},"df":0,"docs":{}}}},"df":0,"docs":{}}},"b":{"df":3,"docs":{"39":{"tf":1.0},"48":{"tf":1.4142135623730951},"7":{"tf":1.0}}},"c":{"df":3,"docs":{"12":{"tf":1.4142135623730951},"31":{"tf":1.4142135623730951},"40":{"tf":1.0}}},"d":{"df":0,"docs":{},"o":{"df":1,"docs":{"13":{"tf":1.0}}}},"df":3,"docs":{"12":{"tf":1.4142135623730951},"6":{"tf":1.0},"7":{"tf":1.0}},"e":{"a":{"c":{"df":0,"docs":{},"t":{"df":0,"docs":{},"i":{"df":0,"docs":{},"v":{"df":1,"docs":{"1":{"tf":1.0}}}}}},"df":0,"docs":{},"l":{"df":1,"docs":{"8":{"tf":1.0}}}},"b":{"df":0,"docs":{},"u":{"df":0,"docs":{},"g":{"df":2,"docs":{"22":{"tf":1.0},"48":{"tf":2.0}}}}},"c":{"df":0,"docs":{},"i":{"d":{"df":1,"docs":{"13":{"tf":1.7320508075688772}}},"df":0,"docs":{}},"r":{"df":0,"docs":{},"y":{"df":0,"docs":{},"p":{"df":0,"docs":{},"t":{"df":1,"docs":{"30":{"tf":1.0}}}}}}},"d":{"df":0,"docs":{},"i":{"c":{"df":1,"docs":{"43":{"tf":1.0}}},"df":0,"docs":{}}},"df":0,"docs":{},"f":{"a":{"df":0,"docs":{},"u":{"df":0,"docs":{},"l":{"df":0,"docs":{},"t":{"df":16,"docs":{"1":{"tf":2.0},"19":{"tf":1.0},"21":{"tf":1.0},"23":{"tf":1.0},"24":{"tf":1.4142135623730951},"27":{"tf":1.0},"29":{"tf":1.0},"30":{"tf":1.0},"34":{"tf":2.0},"36":{"tf":1.0},"41":{"tf":1.4142135623730951},"45":{"tf":3.0},"46":{"tf":1.7320508075688772},"48":{"tf":7.280109889280518},"6":{"tf":1.0},"7":{"tf":1.4142135623730951}}}}}},"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"df":2,"docs":{"30":{"tf":1.4142135623730951},"48":{"tf":1.4142135623730951}}}}},"g":{"df":0,"docs":{},"r":{"a":{"d":{"df":1,"docs":{"36":{"tf":1.4142135623730951}}},"df":0,"docs":{}},"df":0,"docs":{}}},"l":{"df":0,"docs":{},"e":{"df":0,"docs":{},"t":{"df":4,"docs":{"21":{"tf":1.0},"23":{"tf":1.0},"48":{"tf":1.0},"6":{"tf":1.4142135623730951}}}}},"p":{"df":0,"docs":{},"e":{"df":0,"docs":{},"n":{"d":{"df":4,"docs":{"12":{"tf":1.0},"13":{"tf":1.0},"28":{"tf":1.0},"48":{"tf":1.4142135623730951}}},"df":0,"docs":{}}},"l":{"df":0,"docs":{},"o":{"df":0,"docs":{},"y":{"df":14,"docs":{"1":{"tf":1.0},"10":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"15":{"tf":1.7320508075688772},"2":{"tf":1.0},"21":{"tf":1.0},"24":{"tf":2.23606797749979},"32":{"tf":1.0},"37":{"tf":1.4142135623730951},"39":{"tf":2.0},"48":{"tf":2.0},"9":{"tf":1.7320508075688772}}}}},"r":{"df":0,"docs":{},"e":{"c":{"df":1,"docs":{"2":{"tf":1.0}}},"df":0,"docs":{}}},"t":{"df":0,"docs":{},"h":{"df":2,"docs":{"6":{"tf":1.0},"7":{"tf":1.0}}}}},"r":{"df":2,"docs":{"46":{"tf":1.4142135623730951},"48":{"tf":1.4142135623730951}}},"s":{"c":{"df":0,"docs":{},"r":{"df":0,"docs":{},"i":{"b":{"df":4,"docs":{"24":{"tf":1.0},"39":{"tf":1.0},"48":{"tf":1.0},"9":{"tf":1.0}}},"df":0,"docs":{}}}},"df":0,"docs":{},"i":{"df":0,"docs":{},"g":{"df":0,"docs":{},"n":{"df":1,"docs":{"1":{"tf":1.0}}}}}},"t":{"a":{"df":0,"docs":{},"i":{"df":0,"docs":{},"l":{"df":2,"docs":{"13":{"tf":1.0},"32":{"tf":1.0}}}}},"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"m":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"df":1,"docs":{"48":{"tf":1.0}}}}}}}},"v":{"/":{"df":0,"docs":{},"u":{"df":0,"docs":{},"r":{"a":{"df":0,"docs":{},"n":{"d":{"df":0,"docs":{},"o":{"df":0,"docs":{},"m":{"df":3,"docs":{"12":{"tf":1.4142135623730951},"31":{"tf":1.4142135623730951},"40":{"tf":1.0}}}}},"df":0,"docs":{}}},"df":0,"docs":{}}}},"df":0,"docs":{},"i":{"c":{"df":4,"docs":{"1":{"tf":1.0},"26":{"tf":1.0},"29":{"tf":1.7320508075688772},"48":{"tf":1.4142135623730951}}},"df":0,"docs":{}}}},"i":{"a":{"df":0,"docs":{},"l":{"df":0,"docs":{},"e":{"c":{"df":0,"docs":{},"t":{"df":1,"docs":{"2":{"tf":1.0}}}},"df":0,"docs":{}}}},"df":0,"docs":{},"f":{"df":0,"docs":{},"f":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":9,"docs":{"2":{"tf":1.0},"32":{"tf":1.0},"34":{"tf":1.4142135623730951},"36":{"tf":1.7320508075688772},"39":{"tf":1.0},"45":{"tf":1.4142135623730951},"48":{"tf":1.4142135623730951},"7":{"tf":1.0},"9":{"tf":1.0}}}}}},"g":{"df":0,"docs":{},"e":{"df":0,"docs":{},"s":{"df":0,"docs":{},"t":{"df":1,"docs":{"13":{"tf":1.0}}}}}},"r":{"df":0,"docs":{},"e":{"c":{"df":0,"docs":{},"t":{"df":3,"docs":{"13":{"tf":1.0},"23":{"tf":1.0},"36":{"tf":1.0}},"l":{"df":0,"docs":{},"i":{"df":5,"docs":{"13":{"tf":1.0},"21":{"tf":1.0},"36":{"tf":1.0},"42":{"tf":1.0},"7":{"tf":1.0}}}},"o":{"df":0,"docs":{},"r":{"df":0,"docs":{},"i":{"df":1,"docs":{"7":{"tf":2.23606797749979}}}}}}},"df":0,"docs":{}}},"s":{"a":{"b":{"df":0,"docs":{},"l":{"df":3,"docs":{"22":{"tf":1.0},"41":{"tf":1.0},"48":{"tf":1.7320508075688772}}}},"df":0,"docs":{}},"df":0,"docs":{},"k":{"df":3,"docs":{"34":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0}}},"t":{"df":0,"docs":{},"r":{"df":0,"docs":{},"i":{"b":{"df":0,"docs":{},"u":{"df":0,"docs":{},"t":{"df":1,"docs":{"1":{"tf":1.0}}}}},"df":0,"docs":{}}}}}},"o":{"c":{"df":0,"docs":{},"k":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":8,"docs":{"17":{"tf":1.0},"20":{"tf":1.4142135623730951},"39":{"tf":1.0},"4":{"tf":1.0},"48":{"tf":1.0},"5":{"tf":1.0},"6":{"tf":2.449489742783178},"7":{"tf":1.0}}}}},"u":{"df":0,"docs":{},"m":{"df":0,"docs":{},"e":{"df":0,"docs":{},"n":{"df":0,"docs":{},"t":{"df":5,"docs":{"10":{"tf":1.0},"11":{"tf":1.0},"13":{"tf":1.0},"24":{"tf":1.0},"7":{"tf":1.0}}}}}}}},"df":1,"docs":{"24":{"tf":1.0}},"m":{"a":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{".":{"c":{"df":0,"docs":{},"o":{"df":0,"docs":{},"m":{"df":1,"docs":{"48":{"tf":1.0}}}}},"df":0,"docs":{}},"df":5,"docs":{"26":{"tf":1.0},"27":{"tf":1.0},"43":{"tf":1.0},"45":{"tf":1.4142135623730951},"48":{"tf":2.23606797749979}}}}},"df":0,"docs":{}},"n":{"df":0,"docs":{},"e":{"df":6,"docs":{"24":{"tf":1.0},"31":{"tf":1.0},"32":{"tf":1.0},"34":{"tf":1.0},"48":{"tf":1.4142135623730951},"7":{"tf":1.0}}}},"w":{"df":0,"docs":{},"n":{"df":0,"docs":{},"g":{"df":0,"docs":{},"r":{"a":{"d":{"df":1,"docs":{"29":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}}}}}},"r":{"df":0,"docs":{},"i":{"df":0,"docs":{},"v":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":2,"docs":{"12":{"tf":1.0},"48":{"tf":1.0}}}}}}},"u":{"df":0,"docs":{},"r":{"a":{"df":0,"docs":{},"t":{"df":1,"docs":{"48":{"tf":1.0}}}},"df":0,"docs":{},"e":{"df":3,"docs":{"13":{"tf":1.4142135623730951},"31":{"tf":1.0},"43":{"tf":1.0}}}}},"y":{"df":0,"docs":{},"n":{"a":{"df":0,"docs":{},"m":{"df":1,"docs":{"1":{"tf":1.0}}}},"df":0,"docs":{}}}},"df":0,"docs":{},"e":{"a":{"c":{"df":0,"docs":{},"h":{"df":4,"docs":{"1":{"tf":1.4142135623730951},"36":{"tf":1.7320508075688772},"39":{"tf":1.0},"48":{"tf":2.23606797749979}}}},"df":0,"docs":{},"r":{"df":0,"docs":{},"l":{"df":0,"docs":{},"i":{"df":1,"docs":{"7":{"tf":1.0}}}}},"s":{"df":0,"docs":{},"i":{"df":4,"docs":{"14":{"tf":1.0},"17":{"tf":1.0},"38":{"tf":1.0},"39":{"tf":1.0}},"e":{"df":0,"docs":{},"r":{"df":2,"docs":{"12":{"tf":1.0},"32":{"tf":1.0}}},"s":{"df":0,"docs":{},"t":{"df":1,"docs":{"32":{"tf":1.0}}}}},"l":{"df":0,"docs":{},"i":{"df":5,"docs":{"1":{"tf":1.0},"12":{"tf":1.0},"32":{"tf":1.0},"34":{"tf":1.0},"6":{"tf":1.0}}}}}}},"c":{"df":0,"docs":{},"h":{"df":0,"docs":{},"o":{"df":4,"docs":{"11":{"tf":1.0},"12":{"tf":2.0},"31":{"tf":1.4142135623730951},"40":{"tf":1.0}}}}},"d":{"2":{"5":{"5":{"1":{"9":{"df":1,"docs":{"1":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{},"i":{"df":0,"docs":{},"t":{"df":2,"docs":{"21":{"tf":1.0},"7":{"tf":1.0}},"o":{"df":0,"docs":{},"r":{"df":1,"docs":{"11":{"tf":1.0}}}}}}},"df":7,"docs":{"12":{"tf":1.0},"2":{"tf":1.4142135623730951},"22":{"tf":1.4142135623730951},"29":{"tf":1.0},"48":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0}},"f":{"df":0,"docs":{},"f":{"df":0,"docs":{},"e":{"c":{"df":0,"docs":{},"t":{"df":3,"docs":{"26":{"tf":1.0},"27":{"tf":1.0},"48":{"tf":1.4142135623730951}}}},"df":0,"docs":{}},"i":{"c":{"df":0,"docs":{},"i":{"df":2,"docs":{"1":{"tf":1.7320508075688772},"3":{"tf":1.0}}}},"df":0,"docs":{}}}},"g":{"df":0,"docs":{},"g":{"df":1,"docs":{"13":{"tf":1.0}}}},"l":{"df":0,"docs":{},"e":{"c":{"df":0,"docs":{},"t":{"df":3,"docs":{"36":{"tf":1.0},"39":{"tf":1.4142135623730951},"48":{"tf":1.4142135623730951}}}},"df":0,"docs":{}},"i":{"df":0,"docs":{},"m":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"df":1,"docs":{"39":{"tf":1.0}}}}}}},"m":{"b":{"df":0,"docs":{},"e":{"d":{"df":2,"docs":{"1":{"tf":1.0},"36":{"tf":1.0}}},"df":0,"docs":{}}},"df":0,"docs":{},"p":{"df":0,"docs":{},"t":{"df":0,"docs":{},"i":{"df":3,"docs":{"19":{"tf":1.0},"45":{"tf":1.4142135623730951},"48":{"tf":1.4142135623730951}}}}}},"n":{"a":{"b":{"df":0,"docs":{},"l":{"df":3,"docs":{"45":{"tf":1.0},"48":{"tf":2.0},"9":{"tf":1.0}}}},"df":0,"docs":{}},"c":{"_":{"df":0,"docs":{},"k":{"df":0,"docs":{},"e":{"df":0,"docs":{},"y":{"_":{"a":{"c":{"df":0,"docs":{},"t":{"df":2,"docs":{"30":{"tf":1.4142135623730951},"31":{"tf":1.7320508075688772}},"i":{"df":0,"docs":{},"v":{"df":0,"docs":{},"e":{"=":{"b":{"df":0,"docs":{},"v":{"c":{"df":0,"docs":{},"y":{"df":0,"docs":{},"t":{"df":0,"docs":{},"s":{"df":0,"docs":{},"g":{"a":{"df":0,"docs":{},"g":{"df":0,"docs":{},"g":{"df":0,"docs":{},"v":{"df":0,"docs":{},"y":{"5":{"df":0,"docs":{},"y":{"df":0,"docs":{},"q":{"df":0,"docs":{},"q":{"df":1,"docs":{"48":{"tf":1.0}}}}}},"df":0,"docs":{}}}}}},"df":0,"docs":{}}}}}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{}}}}}},"df":0,"docs":{}},"df":0,"docs":{},"i":{"d":{"df":1,"docs":{"12":{"tf":1.4142135623730951}}},"df":0,"docs":{}}},"df":6,"docs":{"11":{"tf":1.0},"12":{"tf":2.0},"13":{"tf":1.4142135623730951},"30":{"tf":1.7320508075688772},"31":{"tf":2.0},"48":{"tf":1.0}},"s":{"=":{"\"":{"b":{"df":0,"docs":{},"v":{"c":{"df":0,"docs":{},"y":{"df":0,"docs":{},"t":{"df":0,"docs":{},"s":{"df":0,"docs":{},"g":{"a":{"df":0,"docs":{},"g":{"df":0,"docs":{},"g":{"df":0,"docs":{},"v":{"df":0,"docs":{},"y":{"5":{"df":0,"docs":{},"y":{"df":0,"docs":{},"q":{"df":0,"docs":{},"q":{"/":{"df":0,"docs":{},"s":{"9":{"df":0,"docs":{},"n":{"7":{"df":0,"docs":{},"o":{"c":{"df":0,"docs":{},"e":{"df":0,"docs":{},"n":{"5":{"3":{"df":0,"docs":{},"x":{"df":0,"docs":{},"s":{"df":0,"docs":{},"j":{"df":0,"docs":{},"l":{"df":0,"docs":{},"z":{"c":{"df":0,"docs":{},"s":{"df":0,"docs":{},"m":{"df":0,"docs":{},"f":{"d":{"df":0,"docs":{},"n":{"b":{"d":{"df":0,"docs":{},"v":{"df":0,"docs":{},"n":{"df":0,"docs":{},"r":{"df":0,"docs":{},"q":{"df":0,"docs":{},"q":{"6":{"3":{"df":0,"docs":{},"r":{"4":{"df":2,"docs":{"31":{"tf":1.0},"48":{"tf":1.0}}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{}}}}}}},"df":0,"docs":{}},"df":0,"docs":{}}},"df":0,"docs":{}}}}},"df":0,"docs":{}}}}}}},"df":0,"docs":{}},"df":0,"docs":{}}}},"df":0,"docs":{}}},"df":0,"docs":{}}},"df":0,"docs":{}}},"df":0,"docs":{}}}}},"df":0,"docs":{}}}}}},"df":0,"docs":{}}}}}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}}},"a":{"df":0,"docs":{},"p":{"df":0,"docs":{},"s":{"df":0,"docs":{},"u":{"df":0,"docs":{},"l":{"df":1,"docs":{"41":{"tf":1.0}}}}}}},"df":0,"docs":{},"o":{"d":{"df":2,"docs":{"12":{"tf":1.0},"31":{"tf":1.0}}},"df":0,"docs":{},"u":{"df":0,"docs":{},"n":{"df":0,"docs":{},"t":{"df":1,"docs":{"32":{"tf":1.0}}}}}},"r":{"df":0,"docs":{},"y":{"df":0,"docs":{},"p":{"df":0,"docs":{},"t":{"df":8,"docs":{"1":{"tf":1.0},"12":{"tf":1.0},"17":{"tf":1.0},"29":{"tf":1.4142135623730951},"30":{"tf":1.7320508075688772},"31":{"tf":2.8284271247461903},"41":{"tf":1.0},"48":{"tf":1.0}}}}}}},"d":{"df":3,"docs":{"43":{"tf":1.4142135623730951},"46":{"tf":1.0},"48":{"tf":1.0}},"p":{"df":0,"docs":{},"o":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"df":0,"docs":{},"t":{"df":1,"docs":{"48":{"tf":2.6457513110645907}}}}}}}},"df":0,"docs":{},"o":{"df":0,"docs":{},"u":{"df":0,"docs":{},"g":{"df":0,"docs":{},"h":{"df":2,"docs":{"13":{"tf":1.4142135623730951},"31":{"tf":1.0}}}}}},"t":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":2,"docs":{"43":{"tf":1.7320508075688772},"48":{"tf":1.0}}}},"i":{"df":0,"docs":{},"t":{"df":0,"docs":{},"i":{"df":1,"docs":{"43":{"tf":1.4142135623730951}}}}},"r":{"df":0,"docs":{},"i":{"df":2,"docs":{"21":{"tf":1.0},"39":{"tf":1.4142135623730951}}},"y":{"df":0,"docs":{},"p":{"df":0,"docs":{},"o":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"df":0,"docs":{},"t":{"df":2,"docs":{"14":{"tf":1.0},"17":{"tf":1.4142135623730951}}}}}}}}}},"v":{"df":1,"docs":{"13":{"tf":1.0}},"i":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"n":{"df":4,"docs":{"32":{"tf":1.0},"39":{"tf":1.0},"48":{"tf":1.4142135623730951},"7":{"tf":1.7320508075688772}},"m":{"df":1,"docs":{"32":{"tf":1.0}}}}}}}}},"r":{"a":{"df":0,"docs":{},"s":{"df":1,"docs":{"6":{"tf":1.0}}}},"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"df":2,"docs":{"43":{"tf":1.0},"48":{"tf":1.0}}}}}},"s":{"df":0,"docs":{},"p":{"df":0,"docs":{},"e":{"c":{"df":0,"docs":{},"i":{"df":3,"docs":{"24":{"tf":1.0},"39":{"tf":1.0},"48":{"tf":1.0}}}},"df":0,"docs":{}}}},"v":{"a":{"df":0,"docs":{},"l":{"df":0,"docs":{},"u":{"df":2,"docs":{"32":{"tf":1.0},"6":{"tf":1.0}}}}},"df":0,"docs":{},"e":{"df":0,"docs":{},"n":{"df":11,"docs":{"0":{"tf":1.0},"1":{"tf":2.0},"2":{"tf":1.4142135623730951},"24":{"tf":1.0},"27":{"tf":1.0},"29":{"tf":1.0},"31":{"tf":1.0},"36":{"tf":1.0},"39":{"tf":1.0},"48":{"tf":1.0},"7":{"tf":1.7320508075688772}}},"r":{"df":0,"docs":{},"y":{"df":0,"docs":{},"o":{"df":0,"docs":{},"n":{"df":1,"docs":{"7":{"tf":1.0}}}},"t":{"df":0,"docs":{},"h":{"df":1,"docs":{"7":{"tf":1.0}}}}}}},"i":{"c":{"df":0,"docs":{},"t":{"df":1,"docs":{"1":{"tf":1.4142135623730951}}}},"df":0,"docs":{}}},"x":{"a":{"c":{"df":0,"docs":{},"t":{"df":2,"docs":{"24":{"tf":1.4142135623730951},"48":{"tf":1.0}},"l":{"df":0,"docs":{},"i":{"df":2,"docs":{"12":{"tf":1.0},"48":{"tf":1.0}}}}}},"df":0,"docs":{},"m":{"df":0,"docs":{},"p":{"df":0,"docs":{},"l":{"df":9,"docs":{"1":{"tf":1.0},"12":{"tf":1.4142135623730951},"13":{"tf":1.7320508075688772},"14":{"tf":1.0},"17":{"tf":1.0},"26":{"tf":1.0},"27":{"tf":1.0},"29":{"tf":1.0},"48":{"tf":1.4142135623730951}}}}}},"c":{"df":0,"docs":{},"e":{"df":2,"docs":{"24":{"tf":1.0},"48":{"tf":1.0}}}},"df":0,"docs":{},"e":{"c":{"df":0,"docs":{},"u":{"df":0,"docs":{},"t":{"df":6,"docs":{"23":{"tf":1.0},"31":{"tf":1.0},"36":{"tf":1.0},"43":{"tf":1.7320508075688772},"6":{"tf":1.0},"7":{"tf":1.0}}}}},"df":0,"docs":{}},"i":{"df":0,"docs":{},"s":{"df":0,"docs":{},"t":{"df":8,"docs":{"1":{"tf":1.0},"17":{"tf":1.0},"2":{"tf":1.4142135623730951},"3":{"tf":1.7320508075688772},"30":{"tf":1.0},"31":{"tf":1.7320508075688772},"32":{"tf":1.0},"43":{"tf":1.0}}}},"t":{"df":2,"docs":{"39":{"tf":1.0},"6":{"tf":1.0}}}},"p":{"df":0,"docs":{},"e":{"c":{"df":0,"docs":{},"t":{"df":4,"docs":{"0":{"tf":1.0},"2":{"tf":1.0},"45":{"tf":1.0},"46":{"tf":1.4142135623730951}}}},"df":0,"docs":{},"n":{"df":0,"docs":{},"s":{"df":1,"docs":{"24":{"tf":1.0}}}},"r":{"df":0,"docs":{},"i":{"df":3,"docs":{"24":{"tf":1.0},"29":{"tf":1.4142135623730951},"43":{"tf":1.0}}}}},"i":{"df":0,"docs":{},"r":{"df":3,"docs":{"29":{"tf":1.0},"31":{"tf":1.0},"48":{"tf":1.0}}}},"l":{"a":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"df":1,"docs":{"17":{"tf":1.0}}}}},"df":0,"docs":{}}},"t":{"df":0,"docs":{},"e":{"df":0,"docs":{},"n":{"d":{"df":2,"docs":{"2":{"tf":1.0},"48":{"tf":1.4142135623730951}}},"df":0,"docs":{},"s":{"df":1,"docs":{"1":{"tf":1.4142135623730951}}}},"r":{"df":0,"docs":{},"n":{"df":4,"docs":{"13":{"tf":1.0},"2":{"tf":1.0},"24":{"tf":1.0},"48":{"tf":1.4142135623730951}}}}},"r":{"a":{"c":{"df":0,"docs":{},"t":{"df":3,"docs":{"12":{"tf":1.0},"39":{"tf":1.4142135623730951},"48":{"tf":1.0}}}},"df":1,"docs":{"48":{"tf":1.0}}},"df":0,"docs":{}}}}},"f":{"1":{"df":1,"docs":{"12":{"tf":1.0}}},"a":{"c":{"df":0,"docs":{},"t":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"df":3,"docs":{"1":{"tf":1.0},"29":{"tf":1.7320508075688772},"48":{"tf":1.4142135623730951}}}}}},"df":0,"docs":{},"i":{"df":0,"docs":{},"l":{"df":1,"docs":{"31":{"tf":1.4142135623730951}}}},"l":{"df":0,"docs":{},"l":{"b":{"a":{"c":{"df":0,"docs":{},"k":{"df":1,"docs":{"22":{"tf":1.0}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":1,"docs":{"31":{"tf":1.0}}},"s":{"df":2,"docs":{"13":{"tf":1.4142135623730951},"48":{"tf":2.6457513110645907}}}},"r":{"df":1,"docs":{"1":{"tf":1.4142135623730951}}},"s":{"df":0,"docs":{},"t":{"df":2,"docs":{"1":{"tf":1.4142135623730951},"3":{"tf":1.0}}}},"v":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"df":0,"docs":{},"i":{"df":0,"docs":{},"t":{"df":1,"docs":{"11":{"tf":1.0}}}}}}}},"df":5,"docs":{"15":{"tf":1.0},"20":{"tf":1.0},"21":{"tf":1.0},"47":{"tf":1.4142135623730951},"6":{"tf":1.0}},"e":{"a":{"df":0,"docs":{},"t":{"df":0,"docs":{},"u":{"df":0,"docs":{},"r":{"df":4,"docs":{"13":{"tf":1.0},"2":{"tf":2.449489742783178},"32":{"tf":1.0},"34":{"tf":1.0}}}}}},"d":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":1,"docs":{"3":{"tf":1.0}}}}},"df":0,"docs":{},"t":{"c":{"df":0,"docs":{},"h":{"df":1,"docs":{"39":{"tf":1.0}}}},"df":0,"docs":{}},"w":{"df":5,"docs":{"17":{"tf":1.0},"2":{"tf":1.0},"3":{"tf":1.0},"30":{"tf":1.0},"31":{"tf":1.0}}}},"i":{"d":{"df":0,"docs":{},"o":{"df":4,"docs":{"1":{"tf":1.4142135623730951},"25":{"tf":1.4142135623730951},"27":{"tf":1.0},"29":{"tf":1.0}}}},"df":0,"docs":{},"l":{"df":0,"docs":{},"e":{"df":13,"docs":{"1":{"tf":1.0},"11":{"tf":1.4142135623730951},"12":{"tf":1.4142135623730951},"13":{"tf":1.4142135623730951},"14":{"tf":1.0},"37":{"tf":1.0},"43":{"tf":2.0},"45":{"tf":2.449489742783178},"46":{"tf":1.7320508075688772},"47":{"tf":1.4142135623730951},"48":{"tf":3.1622776601683795},"7":{"tf":3.1622776601683795},"8":{"tf":1.0}},"n":{"a":{"df":0,"docs":{},"m":{"df":1,"docs":{"48":{"tf":1.0}}}},"df":0,"docs":{}}},"l":{"df":1,"docs":{"29":{"tf":1.0}}}},"n":{"a":{"df":0,"docs":{},"l":{"df":2,"docs":{"12":{"tf":1.0},"31":{"tf":1.0}}}},"d":{"df":4,"docs":{"13":{"tf":1.0},"24":{"tf":1.4142135623730951},"31":{"tf":1.0},"39":{"tf":1.4142135623730951}}},"df":0,"docs":{},"e":{"df":1,"docs":{"36":{"tf":1.0}}},"g":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"p":{"df":0,"docs":{},"r":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"df":0,"docs":{},"t":{"df":1,"docs":{"1":{"tf":1.0}}}}}}}}}},"i":{"df":0,"docs":{},"s":{"df":0,"docs":{},"h":{"df":1,"docs":{"32":{"tf":1.0}}}}}},"r":{"df":0,"docs":{},"e":{"df":0,"docs":{},"f":{"df":0,"docs":{},"o":{"df":0,"docs":{},"x":{"df":3,"docs":{"1":{"tf":1.4142135623730951},"28":{"tf":1.0},"29":{"tf":1.0}}}}}},"s":{"df":0,"docs":{},"t":{"df":10,"docs":{"15":{"tf":1.0},"17":{"tf":1.0},"18":{"tf":1.0},"19":{"tf":1.4142135623730951},"2":{"tf":1.0},"22":{"tf":1.4142135623730951},"38":{"tf":1.0},"48":{"tf":1.0},"6":{"tf":1.7320508075688772},"7":{"tf":1.7320508075688772}}}}}},"l":{"df":0,"docs":{},"e":{"df":0,"docs":{},"x":{"df":0,"docs":{},"i":{"b":{"df":0,"docs":{},"l":{"df":1,"docs":{"3":{"tf":1.0}}}},"df":0,"docs":{}}}},"o":{"df":0,"docs":{},"w":{"df":4,"docs":{"1":{"tf":1.7320508075688772},"29":{"tf":1.0},"3":{"tf":1.7320508075688772},"48":{"tf":1.0}}}}},"o":{"df":0,"docs":{},"l":{"d":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":2,"docs":{"11":{"tf":1.0},"43":{"tf":1.0}}}}},"df":0,"docs":{},"l":{"df":0,"docs":{},"o":{"df":0,"docs":{},"w":{"df":11,"docs":{"10":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"21":{"tf":1.0},"32":{"tf":1.0},"37":{"tf":1.0},"45":{"tf":1.0},"47":{"tf":1.4142135623730951},"48":{"tf":1.4142135623730951},"7":{"tf":1.0}}}}}},"o":{"df":0,"docs":{},"t":{"df":0,"docs":{},"p":{"df":0,"docs":{},"r":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"df":0,"docs":{},"t":{"df":1,"docs":{"1":{"tf":1.0}}}}}}}}},"r":{"c":{"df":1,"docs":{"48":{"tf":1.4142135623730951}}},"df":0,"docs":{},"m":{"a":{"df":0,"docs":{},"t":{"df":5,"docs":{"12":{"tf":1.7320508075688772},"31":{"tf":1.0},"45":{"tf":1.0},"46":{"tf":1.4142135623730951},"48":{"tf":2.449489742783178}}}},"df":0,"docs":{}},"w":{"a":{"df":0,"docs":{},"r":{"d":{"df":2,"docs":{"17":{"tf":1.0},"34":{"tf":1.0}}},"df":0,"docs":{}}},"df":0,"docs":{}}},"u":{"df":0,"docs":{},"n":{"d":{"a":{"df":0,"docs":{},"t":{"df":1,"docs":{"2":{"tf":1.0}}}},"df":3,"docs":{"24":{"tf":1.0},"39":{"tf":1.4142135623730951},"43":{"tf":1.0}}},"df":0,"docs":{}}}},"r":{"df":0,"docs":{},"e":{"df":0,"docs":{},"s":{"df":0,"docs":{},"h":{"df":1,"docs":{"39":{"tf":1.0}}}}},"o":{"df":0,"docs":{},"n":{"df":0,"docs":{},"t":{"df":0,"docs":{},"e":{"df":0,"docs":{},"n":{"d":{"df":1,"docs":{"48":{"tf":1.0}}},"df":0,"docs":{}}}}}}},"s":{"df":0,"docs":{},"g":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"u":{"df":0,"docs":{},"p":{"df":1,"docs":{"13":{"tf":1.0}}}}}}}},"u":{"df":0,"docs":{},"l":{"df":0,"docs":{},"l":{"df":3,"docs":{"1":{"tf":1.4142135623730951},"43":{"tf":1.0},"48":{"tf":1.0}},"i":{"df":4,"docs":{"1":{"tf":1.0},"24":{"tf":1.0},"29":{"tf":1.0},"3":{"tf":1.4142135623730951}}}}},"r":{"df":0,"docs":{},"t":{"df":0,"docs":{},"h":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":1,"docs":{"1":{"tf":1.0}}}}}}},"t":{"df":0,"docs":{},"u":{"df":0,"docs":{},"r":{"df":3,"docs":{"1":{"tf":1.4142135623730951},"2":{"tf":1.0},"36":{"tf":1.0}}}}}}},"g":{"a":{"df":0,"docs":{},"r":{"b":{"a":{"df":0,"docs":{},"g":{"df":1,"docs":{"13":{"tf":1.0}}}},"df":0,"docs":{}},"df":0,"docs":{}}},"df":0,"docs":{},"e":{"df":0,"docs":{},"n":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":6,"docs":{"12":{"tf":1.7320508075688772},"19":{"tf":1.7320508075688772},"31":{"tf":1.4142135623730951},"43":{"tf":2.0},"47":{"tf":1.4142135623730951},"48":{"tf":1.7320508075688772}}}}},"t":{"df":5,"docs":{"30":{"tf":1.0},"39":{"tf":1.0},"4":{"tf":1.0},"40":{"tf":1.0},"6":{"tf":1.0}}}},"i":{"df":0,"docs":{},"t":{"df":0,"docs":{},"h":{"df":0,"docs":{},"u":{"b":{"df":2,"docs":{"13":{"tf":1.0},"2":{"tf":1.0}}},"df":0,"docs":{}}}},"v":{"df":0,"docs":{},"e":{"df":0,"docs":{},"n":{"df":4,"docs":{"12":{"tf":1.0},"30":{"tf":1.0},"32":{"tf":1.0},"48":{"tf":1.4142135623730951}}}}}},"o":{"a":{"df":0,"docs":{},"l":{"df":1,"docs":{"1":{"tf":1.0}}}},"df":5,"docs":{"13":{"tf":1.0},"17":{"tf":1.4142135623730951},"48":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0}},"n":{"df":0,"docs":{},"e":{"df":1,"docs":{"31":{"tf":1.0}}}},"o":{"d":{"df":8,"docs":{"22":{"tf":1.0},"23":{"tf":1.0},"24":{"tf":1.0},"29":{"tf":1.4142135623730951},"3":{"tf":1.0},"31":{"tf":1.4142135623730951},"43":{"tf":1.0},"48":{"tf":1.4142135623730951}}},"df":0,"docs":{}}},"r":{"a":{"c":{"df":0,"docs":{},"e":{"df":1,"docs":{"48":{"tf":1.4142135623730951}}}},"df":0,"docs":{},"n":{"df":0,"docs":{},"t":{"df":1,"docs":{"48":{"tf":1.0}}}}},"df":0,"docs":{},"e":{"a":{"df":0,"docs":{},"t":{"df":1,"docs":{"3":{"tf":1.0}}}},"df":0,"docs":{}},"o":{"df":0,"docs":{},"u":{"df":0,"docs":{},"p":{"df":2,"docs":{"23":{"tf":1.0},"7":{"tf":1.0}}}}},"p":{"c":{"df":1,"docs":{"36":{"tf":1.0}}},"df":0,"docs":{}}},"u":{"a":{"df":0,"docs":{},"r":{"a":{"df":0,"docs":{},"n":{"df":0,"docs":{},"t":{"df":0,"docs":{},"e":{"df":1,"docs":{"36":{"tf":1.0}}}}}},"df":0,"docs":{}}},"df":0,"docs":{},"i":{"d":{"df":1,"docs":{"24":{"tf":1.0}}},"df":0,"docs":{}}}},"h":{"a":{"_":{"df":0,"docs":{},"h":{"df":0,"docs":{},"o":{"df":0,"docs":{},"s":{"df":0,"docs":{},"t":{"df":1,"docs":{"39":{"tf":2.8284271247461903}},"s":{"=":{"\"":{"df":0,"docs":{},"h":{"df":0,"docs":{},"t":{"df":0,"docs":{},"t":{"df":0,"docs":{},"p":{":":{"/":{"/":{"df":0,"docs":{},"r":{"a":{"df":0,"docs":{},"u":{"df":0,"docs":{},"t":{"df":0,"docs":{},"h":{"df":0,"docs":{},"i":{"df":2,"docs":{"39":{"tf":1.0},"48":{"tf":1.0}}}}}}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}}},"df":0,"docs":{}},"df":0,"docs":{}}}}}},"m":{"df":0,"docs":{},"o":{"d":{"df":4,"docs":{"12":{"tf":1.4142135623730951},"37":{"tf":1.0},"38":{"tf":1.0},"9":{"tf":1.0}},"e":{"=":{"df":0,"docs":{},"f":{"a":{"df":0,"docs":{},"l":{"df":0,"docs":{},"s":{"df":1,"docs":{"48":{"tf":1.0}}}}},"df":0,"docs":{}},"t":{"df":0,"docs":{},"r":{"df":0,"docs":{},"u":{"df":1,"docs":{"38":{"tf":1.0}}}}}},"df":0,"docs":{}}},"df":0,"docs":{}}}},"df":9,"docs":{"1":{"tf":1.7320508075688772},"13":{"tf":1.4142135623730951},"21":{"tf":1.0},"32":{"tf":1.0},"36":{"tf":2.449489742783178},"39":{"tf":1.4142135623730951},"41":{"tf":1.0},"48":{"tf":2.6457513110645907},"9":{"tf":1.0}},"n":{"d":{"df":0,"docs":{},"l":{"df":1,"docs":{"35":{"tf":1.0}}}},"df":0,"docs":{}},"p":{"df":0,"docs":{},"p":{"df":0,"docs":{},"e":{"df":0,"docs":{},"n":{"df":4,"docs":{"19":{"tf":1.0},"23":{"tf":1.0},"39":{"tf":1.0},"48":{"tf":1.0}}}}}},"r":{"d":{"df":1,"docs":{"32":{"tf":1.0}},"e":{"df":0,"docs":{},"n":{"df":1,"docs":{"7":{"tf":1.0}}}}},"df":0,"docs":{}},"s":{"df":0,"docs":{},"h":{"_":{"a":{"df":0,"docs":{},"w":{"a":{"df":0,"docs":{},"i":{"df":0,"docs":{},"t":{"_":{"df":0,"docs":{},"w":{"a":{"df":0,"docs":{},"r":{"df":0,"docs":{},"n":{"_":{"df":0,"docs":{},"t":{"df":0,"docs":{},"i":{"df":0,"docs":{},"m":{"df":0,"docs":{},"e":{"=":{"5":{"0":{"0":{"df":1,"docs":{"48":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}}},"df":0,"docs":{}}}},"df":0,"docs":{}}},"df":0,"docs":{}}}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":3,"docs":{"13":{"tf":2.23606797749979},"24":{"tf":2.0},"48":{"tf":1.4142135623730951}}}},"v":{"df":0,"docs":{},"e":{"df":2,"docs":{"39":{"tf":1.0},"47":{"tf":1.0}}}}},"df":0,"docs":{},"e":{"a":{"d":{"df":3,"docs":{"12":{"tf":1.4142135623730951},"31":{"tf":1.4142135623730951},"40":{"tf":1.0}},"e":{"df":0,"docs":{},"r":{"df":1,"docs":{"48":{"tf":1.7320508075688772}}}}},"df":0,"docs":{},"v":{"df":0,"docs":{},"i":{"df":1,"docs":{"24":{"tf":1.0}},"l":{"df":0,"docs":{},"i":{"df":1,"docs":{"13":{"tf":1.0}}}}}}},"df":0,"docs":{},"l":{"df":0,"docs":{},"l":{"df":0,"docs":{},"o":{"df":1,"docs":{"48":{"tf":1.0}}}},"m":{"df":1,"docs":{"8":{"tf":1.0}}},"p":{"df":2,"docs":{"24":{"tf":1.0},"31":{"tf":1.4142135623730951}}}},"r":{"df":0,"docs":{},"e":{"df":4,"docs":{"11":{"tf":1.0},"17":{"tf":1.0},"24":{"tf":1.0},"43":{"tf":1.0}}}}},"i":{"df":0,"docs":{},"g":{"df":0,"docs":{},"h":{"df":2,"docs":{"24":{"tf":1.0},"36":{"tf":1.4142135623730951}},"e":{"df":0,"docs":{},"r":{"df":1,"docs":{"36":{"tf":1.0}}}},"l":{"df":0,"docs":{},"i":{"df":3,"docs":{"1":{"tf":1.0},"13":{"tf":1.0},"41":{"tf":1.0}}}}}},"n":{"df":0,"docs":{},"t":{"df":3,"docs":{"32":{"tf":1.0},"39":{"tf":1.0},"43":{"tf":1.0}}}},"t":{"df":1,"docs":{"48":{"tf":1.7320508075688772}}}},"o":{"df":0,"docs":{},"o":{"d":{"df":1,"docs":{"23":{"tf":1.0}}},"df":0,"docs":{}},"p":{"df":0,"docs":{},"e":{"df":0,"docs":{},"f":{"df":0,"docs":{},"u":{"df":0,"docs":{},"l":{"df":0,"docs":{},"l":{"df":0,"docs":{},"i":{"df":2,"docs":{"31":{"tf":1.0},"48":{"tf":1.0}}}}}}}}},"s":{"df":0,"docs":{},"t":{"(":{"`":{"a":{"df":0,"docs":{},"u":{"df":0,"docs":{},"t":{"df":0,"docs":{},"h":{".":{"df":0,"docs":{},"e":{"df":0,"docs":{},"x":{"a":{"df":0,"docs":{},"m":{"df":0,"docs":{},"p":{"df":0,"docs":{},"l":{"df":0,"docs":{},"e":{".":{"c":{"df":0,"docs":{},"o":{"df":0,"docs":{},"m":{"df":2,"docs":{"14":{"tf":1.0},"17":{"tf":1.4142135623730951}}}}},"df":0,"docs":{}},"df":0,"docs":{}}}}}},"df":0,"docs":{}}}},"df":0,"docs":{}}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":4,"docs":{"1":{"tf":1.4142135623730951},"39":{"tf":1.0},"48":{"tf":1.4142135623730951},"7":{"tf":1.0}},"n":{"a":{"df":0,"docs":{},"m":{"df":2,"docs":{"39":{"tf":2.23606797749979},"48":{"tf":1.4142135623730951}},"e":{"_":{"df":0,"docs":{},"o":{"df":0,"docs":{},"v":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"w":{"df":0,"docs":{},"r":{"df":0,"docs":{},"i":{"df":0,"docs":{},"t":{"df":1,"docs":{"39":{"tf":1.0}},"e":{"=":{"\"":{"df":0,"docs":{},"r":{"a":{"df":0,"docs":{},"u":{"df":0,"docs":{},"t":{"df":0,"docs":{},"h":{"df":0,"docs":{},"i":{"df":1,"docs":{"48":{"tf":1.0}}}}}}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{}}}}}}}}}}},"df":0,"docs":{}}}},"df":0,"docs":{}}}},"u":{"df":0,"docs":{},"r":{"df":4,"docs":{"1":{"tf":1.0},"29":{"tf":1.0},"34":{"tf":1.4142135623730951},"48":{"tf":2.0}}},"s":{"df":0,"docs":{},"e":{"df":0,"docs":{},"k":{"df":0,"docs":{},"e":{"df":0,"docs":{},"e":{"df":0,"docs":{},"p":{"df":1,"docs":{"48":{"tf":1.0}}}}}}}}}},"t":{"df":0,"docs":{},"t":{"df":0,"docs":{},"p":{":":{"/":{"/":{"df":0,"docs":{},"l":{"df":0,"docs":{},"o":{"c":{"a":{"df":0,"docs":{},"l":{"df":0,"docs":{},"h":{"df":0,"docs":{},"o":{"df":0,"docs":{},"s":{"df":0,"docs":{},"t":{":":{"8":{"0":{"8":{"0":{"df":1,"docs":{"48":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}}}},"df":0,"docs":{}},"df":0,"docs":{}}},"r":{"a":{"df":0,"docs":{},"u":{"df":0,"docs":{},"t":{"df":0,"docs":{},"h":{"df":0,"docs":{},"i":{"df":2,"docs":{"39":{"tf":1.4142135623730951},"48":{"tf":1.4142135623730951}}}}}}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{}},"_":{"df":0,"docs":{},"h":{"df":0,"docs":{},"t":{"df":0,"docs":{},"t":{"df":0,"docs":{},"p":{"df":1,"docs":{"48":{"tf":1.4142135623730951}}}}}},"w":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"df":0,"docs":{},"k":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"s":{"=":{"1":{"df":1,"docs":{"48":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}}}}}}}}},"df":6,"docs":{"13":{"tf":3.3166247903554},"14":{"tf":1.0},"17":{"tf":2.449489742783178},"27":{"tf":1.0},"41":{"tf":1.0},"48":{"tf":2.23606797749979}},"g":{"df":0,"docs":{},"e":{"df":0,"docs":{},"t":{"df":1,"docs":{"13":{"tf":1.4142135623730951}}}}},"s":{":":{"/":{"/":{"df":0,"docs":{},"h":{"df":0,"docs":{},"u":{"b":{".":{"d":{"df":0,"docs":{},"o":{"c":{"df":0,"docs":{},"k":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{".":{"c":{"df":0,"docs":{},"o":{"df":0,"docs":{},"m":{"/":{"df":0,"docs":{},"l":{"a":{"df":0,"docs":{},"y":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"s":{"/":{"df":0,"docs":{},"s":{"d":{"df":0,"docs":{},"o":{"b":{"df":0,"docs":{},"e":{"d":{"df":0,"docs":{},"e":{"df":0,"docs":{},"v":{"/":{"df":0,"docs":{},"r":{"a":{"df":0,"docs":{},"u":{"df":0,"docs":{},"t":{"df":0,"docs":{},"h":{"df":0,"docs":{},"y":{"/":{"0":{".":{"1":{"2":{".":{"0":{"/":{"df":0,"docs":{},"i":{"df":0,"docs":{},"m":{"a":{"df":0,"docs":{},"g":{"df":0,"docs":{},"e":{"df":0,"docs":{},"s":{"/":{"df":0,"docs":{},"s":{"df":0,"docs":{},"h":{"a":{"2":{"5":{"6":{"df":1,"docs":{"13":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}},"df":0,"docs":{}}}}},"df":0,"docs":{}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}}},"df":0,"docs":{}}},"df":0,"docs":{}}}},"df":0,"docs":{}}},"df":0,"docs":{}}},"df":0,"docs":{}}},"df":0,"docs":{}}}}}},"df":0,"docs":{}},"r":{"/":{"df":0,"docs":{},"s":{"d":{"df":0,"docs":{},"o":{"b":{"df":0,"docs":{},"e":{"d":{"df":0,"docs":{},"e":{"df":0,"docs":{},"v":{"/":{"df":0,"docs":{},"r":{"a":{"df":0,"docs":{},"u":{"df":0,"docs":{},"t":{"df":0,"docs":{},"h":{"df":0,"docs":{},"i":{"df":1,"docs":{"13":{"tf":1.0}}}}}}},"df":0,"docs":{}}},"df":0,"docs":{}}}},"df":0,"docs":{}}},"df":0,"docs":{}}},"df":0,"docs":{}}},"df":0,"docs":{}}},"df":0,"docs":{}}}},"df":0,"docs":{}},"df":0,"docs":{}}}}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}},"u":{"df":0,"docs":{},"g":{"df":0,"docs":{},"e":{"df":1,"docs":{"48":{"tf":1.0}}}}}},"i":{"d":{"df":6,"docs":{"12":{"tf":1.4142135623730951},"13":{"tf":1.0},"26":{"tf":1.0},"30":{"tf":1.0},"31":{"tf":2.0},"48":{"tf":1.7320508075688772}},"e":{"a":{"df":3,"docs":{"2":{"tf":1.0},"22":{"tf":1.0},"23":{"tf":1.0}}},"df":0,"docs":{},"n":{"df":0,"docs":{},"t":{"df":0,"docs":{},"i":{"df":0,"docs":{},"f":{"df":0,"docs":{},"i":{"df":1,"docs":{"48":{"tf":1.0}}}}}}}}},"df":0,"docs":{},"f":{"df":0,"docs":{},"n":{"df":0,"docs":{},"o":{"df":0,"docs":{},"t":{"df":0,"docs":{},"p":{"df":0,"docs":{},"r":{"df":0,"docs":{},"e":{"df":0,"docs":{},"s":{"df":1,"docs":{"13":{"tf":1.0}}}}}}}}}},"g":{"df":0,"docs":{},"n":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"df":1,"docs":{"1":{"tf":1.0}}}}}},"m":{"a":{"df":0,"docs":{},"g":{"df":2,"docs":{"13":{"tf":2.23606797749979},"6":{"tf":1.0}},"e":{"df":0,"docs":{},"p":{"df":0,"docs":{},"u":{"df":0,"docs":{},"l":{"df":0,"docs":{},"l":{"df":0,"docs":{},"p":{"df":0,"docs":{},"o":{"df":0,"docs":{},"l":{"df":0,"docs":{},"i":{"c":{"df":0,"docs":{},"i":{"df":1,"docs":{"13":{"tf":1.0}}}},"df":0,"docs":{}}}}}}}}}}}},"df":0,"docs":{},"m":{"df":0,"docs":{},"e":{"d":{"df":0,"docs":{},"i":{"df":2,"docs":{"21":{"tf":1.0},"32":{"tf":1.0}}}},"df":0,"docs":{}}},"p":{"df":0,"docs":{},"l":{"df":0,"docs":{},"e":{"df":0,"docs":{},"m":{"df":0,"docs":{},"e":{"df":0,"docs":{},"n":{"df":0,"docs":{},"t":{"df":2,"docs":{"2":{"tf":1.4142135623730951},"3":{"tf":1.0}}}}}}},"i":{"c":{"df":0,"docs":{},"i":{"df":0,"docs":{},"t":{"df":1,"docs":{"3":{"tf":1.0}}}}},"df":0,"docs":{}}},"o":{"df":0,"docs":{},"r":{"df":0,"docs":{},"t":{"df":4,"docs":{"19":{"tf":1.0},"24":{"tf":1.7320508075688772},"27":{"tf":1.0},"48":{"tf":1.0}}}},"s":{"df":0,"docs":{},"s":{"df":1,"docs":{"32":{"tf":1.0}}}}}}},"n":{"c":{"df":0,"docs":{},"l":{"df":0,"docs":{},"u":{"d":{"df":4,"docs":{"11":{"tf":1.4142135623730951},"19":{"tf":1.0},"27":{"tf":1.0},"48":{"tf":2.0}}},"df":0,"docs":{}}},"o":{"df":0,"docs":{},"m":{"df":1,"docs":{"48":{"tf":1.0}}},"n":{"df":0,"docs":{},"s":{"df":0,"docs":{},"i":{"df":0,"docs":{},"s":{"df":0,"docs":{},"t":{"df":2,"docs":{"36":{"tf":1.0},"39":{"tf":1.4142135623730951}}}}}}}}},"d":{"df":0,"docs":{},"e":{"df":0,"docs":{},"n":{"df":0,"docs":{},"t":{"df":1,"docs":{"11":{"tf":1.4142135623730951}}}}},"i":{"c":{"df":1,"docs":{"48":{"tf":1.0}}},"df":0,"docs":{}}},"df":0,"docs":{},"f":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"df":0,"docs":{},"i":{"df":0,"docs":{},"t":{"df":1,"docs":{"36":{"tf":1.0}}}}}},"o":{"df":5,"docs":{"0":{"tf":1.0},"32":{"tf":1.0},"34":{"tf":1.0},"43":{"tf":1.0},"48":{"tf":1.4142135623730951}},"r":{"df":0,"docs":{},"m":{"df":4,"docs":{"11":{"tf":1.0},"12":{"tf":1.0},"19":{"tf":1.0},"48":{"tf":1.4142135623730951}}}}}},"g":{"df":0,"docs":{},"r":{"df":0,"docs":{},"e":{"df":0,"docs":{},"s":{"df":0,"docs":{},"s":{".":{"df":0,"docs":{},"y":{"a":{"df":0,"docs":{},"m":{"df":0,"docs":{},"l":{"df":1,"docs":{"14":{"tf":1.7320508075688772}}}}},"df":0,"docs":{}}},"df":2,"docs":{"13":{"tf":1.0},"14":{"tf":1.7320508075688772}},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"u":{"df":0,"docs":{},"t":{"df":2,"docs":{"14":{"tf":1.4142135623730951},"17":{"tf":1.7320508075688772}}}}}}}}}}},"i":{"df":0,"docs":{},"t":{"df":0,"docs":{},"i":{"a":{"df":0,"docs":{},"l":{"d":{"df":0,"docs":{},"e":{"df":0,"docs":{},"l":{"a":{"df":0,"docs":{},"y":{"df":0,"docs":{},"s":{"df":0,"docs":{},"e":{"c":{"df":0,"docs":{},"o":{"df":0,"docs":{},"n":{"d":{"df":1,"docs":{"13":{"tf":1.4142135623730951}}},"df":0,"docs":{}}}},"df":0,"docs":{}}}}},"df":0,"docs":{}}}},"df":0,"docs":{}}},"df":3,"docs":{"19":{"tf":1.4142135623730951},"21":{"tf":1.0},"48":{"tf":1.0}}}}},"s":{"df":0,"docs":{},"e":{"c":{"df":0,"docs":{},"u":{"df":0,"docs":{},"r":{"df":1,"docs":{"3":{"tf":1.4142135623730951}}}}},"df":0,"docs":{},"r":{"df":0,"docs":{},"t":{"df":1,"docs":{"36":{"tf":1.0}}}}},"i":{"d":{"df":11,"docs":{"11":{"tf":1.0},"24":{"tf":1.0},"30":{"tf":1.0},"31":{"tf":1.0},"34":{"tf":1.0},"39":{"tf":1.7320508075688772},"4":{"tf":1.0},"45":{"tf":1.0},"48":{"tf":1.4142135623730951},"7":{"tf":1.4142135623730951},"8":{"tf":1.0}}},"df":0,"docs":{}},"p":{"df":0,"docs":{},"i":{"df":0,"docs":{},"r":{"df":1,"docs":{"1":{"tf":1.0}}}}},"t":{"a":{"df":0,"docs":{},"n":{"c":{"df":15,"docs":{"1":{"tf":2.0},"11":{"tf":1.0},"24":{"tf":1.0},"28":{"tf":1.0},"29":{"tf":1.0},"3":{"tf":1.0},"31":{"tf":1.0},"32":{"tf":1.4142135623730951},"36":{"tf":1.4142135623730951},"39":{"tf":1.7320508075688772},"41":{"tf":1.0},"43":{"tf":1.0},"45":{"tf":1.0},"48":{"tf":2.449489742783178},"9":{"tf":1.0}}},"df":0,"docs":{}}},"df":0,"docs":{}}},"t":{"df":0,"docs":{},"e":{"df":0,"docs":{},"n":{"df":0,"docs":{},"s":{"df":1,"docs":{"24":{"tf":1.0}}}},"r":{"a":{"c":{"df":0,"docs":{},"t":{"df":1,"docs":{"6":{"tf":1.4142135623730951}}}},"df":0,"docs":{}},"c":{"df":0,"docs":{},"e":{"df":0,"docs":{},"p":{"df":0,"docs":{},"t":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"df":1,"docs":{"48":{"tf":1.0}}}}}}}},"df":0,"docs":{},"m":{"df":0,"docs":{},"e":{"d":{"df":0,"docs":{},"i":{"a":{"df":0,"docs":{},"t":{"df":0,"docs":{},"e":{"/":{"c":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"t":{"df":0,"docs":{},"s":{"/":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"df":0,"docs":{},"t":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"m":{"df":0,"docs":{},"e":{"d":{"df":0,"docs":{},"i":{"a":{"df":0,"docs":{},"t":{"df":0,"docs":{},"e":{".":{"c":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"t":{".":{"df":0,"docs":{},"p":{"df":0,"docs":{},"e":{"df":0,"docs":{},"m":{"df":1,"docs":{"43":{"tf":1.0}}}}}},"df":0,"docs":{}}}}},"df":0,"docs":{}},"df":0,"docs":{}}}},"df":0,"docs":{}}},"df":0,"docs":{}}}}}}}},"r":{"df":0,"docs":{},"e":{"d":{"df":0,"docs":{},"h":{"a":{"c":{".":{"df":0,"docs":{},"l":{"df":0,"docs":{},"o":{"c":{"a":{"df":0,"docs":{},"l":{".":{"c":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"t":{".":{"df":0,"docs":{},"p":{"df":0,"docs":{},"e":{"df":0,"docs":{},"m":{"df":1,"docs":{"43":{"tf":1.0}}}}}},"df":0,"docs":{}}}}},"df":0,"docs":{}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}},"df":0,"docs":{}}}},"df":0,"docs":{}}}}}},"df":0,"docs":{}},"df":0,"docs":{}}}},"df":1,"docs":{"43":{"tf":1.7320508075688772}}}},"df":0,"docs":{}}},"n":{"df":2,"docs":{"13":{"tf":1.0},"17":{"tf":1.0}}},"v":{"df":1,"docs":{"48":{"tf":1.0}}}}},"r":{"df":0,"docs":{},"o":{"d":{"df":0,"docs":{},"u":{"c":{"df":0,"docs":{},"t":{"df":1,"docs":{"0":{"tf":1.0}}}},"df":0,"docs":{}}},"df":0,"docs":{}}}},"v":{"a":{"df":0,"docs":{},"l":{"df":0,"docs":{},"i":{"d":{"df":2,"docs":{"1":{"tf":1.0},"39":{"tf":1.7320508075688772}}},"df":0,"docs":{}}}},"df":0,"docs":{}}},"p":{"df":1,"docs":{"48":{"tf":1.0}}},"r":{"df":0,"docs":{},"r":{"df":0,"docs":{},"e":{"df":0,"docs":{},"l":{"df":0,"docs":{},"e":{"df":0,"docs":{},"v":{"df":1,"docs":{"48":{"tf":1.0}}}}}}}},"s":{"df":0,"docs":{},"s":{"df":0,"docs":{},"u":{"df":1,"docs":{"48":{"tf":1.4142135623730951}}}}},"t":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":1,"docs":{"48":{"tf":1.0}}}},"s":{"df":0,"docs":{},"e":{"df":0,"docs":{},"l":{"df":0,"docs":{},"f":{"df":8,"docs":{"12":{"tf":1.0},"2":{"tf":1.0},"23":{"tf":1.0},"24":{"tf":1.0},"34":{"tf":1.4142135623730951},"43":{"tf":1.4142135623730951},"48":{"tf":1.4142135623730951},"6":{"tf":1.0}}}}}}}},"j":{"df":0,"docs":{},"o":{"b":{"df":2,"docs":{"34":{"tf":1.0},"48":{"tf":1.0}}},"df":0,"docs":{}},"s":{"df":1,"docs":{"48":{"tf":1.0}},"o":{"df":0,"docs":{},"n":{"df":1,"docs":{"19":{"tf":1.0}}}}},"w":{"df":0,"docs":{},"k":{"df":2,"docs":{"19":{"tf":1.0},"31":{"tf":1.0}}},"t":{"df":2,"docs":{"31":{"tf":1.0},"48":{"tf":1.0}}}}},"k":{"df":0,"docs":{},"e":{"df":0,"docs":{},"e":{"df":0,"docs":{},"p":{"a":{"df":0,"docs":{},"l":{"df":1,"docs":{"48":{"tf":1.7320508075688772}}}},"df":4,"docs":{"22":{"tf":1.0},"24":{"tf":1.0},"31":{"tf":1.4142135623730951},"48":{"tf":1.0}}}},"y":{"=":{"\"":{".":{".":{"/":{"a":{"df":0,"docs":{},"u":{"df":0,"docs":{},"t":{"df":0,"docs":{},"h":{".":{"df":0,"docs":{},"e":{"df":0,"docs":{},"x":{"a":{"df":0,"docs":{},"m":{"df":0,"docs":{},"p":{"df":0,"docs":{},"l":{"df":0,"docs":{},"e":{".":{"c":{"df":0,"docs":{},"o":{"df":0,"docs":{},"m":{".":{"df":0,"docs":{},"k":{"df":0,"docs":{},"e":{"df":0,"docs":{},"y":{".":{"df":0,"docs":{},"p":{"df":0,"docs":{},"e":{"df":0,"docs":{},"m":{"df":1,"docs":{"47":{"tf":1.0}}}}}},"df":0,"docs":{}}}}},"df":0,"docs":{}}}},"df":0,"docs":{}},"df":0,"docs":{}}}}}},"df":0,"docs":{}}}},"df":0,"docs":{}}}}},"df":0,"docs":{},"r":{"df":0,"docs":{},"e":{"d":{"df":0,"docs":{},"h":{"a":{"c":{".":{"df":0,"docs":{},"l":{"df":0,"docs":{},"o":{"c":{"a":{"df":0,"docs":{},"l":{".":{"df":0,"docs":{},"k":{"df":0,"docs":{},"e":{"df":0,"docs":{},"y":{".":{"df":0,"docs":{},"p":{"df":0,"docs":{},"e":{"df":0,"docs":{},"m":{"df":1,"docs":{"47":{"tf":1.0}}}}}},"df":0,"docs":{}}}}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}},"df":0,"docs":{}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"_":{"df":0,"docs":{},"i":{"d":{"/":{"df":0,"docs":{},"e":{"df":0,"docs":{},"n":{"c":{"_":{"df":0,"docs":{},"k":{"df":0,"docs":{},"e":{"df":0,"docs":{},"y":{"df":2,"docs":{"12":{"tf":1.0},"48":{"tf":1.0}}}}}},"df":0,"docs":{}},"df":0,"docs":{}}}},"df":0,"docs":{}},"df":0,"docs":{}}},"c":{"df":0,"docs":{},"l":{"df":0,"docs":{},"o":{"a":{"df":0,"docs":{},"k":{"df":2,"docs":{"1":{"tf":1.7320508075688772},"3":{"tf":1.0}}}},"df":0,"docs":{}}}},"df":11,"docs":{"12":{"tf":1.0},"13":{"tf":1.7320508075688772},"19":{"tf":1.0},"28":{"tf":1.4142135623730951},"29":{"tf":2.0},"30":{"tf":2.0},"31":{"tf":4.0},"43":{"tf":2.0},"45":{"tf":1.4142135623730951},"46":{"tf":1.4142135623730951},"48":{"tf":1.7320508075688772}}}},"i":{"df":0,"docs":{},"n":{"d":{"df":7,"docs":{"1":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.4142135623730951},"14":{"tf":1.4142135623730951},"17":{"tf":2.23606797749979},"48":{"tf":1.0}}},"df":0,"docs":{}}},"n":{"df":0,"docs":{},"o":{"df":0,"docs":{},"w":{"df":1,"docs":{"32":{"tf":1.0}}}}},"u":{"b":{"df":0,"docs":{},"e":{"c":{"df":0,"docs":{},"t":{"df":0,"docs":{},"l":{"df":4,"docs":{"10":{"tf":1.0},"15":{"tf":1.4142135623730951},"21":{"tf":1.0},"47":{"tf":2.23606797749979}}}}},"df":0,"docs":{},"r":{"df":0,"docs":{},"n":{"df":0,"docs":{},"e":{"df":0,"docs":{},"t":{"df":15,"docs":{"11":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"17":{"tf":1.0},"21":{"tf":1.4142135623730951},"24":{"tf":1.0},"31":{"tf":1.4142135623730951},"37":{"tf":1.0},"39":{"tf":1.0},"4":{"tf":1.0},"46":{"tf":1.0},"47":{"tf":2.0},"48":{"tf":1.4142135623730951},"8":{"tf":1.4142135623730951},"9":{"tf":1.0}}}}}}}},"df":0,"docs":{},"s":{"df":0,"docs":{},"t":{"df":0,"docs":{},"o":{"df":0,"docs":{},"m":{"df":1,"docs":{"8":{"tf":1.0}}}}}}}},"l":{"a":{"b":{"df":0,"docs":{},"e":{"df":0,"docs":{},"l":{"df":1,"docs":{"13":{"tf":1.4142135623730951}}}}},"df":0,"docs":{},"n":{"df":0,"docs":{},"g":{"df":0,"docs":{},"u":{"a":{"df":0,"docs":{},"g":{"df":1,"docs":{"13":{"tf":1.0}}}},"df":0,"docs":{}}}},"r":{"df":0,"docs":{},"g":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":1,"docs":{"13":{"tf":1.0}}}}}},"s":{"df":0,"docs":{},"t":{"df":1,"docs":{"43":{"tf":1.4142135623730951}}}},"t":{"df":0,"docs":{},"e":{"df":0,"docs":{},"n":{"c":{"df":1,"docs":{"48":{"tf":1.0}}},"df":0,"docs":{}},"r":{"df":7,"docs":{"12":{"tf":1.0},"13":{"tf":1.0},"17":{"tf":1.0},"28":{"tf":1.0},"32":{"tf":1.0},"48":{"tf":1.0},"7":{"tf":1.0}}},"s":{"df":0,"docs":{},"t":{"df":1,"docs":{"13":{"tf":1.4142135623730951}}}}}},"y":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":4,"docs":{"13":{"tf":1.0},"36":{"tf":1.4142135623730951},"43":{"tf":1.0},"45":{"tf":1.0}}}}}},"d":{"a":{"df":0,"docs":{},"p":{"df":1,"docs":{"3":{"tf":1.4142135623730951}}}},"df":0,"docs":{}},"df":0,"docs":{},"e":{"a":{"d":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":3,"docs":{"36":{"tf":1.4142135623730951},"39":{"tf":1.4142135623730951},"48":{"tf":1.7320508075688772}}}}},"df":0,"docs":{},"v":{"df":1,"docs":{"48":{"tf":1.0}}}},"df":0,"docs":{},"f":{"df":0,"docs":{},"t":{"df":1,"docs":{"40":{"tf":1.0}},"o":{"df":0,"docs":{},"v":{"df":1,"docs":{"39":{"tf":1.0}}}}}},"t":{"'":{"df":2,"docs":{"17":{"tf":1.0},"32":{"tf":1.0}}},"df":0,"docs":{}},"v":{"df":0,"docs":{},"e":{"df":0,"docs":{},"l":{"df":2,"docs":{"36":{"tf":1.4142135623730951},"48":{"tf":1.4142135623730951}}}}}},"i":{"b":{"df":0,"docs":{},"r":{"a":{"df":0,"docs":{},"r":{"df":0,"docs":{},"i":{"df":1,"docs":{"36":{"tf":1.0}}}}},"df":0,"docs":{}}},"df":0,"docs":{},"f":{"df":0,"docs":{},"e":{"df":0,"docs":{},"t":{"df":0,"docs":{},"i":{"df":0,"docs":{},"m":{"df":2,"docs":{"29":{"tf":1.0},"48":{"tf":3.0}}}}}}},"k":{"df":0,"docs":{},"e":{"df":3,"docs":{"1":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0}}}},"m":{"df":0,"docs":{},"i":{"df":0,"docs":{},"t":{"df":3,"docs":{"13":{"tf":2.449489742783178},"24":{"tf":2.449489742783178},"48":{"tf":1.4142135623730951}}}}},"n":{"df":0,"docs":{},"e":{"df":1,"docs":{"43":{"tf":1.4142135623730951}},"r":{"df":1,"docs":{"11":{"tf":1.0}}}},"k":{"df":4,"docs":{"21":{"tf":1.4142135623730951},"43":{"tf":1.0},"48":{"tf":1.7320508075688772},"7":{"tf":1.0}},"e":{"df":0,"docs":{},"r":{"d":{"df":1,"docs":{"41":{"tf":1.4142135623730951}}},"df":0,"docs":{}}}},"u":{"df":0,"docs":{},"x":{"df":4,"docs":{"1":{"tf":1.0},"12":{"tf":1.0},"29":{"tf":1.0},"7":{"tf":1.0}}}}},"s":{"df":0,"docs":{},"t":{"df":0,"docs":{},"e":{"df":0,"docs":{},"n":{"_":{"a":{"d":{"d":{"df":0,"docs":{},"r":{"df":0,"docs":{},"e":{"df":0,"docs":{},"s":{"df":0,"docs":{},"s":{"=":{"0":{".":{"0":{".":{"0":{".":{"0":{"df":1,"docs":{"48":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{},"p":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"df":0,"docs":{},"t":{"_":{"df":0,"docs":{},"h":{"df":0,"docs":{},"t":{"df":0,"docs":{},"t":{"df":0,"docs":{},"p":{"=":{"8":{"0":{"8":{"0":{"df":1,"docs":{"48":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{},"s":{"=":{"8":{"4":{"4":{"3":{"df":1,"docs":{"48":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}}}},"df":0,"docs":{}}}}},"s":{"c":{"df":0,"docs":{},"h":{"df":0,"docs":{},"e":{"df":0,"docs":{},"m":{"df":1,"docs":{"48":{"tf":1.4142135623730951}},"e":{"=":{"df":0,"docs":{},"h":{"df":0,"docs":{},"t":{"df":0,"docs":{},"t":{"df":0,"docs":{},"p":{"df":1,"docs":{"48":{"tf":1.0}}}}}}},"df":0,"docs":{}}}}}},"df":0,"docs":{}}},"df":1,"docs":{"48":{"tf":1.4142135623730951}}}}}},"v":{"df":0,"docs":{},"e":{"df":1,"docs":{"36":{"tf":1.0}},"n":{"df":0,"docs":{},"e":{"df":0,"docs":{},"s":{"df":0,"docs":{},"s":{"df":0,"docs":{},"p":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"b":{"df":1,"docs":{"13":{"tf":1.0}}},"df":0,"docs":{}}}}}}}}}}},"o":{"a":{"d":{"b":{"a":{"df":0,"docs":{},"l":{"a":{"df":0,"docs":{},"n":{"c":{"df":2,"docs":{"45":{"tf":1.0},"48":{"tf":1.0}}},"df":0,"docs":{}}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"c":{"a":{"df":0,"docs":{},"l":{"df":2,"docs":{"48":{"tf":1.0},"6":{"tf":1.4142135623730951}},"h":{"df":0,"docs":{},"o":{"df":0,"docs":{},"s":{"df":0,"docs":{},"t":{"df":2,"docs":{"48":{"tf":1.0},"6":{"tf":1.0}}}}}}},"t":{"df":2,"docs":{"45":{"tf":1.4142135623730951},"48":{"tf":1.4142135623730951}}}},"df":0,"docs":{},"k":{"df":0,"docs":{},"o":{"df":0,"docs":{},"u":{"df":0,"docs":{},"t":{"df":1,"docs":{"23":{"tf":1.0}}}}}}},"df":0,"docs":{},"g":{"_":{"df":0,"docs":{},"l":{"df":0,"docs":{},"e":{"df":0,"docs":{},"v":{"df":0,"docs":{},"e":{"df":0,"docs":{},"l":{"=":{"d":{"df":0,"docs":{},"e":{"b":{"df":0,"docs":{},"u":{"df":0,"docs":{},"g":{"df":1,"docs":{"22":{"tf":1.0}}}}},"df":0,"docs":{}}},"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"df":0,"docs":{},"f":{"df":0,"docs":{},"o":{"df":1,"docs":{"48":{"tf":1.0}}}}}}},"_":{"a":{"c":{"c":{"df":0,"docs":{},"e":{"df":0,"docs":{},"s":{"df":0,"docs":{},"s":{"=":{"b":{"a":{"df":0,"docs":{},"s":{"df":1,"docs":{"48":{"tf":1.0}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":1,"docs":{"48":{"tf":1.0}}}}}}}},"df":11,"docs":{"1":{"tf":1.4142135623730951},"19":{"tf":1.0},"20":{"tf":1.4142135623730951},"21":{"tf":3.3166247903554},"22":{"tf":1.4142135623730951},"24":{"tf":1.0},"26":{"tf":1.0},"29":{"tf":1.4142135623730951},"31":{"tf":1.0},"48":{"tf":3.7416573867739413},"6":{"tf":2.0}},"i":{"df":0,"docs":{},"n":{"df":8,"docs":{"1":{"tf":2.449489742783178},"19":{"tf":1.0},"2":{"tf":1.4142135623730951},"24":{"tf":1.4142135623730951},"29":{"tf":2.23606797749979},"3":{"tf":1.0},"31":{"tf":1.0},"48":{"tf":2.449489742783178}}}},"o":{"df":1,"docs":{"1":{"tf":1.0}}}},"n":{"df":0,"docs":{},"g":{"df":7,"docs":{"1":{"tf":1.0},"12":{"tf":1.0},"22":{"tf":1.0},"29":{"tf":1.0},"39":{"tf":1.0},"48":{"tf":1.7320508075688772},"6":{"tf":1.0}},"e":{"df":0,"docs":{},"r":{"df":1,"docs":{"48":{"tf":1.0}}}}}},"o":{"df":0,"docs":{},"k":{"df":8,"docs":{"1":{"tf":1.4142135623730951},"13":{"tf":1.4142135623730951},"3":{"tf":1.0},"31":{"tf":1.0},"32":{"tf":1.0},"45":{"tf":1.0},"48":{"tf":1.0},"6":{"tf":1.7320508075688772}}},"s":{"df":1,"docs":{"36":{"tf":1.0}}}},"s":{"df":0,"docs":{},"t":{"df":1,"docs":{"39":{"tf":1.7320508075688772}}}},"t":{"df":4,"docs":{"17":{"tf":1.0},"31":{"tf":1.0},"35":{"tf":1.0},"43":{"tf":1.0}}},"w":{"df":1,"docs":{"24":{"tf":1.7320508075688772}},"e":{"df":0,"docs":{},"r":{"df":2,"docs":{"1":{"tf":1.0},"48":{"tf":1.4142135623730951}}}}}},"t":{"df":1,"docs":{"48":{"tf":1.0}}}},"m":{"_":{"c":{"df":0,"docs":{},"o":{"df":0,"docs":{},"s":{"df":0,"docs":{},"t":{"df":1,"docs":{"48":{"tf":1.0}}}}}},"df":0,"docs":{}},"a":{"c":{"df":3,"docs":{"1":{"tf":1.0},"29":{"tf":1.0},"7":{"tf":1.4142135623730951}},"h":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"df":1,"docs":{"29":{"tf":1.0}}}}}},"d":{"df":0,"docs":{},"e":{"df":1,"docs":{"1":{"tf":1.0}}}},"df":0,"docs":{},"g":{"df":0,"docs":{},"i":{"c":{"df":1,"docs":{"48":{"tf":1.7320508075688772}}},"df":0,"docs":{}}},"i":{"df":0,"docs":{},"l":{"df":5,"docs":{"12":{"tf":1.0},"2":{"tf":1.4142135623730951},"22":{"tf":1.4142135623730951},"29":{"tf":1.0},"48":{"tf":1.0}}},"n":{"df":3,"docs":{"1":{"tf":1.0},"13":{"tf":1.0},"35":{"tf":1.0}}}},"k":{"df":0,"docs":{},"e":{"df":13,"docs":{"1":{"tf":1.4142135623730951},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.7320508075688772},"2":{"tf":1.0},"24":{"tf":1.0},"25":{"tf":1.4142135623730951},"29":{"tf":1.0},"31":{"tf":1.4142135623730951},"34":{"tf":1.4142135623730951},"43":{"tf":1.4142135623730951},"48":{"tf":2.23606797749979},"7":{"tf":2.23606797749979}}}},"l":{"df":0,"docs":{},"i":{"c":{"df":0,"docs":{},"i":{"df":1,"docs":{"13":{"tf":1.0}}}},"df":0,"docs":{}}},"n":{"a":{"df":0,"docs":{},"g":{"df":4,"docs":{"11":{"tf":1.0},"17":{"tf":1.0},"2":{"tf":1.0},"48":{"tf":1.0}}}},"df":0,"docs":{},"i":{"df":3,"docs":{"17":{"tf":1.0},"24":{"tf":1.0},"36":{"tf":1.0}}}},"r":{"df":0,"docs":{},"i":{"a":{"d":{"b":{"df":1,"docs":{"2":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}},"t":{"c":{"df":0,"docs":{},"h":{"df":7,"docs":{"12":{"tf":1.0},"14":{"tf":1.0},"17":{"tf":1.4142135623730951},"2":{"tf":1.0},"39":{"tf":1.0},"48":{"tf":1.4142135623730951},"7":{"tf":1.0}},"l":{"a":{"b":{"df":0,"docs":{},"e":{"df":0,"docs":{},"l":{"df":1,"docs":{"13":{"tf":1.0}}}}},"df":0,"docs":{}},"df":0,"docs":{}}}},"df":0,"docs":{}},"x":{"_":{"df":0,"docs":{},"h":{"a":{"df":0,"docs":{},"s":{"df":0,"docs":{},"h":{"_":{"df":0,"docs":{},"t":{"df":0,"docs":{},"h":{"df":0,"docs":{},"r":{"df":0,"docs":{},"e":{"a":{"d":{"df":3,"docs":{"13":{"tf":1.4142135623730951},"24":{"tf":1.0},"48":{"tf":1.0}},"s":{"=":{"1":{"df":2,"docs":{"24":{"tf":1.0},"48":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{}}}}}},"df":0,"docs":{}}}},"df":0,"docs":{}}},"df":1,"docs":{"48":{"tf":1.0}},"i":{"df":0,"docs":{},"m":{"df":0,"docs":{},"u":{"df":0,"docs":{},"m":{"df":2,"docs":{"24":{"tf":1.4142135623730951},"48":{"tf":1.7320508075688772}}}}}}},"y":{"b":{"df":2,"docs":{"1":{"tf":1.0},"31":{"tf":1.0}}},"df":0,"docs":{}}},"b":{"df":1,"docs":{"48":{"tf":1.0}}},"df":0,"docs":{},"e":{"a":{"df":0,"docs":{},"n":{"df":9,"docs":{"0":{"tf":1.0},"23":{"tf":1.0},"3":{"tf":1.0},"30":{"tf":1.0},"31":{"tf":1.4142135623730951},"34":{"tf":1.0},"36":{"tf":1.4142135623730951},"39":{"tf":1.0},"6":{"tf":1.0}}}},"c":{"df":0,"docs":{},"h":{"a":{"df":0,"docs":{},"n":{"df":5,"docs":{"13":{"tf":1.4142135623730951},"17":{"tf":1.0},"23":{"tf":1.4142135623730951},"3":{"tf":1.0},"39":{"tf":1.0}}}},"df":0,"docs":{}}},"df":0,"docs":{},"m":{"b":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":4,"docs":{"12":{"tf":1.0},"39":{"tf":2.0},"41":{"tf":1.0},"48":{"tf":1.7320508075688772}}}}},"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"df":0,"docs":{},"i":{"df":5,"docs":{"13":{"tf":2.449489742783178},"24":{"tf":2.23606797749979},"36":{"tf":1.0},"48":{"tf":1.7320508075688772},"6":{"tf":1.0}}}}}},"n":{"df":0,"docs":{},"t":{"df":0,"docs":{},"i":{"df":0,"docs":{},"o":{"df":0,"docs":{},"n":{"df":2,"docs":{"24":{"tf":1.0},"43":{"tf":1.4142135623730951}}}}}}},"s":{"df":0,"docs":{},"h":{"df":1,"docs":{"41":{"tf":1.0}}},"s":{"a":{"df":0,"docs":{},"g":{"df":1,"docs":{"21":{"tf":1.0}}}},"df":0,"docs":{}}},"t":{"a":{"d":{"a":{"df":0,"docs":{},"t":{"a":{"df":5,"docs":{"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":2.0},"14":{"tf":1.0},"17":{"tf":1.7320508075688772}}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}},"f":{"a":{"df":6,"docs":{"1":{"tf":1.4142135623730951},"2":{"tf":1.0},"25":{"tf":1.0},"29":{"tf":1.4142135623730951},"31":{"tf":1.4142135623730951},"48":{"tf":2.23606797749979}}},"df":0,"docs":{}},"i":{"d":{"d":{"df":0,"docs":{},"l":{"df":0,"docs":{},"e":{"df":0,"docs":{},"w":{"a":{"df":0,"docs":{},"r":{"df":2,"docs":{"17":{"tf":1.4142135623730951},"48":{"tf":1.0}}}},"df":0,"docs":{}}}}},"df":0,"docs":{}},"df":1,"docs":{"13":{"tf":1.4142135623730951}},"g":{"df":0,"docs":{},"r":{"a":{"df":0,"docs":{},"t":{"df":5,"docs":{"12":{"tf":1.0},"31":{"tf":2.8284271247461903},"32":{"tf":2.449489742783178},"34":{"tf":1.0},"48":{"tf":1.7320508075688772}},"e":{"_":{"d":{"b":{"_":{"df":0,"docs":{},"f":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"m":{"=":{"df":0,"docs":{},"s":{"df":0,"docs":{},"q":{"df":0,"docs":{},"l":{"df":0,"docs":{},"i":{"df":0,"docs":{},"t":{"df":0,"docs":{},"e":{":":{"d":{"a":{"df":0,"docs":{},"t":{"a":{"/":{"df":0,"docs":{},"r":{"a":{"df":0,"docs":{},"u":{"df":0,"docs":{},"t":{"df":0,"docs":{},"h":{"df":0,"docs":{},"y":{".":{"d":{"b":{"df":1,"docs":{"48":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}}}}},"df":1,"docs":{"32":{"tf":2.8284271247461903}}}}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}},"df":0,"docs":{}}},"n":{"d":{"df":2,"docs":{"24":{"tf":1.0},"31":{"tf":1.4142135623730951}}},"df":2,"docs":{"34":{"tf":1.0},"48":{"tf":1.0}},"u":{"df":0,"docs":{},"t":{"df":1,"docs":{"48":{"tf":1.4142135623730951}}}}},"s":{"c":{"df":0,"docs":{},"o":{"df":0,"docs":{},"n":{"df":0,"docs":{},"f":{"df":0,"docs":{},"i":{"df":0,"docs":{},"g":{"df":0,"docs":{},"u":{"df":0,"docs":{},"r":{"df":1,"docs":{"39":{"tf":1.0}}}}}}}}}},"df":0,"docs":{},"s":{"df":2,"docs":{"2":{"tf":1.4142135623730951},"21":{"tf":1.0}}}}},"k":{"d":{"df":0,"docs":{},"i":{"df":0,"docs":{},"r":{"df":2,"docs":{"11":{"tf":1.0},"7":{"tf":1.4142135623730951}}}}},"df":0,"docs":{}},"l":{"_":{"df":0,"docs":{},"l":{"df":0,"docs":{},"t":{"_":{"df":0,"docs":{},"p":{"df":0,"docs":{},"w":{"d":{"_":{"df":0,"docs":{},"f":{"df":0,"docs":{},"i":{"df":0,"docs":{},"r":{"df":0,"docs":{},"s":{"df":0,"docs":{},"t":{"=":{"8":{"6":{"4":{"0":{"0":{"df":1,"docs":{"48":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}}},"r":{"df":0,"docs":{},"e":{"df":0,"docs":{},"s":{"df":0,"docs":{},"e":{"df":0,"docs":{},"t":{"=":{"3":{"0":{"df":1,"docs":{"48":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}}}},"df":0,"docs":{}},"df":0,"docs":{}}}},"df":0,"docs":{}}}},"df":1,"docs":{"48":{"tf":1.0}}},"o":{"d":{"df":0,"docs":{},"e":{"df":6,"docs":{"1":{"tf":1.0},"13":{"tf":1.7320508075688772},"36":{"tf":1.7320508075688772},"39":{"tf":1.0},"48":{"tf":1.0},"6":{"tf":1.4142135623730951}}},"i":{"df":0,"docs":{},"f":{"df":0,"docs":{},"i":{"df":3,"docs":{"1":{"tf":1.0},"47":{"tf":1.0},"48":{"tf":1.7320508075688772}}}}}},"df":0,"docs":{},"m":{"df":0,"docs":{},"e":{"df":0,"docs":{},"n":{"df":0,"docs":{},"t":{"df":1,"docs":{"1":{"tf":1.0}}}}}},"n":{"df":0,"docs":{},"t":{"df":0,"docs":{},"h":{"df":2,"docs":{"34":{"tf":1.0},"48":{"tf":1.0}}}}},"r":{"df":0,"docs":{},"e":{"df":7,"docs":{"1":{"tf":1.0},"17":{"tf":1.0},"3":{"tf":1.4142135623730951},"36":{"tf":1.4142135623730951},"48":{"tf":1.4142135623730951},"6":{"tf":1.0},"7":{"tf":2.23606797749979}}}},"u":{"df":0,"docs":{},"n":{"df":0,"docs":{},"t":{"df":3,"docs":{"34":{"tf":1.0},"47":{"tf":1.0},"7":{"tf":1.7320508075688772}},"p":{"a":{"df":0,"docs":{},"t":{"df":0,"docs":{},"h":{"df":2,"docs":{"13":{"tf":1.4142135623730951},"47":{"tf":1.7320508075688772}}}}},"df":0,"docs":{}}}}}},"s":{"df":1,"docs":{"48":{"tf":1.4142135623730951}}},"t":{"df":0,"docs":{},"l":{"df":4,"docs":{"41":{"tf":1.0},"43":{"tf":1.0},"45":{"tf":2.0},"48":{"tf":1.7320508075688772}}}},"u":{"c":{"df":0,"docs":{},"h":{"df":4,"docs":{"24":{"tf":1.0},"32":{"tf":1.0},"46":{"tf":1.0},"48":{"tf":1.0}}}},"df":0,"docs":{},"l":{"df":0,"docs":{},"t":{"df":0,"docs":{},"i":{"df":0,"docs":{},"p":{"df":0,"docs":{},"l":{"df":3,"docs":{"30":{"tf":1.0},"45":{"tf":1.0},"48":{"tf":1.4142135623730951}}}}}}}},"y":{"df":0,"docs":{},"s":{"df":0,"docs":{},"e":{"df":0,"docs":{},"l":{"df":0,"docs":{},"f":{"df":1,"docs":{"7":{"tf":1.0}}}}},"q":{"df":0,"docs":{},"l":{"df":2,"docs":{"1":{"tf":1.0},"2":{"tf":1.4142135623730951}}}}}}},"n":{"a":{"df":0,"docs":{},"m":{"df":0,"docs":{},"e":{"df":17,"docs":{"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":4.358898943540674},"14":{"tf":1.4142135623730951},"17":{"tf":2.8284271247461903},"2":{"tf":1.7320508075688772},"26":{"tf":1.0},"27":{"tf":1.0},"34":{"tf":1.0},"39":{"tf":1.4142135623730951},"43":{"tf":1.4142135623730951},"45":{"tf":1.4142135623730951},"46":{"tf":1.0},"47":{"tf":2.449489742783178},"48":{"tf":2.449489742783178},"6":{"tf":1.4142135623730951},"7":{"tf":1.0}},"s":{"df":0,"docs":{},"p":{"a":{"c":{"df":7,"docs":{"10":{"tf":1.4142135623730951},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.4142135623730951},"14":{"tf":1.0},"17":{"tf":1.7320508075688772},"9":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}}}}},"v":{"df":0,"docs":{},"i":{"df":0,"docs":{},"g":{"df":2,"docs":{"24":{"tf":1.0},"31":{"tf":1.0}}}}}},"df":3,"docs":{"15":{"tf":1.0},"21":{"tf":1.0},"47":{"tf":1.7320508075688772}},"e":{"a":{"df":0,"docs":{},"r":{"df":1,"docs":{"2":{"tf":1.0}}}},"c":{"df":0,"docs":{},"e":{"df":0,"docs":{},"s":{"df":0,"docs":{},"s":{"a":{"df":0,"docs":{},"r":{"df":0,"docs":{},"i":{"df":4,"docs":{"19":{"tf":1.0},"24":{"tf":1.0},"29":{"tf":1.0},"36":{"tf":1.0}}}}},"df":0,"docs":{}}}}},"df":0,"docs":{},"e":{"d":{"df":23,"docs":{"1":{"tf":1.7320508075688772},"11":{"tf":1.0},"12":{"tf":2.23606797749979},"13":{"tf":2.449489742783178},"14":{"tf":1.0},"17":{"tf":1.4142135623730951},"2":{"tf":1.0},"24":{"tf":1.4142135623730951},"25":{"tf":1.0},"26":{"tf":1.0},"27":{"tf":1.0},"3":{"tf":1.0},"31":{"tf":1.4142135623730951},"36":{"tf":1.0},"37":{"tf":1.0},"39":{"tf":1.0},"40":{"tf":1.0},"43":{"tf":2.0},"45":{"tf":1.4142135623730951},"47":{"tf":1.7320508075688772},"48":{"tf":2.6457513110645907},"6":{"tf":1.0},"7":{"tf":1.4142135623730951}}},"df":0,"docs":{}},"v":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":8,"docs":{"1":{"tf":1.0},"11":{"tf":1.0},"19":{"tf":1.0},"2":{"tf":2.0},"24":{"tf":1.0},"3":{"tf":1.4142135623730951},"36":{"tf":1.0},"48":{"tf":2.0}},"t":{"df":0,"docs":{},"h":{"df":0,"docs":{},"e":{"df":0,"docs":{},"l":{"df":0,"docs":{},"e":{"df":0,"docs":{},"s":{"df":0,"docs":{},"s":{"df":1,"docs":{"14":{"tf":1.0}}}}}}}}}}}},"w":{"df":15,"docs":{"0":{"tf":1.0},"1":{"tf":1.7320508075688772},"12":{"tf":1.0},"2":{"tf":1.0},"21":{"tf":1.7320508075688772},"22":{"tf":1.0},"29":{"tf":1.4142135623730951},"30":{"tf":1.0},"31":{"tf":2.23606797749979},"32":{"tf":1.0},"39":{"tf":1.0},"43":{"tf":1.0},"48":{"tf":2.23606797749979},"6":{"tf":1.0},"7":{"tf":1.7320508075688772}},"l":{"df":0,"docs":{},"i":{"df":4,"docs":{"19":{"tf":1.0},"31":{"tf":1.0},"47":{"tf":1.0},"48":{"tf":1.0}}}}},"x":{"df":0,"docs":{},"t":{"df":2,"docs":{"11":{"tf":1.0},"32":{"tf":1.4142135623730951}}}}},"i":{"c":{"df":0,"docs":{},"e":{"df":4,"docs":{"11":{"tf":1.0},"2":{"tf":1.0},"28":{"tf":1.0},"48":{"tf":1.0}}}},"df":0,"docs":{}},"o":{"d":{"df":0,"docs":{},"e":{"df":2,"docs":{"36":{"tf":1.0},"39":{"tf":1.7320508075688772}}}},"df":0,"docs":{},"n":{"df":2,"docs":{"29":{"tf":1.0},"48":{"tf":1.7320508075688772}}},"r":{"df":0,"docs":{},"m":{"a":{"df":0,"docs":{},"l":{"df":5,"docs":{"11":{"tf":1.0},"31":{"tf":1.0},"32":{"tf":1.0},"34":{"tf":1.0},"48":{"tf":1.0}}}},"df":0,"docs":{}}},"t":{"df":0,"docs":{},"e":{"df":5,"docs":{"21":{"tf":1.4142135623730951},"22":{"tf":1.0},"48":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.4142135623730951}}},"i":{"df":0,"docs":{},"f":{"df":1,"docs":{"2":{"tf":1.0}}}}},"w":{"df":5,"docs":{"15":{"tf":1.4142135623730951},"17":{"tf":1.0},"22":{"tf":1.0},"47":{"tf":1.4142135623730951},"7":{"tf":1.4142135623730951}}}},"s":{"df":1,"docs":{"10":{"tf":1.0}}},"u":{"df":0,"docs":{},"m":{"b":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":2,"docs":{"27":{"tf":1.0},"48":{"tf":1.7320508075688772}}}}},"df":0,"docs":{}}}},"o":{"b":{"df":0,"docs":{},"s":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"v":{"df":1,"docs":{"15":{"tf":1.0}}}}},"o":{"df":0,"docs":{},"l":{"df":0,"docs":{},"e":{"df":0,"docs":{},"t":{"df":1,"docs":{"24":{"tf":1.0}}}}}}}},"d":{"d":{"df":1,"docs":{"37":{"tf":1.0}}},"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":1,"docs":{"1":{"tf":1.0}}}}},"df":0,"docs":{},"f":{"df":0,"docs":{},"f":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":1,"docs":{"36":{"tf":1.0}}}},"l":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"df":1,"docs":{"48":{"tf":1.0}},"e":{"_":{"df":0,"docs":{},"t":{"df":0,"docs":{},"o":{"df":0,"docs":{},"k":{"df":0,"docs":{},"e":{"df":0,"docs":{},"n":{"_":{"df":0,"docs":{},"l":{"df":0,"docs":{},"i":{"df":0,"docs":{},"f":{"df":0,"docs":{},"e":{"df":0,"docs":{},"t":{"df":0,"docs":{},"i":{"df":0,"docs":{},"m":{"df":0,"docs":{},"e":{"=":{"7":{"2":{"0":{"df":1,"docs":{"48":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}}}}}}},"df":0,"docs":{}}}}}}},"df":0,"docs":{}}}}}}},"i":{"d":{"c":{"df":5,"docs":{"1":{"tf":1.7320508075688772},"2":{"tf":1.4142135623730951},"23":{"tf":1.0},"3":{"tf":1.0},"31":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}},"k":{"df":1,"docs":{"43":{"tf":1.4142135623730951}}},"l":{"d":{"df":2,"docs":{"1":{"tf":1.0},"31":{"tf":2.0}},"e":{"df":0,"docs":{},"r":{"df":5,"docs":{"1":{"tf":1.0},"3":{"tf":1.0},"31":{"tf":1.0},"34":{"tf":1.0},"48":{"tf":1.0}}}}},"df":0,"docs":{}},"n":{"c":{"df":7,"docs":{"1":{"tf":1.7320508075688772},"19":{"tf":1.0},"29":{"tf":1.0},"36":{"tf":1.4142135623730951},"39":{"tf":1.0},"48":{"tf":1.0},"7":{"tf":1.0}}},"df":11,"docs":{"13":{"tf":1.0},"2":{"tf":1.0},"24":{"tf":1.4142135623730951},"3":{"tf":1.0},"31":{"tf":1.0},"36":{"tf":1.4142135623730951},"38":{"tf":1.0},"39":{"tf":1.4142135623730951},"43":{"tf":1.4142135623730951},"48":{"tf":1.0},"7":{"tf":1.0}}},"p":{"a":{"df":0,"docs":{},"q":{"df":0,"docs":{},"u":{"df":1,"docs":{"12":{"tf":1.0}}}}},"df":0,"docs":{},"e":{"df":0,"docs":{},"n":{"_":{"df":0,"docs":{},"u":{"df":0,"docs":{},"s":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"_":{"df":0,"docs":{},"r":{"df":0,"docs":{},"e":{"df":0,"docs":{},"g":{"=":{"df":0,"docs":{},"t":{"df":0,"docs":{},"r":{"df":0,"docs":{},"u":{"df":1,"docs":{"48":{"tf":1.4142135623730951}}}}}},"df":0,"docs":{}}}}},"df":0,"docs":{}}}}}},"df":2,"docs":{"1":{"tf":1.0},"11":{"tf":1.0}},"i":{"d":{"df":1,"docs":{"1":{"tf":1.0}}},"df":0,"docs":{}},"s":{"df":0,"docs":{},"s":{"df":0,"docs":{},"l":{"df":3,"docs":{"43":{"tf":1.0},"45":{"tf":1.0},"48":{"tf":1.0}}}}}},"r":{"df":5,"docs":{"24":{"tf":1.7320508075688772},"29":{"tf":1.0},"31":{"tf":1.4142135623730951},"32":{"tf":1.0},"48":{"tf":1.0}}}},"i":{"df":0,"docs":{},"n":{"df":0,"docs":{},"i":{"df":0,"docs":{},"o":{"df":0,"docs":{},"n":{"df":1,"docs":{"29":{"tf":1.0}}}}}}},"t":{"df":0,"docs":{},"i":{"df":0,"docs":{},"m":{"df":2,"docs":{"36":{"tf":1.0},"37":{"tf":1.0}}},"o":{"df":0,"docs":{},"n":{"df":9,"docs":{"1":{"tf":1.4142135623730951},"12":{"tf":1.0},"2":{"tf":1.0},"24":{"tf":1.0},"32":{"tf":1.0},"36":{"tf":1.0},"43":{"tf":1.0},"45":{"tf":1.0},"7":{"tf":1.4142135623730951}}}}}}},"r":{"df":0,"docs":{},"i":{"df":0,"docs":{},"g":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"df":1,"docs":{"48":{"tf":1.4142135623730951}}}}}}},"s":{"df":5,"docs":{"1":{"tf":1.0},"28":{"tf":1.0},"29":{"tf":1.4142135623730951},"39":{"tf":1.0},"7":{"tf":1.4142135623730951}}},"t":{"df":0,"docs":{},"h":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":3,"docs":{"1":{"tf":1.0},"2":{"tf":1.0},"24":{"tf":1.0}},"w":{"df":0,"docs":{},"i":{"df":0,"docs":{},"s":{"df":2,"docs":{"13":{"tf":1.0},"48":{"tf":1.0}}}}}}}},"p":{"df":1,"docs":{"2":{"tf":1.0}}}},"u":{"df":0,"docs":{},"t":{"df":8,"docs":{"1":{"tf":1.0},"2":{"tf":1.0},"21":{"tf":1.0},"32":{"tf":1.0},"35":{"tf":1.0},"40":{"tf":1.0},"43":{"tf":1.0},"48":{"tf":1.4142135623730951}},"p":{"df":0,"docs":{},"u":{"df":0,"docs":{},"t":{"df":1,"docs":{"48":{"tf":1.0}}}}}}},"v":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":2,"docs":{"13":{"tf":1.0},"31":{"tf":1.0}},"l":{"a":{"df":0,"docs":{},"p":{"df":1,"docs":{"36":{"tf":1.0}}}},"df":0,"docs":{}},"r":{"df":0,"docs":{},"i":{"d":{"df":1,"docs":{"2":{"tf":1.4142135623730951}}},"df":0,"docs":{}}},"w":{"df":0,"docs":{},"r":{"df":0,"docs":{},"i":{"df":0,"docs":{},"t":{"df":4,"docs":{"13":{"tf":1.0},"32":{"tf":1.7320508075688772},"45":{"tf":1.0},"48":{"tf":2.0}},"t":{"df":0,"docs":{},"e":{"df":0,"docs":{},"n":{"df":1,"docs":{"48":{"tf":1.0}}}}}}}}}}}},"w":{"df":0,"docs":{},"n":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":2,"docs":{"48":{"tf":1.0},"7":{"tf":1.4142135623730951}}}}}}},"p":{"_":{"c":{"df":0,"docs":{},"o":{"df":0,"docs":{},"s":{"df":0,"docs":{},"t":{"df":1,"docs":{"48":{"tf":1.0}}}}}},"df":0,"docs":{}},"a":{"df":0,"docs":{},"g":{"df":0,"docs":{},"e":{"df":3,"docs":{"1":{"tf":1.7320508075688772},"2":{"tf":1.0},"21":{"tf":1.0}}}},"n":{"df":0,"docs":{},"i":{"c":{"df":1,"docs":{"39":{"tf":1.0}}},"df":0,"docs":{}}},"r":{"a":{"df":0,"docs":{},"l":{"df":0,"docs":{},"l":{"df":0,"docs":{},"e":{"df":0,"docs":{},"l":{"df":2,"docs":{"24":{"tf":1.4142135623730951},"48":{"tf":1.0}}}}}},"m":{"df":0,"docs":{},"e":{"df":0,"docs":{},"t":{"df":1,"docs":{"24":{"tf":1.0}}}}}},"df":0,"docs":{},"s":{"df":1,"docs":{"48":{"tf":1.0}}},"t":{"df":3,"docs":{"36":{"tf":1.0},"39":{"tf":1.0},"45":{"tf":1.0}},"i":{"df":3,"docs":{"0":{"tf":1.0},"26":{"tf":1.0},"48":{"tf":1.0}}}}},"s":{"df":0,"docs":{},"s":{"df":0,"docs":{},"k":{"df":0,"docs":{},"e":{"df":0,"docs":{},"y":{"df":1,"docs":{"1":{"tf":1.4142135623730951}}}}},"w":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"d":{"df":13,"docs":{"1":{"tf":1.7320508075688772},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"19":{"tf":1.4142135623730951},"21":{"tf":2.449489742783178},"22":{"tf":1.4142135623730951},"24":{"tf":1.4142135623730951},"29":{"tf":1.0},"31":{"tf":1.0},"43":{"tf":2.23606797749979},"48":{"tf":2.8284271247461903},"6":{"tf":1.4142135623730951}},"l":{"df":0,"docs":{},"e":{"df":0,"docs":{},"s":{"df":0,"docs":{},"s":{"df":3,"docs":{"1":{"tf":1.0},"29":{"tf":1.0},"48":{"tf":1.4142135623730951}}}}}}},"df":0,"docs":{}}}}},"t":{"df":6,"docs":{"11":{"tf":1.7320508075688772},"12":{"tf":1.7320508075688772},"13":{"tf":1.0},"14":{"tf":1.0},"17":{"tf":1.0},"7":{"tf":1.4142135623730951}},"e":{"df":0,"docs":{},"t":{"df":0,"docs":{},"h":{"df":0,"docs":{},"e":{"df":0,"docs":{},"g":{"df":0,"docs":{},"e":{"df":0,"docs":{},"n":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"a":{"df":0,"docs":{},"t":{"df":0,"docs":{},"e":{"d":{"b":{"a":{"df":0,"docs":{},"s":{"df":0,"docs":{},"e":{"6":{"4":{"df":0,"docs":{},"h":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":1,"docs":{"12":{"tf":1.0}}}}}},"df":0,"docs":{}},"df":0,"docs":{}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}},"df":0,"docs":{}}}}}}}}},"y":{"df":0,"docs":{},"o":{"df":0,"docs":{},"u":{"df":0,"docs":{},"r":{"df":0,"docs":{},"s":{"df":0,"docs":{},"m":{"df":0,"docs":{},"t":{"df":0,"docs":{},"p":{"df":0,"docs":{},"p":{"a":{"df":0,"docs":{},"s":{"df":0,"docs":{},"s":{"df":0,"docs":{},"w":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"d":{"df":0,"docs":{},"h":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":1,"docs":{"12":{"tf":1.0}}}}}},"df":0,"docs":{}}}}}}},"df":0,"docs":{}}}}}}}}}}}}},"t":{"df":0,"docs":{},"h":{"df":5,"docs":{"13":{"tf":1.4142135623730951},"45":{"tf":2.0},"46":{"tf":1.0},"48":{"tf":2.6457513110645907},"7":{"tf":1.0}}}}},"df":2,"docs":{"6":{"tf":1.4142135623730951},"7":{"tf":1.0}},"e":{"df":0,"docs":{},"m":{"df":3,"docs":{"45":{"tf":2.6457513110645907},"46":{"tf":1.0},"48":{"tf":3.0}}},"r":{"df":0,"docs":{},"f":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"df":0,"docs":{},"m":{"df":4,"docs":{"30":{"tf":1.0},"31":{"tf":1.0},"32":{"tf":1.0},"36":{"tf":1.7320508075688772}}}}}},"i":{"df":0,"docs":{},"o":{"d":{"df":0,"docs":{},"s":{"df":0,"docs":{},"e":{"c":{"df":0,"docs":{},"o":{"df":0,"docs":{},"n":{"d":{"df":1,"docs":{"13":{"tf":1.4142135623730951}}},"df":0,"docs":{}}}},"df":0,"docs":{}}}},"df":0,"docs":{}}},"m":{"a":{"df":0,"docs":{},"n":{"df":1,"docs":{"17":{"tf":1.0}}}},"df":0,"docs":{}},"s":{"df":0,"docs":{},"i":{"df":0,"docs":{},"s":{"df":0,"docs":{},"t":{"df":2,"docs":{"6":{"tf":1.0},"7":{"tf":1.0}}}}}}}},"g":{"1":{"5":{"df":1,"docs":{"48":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}},"h":{"df":0,"docs":{},"y":{"df":0,"docs":{},"s":{"df":0,"docs":{},"i":{"c":{"df":1,"docs":{"48":{"tf":1.0}}},"df":0,"docs":{}}}}},"i":{"df":1,"docs":{"1":{"tf":1.0}},"n":{"df":2,"docs":{"1":{"tf":1.0},"29":{"tf":1.4142135623730951}},"g":{"df":1,"docs":{"48":{"tf":1.7320508075688772}}}}},"k":{"c":{"df":0,"docs":{},"e":{"df":1,"docs":{"1":{"tf":1.0}}}},"df":0,"docs":{}},"l":{"a":{"c":{"df":0,"docs":{},"e":{"df":6,"docs":{"1":{"tf":1.0},"11":{"tf":1.0},"2":{"tf":1.4142135623730951},"23":{"tf":1.0},"30":{"tf":1.0},"7":{"tf":1.0}}}},"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"df":1,"docs":{"41":{"tf":1.0}}}},"n":{"df":1,"docs":{"2":{"tf":1.0}}}},"df":0,"docs":{},"e":{"a":{"df":0,"docs":{},"s":{"df":3,"docs":{"24":{"tf":1.0},"31":{"tf":1.0},"32":{"tf":1.0}}}},"df":0,"docs":{}}},"o":{"d":{"df":8,"docs":{"13":{"tf":1.0},"15":{"tf":1.0},"21":{"tf":1.0},"34":{"tf":1.0},"36":{"tf":1.7320508075688772},"39":{"tf":1.0},"41":{"tf":1.4142135623730951},"47":{"tf":1.0}}},"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"df":0,"docs":{},"t":{"df":8,"docs":{"13":{"tf":1.0},"23":{"tf":1.0},"29":{"tf":1.0},"30":{"tf":1.0},"31":{"tf":1.0},"36":{"tf":1.0},"39":{"tf":1.0},"7":{"tf":1.0}}}}},"r":{"df":0,"docs":{},"t":{"df":6,"docs":{"13":{"tf":3.605551275463989},"14":{"tf":1.0},"17":{"tf":1.4142135623730951},"27":{"tf":1.4142135623730951},"39":{"tf":1.4142135623730951},"48":{"tf":2.23606797749979}}}},"s":{"df":0,"docs":{},"s":{"df":0,"docs":{},"i":{"b":{"df":0,"docs":{},"l":{"df":9,"docs":{"1":{"tf":1.7320508075688772},"13":{"tf":1.0},"2":{"tf":1.0},"23":{"tf":1.0},"24":{"tf":1.0},"32":{"tf":1.0},"34":{"tf":1.4142135623730951},"39":{"tf":1.0},"48":{"tf":1.0}}}},"df":0,"docs":{}}},"t":{"df":0,"docs":{},"g":{"df":0,"docs":{},"r":{"df":6,"docs":{"1":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.4142135623730951},"32":{"tf":1.4142135623730951},"35":{"tf":1.4142135623730951},"48":{"tf":1.4142135623730951}},"e":{"df":0,"docs":{},"s":{"1":{"5":{"df":1,"docs":{"48":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{},"q":{"df":0,"docs":{},"l":{":":{"/":{"/":{"df":0,"docs":{},"u":{"df":0,"docs":{},"s":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{":":{"df":0,"docs":{},"p":{"a":{"df":0,"docs":{},"s":{"df":0,"docs":{},"s":{"df":0,"docs":{},"w":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"d":{"df":0,"docs":{},"w":{"df":0,"docs":{},"i":{"df":0,"docs":{},"t":{"df":0,"docs":{},"h":{"df":0,"docs":{},"o":{"df":0,"docs":{},"u":{"df":0,"docs":{},"t":{"df":0,"docs":{},"s":{"df":0,"docs":{},"p":{"df":0,"docs":{},"e":{"c":{"df":0,"docs":{},"i":{"a":{"df":0,"docs":{},"l":{"c":{"df":0,"docs":{},"h":{"a":{"df":0,"docs":{},"r":{"a":{"c":{"df":0,"docs":{},"t":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"s":{"@":{"df":0,"docs":{},"l":{"df":0,"docs":{},"o":{"c":{"a":{"df":0,"docs":{},"l":{"df":0,"docs":{},"h":{"df":0,"docs":{},"o":{"df":0,"docs":{},"s":{"df":0,"docs":{},"t":{":":{"5":{"4":{"3":{"2":{"/":{"d":{"a":{"df":0,"docs":{},"t":{"a":{"b":{"a":{"df":0,"docs":{},"s":{"df":0,"docs":{},"e":{"df":0,"docs":{},"n":{"a":{"df":0,"docs":{},"m":{"df":2,"docs":{"12":{"tf":1.0},"48":{"tf":1.0}}}},"df":0,"docs":{}}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}}}},"df":0,"docs":{}},"df":0,"docs":{}}}},"df":0,"docs":{}}}}}},"df":0,"docs":{}},"df":0,"docs":{}}},"df":0,"docs":{}}},"df":0,"docs":{}}},"df":0,"docs":{}}},"df":0,"docs":{}}}}}}}}}}}},"df":0,"docs":{}}}}}}},"df":0,"docs":{}}},"df":0,"docs":{}}}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}}}}}},"w":{"_":{"df":0,"docs":{},"e":{"df":0,"docs":{},"x":{"df":0,"docs":{},"p":{"=":{"3":{"0":{"0":{"df":1,"docs":{"48":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}},"i":{"df":0,"docs":{},"t":{"=":{"1":{"0":{"0":{"0":{"0":{"0":{"0":{"df":1,"docs":{"48":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}},"df":1,"docs":{"48":{"tf":2.0}}}},"r":{"a":{"c":{"df":0,"docs":{},"t":{"df":0,"docs":{},"i":{"c":{"df":1,"docs":{"31":{"tf":1.0}}},"df":0,"docs":{}}}},"df":0,"docs":{}},"df":0,"docs":{},"e":{"df":3,"docs":{"0":{"tf":1.0},"1":{"tf":1.0},"2":{"tf":1.0}},"s":{"df":0,"docs":{},"e":{"df":0,"docs":{},"n":{"df":0,"docs":{},"t":{"df":1,"docs":{"29":{"tf":1.0}}}}}},"t":{"df":0,"docs":{},"t":{"df":0,"docs":{},"i":{"df":3,"docs":{"1":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.4142135623730951}}}}},"v":{"df":0,"docs":{},"e":{"df":0,"docs":{},"n":{"df":0,"docs":{},"t":{"df":2,"docs":{"13":{"tf":1.0},"23":{"tf":1.0}}}}}}},"i":{"df":0,"docs":{},"m":{"df":0,"docs":{},"e":{"df":1,"docs":{"13":{"tf":1.0}}}},"v":{"a":{"df":0,"docs":{},"t":{"df":2,"docs":{"43":{"tf":2.0},"48":{"tf":1.0}}}},"df":0,"docs":{}}},"o":{"b":{"a":{"b":{"df":0,"docs":{},"l":{"df":1,"docs":{"2":{"tf":1.4142135623730951}}}},"df":0,"docs":{}},"df":0,"docs":{},"l":{"df":0,"docs":{},"e":{"df":0,"docs":{},"m":{"a":{"df":0,"docs":{},"t":{"df":1,"docs":{"48":{"tf":1.0}}}},"df":4,"docs":{"13":{"tf":1.0},"22":{"tf":1.0},"32":{"tf":1.4142135623730951},"48":{"tf":1.0}}}}}},"c":{"df":0,"docs":{},"e":{"d":{"df":0,"docs":{},"u":{"df":0,"docs":{},"r":{"df":1,"docs":{"47":{"tf":1.0}}}}},"df":4,"docs":{"15":{"tf":1.0},"17":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0}}}},"d":{"df":0,"docs":{},"u":{"c":{"df":0,"docs":{},"t":{"df":9,"docs":{"1":{"tf":1.4142135623730951},"13":{"tf":1.0},"16":{"tf":1.0},"17":{"tf":1.4142135623730951},"24":{"tf":1.0},"25":{"tf":1.0},"26":{"tf":1.0},"48":{"tf":2.23606797749979},"7":{"tf":1.4142135623730951}}}},"df":0,"docs":{}}},"df":0,"docs":{},"j":{"df":0,"docs":{},"e":{"c":{"df":0,"docs":{},"t":{"df":3,"docs":{"0":{"tf":1.4142135623730951},"1":{"tf":1.0},"43":{"tf":1.4142135623730951}}}},"df":0,"docs":{}}},"m":{"df":0,"docs":{},"p":{"df":0,"docs":{},"t":{"df":3,"docs":{"29":{"tf":1.0},"31":{"tf":1.0},"48":{"tf":1.4142135623730951}}}}},"o":{"df":0,"docs":{},"f":{"df":1,"docs":{"48":{"tf":1.0}}}},"p":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":1,"docs":{"13":{"tf":1.0}},"l":{"df":0,"docs":{},"i":{"df":1,"docs":{"13":{"tf":1.0}}}},"t":{"df":0,"docs":{},"i":{"df":1,"docs":{"48":{"tf":1.0}}}}}}},"v":{"df":0,"docs":{},"i":{"d":{"df":9,"docs":{"1":{"tf":2.23606797749979},"24":{"tf":1.4142135623730951},"36":{"tf":1.0},"39":{"tf":1.0},"43":{"tf":1.0},"45":{"tf":1.0},"46":{"tf":1.0},"48":{"tf":1.7320508075688772},"7":{"tf":1.7320508075688772}},"e":{"df":0,"docs":{},"i":{"df":0,"docs":{},"f":{"df":0,"docs":{},"y":{"df":0,"docs":{},"o":{"df":0,"docs":{},"u":{"df":0,"docs":{},"h":{"a":{"df":0,"docs":{},"v":{"df":0,"docs":{},"e":{"df":0,"docs":{},"m":{"df":0,"docs":{},"u":{"df":0,"docs":{},"l":{"df":0,"docs":{},"t":{"df":0,"docs":{},"i":{"df":0,"docs":{},"p":{"df":0,"docs":{},"l":{"df":0,"docs":{},"e":{"df":0,"docs":{},"o":{"df":0,"docs":{},"n":{"df":1,"docs":{"13":{"tf":1.0}}}}}}}}}}}}}}},"df":0,"docs":{}}}}}}}}},"df":0,"docs":{}}},"x":{"df":0,"docs":{},"i":{"df":2,"docs":{"13":{"tf":1.0},"48":{"tf":1.4142135623730951}}},"y":{"_":{"df":0,"docs":{},"m":{"df":0,"docs":{},"o":{"d":{"df":0,"docs":{},"e":{"=":{"df":0,"docs":{},"f":{"a":{"df":0,"docs":{},"l":{"df":0,"docs":{},"s":{"df":1,"docs":{"48":{"tf":1.0}}}}},"df":0,"docs":{}}},"df":0,"docs":{}}},"df":0,"docs":{}}}},"df":0,"docs":{}}}}},"u":{"b":{"_":{"df":0,"docs":{},"u":{"df":0,"docs":{},"r":{"df":0,"docs":{},"l":{"=":{"df":0,"docs":{},"l":{"df":0,"docs":{},"o":{"c":{"a":{"df":0,"docs":{},"l":{"df":0,"docs":{},"h":{"df":0,"docs":{},"o":{"df":0,"docs":{},"s":{"df":0,"docs":{},"t":{":":{"8":{"0":{"8":{"0":{"df":1,"docs":{"48":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}}}},"df":0,"docs":{}},"df":0,"docs":{}}}},"df":1,"docs":{"48":{"tf":1.4142135623730951}}}}}},"df":0,"docs":{},"l":{"df":0,"docs":{},"i":{"c":{"df":1,"docs":{"48":{"tf":1.4142135623730951}}},"df":0,"docs":{}}}},"df":0,"docs":{},"r":{"df":0,"docs":{},"p":{"df":0,"docs":{},"o":{"df":0,"docs":{},"s":{"df":4,"docs":{"10":{"tf":1.0},"2":{"tf":1.0},"31":{"tf":1.0},"8":{"tf":1.0}}}}}},"t":{"df":1,"docs":{"36":{"tf":1.0}},"t":{"df":0,"docs":{},"h":{"df":0,"docs":{},"e":{"df":0,"docs":{},"w":{"df":0,"docs":{},"h":{"df":0,"docs":{},"o":{"df":0,"docs":{},"l":{"df":0,"docs":{},"e":{"df":0,"docs":{},"v":{"a":{"df":0,"docs":{},"l":{"df":0,"docs":{},"u":{"df":0,"docs":{},"e":{"df":0,"docs":{},"h":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":1,"docs":{"31":{"tf":1.0}}}}}}}}},"df":0,"docs":{}}}}}}}}}}}},"w":{"d":{")":{"/":{"df":0,"docs":{},"r":{"a":{"df":0,"docs":{},"u":{"df":0,"docs":{},"t":{"df":0,"docs":{},"h":{"df":0,"docs":{},"y":{"/":{"d":{"a":{"df":0,"docs":{},"t":{"a":{":":{"/":{"a":{"df":0,"docs":{},"p":{"df":0,"docs":{},"p":{"/":{"d":{"a":{"df":0,"docs":{},"t":{"a":{"df":1,"docs":{"7":{"tf":1.0}}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{},"r":{"a":{"df":0,"docs":{},"u":{"df":0,"docs":{},"t":{"df":0,"docs":{},"h":{"df":0,"docs":{},"y":{".":{"c":{"df":0,"docs":{},"f":{"df":0,"docs":{},"g":{":":{"/":{"a":{"df":0,"docs":{},"p":{"df":0,"docs":{},"p":{"/":{"df":0,"docs":{},"r":{"a":{"df":0,"docs":{},"u":{"df":0,"docs":{},"t":{"df":0,"docs":{},"h":{"df":0,"docs":{},"y":{".":{"c":{"df":0,"docs":{},"f":{"df":0,"docs":{},"g":{"df":1,"docs":{"7":{"tf":1.0}}}}},"df":0,"docs":{}},"df":0,"docs":{}}}}}},"df":0,"docs":{}}},"df":0,"docs":{}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}},"df":0,"docs":{}},"df":0,"docs":{}}}}}},"df":0,"docs":{}}},"df":0,"docs":{}}}}}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":1,"docs":{"7":{"tf":1.0}}},"df":0,"docs":{}}},"q":{"6":{"df":0,"docs":{},"u":{"2":{"6":{"df":0,"docs":{},"o":{"df":0,"docs":{},"n":{"df":0,"docs":{},"r":{"df":0,"docs":{},"v":{"df":0,"docs":{},"x":{"df":0,"docs":{},"v":{"df":0,"docs":{},"g":{"4":{"4":{"2":{"7":{"/":{"3":{"c":{"df":0,"docs":{},"e":{"c":{"8":{"df":0,"docs":{},"r":{"df":0,"docs":{},"j":{"df":0,"docs":{},"w":{"b":{"c":{"df":0,"docs":{},"m":{"df":0,"docs":{},"k":{"df":0,"docs":{},"r":{"b":{"df":0,"docs":{},"m":{"df":0,"docs":{},"k":{"df":0,"docs":{},"r":{"df":0,"docs":{},"x":{"df":0,"docs":{},"g":{"df":0,"docs":{},"x":{"6":{"5":{"a":{"df":0,"docs":{},"m":{"df":0,"docs":{},"j":{"df":0,"docs":{},"s":{"df":0,"docs":{},"n":{"df":0,"docs":{},"t":{"df":0,"docs":{},"g":{"df":0,"docs":{},"h":{"df":0,"docs":{},"s":{"a":{"df":2,"docs":{"31":{"tf":1.0},"48":{"tf":1.0}}},"df":0,"docs":{}}}}}}}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}}}}},"df":0,"docs":{}}}}},"df":0,"docs":{}},"df":0,"docs":{}}}}},"df":0,"docs":{}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}}}}}},"df":0,"docs":{}},"df":0,"docs":{}}},"df":0,"docs":{},"u":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"i":{"df":1,"docs":{"2":{"tf":1.0}}}}},"i":{"c":{"df":0,"docs":{},"k":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":1,"docs":{"32":{"tf":1.0}}}},"l":{"df":0,"docs":{},"i":{"df":1,"docs":{"24":{"tf":1.0}}}}}},"df":0,"docs":{},"t":{"df":1,"docs":{"1":{"tf":1.0}}}},"o":{"df":0,"docs":{},"r":{"df":0,"docs":{},"u":{"df":0,"docs":{},"m":{"df":3,"docs":{"36":{"tf":1.4142135623730951},"39":{"tf":1.4142135623730951},"48":{"tf":1.0}}}}}}}},"r":{"a":{"c":{"df":0,"docs":{},"e":{"df":1,"docs":{"48":{"tf":1.0}}}},"df":0,"docs":{},"n":{"d":{"df":0,"docs":{},"o":{"df":0,"docs":{},"m":{"df":2,"docs":{"12":{"tf":1.0},"48":{"tf":1.0}}}}},"df":0,"docs":{}},"s":{"df":0,"docs":{},"p":{"b":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"df":0,"docs":{},"i":{"df":1,"docs":{"1":{"tf":1.0}}}}}}},"df":0,"docs":{}}},"t":{"df":0,"docs":{},"e":{"df":2,"docs":{"13":{"tf":1.0},"24":{"tf":1.0}}}},"u":{"df":0,"docs":{},"t":{"df":0,"docs":{},"h":{"df":0,"docs":{},"i":{"df":32,"docs":{"1":{"tf":2.6457513110645907},"10":{"tf":1.7320508075688772},"11":{"tf":2.23606797749979},"12":{"tf":1.4142135623730951},"13":{"tf":4.242640687119285},"14":{"tf":1.7320508075688772},"15":{"tf":1.0},"17":{"tf":2.6457513110645907},"19":{"tf":1.4142135623730951},"2":{"tf":2.6457513110645907},"20":{"tf":1.0},"21":{"tf":2.0},"22":{"tf":1.0},"23":{"tf":1.4142135623730951},"24":{"tf":1.4142135623730951},"27":{"tf":1.0},"29":{"tf":1.0},"3":{"tf":1.4142135623730951},"31":{"tf":1.0},"32":{"tf":1.0},"34":{"tf":1.4142135623730951},"35":{"tf":1.0},"36":{"tf":1.4142135623730951},"39":{"tf":2.0},"4":{"tf":1.0},"43":{"tf":1.7320508075688772},"46":{"tf":1.0},"47":{"tf":2.8284271247461903},"48":{"tf":4.0},"6":{"tf":2.449489742783178},"7":{"tf":2.6457513110645907},"9":{"tf":1.0}}},"y":{"'":{"df":4,"docs":{"2":{"tf":1.0},"32":{"tf":1.0},"48":{"tf":1.0},"7":{"tf":1.0}}},".":{"c":{"df":0,"docs":{},"f":{"df":0,"docs":{},"g":{"df":2,"docs":{"11":{"tf":1.0},"13":{"tf":1.0}}}}},"df":0,"docs":{}},"/":{"d":{"a":{"df":0,"docs":{},"t":{"a":{"df":1,"docs":{"7":{"tf":2.0}}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{},"r":{"a":{"df":0,"docs":{},"u":{"df":0,"docs":{},"t":{"df":0,"docs":{},"h":{"df":0,"docs":{},"y":{".":{"c":{"df":0,"docs":{},"f":{"df":0,"docs":{},"g":{"df":1,"docs":{"7":{"tf":1.4142135623730951}}}}},"df":0,"docs":{}},"df":0,"docs":{}}}}}},"df":0,"docs":{}}},"@":{"df":0,"docs":{},"l":{"df":0,"docs":{},"o":{"c":{"a":{"df":0,"docs":{},"l":{"df":0,"docs":{},"h":{"df":0,"docs":{},"o":{"df":0,"docs":{},"s":{"df":0,"docs":{},"t":{".":{"d":{"df":1,"docs":{"48":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}}}}}}},"df":0,"docs":{}},"df":0,"docs":{}}}},"_":{"a":{"d":{"df":0,"docs":{},"m":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"df":1,"docs":{"23":{"tf":1.7320508075688772}}}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}}},"df":1,"docs":{"7":{"tf":1.7320508075688772}},"e":{"a":{"c":{"df":0,"docs":{},"h":{"df":3,"docs":{"36":{"tf":1.0},"39":{"tf":1.0},"48":{"tf":1.0}}}},"d":{"df":1,"docs":{"7":{"tf":1.4142135623730951}},"e":{"df":0,"docs":{},"r":{"df":1,"docs":{"1":{"tf":1.0}}}},"i":{"df":1,"docs":{"15":{"tf":1.0}},"n":{"df":0,"docs":{},"e":{"df":0,"docs":{},"s":{"df":0,"docs":{},"s":{"df":0,"docs":{},"p":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"b":{"df":1,"docs":{"13":{"tf":1.0}}},"df":0,"docs":{}}}}}}}}},"o":{"df":0,"docs":{},"n":{"df":0,"docs":{},"l":{"df":0,"docs":{},"i":{"df":2,"docs":{"13":{"tf":1.4142135623730951},"47":{"tf":1.7320508075688772}}}}}},"w":{"df":0,"docs":{},"r":{"df":0,"docs":{},"i":{"df":0,"docs":{},"t":{"df":0,"docs":{},"e":{"df":0,"docs":{},"o":{"df":0,"docs":{},"n":{"c":{"df":1,"docs":{"13":{"tf":1.0}}},"df":0,"docs":{}}}}}}}}},"df":0,"docs":{},"l":{"df":4,"docs":{"24":{"tf":1.0},"29":{"tf":1.0},"36":{"tf":1.0},"43":{"tf":1.0}},"l":{"df":0,"docs":{},"i":{"df":5,"docs":{"13":{"tf":1.0},"14":{"tf":1.0},"24":{"tf":1.7320508075688772},"36":{"tf":1.4142135623730951},"39":{"tf":1.0}}}}},"s":{"df":0,"docs":{},"o":{"df":0,"docs":{},"n":{"df":6,"docs":{"1":{"tf":1.4142135623730951},"29":{"tf":1.0},"36":{"tf":1.0},"39":{"tf":1.4142135623730951},"7":{"tf":1.0},"9":{"tf":1.0}}}}}},"c":{"df":0,"docs":{},"e":{"df":0,"docs":{},"i":{"df":0,"docs":{},"v":{"df":1,"docs":{"22":{"tf":1.4142135623730951}}}}},"o":{"df":0,"docs":{},"g":{"df":0,"docs":{},"n":{"df":1,"docs":{"31":{"tf":1.0}}}},"m":{"df":0,"docs":{},"m":{"df":0,"docs":{},"e":{"df":0,"docs":{},"n":{"d":{"df":2,"docs":{"13":{"tf":1.0},"41":{"tf":1.0}}},"df":0,"docs":{}}}}},"n":{"df":0,"docs":{},"n":{"df":0,"docs":{},"e":{"c":{"df":0,"docs":{},"t":{"df":1,"docs":{"48":{"tf":1.0}}}},"df":0,"docs":{}}}}}},"d":{"df":0,"docs":{},"h":{"a":{"c":{".":{"df":0,"docs":{},"l":{"df":0,"docs":{},"o":{"c":{"a":{"df":0,"docs":{},"l":{".":{"c":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"t":{".":{"df":0,"docs":{},"p":{"df":0,"docs":{},"e":{"df":0,"docs":{},"m":{"df":1,"docs":{"43":{"tf":1.0}}}}}},"df":0,"docs":{}}}}},"df":0,"docs":{},"k":{"df":0,"docs":{},"e":{"df":0,"docs":{},"y":{".":{"df":0,"docs":{},"p":{"df":0,"docs":{},"e":{"df":0,"docs":{},"m":{"df":1,"docs":{"43":{"tf":1.0}}}}}},"df":0,"docs":{}}}}},"df":0,"docs":{}}},"df":3,"docs":{"43":{"tf":1.0},"45":{"tf":1.4142135623730951},"48":{"tf":1.0}}},"df":0,"docs":{}}}},"df":4,"docs":{"1":{"tf":1.0},"36":{"tf":1.0},"45":{"tf":1.0},"47":{"tf":3.3166247903554}}},"df":0,"docs":{}},"df":0,"docs":{}},"i":{"df":0,"docs":{},"r":{"df":0,"docs":{},"e":{"c":{"df":0,"docs":{},"t":{"df":1,"docs":{"17":{"tf":1.0}},"s":{"c":{"df":0,"docs":{},"h":{"df":0,"docs":{},"e":{"df":0,"docs":{},"m":{"df":1,"docs":{"17":{"tf":1.0}}}}}},"df":0,"docs":{}}}},"df":0,"docs":{}}}},"u":{"c":{"df":1,"docs":{"1":{"tf":1.0}}},"df":0,"docs":{}}},"df":1,"docs":{"31":{"tf":1.4142135623730951}},"f":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":4,"docs":{"11":{"tf":1.4142135623730951},"44":{"tf":1.0},"48":{"tf":1.0},"7":{"tf":1.0}}}},"r":{"df":0,"docs":{},"e":{"df":0,"docs":{},"s":{"df":0,"docs":{},"h":{"_":{"df":0,"docs":{},"t":{"df":0,"docs":{},"o":{"df":0,"docs":{},"k":{"df":0,"docs":{},"e":{"df":0,"docs":{},"n":{"_":{"df":0,"docs":{},"g":{"df":0,"docs":{},"r":{"a":{"c":{"df":0,"docs":{},"e":{"_":{"df":0,"docs":{},"t":{"df":0,"docs":{},"i":{"df":0,"docs":{},"m":{"df":0,"docs":{},"e":{"=":{"5":{"df":1,"docs":{"48":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}}}}}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{}}}},"df":0,"docs":{}}}}}}},"df":1,"docs":{"48":{"tf":1.4142135623730951}}}}}}},"g":{"a":{"df":0,"docs":{},"r":{"d":{"df":1,"docs":{"3":{"tf":1.0}}},"df":0,"docs":{}}},"df":0,"docs":{},"i":{"df":0,"docs":{},"s":{"df":0,"docs":{},"t":{"df":4,"docs":{"1":{"tf":1.0},"26":{"tf":1.0},"28":{"tf":1.0},"48":{"tf":1.0}},"r":{"df":2,"docs":{"22":{"tf":1.0},"48":{"tf":2.0}},"i":{"df":1,"docs":{"13":{"tf":1.0}}}}}}}},"l":{"a":{"df":0,"docs":{},"y":{"df":2,"docs":{"26":{"tf":1.0},"48":{"tf":1.0}}}},"df":0,"docs":{},"e":{"a":{"df":0,"docs":{},"s":{"df":0,"docs":{},"e":{"df":0,"docs":{},"s":{"]":{"(":{"df":0,"docs":{},"h":{"df":0,"docs":{},"t":{"df":0,"docs":{},"t":{"df":0,"docs":{},"p":{"df":0,"docs":{},"s":{":":{"/":{"/":{"df":0,"docs":{},"g":{"df":0,"docs":{},"i":{"df":0,"docs":{},"t":{"df":0,"docs":{},"h":{"df":0,"docs":{},"u":{"b":{".":{"c":{"df":0,"docs":{},"o":{"df":0,"docs":{},"m":{"/":{"df":0,"docs":{},"s":{"df":0,"docs":{},"e":{"b":{"a":{"d":{"df":0,"docs":{},"o":{"b":{"/":{"df":0,"docs":{},"r":{"a":{"df":0,"docs":{},"u":{"df":0,"docs":{},"t":{"df":0,"docs":{},"h":{"df":0,"docs":{},"y":{"/":{"df":0,"docs":{},"r":{"df":0,"docs":{},"e":{"df":0,"docs":{},"l":{"df":0,"docs":{},"e":{"a":{"df":0,"docs":{},"s":{"df":1,"docs":{"13":{"tf":1.0}}}},"df":0,"docs":{}}}}}},"df":0,"docs":{}}}}}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}},"df":0,"docs":{}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}}}},"df":0,"docs":{}},"df":0,"docs":{}}}}},"df":0,"docs":{}}},"m":{"df":0,"docs":{},"o":{"df":0,"docs":{},"t":{"df":3,"docs":{"1":{"tf":1.0},"48":{"tf":1.0},"7":{"tf":1.0}}},"v":{"df":2,"docs":{"31":{"tf":2.23606797749979},"32":{"tf":1.7320508075688772}}}}},"n":{"a":{"df":0,"docs":{},"m":{"df":2,"docs":{"46":{"tf":1.0},"47":{"tf":1.0}}}},"df":0,"docs":{}},"p":{"df":0,"docs":{},"l":{"a":{"c":{"df":2,"docs":{"31":{"tf":1.4142135623730951},"7":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{},"i":{"c":{"a":{"df":4,"docs":{"13":{"tf":1.4142135623730951},"36":{"tf":2.449489742783178},"39":{"tf":1.4142135623730951},"9":{"tf":1.0}}},"df":1,"docs":{"3":{"tf":1.0}}},"df":0,"docs":{}}},"o":{"df":0,"docs":{},"s":{"df":0,"docs":{},"i":{"df":0,"docs":{},"t":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"df":0,"docs":{},"i":{"df":1,"docs":{"43":{"tf":1.0}}}}}}}}},"r":{"df":0,"docs":{},"o":{"d":{"df":0,"docs":{},"u":{"c":{"df":1,"docs":{"32":{"tf":1.0}}},"df":0,"docs":{}}},"df":0,"docs":{}}}},"q":{"df":0,"docs":{},"u":{"df":0,"docs":{},"e":{"df":0,"docs":{},"s":{"df":0,"docs":{},"t":{"df":6,"docs":{"1":{"tf":1.0},"13":{"tf":2.23606797749979},"28":{"tf":1.0},"36":{"tf":1.0},"39":{"tf":1.0},"48":{"tf":3.4641016151377544}}}}},"i":{"df":0,"docs":{},"r":{"df":1,"docs":{"32":{"tf":1.0}}}}}},"s":{"df":0,"docs":{},"e":{"df":0,"docs":{},"t":{"df":3,"docs":{"12":{"tf":1.0},"22":{"tf":1.0},"48":{"tf":1.4142135623730951}}}},"i":{"df":0,"docs":{},"l":{"df":0,"docs":{},"i":{"df":1,"docs":{"36":{"tf":1.0}}}}},"o":{"df":0,"docs":{},"u":{"df":0,"docs":{},"r":{"c":{"df":5,"docs":{"1":{"tf":1.0},"13":{"tf":2.0},"14":{"tf":1.0},"24":{"tf":1.7320508075688772},"36":{"tf":1.0}}},"df":0,"docs":{}}}},"s":{"df":0,"docs":{},"o":{"df":0,"docs":{},"u":{"df":0,"docs":{},"r":{"c":{"df":1,"docs":{"24":{"tf":1.0}}},"df":0,"docs":{}}}}},"t":{"a":{"df":0,"docs":{},"r":{"df":0,"docs":{},"t":{"df":6,"docs":{"21":{"tf":1.0},"22":{"tf":1.0},"24":{"tf":1.0},"32":{"tf":1.4142135623730951},"47":{"tf":1.0},"6":{"tf":1.0}}}}},"df":3,"docs":{"13":{"tf":1.0},"46":{"tf":1.0},"47":{"tf":2.0}},"r":{"df":0,"docs":{},"i":{"c":{"df":0,"docs":{},"t":{"df":3,"docs":{"24":{"tf":1.0},"48":{"tf":1.0},"7":{"tf":1.0}}}},"df":0,"docs":{}}}}},"v":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"s":{"df":2,"docs":{"13":{"tf":1.0},"48":{"tf":1.4142135623730951}}}}}},"w":{"df":0,"docs":{},"r":{"df":0,"docs":{},"i":{"df":0,"docs":{},"t":{"df":0,"docs":{},"t":{"df":0,"docs":{},"e":{"df":0,"docs":{},"n":{"df":1,"docs":{"2":{"tf":1.0}}}}}}}}}},"i":{"df":0,"docs":{},"g":{"df":0,"docs":{},"h":{"df":0,"docs":{},"t":{"df":2,"docs":{"22":{"tf":1.0},"7":{"tf":1.7320508075688772}}}}},"s":{"df":0,"docs":{},"k":{"df":2,"docs":{"0":{"tf":1.0},"39":{"tf":1.0}}}}},"m":{"df":1,"docs":{"6":{"tf":1.4142135623730951}}},"o":{"df":0,"docs":{},"l":{"df":0,"docs":{},"e":{"df":1,"docs":{"23":{"tf":2.23606797749979}}}},"t":{"a":{"df":0,"docs":{},"t":{"df":2,"docs":{"30":{"tf":1.0},"31":{"tf":1.4142135623730951}}}},"df":0,"docs":{}},"u":{"df":0,"docs":{},"g":{"df":0,"docs":{},"h":{"df":1,"docs":{"1":{"tf":1.0}}}},"t":{"df":2,"docs":{"14":{"tf":1.0},"17":{"tf":1.4142135623730951}}}}},"p":{"_":{"b":{"df":0,"docs":{},"n":{"a":{"df":0,"docs":{},"e":{"df":1,"docs":{"28":{"tf":1.0}}}},"df":0,"docs":{}}},"df":0,"docs":{},"i":{"d":{"=":{"a":{"df":0,"docs":{},"u":{"df":0,"docs":{},"t":{"df":0,"docs":{},"h":{".":{"df":0,"docs":{},"e":{"df":0,"docs":{},"x":{"a":{"df":0,"docs":{},"m":{"df":0,"docs":{},"p":{"df":0,"docs":{},"l":{"df":0,"docs":{},"e":{".":{"c":{"df":0,"docs":{},"o":{"df":0,"docs":{},"m":{"df":1,"docs":{"26":{"tf":1.0}}}}},"df":0,"docs":{}},"df":0,"docs":{}}}}}},"df":0,"docs":{}}}},"df":0,"docs":{}}}}},"df":0,"docs":{},"l":{"df":0,"docs":{},"o":{"c":{"a":{"df":0,"docs":{},"l":{"df":0,"docs":{},"h":{"df":0,"docs":{},"o":{"df":0,"docs":{},"s":{"df":0,"docs":{},"t":{"df":1,"docs":{"48":{"tf":1.0}}}}}}}},"df":0,"docs":{}},"df":0,"docs":{}}}},"df":1,"docs":{"26":{"tf":1.4142135623730951}}},"df":0,"docs":{}},"n":{"a":{"df":0,"docs":{},"m":{"df":0,"docs":{},"e":{"=":{"'":{"df":0,"docs":{},"r":{"a":{"df":0,"docs":{},"u":{"df":0,"docs":{},"t":{"df":0,"docs":{},"h":{"df":0,"docs":{},"i":{"df":1,"docs":{"48":{"tf":1.0}}}}}}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":1,"docs":{"28":{"tf":1.4142135623730951}}}}},"df":0,"docs":{}},"o":{"df":0,"docs":{},"r":{"df":0,"docs":{},"i":{"df":0,"docs":{},"g":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"=":{"df":0,"docs":{},"h":{"df":0,"docs":{},"t":{"df":0,"docs":{},"t":{"df":0,"docs":{},"p":{":":{"/":{"/":{"df":0,"docs":{},"l":{"df":0,"docs":{},"o":{"c":{"a":{"df":0,"docs":{},"l":{"df":0,"docs":{},"h":{"df":0,"docs":{},"o":{"df":0,"docs":{},"s":{"df":0,"docs":{},"t":{":":{"8":{"0":{"8":{"0":{"df":1,"docs":{"48":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}}}},"df":0,"docs":{}},"df":0,"docs":{}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{},"s":{":":{"/":{"/":{"a":{"df":0,"docs":{},"u":{"df":0,"docs":{},"t":{"df":0,"docs":{},"h":{".":{"df":0,"docs":{},"e":{"df":0,"docs":{},"x":{"a":{"df":0,"docs":{},"m":{"df":0,"docs":{},"p":{"df":0,"docs":{},"l":{"df":0,"docs":{},"e":{".":{"c":{"df":0,"docs":{},"o":{"df":0,"docs":{},"m":{":":{"4":{"4":{"3":{"df":1,"docs":{"27":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}},"df":0,"docs":{}},"df":0,"docs":{}}}}}},"df":0,"docs":{}}}},"df":0,"docs":{}}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}}}},"df":1,"docs":{"27":{"tf":1.7320508075688772}}}}}}}}},"df":2,"docs":{"26":{"tf":1.0},"48":{"tf":1.4142135623730951}}},"u":{"df":0,"docs":{},"l":{"df":0,"docs":{},"e":{"df":3,"docs":{"14":{"tf":1.0},"17":{"tf":1.4142135623730951},"24":{"tf":1.0}}}},"n":{"a":{"df":0,"docs":{},"s":{"df":0,"docs":{},"g":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"u":{"df":0,"docs":{},"p":{"df":1,"docs":{"13":{"tf":1.0}}}}}}},"u":{"df":0,"docs":{},"s":{"df":1,"docs":{"13":{"tf":1.0}}}}}},"df":11,"docs":{"1":{"tf":1.7320508075688772},"13":{"tf":1.0},"14":{"tf":1.0},"24":{"tf":1.4142135623730951},"36":{"tf":1.0},"39":{"tf":1.0},"4":{"tf":1.0},"48":{"tf":1.4142135623730951},"6":{"tf":1.4142135623730951},"7":{"tf":1.4142135623730951},"8":{"tf":1.0}},"t":{"df":0,"docs":{},"i":{"df":0,"docs":{},"m":{"df":4,"docs":{"12":{"tf":1.0},"13":{"tf":1.0},"48":{"tf":1.0},"6":{"tf":1.0}}}}}},"s":{"df":0,"docs":{},"t":{"df":3,"docs":{"1":{"tf":1.0},"13":{"tf":1.0},"36":{"tf":1.0}}}}}},"s":{"2":{"5":{"6":{"df":1,"docs":{"1":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}},"a":{"df":0,"docs":{},"f":{"df":0,"docs":{},"e":{"df":2,"docs":{"19":{"tf":1.0},"48":{"tf":1.0}},"r":{"df":1,"docs":{"48":{"tf":1.0}}},"s":{"df":0,"docs":{},"t":{"df":2,"docs":{"29":{"tf":1.0},"7":{"tf":1.0}}}},"t":{"df":0,"docs":{},"i":{"df":1,"docs":{"36":{"tf":1.4142135623730951}}}}}},"m":{"df":0,"docs":{},"e":{"df":11,"docs":{"17":{"tf":1.0},"23":{"tf":1.0},"24":{"tf":1.4142135623730951},"32":{"tf":1.0},"36":{"tf":1.0},"37":{"tf":1.0},"39":{"tf":1.0},"40":{"tf":1.0},"43":{"tf":1.0},"48":{"tf":2.0},"7":{"tf":1.0}}},"l":{"df":1,"docs":{"3":{"tf":1.4142135623730951}}}},"v":{"df":0,"docs":{},"e":{"df":2,"docs":{"34":{"tf":1.0},"48":{"tf":1.4142135623730951}}}}},"b":{"c":{"df":1,"docs":{"1":{"tf":1.0}}},"df":0,"docs":{}},"c":{"a":{"df":0,"docs":{},"l":{"df":0,"docs":{},"e":{"df":3,"docs":{"13":{"tf":1.0},"36":{"tf":1.7320508075688772},"9":{"tf":1.0}}}}},"df":0,"docs":{},"e":{"df":0,"docs":{},"n":{"a":{"df":0,"docs":{},"r":{"df":0,"docs":{},"i":{"df":0,"docs":{},"o":{"df":2,"docs":{"1":{"tf":1.0},"48":{"tf":1.0}}}}}},"df":0,"docs":{}}},"h":{"df":0,"docs":{},"e":{"d":{"_":{"d":{"df":0,"docs":{},"i":{"df":0,"docs":{},"s":{"a":{"b":{"df":0,"docs":{},"l":{"df":0,"docs":{},"e":{"=":{"df":0,"docs":{},"t":{"df":0,"docs":{},"r":{"df":0,"docs":{},"u":{"df":1,"docs":{"48":{"tf":1.0}}}}}},"df":0,"docs":{}}}},"df":0,"docs":{}},"df":0,"docs":{}}}},"df":0,"docs":{}},"df":0,"docs":{},"u":{"df":0,"docs":{},"l":{"df":1,"docs":{"48":{"tf":1.0}}}}},"df":0,"docs":{},"m":{"a":{"df":2,"docs":{"19":{"tf":1.0},"48":{"tf":1.7320508075688772}}},"df":0,"docs":{},"e":{":":{"/":{"/":{"df":0,"docs":{},"h":{"df":0,"docs":{},"o":{"df":0,"docs":{},"s":{"df":0,"docs":{},"t":{"df":0,"docs":{},"n":{"a":{"df":0,"docs":{},"m":{"df":0,"docs":{},"e":{":":{"df":0,"docs":{},"p":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"df":0,"docs":{},"t":{"df":1,"docs":{"48":{"tf":1.0}}}}}}},"df":0,"docs":{}}}},"df":0,"docs":{}}}}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":3,"docs":{"13":{"tf":2.0},"17":{"tf":1.0},"48":{"tf":1.0}}}}}},"r":{"df":0,"docs":{},"i":{"df":0,"docs":{},"p":{"df":0,"docs":{},"t":{"df":1,"docs":{"43":{"tf":1.4142135623730951}}}}}}},"d":{"df":1,"docs":{"1":{"tf":1.0}},"o":{"b":{"df":0,"docs":{},"e":{"d":{"df":0,"docs":{},"e":{"df":0,"docs":{},"v":{"/":{"df":0,"docs":{},"r":{"a":{"df":0,"docs":{},"u":{"df":0,"docs":{},"t":{"df":0,"docs":{},"h":{"df":0,"docs":{},"i":{"df":2,"docs":{"6":{"tf":1.4142135623730951},"7":{"tf":1.0}}},"y":{":":{"0":{".":{"1":{"3":{".":{"1":{"df":1,"docs":{"13":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}}},"df":0,"docs":{}}},"df":0,"docs":{}}}},"df":0,"docs":{}}},"df":0,"docs":{}}},"df":0,"docs":{},"e":{"c":{"df":2,"docs":{"34":{"tf":1.0},"48":{"tf":1.0}},"o":{"df":0,"docs":{},"n":{"d":{"df":7,"docs":{"27":{"tf":1.0},"29":{"tf":1.4142135623730951},"31":{"tf":1.0},"34":{"tf":1.0},"48":{"tf":3.3166247903554},"6":{"tf":1.0},"7":{"tf":1.0}}},"df":0,"docs":{}}},"r":{"df":0,"docs":{},"e":{"df":0,"docs":{},"t":{"df":13,"docs":{"11":{"tf":1.0},"12":{"tf":2.8284271247461903},"13":{"tf":1.7320508075688772},"17":{"tf":1.4142135623730951},"19":{"tf":1.4142135623730951},"30":{"tf":1.0},"31":{"tf":2.6457513110645907},"40":{"tf":1.4142135623730951},"46":{"tf":1.0},"47":{"tf":3.3166247903554},"48":{"tf":1.7320508075688772},"7":{"tf":1.0},"9":{"tf":1.0}},"k":{"df":0,"docs":{},"e":{"df":0,"docs":{},"y":{"df":0,"docs":{},"r":{"df":0,"docs":{},"e":{"df":0,"docs":{},"f":{"df":1,"docs":{"13":{"tf":1.7320508075688772}}}}}}}},"n":{"a":{"df":0,"docs":{},"m":{"df":2,"docs":{"17":{"tf":1.0},"47":{"tf":1.7320508075688772}}}},"df":0,"docs":{}},"s":{".":{"df":0,"docs":{},"y":{"a":{"df":0,"docs":{},"m":{"df":0,"docs":{},"l":{"df":1,"docs":{"12":{"tf":1.7320508075688772}}}}},"df":0,"docs":{}}},"df":0,"docs":{}}}}},"t":{"df":0,"docs":{},"i":{"df":0,"docs":{},"o":{"df":0,"docs":{},"n":{"df":2,"docs":{"44":{"tf":1.0},"47":{"tf":1.4142135623730951}}}}}},"u":{"df":0,"docs":{},"r":{"df":13,"docs":{"0":{"tf":1.0},"1":{"tf":1.7320508075688772},"12":{"tf":1.0},"13":{"tf":1.0},"19":{"tf":1.0},"24":{"tf":1.7320508075688772},"28":{"tf":1.0},"29":{"tf":1.0},"3":{"tf":1.0},"31":{"tf":1.0},"39":{"tf":1.0},"48":{"tf":1.4142135623730951},"7":{"tf":1.0}},"i":{"df":0,"docs":{},"t":{"df":0,"docs":{},"y":{"c":{"df":0,"docs":{},"o":{"df":0,"docs":{},"n":{"df":0,"docs":{},"t":{"df":0,"docs":{},"e":{"df":0,"docs":{},"x":{"df":0,"docs":{},"t":{"df":1,"docs":{"13":{"tf":1.4142135623730951}}}}}}}}},"df":0,"docs":{}}}}}}},"df":0,"docs":{},"e":{"df":5,"docs":{"13":{"tf":1.0},"2":{"tf":1.0},"31":{"tf":1.0},"43":{"tf":1.4142135623730951},"6":{"tf":1.4142135623730951}},"m":{"df":1,"docs":{"37":{"tf":1.0}}},"n":{"df":1,"docs":{"23":{"tf":1.0}}}},"l":{"df":0,"docs":{},"e":{"c":{"df":0,"docs":{},"t":{"df":1,"docs":{"31":{"tf":1.0}},"o":{"df":0,"docs":{},"r":{"df":1,"docs":{"13":{"tf":1.4142135623730951}}}}}},"df":0,"docs":{}}},"n":{"d":{"df":2,"docs":{"12":{"tf":1.0},"48":{"tf":1.0}}},"df":0,"docs":{},"s":{"df":2,"docs":{"13":{"tf":1.0},"48":{"tf":1.0}},"i":{"df":0,"docs":{},"s":{"df":0,"docs":{},"t":{"df":1,"docs":{"48":{"tf":1.0}}}},"t":{"df":4,"docs":{"11":{"tf":1.0},"12":{"tf":1.0},"19":{"tf":1.0},"48":{"tf":1.0}}}}},"t":{"df":1,"docs":{"48":{"tf":1.0}}}},"r":{"df":0,"docs":{},"v":{"df":1,"docs":{"2":{"tf":1.0}},"e":{"df":0,"docs":{},"r":{"df":7,"docs":{"36":{"tf":1.0},"39":{"tf":1.0},"43":{"tf":1.0},"45":{"tf":2.449489742783178},"46":{"tf":1.0},"47":{"tf":2.8284271247461903},"48":{"tf":3.1622776601683795}}}},"i":{"c":{"df":4,"docs":{"13":{"tf":1.0},"14":{"tf":1.0},"17":{"tf":1.4142135623730951},"41":{"tf":1.0}},"e":{"df":0,"docs":{},"n":{"a":{"df":0,"docs":{},"m":{"df":1,"docs":{"13":{"tf":1.0}}}},"df":0,"docs":{}}}},"df":0,"docs":{}}}},"s":{"df":0,"docs":{},"s":{"df":0,"docs":{},"i":{"df":0,"docs":{},"o":{"df":0,"docs":{},"n":{"_":{"df":0,"docs":{},"l":{"df":0,"docs":{},"i":{"df":0,"docs":{},"f":{"df":0,"docs":{},"e":{"df":0,"docs":{},"t":{"df":0,"docs":{},"i":{"df":0,"docs":{},"m":{"df":1,"docs":{"48":{"tf":1.0}},"e":{"=":{"1":{"4":{"4":{"0":{"0":{"df":1,"docs":{"48":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}}}}}},"r":{"df":0,"docs":{},"e":{"df":0,"docs":{},"n":{"df":0,"docs":{},"e":{"df":0,"docs":{},"w":{"_":{"df":0,"docs":{},"m":{"df":0,"docs":{},"f":{"a":{"=":{"df":0,"docs":{},"f":{"a":{"df":0,"docs":{},"l":{"df":0,"docs":{},"s":{"df":1,"docs":{"48":{"tf":1.0}}}}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{}}}},"df":0,"docs":{}}}}}},"t":{"df":0,"docs":{},"i":{"df":0,"docs":{},"m":{"df":0,"docs":{},"e":{"df":0,"docs":{},"o":{"df":0,"docs":{},"u":{"df":0,"docs":{},"t":{"=":{"5":{"4":{"0":{"0":{"df":1,"docs":{"48":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}}}}}},"df":1,"docs":{"48":{"tf":3.1622776601683795}}}}}}},"t":{"df":22,"docs":{"1":{"tf":1.0},"13":{"tf":1.4142135623730951},"19":{"tf":1.0},"2":{"tf":1.0},"21":{"tf":1.4142135623730951},"22":{"tf":1.4142135623730951},"24":{"tf":1.7320508075688772},"25":{"tf":1.0},"27":{"tf":1.0},"28":{"tf":1.0},"30":{"tf":1.0},"31":{"tf":1.4142135623730951},"32":{"tf":1.4142135623730951},"38":{"tf":1.0},"39":{"tf":1.0},"40":{"tf":1.0},"41":{"tf":1.0},"43":{"tf":1.4142135623730951},"44":{"tf":1.0},"45":{"tf":1.4142135623730951},"48":{"tf":3.7416573867739413},"9":{"tf":1.0}},"u":{"df":0,"docs":{},"p":{"df":10,"docs":{"13":{"tf":1.0},"16":{"tf":1.0},"22":{"tf":1.0},"24":{"tf":1.0},"32":{"tf":1.0},"43":{"tf":1.0},"45":{"tf":1.0},"47":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0}}}}},"v":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":1,"docs":{"1":{"tf":1.0}}}}}},"h":{"a":{"2":{"5":{"6":{"df":1,"docs":{"13":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":1,"docs":{"13":{"tf":1.7320508075688772}},"r":{"df":0,"docs":{},"e":{"df":1,"docs":{"36":{"tf":1.0}}}}},"df":0,"docs":{},"e":{"df":0,"docs":{},"l":{"df":0,"docs":{},"l":{"df":2,"docs":{"12":{"tf":1.0},"43":{"tf":1.0}}}}},"o":{"df":0,"docs":{},"w":{"df":2,"docs":{"28":{"tf":1.0},"48":{"tf":1.0}},"n":{"df":3,"docs":{"13":{"tf":1.0},"28":{"tf":1.4142135623730951},"7":{"tf":1.0}}}}},"u":{"df":0,"docs":{},"t":{"d":{"df":0,"docs":{},"o":{"df":0,"docs":{},"w":{"df":0,"docs":{},"n":{"df":1,"docs":{"6":{"tf":1.0}}}}}},"df":0,"docs":{}}}},"i":{"d":{"df":0,"docs":{},"e":{"df":1,"docs":{"48":{"tf":1.0}}}},"df":0,"docs":{},"g":{"df":0,"docs":{},"n":{"df":3,"docs":{"1":{"tf":1.4142135623730951},"19":{"tf":1.0},"43":{"tf":1.4142135623730951}}}},"m":{"df":0,"docs":{},"p":{"df":0,"docs":{},"l":{"df":6,"docs":{"1":{"tf":1.4142135623730951},"14":{"tf":1.0},"24":{"tf":1.0},"34":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}},"e":{"df":0,"docs":{},"r":{"df":1,"docs":{"46":{"tf":1.0}}}}}}},"n":{"df":0,"docs":{},"g":{"df":1,"docs":{"31":{"tf":1.0}},"l":{"df":6,"docs":{"1":{"tf":1.7320508075688772},"29":{"tf":1.4142135623730951},"32":{"tf":1.0},"36":{"tf":1.0},"48":{"tf":1.4142135623730951},"9":{"tf":1.4142135623730951}}}}},"t":{"df":0,"docs":{},"u":{"a":{"df":0,"docs":{},"t":{"df":2,"docs":{"36":{"tf":1.4142135623730951},"39":{"tf":1.0}}}},"df":0,"docs":{}}},"z":{"df":0,"docs":{},"e":{"df":1,"docs":{"48":{"tf":1.4142135623730951}}}}},"k":{"df":0,"docs":{},"i":{"df":0,"docs":{},"p":{"df":2,"docs":{"42":{"tf":1.0},"48":{"tf":1.0}}}}},"l":{"df":0,"docs":{},"o":{"df":0,"docs":{},"w":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":1,"docs":{"1":{"tf":1.0}}}}}}},"m":{"a":{"df":0,"docs":{},"l":{"df":0,"docs":{},"l":{"df":3,"docs":{"13":{"tf":1.0},"31":{"tf":1.0},"48":{"tf":1.4142135623730951}},"e":{"df":0,"docs":{},"r":{"df":1,"docs":{"24":{"tf":1.0}}}}}}},"df":0,"docs":{},"t":{"df":0,"docs":{},"p":{"_":{"df":0,"docs":{},"f":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"m":{"df":1,"docs":{"48":{"tf":1.0}}}}}},"p":{"a":{"df":0,"docs":{},"s":{"df":0,"docs":{},"s":{"df":0,"docs":{},"w":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"d":{"df":3,"docs":{"12":{"tf":1.4142135623730951},"13":{"tf":1.4142135623730951},"48":{"tf":1.0}}},"df":0,"docs":{}}}}}}},"df":0,"docs":{}},"u":{"df":0,"docs":{},"r":{"df":0,"docs":{},"l":{"df":1,"docs":{"48":{"tf":1.0}}}},"s":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"n":{"a":{"df":0,"docs":{},"m":{"df":1,"docs":{"48":{"tf":1.0}}}},"df":0,"docs":{}}}}}}},"df":1,"docs":{"22":{"tf":1.4142135623730951}}}}},"n":{"df":0,"docs":{},"i":{"df":2,"docs":{"45":{"tf":1.4142135623730951},"48":{"tf":1.0}}}},"o":{"df":0,"docs":{},"f":{"df":0,"docs":{},"t":{"df":0,"docs":{},"w":{"a":{"df":0,"docs":{},"r":{"df":3,"docs":{"0":{"tf":1.0},"2":{"tf":1.0},"3":{"tf":1.0}}}},"df":0,"docs":{}}}},"l":{"df":0,"docs":{},"u":{"df":0,"docs":{},"t":{"df":5,"docs":{"1":{"tf":1.4142135623730951},"2":{"tf":1.0},"3":{"tf":1.0},"32":{"tf":1.0},"7":{"tf":1.0}}}}},"m":{"df":0,"docs":{},"e":{"df":0,"docs":{},"o":{"df":0,"docs":{},"n":{"df":2,"docs":{"13":{"tf":1.0},"3":{"tf":1.0}}}},"t":{"df":0,"docs":{},"h":{"df":4,"docs":{"1":{"tf":1.0},"13":{"tf":1.4142135623730951},"17":{"tf":1.0},"31":{"tf":1.4142135623730951}}},"i":{"df":0,"docs":{},"m":{"df":1,"docs":{"48":{"tf":1.0}}}}},"w":{"df":0,"docs":{},"h":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":1,"docs":{"37":{"tf":1.0}}}}}}}},"u":{"df":0,"docs":{},"r":{"c":{"df":2,"docs":{"1":{"tf":1.0},"42":{"tf":1.0}}},"df":0,"docs":{}}}},"p":{"df":0,"docs":{},"e":{"c":{".":{"df":0,"docs":{},"t":{"df":0,"docs":{},"e":{"df":0,"docs":{},"m":{"df":0,"docs":{},"p":{"df":0,"docs":{},"l":{"a":{"df":0,"docs":{},"t":{"df":0,"docs":{},"e":{".":{"df":0,"docs":{},"s":{"df":0,"docs":{},"p":{"df":0,"docs":{},"e":{"c":{".":{"c":{"df":0,"docs":{},"o":{"df":0,"docs":{},"n":{"df":0,"docs":{},"t":{"a":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"s":{".":{"[":{"df":0,"docs":{},"r":{"a":{"df":0,"docs":{},"u":{"df":0,"docs":{},"t":{"df":0,"docs":{},"h":{"df":0,"docs":{},"y":{"]":{".":{"df":0,"docs":{},"v":{"df":0,"docs":{},"o":{"df":0,"docs":{},"l":{"df":0,"docs":{},"u":{"df":0,"docs":{},"m":{"df":0,"docs":{},"e":{"df":0,"docs":{},"m":{"df":0,"docs":{},"o":{"df":0,"docs":{},"u":{"df":0,"docs":{},"n":{"df":0,"docs":{},"t":{"df":1,"docs":{"47":{"tf":1.0}}}}}}}}}}}}}},"df":0,"docs":{}},"df":0,"docs":{}}}}}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{}}}}}}},"df":0,"docs":{}}}}},"df":0,"docs":{},"v":{"df":0,"docs":{},"o":{"df":0,"docs":{},"l":{"df":0,"docs":{},"u":{"df":0,"docs":{},"m":{"df":1,"docs":{"47":{"tf":1.0}}}}}}}},"df":0,"docs":{}},"df":0,"docs":{}}}}},"df":0,"docs":{}}}},"df":0,"docs":{}}}}}}},"df":3,"docs":{"13":{"tf":2.0},"14":{"tf":1.0},"17":{"tf":1.7320508075688772}},"i":{"a":{"df":0,"docs":{},"l":{"df":4,"docs":{"1":{"tf":1.0},"12":{"tf":1.0},"36":{"tf":1.0},"48":{"tf":1.7320508075688772}}}},"df":0,"docs":{},"f":{"df":4,"docs":{"2":{"tf":1.0},"32":{"tf":1.0},"43":{"tf":1.0},"48":{"tf":1.0}},"i":{"df":5,"docs":{"32":{"tf":1.0},"34":{"tf":1.0},"39":{"tf":1.0},"45":{"tf":1.4142135623730951},"48":{"tf":2.0}}}}}},"df":0,"docs":{},"e":{"d":{"df":1,"docs":{"1":{"tf":1.0}}},"df":0,"docs":{}}}},"q":{"df":0,"docs":{},"l":{"df":1,"docs":{"2":{"tf":1.0}},"i":{"df":0,"docs":{},"t":{"df":0,"docs":{},"e":{":":{":":{"df":0,"docs":{},"m":{"df":0,"docs":{},"e":{"df":0,"docs":{},"m":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"df":0,"docs":{},"i":{"df":2,"docs":{"12":{"tf":1.0},"48":{"tf":1.0}}}}}}}}},"d":{"a":{"df":0,"docs":{},"t":{"a":{"/":{"df":0,"docs":{},"r":{"a":{"df":0,"docs":{},"u":{"df":0,"docs":{},"t":{"df":0,"docs":{},"h":{"df":0,"docs":{},"y":{".":{"d":{"b":{"df":3,"docs":{"12":{"tf":1.4142135623730951},"48":{"tf":1.0},"7":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":9,"docs":{"1":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.4142135623730951},"13":{"tf":1.0},"32":{"tf":1.4142135623730951},"34":{"tf":1.7320508075688772},"48":{"tf":1.4142135623730951},"6":{"tf":1.0},"7":{"tf":2.0}}}}}}},"s":{"df":0,"docs":{},"o":{"df":1,"docs":{"1":{"tf":1.4142135623730951}}}},"t":{"a":{"df":0,"docs":{},"n":{"d":{"a":{"df":0,"docs":{},"l":{"df":0,"docs":{},"o":{"df":0,"docs":{},"n":{"df":1,"docs":{"48":{"tf":1.0}}}}},"r":{"d":{"df":1,"docs":{"48":{"tf":1.0}}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{}},"r":{"df":0,"docs":{},"t":{"df":15,"docs":{"13":{"tf":1.7320508075688772},"15":{"tf":1.0},"17":{"tf":1.0},"18":{"tf":1.0},"19":{"tf":1.7320508075688772},"23":{"tf":1.0},"30":{"tf":1.0},"32":{"tf":1.4142135623730951},"39":{"tf":1.0},"4":{"tf":1.0},"40":{"tf":1.0},"43":{"tf":1.4142135623730951},"48":{"tf":1.4142135623730951},"6":{"tf":2.0},"7":{"tf":1.7320508075688772}},"u":{"df":0,"docs":{},"p":{"df":2,"docs":{"32":{"tf":1.0},"7":{"tf":1.0}}}}}},"t":{"df":0,"docs":{},"e":{"df":2,"docs":{"13":{"tf":1.0},"9":{"tf":1.0}},"f":{"df":0,"docs":{},"u":{"df":0,"docs":{},"l":{"df":0,"docs":{},"s":{"df":0,"docs":{},"e":{"df":0,"docs":{},"t":{"df":2,"docs":{"13":{"tf":1.0},"39":{"tf":2.0}}}}}}}}},"i":{"c":{"df":2,"docs":{"1":{"tf":1.0},"30":{"tf":1.0}}},"df":0,"docs":{}}}},"d":{".":{"df":0,"docs":{},"y":{"a":{"df":0,"docs":{},"m":{"df":0,"docs":{},"l":{"df":1,"docs":{"47":{"tf":1.0}}}}},"df":0,"docs":{}}},"df":0,"docs":{},"o":{"df":0,"docs":{},"u":{"df":0,"docs":{},"t":{"df":1,"docs":{"48":{"tf":1.0}}}}}},"df":0,"docs":{},"e":{"df":0,"docs":{},"p":{"df":8,"docs":{"11":{"tf":1.0},"12":{"tf":1.4142135623730951},"15":{"tf":1.0},"17":{"tf":1.7320508075688772},"24":{"tf":1.0},"43":{"tf":1.4142135623730951},"7":{"tf":1.4142135623730951},"9":{"tf":1.0}}}},"i":{"df":0,"docs":{},"l":{"df":0,"docs":{},"l":{"df":4,"docs":{"1":{"tf":1.0},"24":{"tf":1.0},"36":{"tf":1.0},"48":{"tf":1.4142135623730951}}}}},"o":{"df":0,"docs":{},"n":{"df":0,"docs":{},"e":{"df":1,"docs":{"2":{"tf":1.0}}}},"p":{"df":4,"docs":{"26":{"tf":1.0},"31":{"tf":1.0},"48":{"tf":1.0},"6":{"tf":1.0}}},"r":{"a":{"df":0,"docs":{},"g":{"df":1,"docs":{"13":{"tf":1.0}},"e":{"c":{"df":0,"docs":{},"l":{"a":{"df":0,"docs":{},"s":{"df":0,"docs":{},"s":{"df":0,"docs":{},"n":{"a":{"df":0,"docs":{},"m":{"df":1,"docs":{"13":{"tf":1.0}}}},"df":0,"docs":{}}}}},"df":0,"docs":{}}},"df":0,"docs":{}}}},"df":0,"docs":{},"e":{"df":2,"docs":{"34":{"tf":1.4142135623730951},"48":{"tf":1.4142135623730951}}}}},"r":{"a":{"df":0,"docs":{},"i":{"df":0,"docs":{},"g":{"df":0,"docs":{},"h":{"df":0,"docs":{},"t":{"df":2,"docs":{"17":{"tf":1.0},"34":{"tf":1.0}}}}}},"t":{"df":0,"docs":{},"e":{"df":0,"docs":{},"g":{"df":0,"docs":{},"i":{"df":1,"docs":{"34":{"tf":1.0}}}}}}},"df":0,"docs":{},"e":{"a":{"df":0,"docs":{},"m":{"df":1,"docs":{"48":{"tf":1.0}}}},"df":0,"docs":{}},"i":{"df":0,"docs":{},"n":{"df":0,"docs":{},"g":{"df":2,"docs":{"12":{"tf":1.0},"48":{"tf":1.4142135623730951}}}}},"o":{"df":0,"docs":{},"n":{"df":0,"docs":{},"g":{"df":2,"docs":{"1":{"tf":1.0},"29":{"tf":1.4142135623730951}}}}}},"s":{".":{"df":0,"docs":{},"y":{"a":{"df":0,"docs":{},"m":{"df":0,"docs":{},"l":{"df":2,"docs":{"13":{"tf":1.4142135623730951},"47":{"tf":1.4142135623730951}}}}},"df":0,"docs":{}}},"df":0,"docs":{}},"u":{"df":0,"docs":{},"f":{"df":0,"docs":{},"f":{"df":1,"docs":{"43":{"tf":1.0}}}}},"y":{"df":0,"docs":{},"l":{"df":0,"docs":{},"i":{"df":0,"docs":{},"z":{"df":1,"docs":{"1":{"tf":1.0}}}}}}},"u":{"b":{"df":1,"docs":{"7":{"tf":1.0}},"j":{"df":0,"docs":{},"e":{"c":{"df":0,"docs":{},"t":{"df":2,"docs":{"45":{"tf":1.0},"48":{"tf":1.0}}}},"df":0,"docs":{}}},"p":{"a":{"df":0,"docs":{},"t":{"df":0,"docs":{},"h":{"df":1,"docs":{"13":{"tf":1.0}}}}},"df":0,"docs":{}}},"c":{"c":{"df":0,"docs":{},"e":{"df":0,"docs":{},"s":{"df":0,"docs":{},"s":{"df":2,"docs":{"31":{"tf":1.4142135623730951},"43":{"tf":1.4142135623730951}},"f":{"df":0,"docs":{},"u":{"df":0,"docs":{},"l":{"df":0,"docs":{},"l":{"df":0,"docs":{},"i":{"df":1,"docs":{"29":{"tf":1.0}}}}}}}}}}},"df":0,"docs":{}},"d":{"df":0,"docs":{},"o":{"df":1,"docs":{"7":{"tf":2.449489742783178}}}},"df":0,"docs":{},"f":{"df":0,"docs":{},"f":{"df":0,"docs":{},"i":{"c":{"df":0,"docs":{},"i":{"df":1,"docs":{"6":{"tf":1.0}}}},"df":0,"docs":{}}}},"g":{"df":0,"docs":{},"g":{"df":0,"docs":{},"e":{"df":0,"docs":{},"s":{"df":0,"docs":{},"t":{"df":1,"docs":{"17":{"tf":1.0}}}}}}},"p":{"df":0,"docs":{},"p":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"df":0,"docs":{},"t":{"df":3,"docs":{"1":{"tf":2.0},"2":{"tf":1.0},"29":{"tf":1.0}}}}}}},"r":{"df":0,"docs":{},"e":{"df":7,"docs":{"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.4142135623730951},"25":{"tf":1.4142135623730951},"31":{"tf":1.4142135623730951},"48":{"tf":1.4142135623730951},"7":{"tf":1.7320508075688772}}}}},"y":{"df":0,"docs":{},"n":{"c":{"df":1,"docs":{"36":{"tf":1.4142135623730951}}},"df":0,"docs":{}},"s":{"df":0,"docs":{},"t":{"df":0,"docs":{},"e":{"df":0,"docs":{},"m":{"df":6,"docs":{"1":{"tf":1.0},"24":{"tf":1.0},"29":{"tf":1.0},"43":{"tf":1.0},"48":{"tf":1.4142135623730951},"7":{"tf":1.0}}}}}}}},"t":{"_":{"c":{"df":0,"docs":{},"o":{"df":0,"docs":{},"s":{"df":0,"docs":{},"t":{"df":1,"docs":{"48":{"tf":1.0}}}}}},"df":0,"docs":{}},"a":{"df":0,"docs":{},"g":{"df":1,"docs":{"13":{"tf":2.0}}},"i":{"df":0,"docs":{},"l":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"df":1,"docs":{"43":{"tf":1.0}}}}}},"k":{"df":0,"docs":{},"e":{"df":7,"docs":{"13":{"tf":1.4142135623730951},"3":{"tf":1.0},"31":{"tf":1.0},"39":{"tf":1.0},"45":{"tf":1.0},"48":{"tf":1.0},"6":{"tf":1.4142135623730951}},"n":{"df":2,"docs":{"1":{"tf":1.0},"24":{"tf":1.0}}}}},"r":{"df":0,"docs":{},"g":{"df":0,"docs":{},"e":{"df":0,"docs":{},"t":{"df":1,"docs":{"32":{"tf":1.4142135623730951}},"p":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"df":0,"docs":{},"t":{"df":1,"docs":{"13":{"tf":1.7320508075688772}}}}}}}}}},"s":{"df":0,"docs":{},"k":{"df":1,"docs":{"35":{"tf":1.0}}}}},"df":0,"docs":{},"e":{"c":{"df":0,"docs":{},"h":{"df":0,"docs":{},"n":{"df":0,"docs":{},"i":{"c":{"df":1,"docs":{"24":{"tf":1.0}}},"df":0,"docs":{}}}}},"df":0,"docs":{},"m":{"df":0,"docs":{},"p":{"df":0,"docs":{},"l":{"a":{"df":0,"docs":{},"t":{"df":2,"docs":{"13":{"tf":1.0},"2":{"tf":1.0}}}},"df":0,"docs":{}}}},"r":{"df":0,"docs":{},"m":{"df":1,"docs":{"36":{"tf":1.0}}},"r":{"df":0,"docs":{},"i":{"b":{"df":0,"docs":{},"l":{"df":1,"docs":{"43":{"tf":1.0}}}},"df":0,"docs":{}}}},"s":{"df":0,"docs":{},"t":{"df":7,"docs":{"22":{"tf":1.0},"24":{"tf":1.0},"36":{"tf":1.0},"43":{"tf":1.4142135623730951},"48":{"tf":1.0},"6":{"tf":2.0},"7":{"tf":1.7320508075688772}}}}},"h":{"df":0,"docs":{},"e":{"df":0,"docs":{},"m":{"df":0,"docs":{},"e":{"df":2,"docs":{"1":{"tf":1.0},"3":{"tf":1.0}}},"s":{"df":0,"docs":{},"e":{"df":0,"docs":{},"l":{"df":0,"docs":{},"v":{"df":1,"docs":{"31":{"tf":1.0}}}}}}}},"i":{"df":0,"docs":{},"n":{"df":0,"docs":{},"g":{"df":8,"docs":{"1":{"tf":1.4142135623730951},"12":{"tf":1.0},"17":{"tf":1.4142135623730951},"2":{"tf":1.4142135623730951},"29":{"tf":1.0},"3":{"tf":1.7320508075688772},"31":{"tf":1.0},"7":{"tf":1.4142135623730951}}},"k":{"df":1,"docs":{"24":{"tf":1.0}}}},"r":{"d":{"df":1,"docs":{"0":{"tf":1.0}}},"df":0,"docs":{}}},"o":{"df":0,"docs":{},"u":{"df":0,"docs":{},"g":{"df":0,"docs":{},"h":{"df":6,"docs":{"0":{"tf":1.0},"1":{"tf":1.4142135623730951},"2":{"tf":1.0},"24":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0}}}}}},"r":{"df":0,"docs":{},"e":{"a":{"d":{"df":1,"docs":{"24":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}},"o":{"df":0,"docs":{},"w":{"df":1,"docs":{"43":{"tf":1.0}}}}}},"i":{"df":0,"docs":{},"m":{"df":0,"docs":{},"e":{"df":15,"docs":{"1":{"tf":1.0},"13":{"tf":1.0},"2":{"tf":1.0},"24":{"tf":1.4142135623730951},"28":{"tf":1.0},"31":{"tf":1.0},"32":{"tf":1.0},"36":{"tf":1.0},"37":{"tf":1.0},"39":{"tf":1.0},"4":{"tf":1.0},"43":{"tf":1.7320508075688772},"48":{"tf":2.8284271247461903},"7":{"tf":1.0},"8":{"tf":1.0}},"o":{"df":0,"docs":{},"u":{"df":0,"docs":{},"t":{"df":1,"docs":{"48":{"tf":3.0}}}}},"s":{"df":0,"docs":{},"t":{"a":{"df":0,"docs":{},"m":{"df":0,"docs":{},"p":{"df":2,"docs":{"34":{"tf":1.0},"48":{"tf":1.0}}}}},"df":0,"docs":{}}}}}},"l":{"df":9,"docs":{"17":{"tf":2.23606797749979},"41":{"tf":1.7320508075688772},"42":{"tf":1.4142135623730951},"43":{"tf":2.23606797749979},"44":{"tf":1.0},"45":{"tf":2.0},"46":{"tf":1.4142135623730951},"47":{"tf":3.3166247903554},"48":{"tf":3.0}},"s":{"/":{"c":{"a":{"df":2,"docs":{"45":{"tf":1.4142135623730951},"48":{"tf":1.4142135623730951}}},"df":0,"docs":{}},"df":0,"docs":{},"r":{"df":0,"docs":{},"e":{"d":{"df":0,"docs":{},"h":{"a":{"c":{".":{"df":0,"docs":{},"l":{"df":0,"docs":{},"o":{"c":{"a":{"df":0,"docs":{},"l":{".":{"c":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"t":{".":{"df":0,"docs":{},"p":{"df":0,"docs":{},"e":{"df":0,"docs":{},"m":{"df":2,"docs":{"45":{"tf":1.4142135623730951},"48":{"tf":1.4142135623730951}}}}}},"df":0,"docs":{}}}}},"df":0,"docs":{},"k":{"df":0,"docs":{},"e":{"df":0,"docs":{},"y":{".":{"df":0,"docs":{},"p":{"df":0,"docs":{},"e":{"df":0,"docs":{},"m":{"df":2,"docs":{"45":{"tf":1.4142135623730951},"48":{"tf":1.4142135623730951}}}}}},"df":0,"docs":{}}}}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}},"df":0,"docs":{}}},"t":{"df":0,"docs":{},"l":{"df":0,"docs":{},"s":{".":{"c":{"df":0,"docs":{},"r":{"df":0,"docs":{},"t":{"df":1,"docs":{"48":{"tf":1.0}}}}},"df":0,"docs":{},"k":{"df":0,"docs":{},"e":{"df":0,"docs":{},"y":{"df":1,"docs":{"48":{"tf":1.0}}}}}},"df":0,"docs":{}}}}},"_":{"c":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"t":{"=":{"df":0,"docs":{},"t":{"df":0,"docs":{},"l":{"df":0,"docs":{},"s":{"/":{"df":0,"docs":{},"t":{"df":0,"docs":{},"l":{"df":0,"docs":{},"s":{".":{"c":{"df":0,"docs":{},"r":{"df":0,"docs":{},"t":{"df":1,"docs":{"48":{"tf":1.0}}}}},"df":0,"docs":{}},"df":0,"docs":{}}}}},"df":0,"docs":{}}}}},"df":1,"docs":{"46":{"tf":1.0}}}}}},"df":0,"docs":{},"k":{"df":0,"docs":{},"e":{"df":0,"docs":{},"y":{"=":{"df":0,"docs":{},"t":{"df":0,"docs":{},"l":{"df":0,"docs":{},"s":{"/":{"df":0,"docs":{},"t":{"df":0,"docs":{},"l":{"df":0,"docs":{},"s":{".":{"df":0,"docs":{},"k":{"df":0,"docs":{},"e":{"df":0,"docs":{},"y":{"df":1,"docs":{"48":{"tf":1.0}}}}}},"df":0,"docs":{}}}}},"df":0,"docs":{}}}}},"df":1,"docs":{"46":{"tf":1.0}}}}}},"df":0,"docs":{}}},"o":{"d":{"df":0,"docs":{},"o":{"df":1,"docs":{"43":{"tf":1.0}}}},"df":0,"docs":{},"k":{"df":0,"docs":{},"e":{"df":0,"docs":{},"n":{"df":5,"docs":{"1":{"tf":1.0},"12":{"tf":1.0},"19":{"tf":1.0},"31":{"tf":1.0},"48":{"tf":2.8284271247461903}}}}},"o":{"df":0,"docs":{},"l":{"df":8,"docs":{"12":{"tf":1.0},"17":{"tf":1.0},"24":{"tf":1.0},"31":{"tf":1.4142135623730951},"35":{"tf":1.0},"43":{"tf":2.0},"45":{"tf":1.0},"48":{"tf":1.0}}}},"p":{"df":1,"docs":{"13":{"tf":1.0}}},"t":{"a":{"df":0,"docs":{},"l":{"df":1,"docs":{"48":{"tf":1.0}}}},"df":0,"docs":{}},"u":{"c":{"df":0,"docs":{},"h":{"df":5,"docs":{"1":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"48":{"tf":1.0}}}},"df":0,"docs":{}}},"r":{"a":{"c":{"df":0,"docs":{},"e":{"df":1,"docs":{"48":{"tf":1.0}}}},"d":{"df":0,"docs":{},"e":{"df":0,"docs":{},"o":{"df":0,"docs":{},"f":{"df":0,"docs":{},"f":{"df":1,"docs":{"1":{"tf":1.0}}}}}}},"df":0,"docs":{},"e":{"df":0,"docs":{},"f":{"df":0,"docs":{},"i":{"df":0,"docs":{},"k":{".":{"c":{"df":0,"docs":{},"o":{"df":0,"docs":{},"n":{"df":0,"docs":{},"t":{"a":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"df":0,"docs":{},"o":{".":{"df":0,"docs":{},"u":{"df":0,"docs":{},"s":{"/":{"df":0,"docs":{},"v":{"1":{"a":{"df":0,"docs":{},"l":{"df":0,"docs":{},"p":{"df":0,"docs":{},"h":{"a":{"1":{"df":2,"docs":{"14":{"tf":1.0},"17":{"tf":1.7320508075688772}}},"df":0,"docs":{}},"df":0,"docs":{}}}}},"df":0,"docs":{}},"df":0,"docs":{}}},"df":0,"docs":{}}}},"df":0,"docs":{}}}}},"df":0,"docs":{}}}}},"df":0,"docs":{}},"df":2,"docs":{"14":{"tf":1.0},"17":{"tf":1.0}}}}}},"f":{"df":0,"docs":{},"f":{"df":0,"docs":{},"i":{"c":{"df":1,"docs":{"41":{"tf":1.0}}},"df":0,"docs":{}}}},"n":{"df":0,"docs":{},"s":{"df":0,"docs":{},"l":{"a":{"df":0,"docs":{},"t":{"df":1,"docs":{"2":{"tf":1.7320508075688772}}}},"df":0,"docs":{}}}}},"df":3,"docs":{"12":{"tf":1.4142135623730951},"31":{"tf":1.4142135623730951},"40":{"tf":1.0}},"i":{"df":3,"docs":{"1":{"tf":1.0},"21":{"tf":1.0},"3":{"tf":1.0}},"g":{"df":0,"docs":{},"g":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":1,"docs":{"31":{"tf":1.0}}}}}}},"u":{"df":0,"docs":{},"e":{"df":6,"docs":{"12":{"tf":1.4142135623730951},"13":{"tf":1.0},"17":{"tf":1.0},"39":{"tf":1.0},"47":{"tf":1.7320508075688772},"48":{"tf":2.6457513110645907}},"|":{"df":0,"docs":{},"f":{"a":{"df":0,"docs":{},"l":{"df":0,"docs":{},"s":{"df":1,"docs":{"48":{"tf":1.0}}}}},"df":0,"docs":{}}}}}},"u":{"df":0,"docs":{},"n":{"df":0,"docs":{},"e":{"df":2,"docs":{"13":{"tf":1.0},"24":{"tf":1.7320508075688772}}}},"t":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"df":0,"docs":{},"i":{"df":1,"docs":{"43":{"tf":1.0}}}}}}},"y":{"df":0,"docs":{},"p":{"df":0,"docs":{},"e":{"df":2,"docs":{"12":{"tf":1.0},"43":{"tf":1.4142135623730951}}},"i":{"c":{"df":1,"docs":{"1":{"tf":1.0}}},"df":0,"docs":{}}}}},"u":{"df":0,"docs":{},"i":{"df":8,"docs":{"1":{"tf":1.0},"2":{"tf":1.7320508075688772},"21":{"tf":1.0},"22":{"tf":1.0},"23":{"tf":1.4142135623730951},"24":{"tf":2.0},"31":{"tf":2.0},"48":{"tf":1.0}}},"n":{"c":{"df":0,"docs":{},"o":{"df":0,"docs":{},"m":{"df":1,"docs":{"13":{"tf":1.0}}}}},"d":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":3,"docs":{"13":{"tf":1.0},"23":{"tf":1.0},"26":{"tf":1.0}}}}},"df":0,"docs":{},"s":{"df":0,"docs":{},"u":{"df":0,"docs":{},"r":{"df":1,"docs":{"2":{"tf":1.0}}}}},"t":{"df":0,"docs":{},"i":{"df":0,"docs":{},"l":{"df":2,"docs":{"29":{"tf":1.0},"48":{"tf":1.4142135623730951}}}}}},"p":{"d":{"a":{"df":0,"docs":{},"t":{"df":1,"docs":{"31":{"tf":1.0}}}},"df":0,"docs":{}},"df":9,"docs":{"13":{"tf":1.0},"2":{"tf":1.0},"29":{"tf":1.4142135623730951},"30":{"tf":1.0},"34":{"tf":1.0},"36":{"tf":1.7320508075688772},"43":{"tf":1.0},"48":{"tf":1.4142135623730951},"9":{"tf":1.0}}},"r":{"df":0,"docs":{},"l":{"df":3,"docs":{"27":{"tf":1.0},"48":{"tf":1.4142135623730951},"6":{"tf":1.0}}}},"s":{"a":{"df":0,"docs":{},"g":{"df":2,"docs":{"24":{"tf":1.0},"48":{"tf":1.0}}}},"df":27,"docs":{"0":{"tf":1.0},"1":{"tf":2.23606797749979},"11":{"tf":1.4142135623730951},"12":{"tf":1.7320508075688772},"13":{"tf":2.8284271247461903},"14":{"tf":1.0},"17":{"tf":2.0},"2":{"tf":1.0},"21":{"tf":1.0},"23":{"tf":1.0},"24":{"tf":1.4142135623730951},"25":{"tf":1.0},"28":{"tf":1.0},"29":{"tf":1.4142135623730951},"30":{"tf":1.7320508075688772},"31":{"tf":2.0},"32":{"tf":1.7320508075688772},"34":{"tf":1.7320508075688772},"35":{"tf":1.0},"36":{"tf":1.0},"39":{"tf":2.0},"41":{"tf":2.0},"43":{"tf":1.7320508075688772},"45":{"tf":1.0},"48":{"tf":3.3166247903554},"6":{"tf":1.0},"9":{"tf":1.0}},"e":{"df":0,"docs":{},"l":{"df":0,"docs":{},"e":{"df":0,"docs":{},"s":{"df":0,"docs":{},"s":{"df":1,"docs":{"48":{"tf":1.0}}}}}},"r":{"'":{"df":1,"docs":{"19":{"tf":1.0}}},":":{"df":0,"docs":{},"g":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"u":{"df":0,"docs":{},"p":{"df":1,"docs":{"7":{"tf":1.0}}}}}}}},"@":{"df":0,"docs":{},"g":{"df":0,"docs":{},"m":{"a":{"df":0,"docs":{},"i":{"df":0,"docs":{},"l":{".":{"c":{"df":0,"docs":{},"o":{"df":0,"docs":{},"m":{"df":1,"docs":{"48":{"tf":1.0}}}}},"df":0,"docs":{}},"df":0,"docs":{}}}},"df":0,"docs":{}}}},"_":{"df":0,"docs":{},"r":{"df":0,"docs":{},"e":{"df":0,"docs":{},"g":{"_":{"d":{"df":0,"docs":{},"o":{"df":0,"docs":{},"m":{"a":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"_":{"df":0,"docs":{},"r":{"df":0,"docs":{},"e":{"df":0,"docs":{},"s":{"df":0,"docs":{},"t":{"df":0,"docs":{},"r":{"df":0,"docs":{},"i":{"c":{"df":0,"docs":{},"t":{"df":0,"docs":{},"i":{"df":0,"docs":{},"o":{"df":0,"docs":{},"n":{"=":{"df":0,"docs":{},"g":{"df":0,"docs":{},"m":{"a":{"df":0,"docs":{},"i":{"df":0,"docs":{},"l":{".":{"c":{"df":0,"docs":{},"o":{"df":0,"docs":{},"m":{"df":1,"docs":{"48":{"tf":1.0}}}}},"df":0,"docs":{}},"df":0,"docs":{}}}},"df":0,"docs":{}}},"s":{"df":0,"docs":{},"o":{"df":0,"docs":{},"m":{"df":1,"docs":{"48":{"tf":1.0}}}}}},"df":0,"docs":{}}}}}},"df":0,"docs":{}}}}}}}},"df":0,"docs":{}}}},"df":0,"docs":{}}}},"df":0,"docs":{}},"df":0,"docs":{}}}}},"df":14,"docs":{"1":{"tf":1.0},"13":{"tf":1.0},"2":{"tf":1.0},"22":{"tf":2.0},"23":{"tf":1.7320508075688772},"24":{"tf":1.4142135623730951},"26":{"tf":1.0},"28":{"tf":1.0},"29":{"tf":2.23606797749979},"3":{"tf":1.0},"31":{"tf":1.0},"43":{"tf":1.0},"48":{"tf":3.4641016151377544},"7":{"tf":1.0}},"n":{"a":{"df":0,"docs":{},"m":{"df":2,"docs":{"1":{"tf":1.0},"48":{"tf":1.0}}}},"df":0,"docs":{}}}},"u":{"a":{"df":0,"docs":{},"l":{"df":1,"docs":{"26":{"tf":1.0}}}},"df":0,"docs":{}}},"t":{"df":0,"docs":{},"i":{"df":0,"docs":{},"l":{"df":1,"docs":{"24":{"tf":1.4142135623730951}}}}}},"v":{"1":{".":{"0":{"df":2,"docs":{"0":{"tf":1.0},"2":{"tf":1.0}}},"df":0,"docs":{}},"1":{"4":{"df":1,"docs":{"1":{"tf":1.0}}},"df":0,"docs":{}},"df":3,"docs":{"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0}}},"a":{"c":{"df":0,"docs":{},"u":{"df":0,"docs":{},"u":{"df":0,"docs":{},"m":{"df":1,"docs":{"34":{"tf":1.0}}}}}},"df":0,"docs":{},"l":{"df":0,"docs":{},"i":{"d":{"df":5,"docs":{"17":{"tf":1.0},"28":{"tf":1.0},"43":{"tf":1.0},"45":{"tf":2.0},"48":{"tf":3.0}}},"df":0,"docs":{}},"u":{"df":12,"docs":{"13":{"tf":1.0},"21":{"tf":1.0},"24":{"tf":2.23606797749979},"29":{"tf":1.0},"30":{"tf":1.0},"31":{"tf":1.7320508075688772},"36":{"tf":1.4142135623730951},"37":{"tf":1.0},"39":{"tf":1.7320508075688772},"44":{"tf":1.0},"48":{"tf":3.4641016151377544},"7":{"tf":1.0}},"e":{"df":0,"docs":{},"f":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"m":{"df":1,"docs":{"13":{"tf":1.7320508075688772}}}}}}}}},"r":{"df":0,"docs":{},"i":{"a":{"b":{"df":0,"docs":{},"l":{"df":10,"docs":{"24":{"tf":1.4142135623730951},"25":{"tf":1.0},"27":{"tf":1.0},"28":{"tf":1.0},"32":{"tf":1.4142135623730951},"39":{"tf":1.4142135623730951},"45":{"tf":1.0},"46":{"tf":1.0},"48":{"tf":1.4142135623730951},"7":{"tf":1.4142135623730951}}}},"df":0,"docs":{}},"df":0,"docs":{}}}},"df":1,"docs":{"7":{"tf":1.4142135623730951}},"e":{"df":0,"docs":{},"r":{"b":{"df":0,"docs":{},"o":{"df":0,"docs":{},"s":{"df":1,"docs":{"48":{"tf":1.4142135623730951}}}}},"df":0,"docs":{},"i":{"df":9,"docs":{"13":{"tf":1.0},"14":{"tf":1.0},"19":{"tf":1.4142135623730951},"22":{"tf":1.4142135623730951},"26":{"tf":1.0},"29":{"tf":1.4142135623730951},"32":{"tf":1.0},"34":{"tf":1.0},"43":{"tf":1.4142135623730951}},"f":{"df":1,"docs":{"1":{"tf":1.0}},"i":{"df":2,"docs":{"43":{"tf":1.4142135623730951},"48":{"tf":1.4142135623730951}}}}},"s":{"df":0,"docs":{},"i":{"df":0,"docs":{},"o":{"df":0,"docs":{},"n":{"df":6,"docs":{"0":{"tf":1.0},"13":{"tf":1.4142135623730951},"2":{"tf":1.0},"36":{"tf":1.0},"7":{"tf":1.0},"9":{"tf":1.0}}}}}}}},"i":{"a":{"df":5,"docs":{"1":{"tf":1.4142135623730951},"23":{"tf":1.4142135623730951},"31":{"tf":1.4142135623730951},"48":{"tf":1.0},"7":{"tf":1.0}}},"df":0,"docs":{},"m":{"df":1,"docs":{"7":{"tf":1.0}}}},"o":{"df":0,"docs":{},"l":{"df":0,"docs":{},"u":{"df":0,"docs":{},"m":{"df":6,"docs":{"13":{"tf":1.0},"21":{"tf":1.0},"34":{"tf":1.0},"39":{"tf":1.0},"47":{"tf":1.0},"7":{"tf":1.7320508075688772}},"e":{"c":{"df":0,"docs":{},"l":{"a":{"df":0,"docs":{},"i":{"df":0,"docs":{},"m":{"df":0,"docs":{},"t":{"df":0,"docs":{},"e":{"df":0,"docs":{},"m":{"df":0,"docs":{},"p":{"df":0,"docs":{},"l":{"df":1,"docs":{"13":{"tf":1.0}}}}}}}}}},"df":0,"docs":{}}},"df":0,"docs":{},"m":{"df":0,"docs":{},"o":{"df":0,"docs":{},"u":{"df":0,"docs":{},"n":{"df":0,"docs":{},"t":{"df":1,"docs":{"13":{"tf":1.0}}}}}}}}}}}}},"w":{"a":{"df":0,"docs":{},"i":{"df":0,"docs":{},"t":{"df":1,"docs":{"48":{"tf":1.0}}}},"n":{"df":0,"docs":{},"t":{"df":11,"docs":{"17":{"tf":1.4142135623730951},"24":{"tf":1.4142135623730951},"26":{"tf":1.0},"3":{"tf":1.0},"30":{"tf":1.0},"31":{"tf":1.7320508075688772},"32":{"tf":1.0},"39":{"tf":1.4142135623730951},"48":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.4142135623730951}}}},"r":{"df":0,"docs":{},"n":{"df":1,"docs":{"48":{"tf":1.0}}}},"t":{"c":{"df":0,"docs":{},"h":{"df":2,"docs":{"11":{"tf":1.4142135623730951},"22":{"tf":1.0}}}},"df":0,"docs":{}},"y":{"df":12,"docs":{"1":{"tf":1.4142135623730951},"12":{"tf":1.0},"23":{"tf":1.0},"24":{"tf":1.4142135623730951},"28":{"tf":1.0},"3":{"tf":1.0},"32":{"tf":1.0},"35":{"tf":1.0},"37":{"tf":1.0},"39":{"tf":1.7320508075688772},"40":{"tf":1.0},"48":{"tf":1.0}}}},"df":1,"docs":{"15":{"tf":1.0}},"e":{"b":{"a":{"df":0,"docs":{},"u":{"df":0,"docs":{},"t":{"df":0,"docs":{},"h":{"df":0,"docs":{},"n":{"_":{"d":{"a":{"df":0,"docs":{},"t":{"a":{"_":{"df":0,"docs":{},"e":{"df":0,"docs":{},"x":{"df":0,"docs":{},"p":{"=":{"9":{"0":{"df":1,"docs":{"48":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}},"df":0,"docs":{}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{},"r":{"df":0,"docs":{},"e":{"df":0,"docs":{},"n":{"df":0,"docs":{},"e":{"df":0,"docs":{},"w":{"_":{"df":0,"docs":{},"e":{"df":0,"docs":{},"x":{"df":0,"docs":{},"p":{"=":{"2":{"1":{"6":{"0":{"df":1,"docs":{"48":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":1,"docs":{"29":{"tf":1.4142135623730951}}}}}},"df":0,"docs":{}}}},"q":{"_":{"df":0,"docs":{},"e":{"df":0,"docs":{},"x":{"df":0,"docs":{},"p":{"=":{"6":{"0":{"df":1,"docs":{"48":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":1,"docs":{"48":{"tf":1.0}}}}}},"df":0,"docs":{}}}}},"df":5,"docs":{"1":{"tf":1.0},"2":{"tf":1.0},"25":{"tf":1.0},"29":{"tf":1.4142135623730951},"48":{"tf":3.1622776601683795}}}}}}},"df":2,"docs":{"17":{"tf":1.0},"19":{"tf":1.0}},"s":{"df":0,"docs":{},"e":{"c":{"df":0,"docs":{},"u":{"df":0,"docs":{},"r":{"df":2,"docs":{"14":{"tf":1.0},"17":{"tf":1.0}}}}},"df":0,"docs":{}}}},"df":0,"docs":{},"l":{"df":0,"docs":{},"l":{"df":2,"docs":{"17":{"tf":1.0},"2":{"tf":1.0}}}},"r":{"d":{"df":1,"docs":{"1":{"tf":1.0}}},"df":0,"docs":{}}},"h":{"df":0,"docs":{},"o":{"df":0,"docs":{},"l":{"df":0,"docs":{},"e":{"df":6,"docs":{"1":{"tf":1.0},"29":{"tf":1.4142135623730951},"31":{"tf":1.0},"48":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0}}}}}},"i":{"df":0,"docs":{},"n":{"d":{"df":0,"docs":{},"o":{"df":0,"docs":{},"w":{"df":3,"docs":{"43":{"tf":1.0},"48":{"tf":1.0},"7":{"tf":1.4142135623730951}}}}},"df":0,"docs":{}},"s":{"df":0,"docs":{},"e":{"df":1,"docs":{"24":{"tf":1.0}}}},"t":{"df":0,"docs":{},"h":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"df":1,"docs":{"48":{"tf":1.0}}}},"o":{"df":0,"docs":{},"u":{"df":0,"docs":{},"t":{"df":10,"docs":{"1":{"tf":1.0},"13":{"tf":1.4142135623730951},"28":{"tf":1.0},"30":{"tf":1.0},"36":{"tf":1.0},"39":{"tf":1.0},"48":{"tf":2.0},"6":{"tf":1.0},"7":{"tf":1.0},"9":{"tf":1.0}}}}}}}},"o":{"df":0,"docs":{},"r":{"df":0,"docs":{},"k":{"df":10,"docs":{"1":{"tf":2.0},"17":{"tf":1.0},"25":{"tf":1.4142135623730951},"26":{"tf":1.0},"29":{"tf":1.4142135623730951},"32":{"tf":1.0},"36":{"tf":1.0},"39":{"tf":2.0},"48":{"tf":2.23606797749979},"7":{"tf":1.4142135623730951}},"f":{"df":0,"docs":{},"l":{"df":0,"docs":{},"o":{"df":0,"docs":{},"w":{"df":1,"docs":{"43":{"tf":1.0}}}}}}}}},"r":{"df":0,"docs":{},"i":{"df":0,"docs":{},"t":{"df":0,"docs":{},"e":{"a":{"b":{"df":0,"docs":{},"l":{"df":1,"docs":{"7":{"tf":1.0}}}},"df":0,"docs":{}},"df":5,"docs":{"2":{"tf":1.0},"28":{"tf":1.0},"36":{"tf":1.0},"4":{"tf":1.0},"8":{"tf":1.0}}},"t":{"df":0,"docs":{},"e":{"df":0,"docs":{},"n":{"df":2,"docs":{"1":{"tf":1.0},"34":{"tf":1.0}}}}}}}}},"x":{"5":{"0":{"9":{"df":0,"docs":{},"v":{"3":{"df":2,"docs":{"45":{"tf":1.0},"48":{"tf":1.0}}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"y":{"df":1,"docs":{"43":{"tf":1.0}},"e":{"a":{"df":0,"docs":{},"r":{"df":2,"docs":{"34":{"tf":1.0},"48":{"tf":1.0}}}},"df":1,"docs":{"32":{"tf":1.0}}},"u":{"b":{"df":0,"docs":{},"i":{"df":0,"docs":{},"k":{"df":0,"docs":{},"e":{"df":0,"docs":{},"y":{"df":1,"docs":{"48":{"tf":1.0}}}}}}},"df":0,"docs":{}}},"z":{"0":{"df":4,"docs":{"12":{"tf":1.7320508075688772},"31":{"tf":1.4142135623730951},"40":{"tf":1.0},"48":{"tf":1.0}}},"a":{"df":4,"docs":{"12":{"tf":1.7320508075688772},"31":{"tf":1.4142135623730951},"40":{"tf":1.0},"48":{"tf":1.0}}},"df":0,"docs":{}}}},"breadcrumbs":{"root":{"0":{".":{"0":{".":{"0":{".":{"0":{"df":1,"docs":{"48":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{},"r":{"a":{"df":0,"docs":{},"u":{"df":0,"docs":{},"t":{"df":0,"docs":{},"h":{"df":0,"docs":{},"y":{":":{"8":{"0":{"0":{"0":{"df":2,"docs":{"39":{"tf":1.0},"48":{"tf":1.0}}},"df":0,"docs":{}},"8":{"0":{"df":1,"docs":{"48":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}}},"df":0,"docs":{}}},"6":{"4":{"0":{"df":1,"docs":{"7":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}},"7":{"0":{"0":{"df":1,"docs":{"7":{"tf":1.4142135623730951}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":4,"docs":{"21":{"tf":1.4142135623730951},"34":{"tf":1.7320508075688772},"39":{"tf":1.0},"48":{"tf":2.23606797749979}}},"1":{".":{"df":0,"docs":{},"r":{"a":{"df":0,"docs":{},"u":{"df":0,"docs":{},"t":{"df":0,"docs":{},"h":{"df":0,"docs":{},"y":{":":{"8":{"0":{"0":{"0":{"df":2,"docs":{"39":{"tf":1.0},"48":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}}},"df":0,"docs":{}}},"0":{"0":{"0":{"0":{"0":{"0":{"df":1,"docs":{"48":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}},"1":{":":{"1":{"0":{"0":{"0":{"1":{"df":1,"docs":{"7":{"tf":1.7320508075688772}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":1,"docs":{"13":{"tf":2.0}}},"df":0,"docs":{},"m":{"df":1,"docs":{"13":{"tf":1.0}}}},"df":0,"docs":{},"m":{"df":1,"docs":{"13":{"tf":1.0}}}},"2":{"4":{"df":2,"docs":{"13":{"tf":1.0},"48":{"tf":1.0}}},"df":0,"docs":{}},"df":1,"docs":{"13":{"tf":1.0}}},"2":{"8":{"df":1,"docs":{"48":{"tf":1.4142135623730951}},"m":{"df":0,"docs":{},"i":{"df":1,"docs":{"13":{"tf":1.0}}}}},"df":0,"docs":{}},"4":{"4":{"0":{"0":{"df":1,"docs":{"48":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"5":{"df":1,"docs":{"48":{"tf":1.0}}},"df":7,"docs":{"11":{"tf":1.0},"13":{"tf":1.7320508075688772},"31":{"tf":1.0},"39":{"tf":1.0},"43":{"tf":1.7320508075688772},"48":{"tf":1.4142135623730951},"7":{"tf":1.0}}},"2":{".":{"0":{"df":1,"docs":{"3":{"tf":1.0}}},"df":0,"docs":{},"r":{"a":{"df":0,"docs":{},"u":{"df":0,"docs":{},"t":{"df":0,"docs":{},"h":{"df":0,"docs":{},"y":{":":{"8":{"0":{"0":{"0":{"df":2,"docs":{"39":{"tf":1.0},"48":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}}},"df":0,"docs":{}}},"0":{"df":1,"docs":{"13":{"tf":1.0}}},"1":{"6":{"0":{"df":2,"docs":{"29":{"tf":1.0},"48":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}},"5":{"0":{"0":{"df":1,"docs":{"48":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":10,"docs":{"1":{"tf":1.0},"12":{"tf":1.0},"24":{"tf":2.0},"25":{"tf":1.7320508075688772},"27":{"tf":1.0},"29":{"tf":1.0},"31":{"tf":1.0},"43":{"tf":1.7320508075688772},"48":{"tf":2.0},"7":{"tf":1.4142135623730951}},"f":{"a":{"df":7,"docs":{"25":{"tf":1.4142135623730951},"26":{"tf":1.0},"27":{"tf":1.0},"28":{"tf":1.0},"29":{"tf":1.4142135623730951},"3":{"tf":1.0},"48":{"tf":1.0}}},"df":0,"docs":{}}},"3":{"0":{"0":{"df":1,"docs":{"48":{"tf":1.0}}},"df":2,"docs":{"13":{"tf":1.0},"48":{"tf":1.4142135623730951}},"m":{"df":0,"docs":{},"i":{"df":1,"docs":{"13":{"tf":1.0}}}}},"2":{"7":{"6":{"8":{"df":1,"docs":{"48":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":2,"docs":{"12":{"tf":1.0},"48":{"tf":1.0}}},"df":5,"docs":{"31":{"tf":1.0},"36":{"tf":1.4142135623730951},"39":{"tf":1.0},"43":{"tf":1.7320508075688772},"7":{"tf":1.0}}},"4":{"4":{"3":{"df":1,"docs":{"27":{"tf":1.4142135623730951}}},"df":0,"docs":{}},"d":{"0":{"a":{"3":{"9":{"7":{"7":{"df":0,"docs":{},"f":{"4":{"df":0,"docs":{},"f":{"d":{"a":{"6":{"8":{"df":0,"docs":{},"e":{"8":{"4":{"8":{"b":{"4":{"5":{"8":{"9":{"9":{"d":{"3":{"b":{"8":{"a":{"1":{"b":{"6":{"3":{"c":{"0":{"9":{"c":{"8":{"0":{"d":{"c":{"a":{"0":{"c":{"c":{"7":{"3":{"7":{"b":{"df":0,"docs":{},"e":{"7":{"3":{"3":{"8":{"8":{"7":{"6":{"1":{"9":{"4":{"c":{"4":{"0":{"?":{"c":{"df":0,"docs":{},"o":{"df":0,"docs":{},"n":{"df":0,"docs":{},"t":{"df":0,"docs":{},"e":{"df":0,"docs":{},"x":{"df":0,"docs":{},"t":{"=":{"df":0,"docs":{},"e":{"df":0,"docs":{},"x":{"df":0,"docs":{},"p":{"df":0,"docs":{},"l":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"df":1,"docs":{"13":{"tf":1.0}}}}}}}}},"df":0,"docs":{}}}}}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":5,"docs":{"31":{"tf":1.0},"34":{"tf":1.4142135623730951},"43":{"tf":1.7320508075688772},"48":{"tf":1.4142135623730951},"7":{"tf":1.0}}},"5":{"0":{"0":{"0":{"df":1,"docs":{"48":{"tf":1.0}}},"df":1,"docs":{"48":{"tf":1.0}}},"df":1,"docs":{"13":{"tf":1.0}}},"df":5,"docs":{"31":{"tf":1.0},"36":{"tf":1.0},"43":{"tf":1.0},"48":{"tf":2.0},"7":{"tf":1.4142135623730951}}},"6":{"0":{"df":1,"docs":{"48":{"tf":1.0}}},"4":{"df":0,"docs":{},"m":{"df":0,"docs":{},"i":{"df":1,"docs":{"13":{"tf":1.0}}}}},"df":1,"docs":{"7":{"tf":1.0}}},"7":{"0":{"df":1,"docs":{"13":{"tf":1.0}}},"2":{"0":{"df":2,"docs":{"34":{"tf":1.0},"48":{"tf":1.4142135623730951}}},"df":0,"docs":{}},"df":1,"docs":{"7":{"tf":1.0}}},"8":{"0":{"/":{"4":{"4":{"3":{"df":1,"docs":{"48":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"0":{"0":{"df":1,"docs":{"13":{"tf":1.7320508075688772}}},"df":0,"docs":{}},"8":{"0":{":":{"8":{"0":{"8":{"0":{"df":2,"docs":{"6":{"tf":1.4142135623730951},"7":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":4,"docs":{"13":{"tf":2.23606797749979},"14":{"tf":1.0},"17":{"tf":1.4142135623730951},"48":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}},"4":{"4":{"3":{"df":2,"docs":{"13":{"tf":2.23606797749979},"48":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}},"6":{"4":{"0":{"0":{"df":1,"docs":{"48":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"9":{"0":{"df":1,"docs":{"48":{"tf":1.0}}},"]":{"df":0,"docs":{},"{":{"2":{",":{"2":{"0":{"df":2,"docs":{"12":{"tf":1.0},"48":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}},"df":3,"docs":{"12":{"tf":1.4142135623730951},"31":{"tf":1.4142135623730951},"40":{"tf":1.0}}},"a":{"+":{"df":0,"docs":{},"w":{"df":1,"docs":{"7":{"tf":1.0}}}},"b":{"df":0,"docs":{},"o":{"df":0,"docs":{},"v":{"df":5,"docs":{"13":{"tf":1.0},"17":{"tf":1.0},"26":{"tf":1.0},"43":{"tf":1.0},"47":{"tf":1.4142135623730951}}}}},"c":{"c":{"df":0,"docs":{},"e":{"df":0,"docs":{},"p":{"df":0,"docs":{},"t":{"df":2,"docs":{"39":{"tf":1.0},"48":{"tf":1.4142135623730951}}}},"s":{"df":0,"docs":{},"s":{"df":3,"docs":{"23":{"tf":1.0},"48":{"tf":2.8284271247461903},"7":{"tf":1.7320508075688772}},"m":{"df":0,"docs":{},"o":{"d":{"df":1,"docs":{"13":{"tf":1.0}}},"df":0,"docs":{}}}}}},"i":{"d":{"df":1,"docs":{"23":{"tf":1.0}}},"df":0,"docs":{}},"o":{"df":0,"docs":{},"r":{"d":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"df":0,"docs":{},"g":{"df":0,"docs":{},"l":{"df":0,"docs":{},"i":{"df":1,"docs":{"10":{"tf":1.0}}}}}}}},"df":0,"docs":{}},"u":{"df":0,"docs":{},"n":{"df":0,"docs":{},"t":{"df":5,"docs":{"1":{"tf":1.7320508075688772},"2":{"tf":1.0},"21":{"tf":1.7320508075688772},"24":{"tf":1.0},"48":{"tf":1.0}}}}}}},"df":0,"docs":{},"h":{"df":0,"docs":{},"i":{"df":0,"docs":{},"e":{"df":0,"docs":{},"v":{"df":2,"docs":{"1":{"tf":1.0},"36":{"tf":1.4142135623730951}}}}}},"k":{"df":0,"docs":{},"l":{"df":0,"docs":{},"e":{"df":0,"docs":{},"v":{"df":0,"docs":{},"e":{"df":0,"docs":{},"l":{"df":1,"docs":{"36":{"tf":1.0}}}}}}}},"t":{"df":1,"docs":{"2":{"tf":1.0}},"i":{"df":0,"docs":{},"v":{"df":4,"docs":{"1":{"tf":1.0},"29":{"tf":1.4142135623730951},"31":{"tf":1.4142135623730951},"48":{"tf":1.7320508075688772}}}},"u":{"a":{"df":0,"docs":{},"l":{"df":1,"docs":{"13":{"tf":1.7320508075688772}}}},"df":0,"docs":{}}}},"d":{"d":{"df":12,"docs":{"13":{"tf":1.0},"17":{"tf":1.4142135623730951},"22":{"tf":1.0},"24":{"tf":1.0},"31":{"tf":1.4142135623730951},"34":{"tf":1.0},"39":{"tf":1.0},"40":{"tf":1.0},"43":{"tf":1.4142135623730951},"47":{"tf":1.0},"48":{"tf":1.0},"7":{"tf":1.7320508075688772}},"i":{"df":0,"docs":{},"t":{"df":8,"docs":{"1":{"tf":1.0},"13":{"tf":1.0},"17":{"tf":1.4142135623730951},"24":{"tf":1.0},"3":{"tf":1.0},"30":{"tf":1.0},"36":{"tf":1.0},"48":{"tf":2.0}},"i":{"df":0,"docs":{},"o":{"df":0,"docs":{},"n":{"df":2,"docs":{"1":{"tf":1.0},"36":{"tf":1.0}}}}}}},"r":{"df":0,"docs":{},"e":{"df":0,"docs":{},"s":{"df":0,"docs":{},"s":{"df":1,"docs":{"48":{"tf":1.0}}}}}}},"df":7,"docs":{"12":{"tf":1.0},"2":{"tf":1.4142135623730951},"22":{"tf":1.0},"36":{"tf":1.0},"45":{"tf":1.4142135623730951},"48":{"tf":1.4142135623730951},"7":{"tf":1.0}},"j":{"df":0,"docs":{},"u":{"df":0,"docs":{},"s":{"df":0,"docs":{},"t":{"df":6,"docs":{"11":{"tf":1.0},"13":{"tf":2.0},"14":{"tf":1.0},"47":{"tf":1.0},"48":{"tf":1.0},"7":{"tf":1.0}}}}}},"m":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"@":{"df":0,"docs":{},"l":{"df":0,"docs":{},"o":{"c":{"a":{"df":0,"docs":{},"l":{"df":0,"docs":{},"h":{"df":0,"docs":{},"o":{"df":0,"docs":{},"s":{"df":0,"docs":{},"t":{".":{"d":{"df":2,"docs":{"21":{"tf":1.0},"22":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}}}}}}},"df":0,"docs":{}},"df":0,"docs":{}}}},"_":{"a":{"c":{"c":{"df":0,"docs":{},"e":{"df":0,"docs":{},"s":{"df":0,"docs":{},"s":{"_":{"df":0,"docs":{},"s":{"df":0,"docs":{},"e":{"df":0,"docs":{},"s":{"df":0,"docs":{},"s":{"df":0,"docs":{},"i":{"df":0,"docs":{},"o":{"df":0,"docs":{},"n":{"_":{"df":0,"docs":{},"o":{"df":0,"docs":{},"n":{"df":0,"docs":{},"l":{"df":0,"docs":{},"y":{"=":{"df":0,"docs":{},"t":{"df":0,"docs":{},"r":{"df":0,"docs":{},"u":{"df":1,"docs":{"48":{"tf":1.0}}}}}},"df":0,"docs":{}}}}}},"df":0,"docs":{}}}}}}}}},"df":0,"docs":{}}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{},"f":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"c":{"df":0,"docs":{},"e":{"_":{"df":0,"docs":{},"m":{"df":0,"docs":{},"f":{"a":{"=":{"df":0,"docs":{},"f":{"a":{"df":0,"docs":{},"l":{"df":0,"docs":{},"s":{"df":1,"docs":{"48":{"tf":1.0}}}}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{}}}},"df":0,"docs":{}}},"df":0,"docs":{}}}}},"df":10,"docs":{"1":{"tf":1.0},"19":{"tf":1.7320508075688772},"2":{"tf":1.4142135623730951},"21":{"tf":1.4142135623730951},"22":{"tf":2.0},"23":{"tf":1.4142135623730951},"24":{"tf":2.0},"31":{"tf":1.4142135623730951},"48":{"tf":1.7320508075688772},"6":{"tf":1.0}}}}},"o":{"df":0,"docs":{},"p":{"df":0,"docs":{},"t":{"df":3,"docs":{"13":{"tf":1.0},"14":{"tf":1.0},"7":{"tf":1.0}}}}}},"df":0,"docs":{},"f":{"df":0,"docs":{},"f":{"df":0,"docs":{},"e":{"c":{"df":0,"docs":{},"t":{"df":1,"docs":{"28":{"tf":1.0}}}},"df":0,"docs":{}}},"t":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"w":{"a":{"df":0,"docs":{},"r":{"d":{"df":1,"docs":{"32":{"tf":1.0}}},"df":0,"docs":{}}},"df":0,"docs":{}}}}}},"g":{"a":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"df":11,"docs":{"1":{"tf":1.7320508075688772},"19":{"tf":1.0},"24":{"tf":1.0},"29":{"tf":1.0},"31":{"tf":1.0},"32":{"tf":1.4142135623730951},"34":{"tf":1.0},"39":{"tf":1.0},"43":{"tf":1.0},"48":{"tf":1.7320508075688772},"7":{"tf":1.0}},"s":{"df":0,"docs":{},"t":{"df":2,"docs":{"45":{"tf":1.0},"48":{"tf":1.0}}}}}}},"df":0,"docs":{},"g":{"df":0,"docs":{},"r":{"df":0,"docs":{},"e":{"df":0,"docs":{},"s":{"df":0,"docs":{},"s":{"df":1,"docs":{"9":{"tf":1.0}}}}}}}},"l":{"df":0,"docs":{},"g":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"df":0,"docs":{},"i":{"df":0,"docs":{},"t":{"df":0,"docs":{},"h":{"df":0,"docs":{},"m":{"df":3,"docs":{"1":{"tf":1.0},"24":{"tf":1.0},"48":{"tf":1.0}}}}}}}}},"l":{"df":0,"docs":{},"o":{"df":0,"docs":{},"w":{"df":4,"docs":{"1":{"tf":1.4142135623730951},"23":{"tf":1.0},"24":{"tf":1.7320508075688772},"48":{"tf":2.0}},"p":{"df":0,"docs":{},"r":{"df":0,"docs":{},"i":{"df":0,"docs":{},"v":{"df":0,"docs":{},"i":{"df":0,"docs":{},"l":{"df":0,"docs":{},"e":{"df":0,"docs":{},"g":{"df":0,"docs":{},"e":{"df":0,"docs":{},"e":{"df":0,"docs":{},"s":{"c":{"a":{"df":0,"docs":{},"l":{"df":1,"docs":{"13":{"tf":1.0}}}},"df":0,"docs":{}},"df":0,"docs":{}}}}}}}}}}}}}}},"p":{"df":0,"docs":{},"h":{"a":{"df":0,"docs":{},"n":{"df":0,"docs":{},"u":{"df":0,"docs":{},"m":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":1,"docs":{"48":{"tf":1.0}}}}}}}},"df":0,"docs":{}}},"r":{"df":0,"docs":{},"e":{"a":{"d":{"df":0,"docs":{},"i":{"df":10,"docs":{"1":{"tf":1.4142135623730951},"2":{"tf":1.4142135623730951},"26":{"tf":1.0},"28":{"tf":1.0},"29":{"tf":1.0},"3":{"tf":1.0},"30":{"tf":1.0},"42":{"tf":1.0},"43":{"tf":1.4142135623730951},"48":{"tf":1.0}}}},"df":0,"docs":{}},"df":0,"docs":{}}},"t":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"n":{"df":2,"docs":{"45":{"tf":1.0},"48":{"tf":1.0}}}}}},"w":{"a":{"df":0,"docs":{},"y":{"df":6,"docs":{"13":{"tf":1.0},"27":{"tf":1.0},"29":{"tf":1.0},"34":{"tf":1.0},"39":{"tf":1.0},"48":{"tf":1.0}}}},"df":0,"docs":{}}},"m":{"df":0,"docs":{},"o":{"df":0,"docs":{},"u":{"df":0,"docs":{},"n":{"df":0,"docs":{},"t":{"df":3,"docs":{"24":{"tf":2.0},"36":{"tf":1.0},"48":{"tf":1.7320508075688772}}}}}}},"n":{"d":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"i":{"d":{"df":1,"docs":{"1":{"tf":1.0}}},"df":0,"docs":{}}}}},"df":0,"docs":{},"n":{"df":0,"docs":{},"o":{"df":0,"docs":{},"y":{"df":2,"docs":{"3":{"tf":1.0},"7":{"tf":1.0}}}}},"o":{"df":0,"docs":{},"t":{"df":0,"docs":{},"h":{"df":4,"docs":{"13":{"tf":1.7320508075688772},"39":{"tf":1.0},"42":{"tf":1.0},"43":{"tf":1.7320508075688772}},"e":{"df":0,"docs":{},"r":{"_":{"df":0,"docs":{},"k":{"df":0,"docs":{},"e":{"df":0,"docs":{},"y":{"_":{"df":0,"docs":{},"i":{"d":{"/":{"a":{"df":0,"docs":{},"n":{"df":0,"docs":{},"o":{"df":0,"docs":{},"t":{"df":0,"docs":{},"h":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"_":{"df":0,"docs":{},"e":{"df":0,"docs":{},"n":{"c":{"_":{"df":0,"docs":{},"k":{"df":0,"docs":{},"e":{"df":0,"docs":{},"y":{"df":2,"docs":{"12":{"tf":1.0},"48":{"tf":1.0}}}}}},"df":0,"docs":{}},"df":0,"docs":{}}}},"df":0,"docs":{}}}}}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}},"df":0,"docs":{}}}}},"df":0,"docs":{}}}}}},"t":{"df":0,"docs":{},"i":{"df":1,"docs":{"23":{"tf":1.0}}}},"y":{"df":0,"docs":{},"m":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"df":3,"docs":{"26":{"tf":1.0},"48":{"tf":1.0},"6":{"tf":1.0}}}}},"o":{"df":0,"docs":{},"n":{"df":1,"docs":{"48":{"tf":1.0}}}},"t":{"df":0,"docs":{},"h":{"df":2,"docs":{"14":{"tf":1.0},"28":{"tf":1.0}}}},"w":{"a":{"df":0,"docs":{},"y":{"df":6,"docs":{"12":{"tf":1.0},"17":{"tf":1.0},"23":{"tf":1.0},"24":{"tf":1.0},"36":{"tf":1.0},"41":{"tf":1.0}}}},"df":0,"docs":{}}}},"p":{"a":{"df":0,"docs":{},"r":{"df":0,"docs":{},"t":{"df":2,"docs":{"31":{"tf":1.0},"48":{"tf":1.0}}}}},"df":0,"docs":{},"i":{"df":4,"docs":{"23":{"tf":1.0},"46":{"tf":1.0},"47":{"tf":2.0},"48":{"tf":1.0}},"v":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"s":{"df":5,"docs":{"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.4142135623730951},"14":{"tf":1.0},"17":{"tf":1.7320508075688772}}}}}}},"p":{"/":{"d":{"a":{"df":0,"docs":{},"t":{"a":{"/":{"b":{"a":{"c":{"df":0,"docs":{},"k":{"df":0,"docs":{},"u":{"df":0,"docs":{},"p":{"df":1,"docs":{"34":{"tf":1.0}}}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":2,"docs":{"13":{"tf":1.0},"34":{"tf":1.0}}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{},"r":{"a":{"df":0,"docs":{},"u":{"df":0,"docs":{},"t":{"df":0,"docs":{},"h":{"df":0,"docs":{},"y":{".":{"c":{"df":0,"docs":{},"f":{"df":0,"docs":{},"g":{"df":1,"docs":{"13":{"tf":1.0}}}}},"df":0,"docs":{}},"df":0,"docs":{}}}}}},"df":0,"docs":{}},"t":{"df":0,"docs":{},"l":{"df":2,"docs":{"45":{"tf":1.0},"47":{"tf":1.0}},"s":{"/":{"df":0,"docs":{},"r":{"df":0,"docs":{},"e":{"d":{"df":0,"docs":{},"h":{"a":{"c":{"/":{"c":{"a":{"df":1,"docs":{"47":{"tf":1.0}}},"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"t":{"df":1,"docs":{"47":{"tf":1.0}}}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}},"df":0,"docs":{}}},"t":{"df":0,"docs":{},"l":{"df":0,"docs":{},"s":{".":{"c":{"df":0,"docs":{},"r":{"df":0,"docs":{},"t":{"df":1,"docs":{"46":{"tf":1.0}}}}},"df":0,"docs":{},"k":{"df":0,"docs":{},"e":{"df":0,"docs":{},"y":{"df":1,"docs":{"46":{"tf":1.0}}}}}},"df":0,"docs":{}}}}},"df":0,"docs":{}}}}},"df":2,"docs":{"13":{"tf":2.0},"2":{"tf":1.7320508075688772}},"e":{"df":0,"docs":{},"n":{"d":{"df":2,"docs":{"34":{"tf":1.0},"48":{"tf":1.0}}},"df":0,"docs":{}}},"l":{"df":1,"docs":{"48":{"tf":1.0}},"i":{"c":{"df":6,"docs":{"13":{"tf":1.0},"24":{"tf":1.4142135623730951},"26":{"tf":1.0},"32":{"tf":1.0},"36":{"tf":1.0},"39":{"tf":1.0}}},"df":9,"docs":{"11":{"tf":1.4142135623730951},"12":{"tf":1.4142135623730951},"13":{"tf":1.4142135623730951},"15":{"tf":1.0},"24":{"tf":1.0},"34":{"tf":1.0},"47":{"tf":1.7320508075688772},"7":{"tf":1.0},"9":{"tf":1.7320508075688772}}}},"r":{"df":0,"docs":{},"o":{"a":{"c":{"df":0,"docs":{},"h":{"df":3,"docs":{"2":{"tf":1.0},"34":{"tf":1.0},"7":{"tf":1.4142135623730951}}}},"df":0,"docs":{}},"df":0,"docs":{},"p":{"df":0,"docs":{},"r":{"df":0,"docs":{},"i":{"df":1,"docs":{"48":{"tf":1.0}}}}}}},"s":{"/":{"df":0,"docs":{},"v":{"1":{"df":1,"docs":{"13":{"tf":1.0}}},"df":0,"docs":{}}},"df":0,"docs":{}}}},"r":{"df":0,"docs":{},"g":{"df":0,"docs":{},"o":{"df":0,"docs":{},"n":{"2":{"_":{"df":0,"docs":{},"m":{"_":{"c":{"df":0,"docs":{},"o":{"df":0,"docs":{},"s":{"df":0,"docs":{},"t":{"=":{"3":{"2":{"7":{"6":{"8":{"df":1,"docs":{"48":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":3,"docs":{"13":{"tf":1.0},"24":{"tf":1.0},"48":{"tf":1.0}}}}}},"df":0,"docs":{}},"df":0,"docs":{}},"p":{"_":{"c":{"df":0,"docs":{},"o":{"df":0,"docs":{},"s":{"df":0,"docs":{},"t":{"=":{"2":{"df":1,"docs":{"48":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}}}}},"df":0,"docs":{}},"df":0,"docs":{}},"t":{"_":{"c":{"df":0,"docs":{},"o":{"df":0,"docs":{},"s":{"df":0,"docs":{},"t":{"=":{"3":{"df":1,"docs":{"48":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}}}}},"df":0,"docs":{}},"df":0,"docs":{}}},"df":1,"docs":{"24":{"tf":1.0}},"i":{"d":{"df":2,"docs":{"24":{"tf":1.4142135623730951},"48":{"tf":1.0}}},"df":0,"docs":{}}},"df":1,"docs":{"24":{"tf":1.7320508075688772}}}},"u":{"df":0,"docs":{},"m":{"df":0,"docs":{},"e":{"df":0,"docs":{},"n":{"df":0,"docs":{},"t":{"df":1,"docs":{"43":{"tf":1.0}}}}}}}},"t":{"df":0,"docs":{},"i":{"df":0,"docs":{},"f":{"a":{"c":{"df":0,"docs":{},"t":{"df":1,"docs":{"2":{"tf":1.0}}}},"df":0,"docs":{}},"df":0,"docs":{}}}}},"s":{"df":0,"docs":{},"k":{"df":1,"docs":{"48":{"tf":1.0}}},"s":{"df":0,"docs":{},"i":{"df":0,"docs":{},"g":{"df":0,"docs":{},"n":{"df":1,"docs":{"23":{"tf":1.0}}}}},"u":{"df":0,"docs":{},"m":{"df":4,"docs":{"10":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"27":{"tf":1.0}}}}}},"t":{"df":0,"docs":{},"t":{"a":{"c":{"df":0,"docs":{},"h":{"df":1,"docs":{"39":{"tf":1.0}}},"k":{"df":1,"docs":{"13":{"tf":1.0}}}},"df":0,"docs":{}},"df":0,"docs":{}}},"u":{"d":{"df":0,"docs":{},"i":{"df":0,"docs":{},"t":{"df":1,"docs":{"0":{"tf":1.0}}}}},"df":0,"docs":{},"t":{"df":0,"docs":{},"h":{".":{"df":0,"docs":{},"e":{"df":0,"docs":{},"x":{"a":{"df":0,"docs":{},"m":{"df":0,"docs":{},"p":{"df":0,"docs":{},"l":{"df":0,"docs":{},"e":{".":{"c":{"df":0,"docs":{},"o":{"df":0,"docs":{},"m":{".":{"c":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"t":{".":{"df":0,"docs":{},"p":{"df":0,"docs":{},"e":{"df":0,"docs":{},"m":{"df":1,"docs":{"43":{"tf":1.0}}}}}},"df":0,"docs":{}}}}},"df":0,"docs":{},"k":{"df":0,"docs":{},"e":{"df":0,"docs":{},"y":{".":{"df":0,"docs":{},"p":{"df":0,"docs":{},"e":{"df":0,"docs":{},"m":{"df":1,"docs":{"43":{"tf":1.0}}}}}},"df":0,"docs":{}}}}},"df":2,"docs":{"26":{"tf":1.0},"43":{"tf":1.0}}}}},"df":0,"docs":{}},"df":0,"docs":{}}}}}},"df":0,"docs":{}}}},"/":{"df":0,"docs":{},"v":{"1":{"/":{"df":0,"docs":{},"h":{"df":0,"docs":{},"e":{"a":{"df":0,"docs":{},"l":{"df":0,"docs":{},"t":{"df":0,"docs":{},"h":{"df":1,"docs":{"13":{"tf":1.0}}}}}},"df":0,"docs":{}}},"p":{"df":1,"docs":{"13":{"tf":1.0}}}},"df":0,"docs":{}},"df":0,"docs":{}}},"df":1,"docs":{"48":{"tf":1.0}},"e":{"df":0,"docs":{},"n":{"df":0,"docs":{},"t":{"df":4,"docs":{"12":{"tf":1.0},"2":{"tf":2.0},"36":{"tf":1.0},"48":{"tf":1.4142135623730951}}}}},"n":{"df":1,"docs":{"39":{"tf":1.0}}},"o":{"df":0,"docs":{},"r":{"df":3,"docs":{"17":{"tf":1.0},"43":{"tf":1.0},"48":{"tf":1.4142135623730951}}}},"z":{"df":1,"docs":{"39":{"tf":1.0}}}},"o":{"df":0,"docs":{},"m":{"a":{"df":0,"docs":{},"t":{"df":3,"docs":{"29":{"tf":1.0},"34":{"tf":2.0},"48":{"tf":2.23606797749979}}}},"df":0,"docs":{}}}}},"v":{"a":{"df":0,"docs":{},"i":{"df":0,"docs":{},"l":{"df":15,"docs":{"1":{"tf":1.0},"11":{"tf":1.0},"13":{"tf":1.0},"26":{"tf":1.0},"27":{"tf":1.0},"36":{"tf":2.449489742783178},"37":{"tf":1.0},"38":{"tf":1.0},"39":{"tf":1.0},"40":{"tf":1.0},"41":{"tf":1.0},"43":{"tf":1.0},"48":{"tf":1.7320508075688772},"7":{"tf":1.0},"8":{"tf":1.0}}}}},"df":0,"docs":{},"o":{"df":0,"docs":{},"i":{"d":{"df":2,"docs":{"36":{"tf":1.0},"48":{"tf":1.0}}},"df":0,"docs":{}}}},"w":{"a":{"df":0,"docs":{},"y":{"df":1,"docs":{"1":{"tf":1.0}}}},"df":0,"docs":{}}},"b":{"a":{"c":{"df":0,"docs":{},"k":{"df":0,"docs":{},"e":{"df":0,"docs":{},"n":{"d":{"df":3,"docs":{"23":{"tf":1.0},"29":{"tf":1.0},"30":{"tf":1.0}}},"df":0,"docs":{}}},"u":{"df":0,"docs":{},"p":{"_":{"df":0,"docs":{},"n":{"a":{"df":0,"docs":{},"m":{"df":0,"docs":{},"e":{"=":{"\"":{"df":0,"docs":{},"r":{"a":{"df":0,"docs":{},"u":{"df":0,"docs":{},"t":{"df":0,"docs":{},"h":{"df":0,"docs":{},"i":{"df":2,"docs":{"34":{"tf":1.0},"48":{"tf":1.0}}}}}}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{}}}},"df":0,"docs":{}},"r":{"df":0,"docs":{},"e":{"df":0,"docs":{},"t":{"df":0,"docs":{},"e":{"df":0,"docs":{},"n":{"df":0,"docs":{},"t":{"df":0,"docs":{},"i":{"df":0,"docs":{},"o":{"df":0,"docs":{},"n":{"_":{"df":0,"docs":{},"l":{"df":0,"docs":{},"o":{"c":{"a":{"df":0,"docs":{},"l":{"=":{"2":{"4":{"df":1,"docs":{"34":{"tf":1.0}}},"df":0,"docs":{}},"7":{"2":{"0":{"df":1,"docs":{"48":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{}}}},"df":0,"docs":{}}}}}}}}}},"t":{"a":{"df":0,"docs":{},"s":{"df":0,"docs":{},"k":{"=":{"\"":{"0":{"df":2,"docs":{"34":{"tf":1.0},"48":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}},"df":0,"docs":{}}},"df":4,"docs":{"33":{"tf":1.7320508075688772},"34":{"tf":3.605551275463989},"35":{"tf":1.4142135623730951},"48":{"tf":2.449489742783178}}}}}},"d":{"df":2,"docs":{"39":{"tf":1.0},"43":{"tf":1.0}}},"df":0,"docs":{},"s":{"df":0,"docs":{},"e":{"6":{"4":{"df":3,"docs":{"12":{"tf":2.449489742783178},"31":{"tf":1.4142135623730951},"40":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}},"h":{"df":1,"docs":{"43":{"tf":1.0}}},"i":{"c":{"df":6,"docs":{"2":{"tf":1.4142135623730951},"29":{"tf":1.0},"34":{"tf":1.0},"43":{"tf":1.4142135623730951},"48":{"tf":1.0},"6":{"tf":1.0}}},"df":0,"docs":{}}}},"df":0,"docs":{},"e":{"df":2,"docs":{"1":{"tf":1.7320508075688772},"23":{"tf":1.0}},"f":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"df":4,"docs":{"12":{"tf":1.0},"31":{"tf":1.0},"36":{"tf":1.0},"48":{"tf":1.0}}}}},"g":{"df":0,"docs":{},"e":{"df":1,"docs":{"24":{"tf":1.0}}}},"h":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"d":{"df":4,"docs":{"13":{"tf":1.0},"14":{"tf":1.0},"45":{"tf":1.0},"48":{"tf":1.7320508075688772}}},"df":0,"docs":{}}}},"l":{"df":0,"docs":{},"o":{"df":0,"docs":{},"w":{"df":3,"docs":{"2":{"tf":1.0},"48":{"tf":1.7320508075688772},"9":{"tf":1.0}}}}},"n":{"df":0,"docs":{},"e":{"df":0,"docs":{},"f":{"df":0,"docs":{},"i":{"df":0,"docs":{},"t":{"df":1,"docs":{"43":{"tf":1.0}}}}}}},"s":{"df":0,"docs":{},"t":{"df":3,"docs":{"24":{"tf":1.0},"29":{"tf":1.0},"36":{"tf":1.0}}}},"t":{"df":0,"docs":{},"t":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":5,"docs":{"13":{"tf":1.4142135623730951},"19":{"tf":1.0},"35":{"tf":1.0},"39":{"tf":1.0},"7":{"tf":1.0}}}}},"w":{"df":0,"docs":{},"e":{"df":0,"docs":{},"e":{"df":0,"docs":{},"n":{"df":5,"docs":{"1":{"tf":1.0},"32":{"tf":1.4142135623730951},"36":{"tf":1.0},"41":{"tf":1.7320508075688772},"48":{"tf":1.7320508075688772}}}}}}},"y":{"df":0,"docs":{},"o":{"df":0,"docs":{},"n":{"d":{"df":1,"docs":{"48":{"tf":1.0}}},"df":0,"docs":{}}}}},"i":{"df":0,"docs":{},"g":{"df":1,"docs":{"8":{"tf":1.0}},"g":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":1,"docs":{"7":{"tf":1.0}}}}}},"n":{"d":{"df":1,"docs":{"48":{"tf":1.0}}},"df":0,"docs":{}},"o":{"df":0,"docs":{},"m":{"df":0,"docs":{},"e":{"df":0,"docs":{},"t":{"df":0,"docs":{},"r":{"df":1,"docs":{"1":{"tf":1.0}}}}}}},"t":{"df":5,"docs":{"1":{"tf":1.0},"32":{"tf":1.0},"37":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0}}}},"l":{"df":0,"docs":{},"o":{"df":0,"docs":{},"w":{"df":0,"docs":{},"n":{"df":1,"docs":{"1":{"tf":1.0}}}}}},"o":{"df":0,"docs":{},"t":{"df":0,"docs":{},"h":{"df":2,"docs":{"47":{"tf":1.0},"48":{"tf":1.0}}}}},"r":{"a":{"df":0,"docs":{},"n":{"d":{"df":2,"docs":{"1":{"tf":1.7320508075688772},"3":{"tf":1.0}}},"df":0,"docs":{}}},"df":0,"docs":{},"e":{"a":{"df":0,"docs":{},"k":{"df":3,"docs":{"0":{"tf":1.0},"30":{"tf":1.0},"31":{"tf":1.0}}}},"df":0,"docs":{}},"o":{"df":0,"docs":{},"w":{"df":0,"docs":{},"s":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":3,"docs":{"1":{"tf":1.7320508075688772},"28":{"tf":1.0},"29":{"tf":1.4142135623730951}}}}}}}},"u":{"df":0,"docs":{},"f":{"df":0,"docs":{},"f":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":1,"docs":{"48":{"tf":1.7320508075688772}}}}}},"g":{"df":1,"docs":{"32":{"tf":1.0}}},"i":{"df":0,"docs":{},"l":{"d":{"_":{"c":{"a":{".":{"df":0,"docs":{},"s":{"df":0,"docs":{},"h":{"df":1,"docs":{"43":{"tf":1.0}}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{},"e":{"df":0,"docs":{},"n":{"d":{"_":{"df":0,"docs":{},"e":{"df":0,"docs":{},"n":{"df":0,"docs":{},"t":{"df":0,"docs":{},"i":{"df":0,"docs":{},"t":{"df":0,"docs":{},"y":{".":{"df":0,"docs":{},"s":{"df":0,"docs":{},"h":{"df":1,"docs":{"43":{"tf":1.4142135623730951}}}}},"df":0,"docs":{}}}}}}}},"df":0,"docs":{}},"df":0,"docs":{}}},"i":{"df":0,"docs":{},"n":{"df":0,"docs":{},"t":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"m":{"df":0,"docs":{},"e":{"d":{"df":0,"docs":{},"i":{"a":{"df":0,"docs":{},"t":{"df":0,"docs":{},"e":{".":{"df":0,"docs":{},"s":{"df":0,"docs":{},"h":{"df":1,"docs":{"43":{"tf":1.0}}}}},"df":0,"docs":{}}}},"df":0,"docs":{}}},"df":0,"docs":{}}}}}}}}},"df":0,"docs":{}},"df":0,"docs":{},"t":{"df":1,"docs":{"13":{"tf":1.0}}}}},"m":{"df":0,"docs":{},"p":{"df":1,"docs":{"29":{"tf":1.0}}}},"t":{"df":0,"docs":{},"t":{"df":0,"docs":{},"o":{"df":0,"docs":{},"n":{"df":1,"docs":{"29":{"tf":1.0}}}}}}}},"c":{"3":{"2":{"df":2,"docs":{"12":{"tf":1.0},"31":{"tf":1.0}}},"df":0,"docs":{}},"4":{"8":{"df":1,"docs":{"40":{"tf":1.0}}},"df":0,"docs":{}},"8":{")":{"/":{"$":{"(":{"c":{"a":{"df":0,"docs":{},"t":{"df":2,"docs":{"12":{"tf":1.0},"31":{"tf":1.0}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"a":{"c":{"df":0,"docs":{},"h":{"df":11,"docs":{"1":{"tf":2.449489742783178},"12":{"tf":1.0},"13":{"tf":1.4142135623730951},"36":{"tf":2.6457513110645907},"39":{"tf":2.8284271247461903},"41":{"tf":1.4142135623730951},"43":{"tf":1.4142135623730951},"45":{"tf":1.7320508075688772},"47":{"tf":1.7320508075688772},"48":{"tf":3.605551275463989},"9":{"tf":1.0}},"e":{"_":{"a":{"df":0,"docs":{},"u":{"df":0,"docs":{},"t":{"df":0,"docs":{},"h":{"_":{"df":0,"docs":{},"t":{"df":0,"docs":{},"o":{"df":0,"docs":{},"k":{"df":0,"docs":{},"e":{"df":0,"docs":{},"n":{"=":{"df":0,"docs":{},"s":{"df":0,"docs":{},"o":{"df":0,"docs":{},"m":{"df":0,"docs":{},"e":{"df":0,"docs":{},"s":{"df":0,"docs":{},"u":{"df":0,"docs":{},"p":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"s":{"df":0,"docs":{},"e":{"c":{"df":0,"docs":{},"r":{"df":0,"docs":{},"e":{"df":0,"docs":{},"t":{"a":{"df":0,"docs":{},"n":{"d":{"df":0,"docs":{},"v":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"y":{"df":0,"docs":{},"s":{"a":{"df":0,"docs":{},"f":{"df":0,"docs":{},"e":{"df":0,"docs":{},"t":{"df":0,"docs":{},"o":{"df":0,"docs":{},"k":{"df":0,"docs":{},"e":{"df":0,"docs":{},"n":{"1":{"3":{"3":{"7":{"df":1,"docs":{"48":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}}}}}},"df":0,"docs":{}}}}}}},"df":0,"docs":{}}},"df":0,"docs":{}}}}},"df":0,"docs":{}}}}}}}}}}}}},"df":2,"docs":{"12":{"tf":1.7320508075688772},"40":{"tf":1.7320508075688772}}}}}}}},"df":0,"docs":{}}}}},"b":{"df":0,"docs":{},"u":{"df":0,"docs":{},"f":{"_":{"c":{"df":0,"docs":{},"l":{"df":0,"docs":{},"i":{"df":1,"docs":{"48":{"tf":1.0}},"e":{"df":0,"docs":{},"n":{"df":0,"docs":{},"t":{"=":{"1":{"2":{"8":{"df":1,"docs":{"48":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}}}},"df":0,"docs":{},"s":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"v":{"df":1,"docs":{"48":{"tf":1.0}},"e":{"df":0,"docs":{},"r":{"=":{"1":{"2":{"8":{"df":1,"docs":{"48":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}}}}},"df":0,"docs":{}}}},"df":0,"docs":{},"e":{"df":0,"docs":{},"l":{"df":0,"docs":{},"e":{"c":{"df":0,"docs":{},"t":{"df":0,"docs":{},"i":{"df":0,"docs":{},"o":{"df":0,"docs":{},"n":{"_":{"df":0,"docs":{},"t":{"df":0,"docs":{},"i":{"df":0,"docs":{},"m":{"df":0,"docs":{},"e":{"df":0,"docs":{},"o":{"df":0,"docs":{},"u":{"df":0,"docs":{},"t":{"=":{"1":{"5":{"df":1,"docs":{"48":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}}}}}},"df":0,"docs":{}}}}}},"df":0,"docs":{}}}},"k":{"df":0,"docs":{},"e":{"df":0,"docs":{},"e":{"df":0,"docs":{},"p":{"a":{"df":0,"docs":{},"l":{"df":0,"docs":{},"i":{"df":0,"docs":{},"v":{"df":0,"docs":{},"e":{"_":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"df":0,"docs":{},"t":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"v":{"a":{"df":0,"docs":{},"l":{"=":{"5":{"df":1,"docs":{"48":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}}},"df":0,"docs":{}}}}}}},"t":{"df":0,"docs":{},"i":{"df":0,"docs":{},"m":{"df":0,"docs":{},"e":{"df":0,"docs":{},"o":{"df":0,"docs":{},"u":{"df":0,"docs":{},"t":{"=":{"5":{"df":1,"docs":{"48":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}}}}}}}}},"df":0,"docs":{}}}}}},"df":0,"docs":{}}}}},"r":{"df":0,"docs":{},"e":{"c":{"df":0,"docs":{},"o":{"df":0,"docs":{},"n":{"df":0,"docs":{},"n":{"df":0,"docs":{},"e":{"c":{"df":0,"docs":{},"t":{"_":{"df":0,"docs":{},"t":{"df":0,"docs":{},"i":{"df":0,"docs":{},"m":{"df":0,"docs":{},"e":{"df":0,"docs":{},"o":{"df":0,"docs":{},"u":{"df":0,"docs":{},"t":{"_":{"df":0,"docs":{},"l":{"df":0,"docs":{},"o":{"df":0,"docs":{},"w":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"=":{"2":{"5":{"0":{"0":{"df":1,"docs":{"48":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}}},"u":{"df":0,"docs":{},"p":{"df":0,"docs":{},"p":{"df":1,"docs":{"48":{"tf":1.0}},"e":{"df":0,"docs":{},"r":{"=":{"5":{"0":{"0":{"0":{"df":1,"docs":{"48":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}}}},"df":0,"docs":{}}}}}}}}},"df":0,"docs":{}}},"df":0,"docs":{}}}}}},"df":0,"docs":{}}},"t":{"df":0,"docs":{},"l":{"df":0,"docs":{},"s":{"=":{"df":0,"docs":{},"f":{"a":{"df":0,"docs":{},"l":{"df":0,"docs":{},"s":{"df":1,"docs":{"41":{"tf":1.0}}}}},"df":0,"docs":{}},"t":{"df":0,"docs":{},"r":{"df":0,"docs":{},"u":{"df":2,"docs":{"45":{"tf":1.0},"48":{"tf":1.0}}}}}},"_":{"c":{"a":{"_":{"c":{"df":0,"docs":{},"l":{"df":0,"docs":{},"i":{"df":0,"docs":{},"e":{"df":0,"docs":{},"n":{"df":0,"docs":{},"t":{"=":{"df":0,"docs":{},"t":{"df":0,"docs":{},"l":{"df":0,"docs":{},"s":{"/":{"c":{"a":{"df":2,"docs":{"45":{"tf":1.0},"48":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}},"df":0,"docs":{}}}}}}},"df":0,"docs":{},"s":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"v":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"=":{"df":0,"docs":{},"t":{"df":0,"docs":{},"l":{"df":0,"docs":{},"s":{"/":{"c":{"a":{"df":2,"docs":{"45":{"tf":1.0},"48":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}},"df":0,"docs":{}}}}}}}},"df":0,"docs":{}},"df":0,"docs":{},"l":{"df":0,"docs":{},"i":{"df":0,"docs":{},"e":{"df":0,"docs":{},"n":{"df":0,"docs":{},"t":{"_":{"c":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"t":{"=":{"df":0,"docs":{},"t":{"df":0,"docs":{},"l":{"df":0,"docs":{},"s":{"/":{"df":0,"docs":{},"r":{"df":0,"docs":{},"e":{"d":{"df":0,"docs":{},"h":{"a":{"c":{".":{"df":0,"docs":{},"l":{"df":0,"docs":{},"o":{"c":{"a":{"df":0,"docs":{},"l":{".":{"c":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"t":{".":{"df":0,"docs":{},"p":{"df":0,"docs":{},"e":{"df":0,"docs":{},"m":{"df":2,"docs":{"45":{"tf":1.0},"48":{"tf":1.0}}}}}},"df":0,"docs":{}}}}},"df":0,"docs":{}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}},"df":0,"docs":{}}}},"df":0,"docs":{}}}}},"df":0,"docs":{}}}}},"df":0,"docs":{},"k":{"df":0,"docs":{},"e":{"df":0,"docs":{},"y":{"=":{"df":0,"docs":{},"t":{"df":0,"docs":{},"l":{"df":0,"docs":{},"s":{"/":{"df":0,"docs":{},"r":{"df":0,"docs":{},"e":{"d":{"df":0,"docs":{},"h":{"a":{"c":{".":{"df":0,"docs":{},"l":{"df":0,"docs":{},"o":{"c":{"a":{"df":0,"docs":{},"l":{".":{"df":0,"docs":{},"k":{"df":0,"docs":{},"e":{"df":0,"docs":{},"y":{".":{"df":0,"docs":{},"p":{"df":0,"docs":{},"e":{"df":0,"docs":{},"m":{"df":2,"docs":{"45":{"tf":1.0},"48":{"tf":1.0}}}}}},"df":0,"docs":{}}}}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}},"df":0,"docs":{}}}},"df":0,"docs":{}}}}},"df":0,"docs":{}}}},"v":{"a":{"df":0,"docs":{},"l":{"df":0,"docs":{},"i":{"d":{"a":{"df":0,"docs":{},"t":{"df":0,"docs":{},"e":{"_":{"d":{"df":0,"docs":{},"o":{"df":0,"docs":{},"m":{"a":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"=":{"df":0,"docs":{},"r":{"df":0,"docs":{},"e":{"d":{"df":0,"docs":{},"h":{"a":{"c":{".":{"df":0,"docs":{},"l":{"df":0,"docs":{},"o":{"c":{"df":2,"docs":{"45":{"tf":1.0},"48":{"tf":1.0}}},"df":0,"docs":{}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}},"df":0,"docs":{}}}},"df":0,"docs":{}}}},"df":0,"docs":{}}}},"df":0,"docs":{}},"df":0,"docs":{}}}},"df":0,"docs":{}},"df":0,"docs":{}}}},"df":0,"docs":{}}},"df":0,"docs":{}}}}}}},"df":0,"docs":{},"s":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"v":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"_":{"c":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"t":{"=":{"df":0,"docs":{},"t":{"df":0,"docs":{},"l":{"df":0,"docs":{},"s":{"/":{"df":0,"docs":{},"r":{"df":0,"docs":{},"e":{"d":{"df":0,"docs":{},"h":{"a":{"c":{".":{"df":0,"docs":{},"l":{"df":0,"docs":{},"o":{"c":{"a":{"df":0,"docs":{},"l":{".":{"c":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"t":{".":{"df":0,"docs":{},"p":{"df":0,"docs":{},"e":{"df":0,"docs":{},"m":{"df":2,"docs":{"45":{"tf":1.0},"48":{"tf":1.0}}}}}},"df":0,"docs":{}}}}},"df":0,"docs":{}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}},"df":0,"docs":{}}}},"df":0,"docs":{}}}}},"df":0,"docs":{}}}}},"df":0,"docs":{},"k":{"df":0,"docs":{},"e":{"df":0,"docs":{},"y":{"=":{"df":0,"docs":{},"t":{"df":0,"docs":{},"l":{"df":0,"docs":{},"s":{"/":{"df":0,"docs":{},"r":{"df":0,"docs":{},"e":{"d":{"df":0,"docs":{},"h":{"a":{"c":{".":{"df":0,"docs":{},"l":{"df":0,"docs":{},"o":{"c":{"a":{"df":0,"docs":{},"l":{".":{"df":0,"docs":{},"k":{"df":0,"docs":{},"e":{"df":0,"docs":{},"y":{".":{"df":0,"docs":{},"p":{"df":0,"docs":{},"e":{"df":0,"docs":{},"m":{"df":2,"docs":{"45":{"tf":1.0},"48":{"tf":1.0}}}}}},"df":0,"docs":{}}}}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}},"df":0,"docs":{}}}},"df":0,"docs":{}}}}},"df":0,"docs":{}}}}},"df":0,"docs":{}}}}}},"n":{"df":0,"docs":{},"i":{"_":{"df":0,"docs":{},"o":{"df":0,"docs":{},"v":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"w":{"df":0,"docs":{},"r":{"df":0,"docs":{},"i":{"df":0,"docs":{},"t":{"df":2,"docs":{"45":{"tf":1.0},"48":{"tf":1.0}}}}}}}}}}},"df":0,"docs":{}}}}},"df":0,"docs":{}}}}},"df":0,"docs":{}}}},"df":5,"docs":{"17":{"tf":1.0},"43":{"tf":3.1622776601683795},"45":{"tf":1.4142135623730951},"47":{"tf":2.449489742783178},"48":{"tf":1.4142135623730951}},"l":{"c":{"df":0,"docs":{},"u":{"df":0,"docs":{},"l":{"df":1,"docs":{"48":{"tf":1.0}}}}},"df":0,"docs":{},"l":{"df":5,"docs":{"1":{"tf":1.0},"11":{"tf":1.0},"23":{"tf":1.0},"36":{"tf":1.4142135623730951},"39":{"tf":1.0}}}},"p":{"a":{"b":{"df":0,"docs":{},"l":{"df":1,"docs":{"36":{"tf":1.0}}}},"df":0,"docs":{}},"df":0,"docs":{}},"r":{"d":{"df":1,"docs":{"1":{"tf":1.0}}},"df":0,"docs":{},"e":{"df":7,"docs":{"1":{"tf":1.4142135623730951},"13":{"tf":1.0},"23":{"tf":1.0},"26":{"tf":1.0},"31":{"tf":1.0},"32":{"tf":1.0},"48":{"tf":1.0}},"f":{"df":0,"docs":{},"u":{"df":0,"docs":{},"l":{"df":0,"docs":{},"l":{"df":0,"docs":{},"i":{"df":1,"docs":{"13":{"tf":1.0}}}}}}}}},"s":{"df":0,"docs":{},"e":{"df":9,"docs":{"1":{"tf":1.4142135623730951},"10":{"tf":1.0},"13":{"tf":1.4142135623730951},"2":{"tf":1.0},"21":{"tf":1.0},"32":{"tf":1.0},"39":{"tf":1.0},"48":{"tf":2.0},"7":{"tf":1.0}}}},"t":{"df":3,"docs":{"12":{"tf":1.0},"31":{"tf":1.0},"40":{"tf":1.0}}},"u":{"df":0,"docs":{},"g":{"df":0,"docs":{},"h":{"df":0,"docs":{},"t":{"df":1,"docs":{"29":{"tf":1.0}}}}},"s":{"df":1,"docs":{"48":{"tf":1.0}}},"t":{"df":0,"docs":{},"i":{"df":0,"docs":{},"o":{"df":0,"docs":{},"n":{"df":6,"docs":{"0":{"tf":1.0},"11":{"tf":1.0},"26":{"tf":1.0},"27":{"tf":1.0},"31":{"tf":1.0},"48":{"tf":2.6457513110645907}}}}}}}},"d":{"df":1,"docs":{"11":{"tf":1.0}}},"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"t":{"=":{"\"":{".":{".":{"/":{"a":{"df":0,"docs":{},"u":{"df":0,"docs":{},"t":{"df":0,"docs":{},"h":{".":{"df":0,"docs":{},"e":{"df":0,"docs":{},"x":{"a":{"df":0,"docs":{},"m":{"df":0,"docs":{},"p":{"df":0,"docs":{},"l":{"df":0,"docs":{},"e":{".":{"c":{"df":0,"docs":{},"o":{"df":0,"docs":{},"m":{".":{"c":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"t":{".":{"df":0,"docs":{},"p":{"df":0,"docs":{},"e":{"df":0,"docs":{},"m":{"df":1,"docs":{"47":{"tf":1.0}}}}}},"df":0,"docs":{}}}}},"df":0,"docs":{}},"df":0,"docs":{}}}},"df":0,"docs":{}},"df":0,"docs":{}}}}}},"df":0,"docs":{}}}},"df":0,"docs":{}}}}},"df":0,"docs":{},"r":{"df":0,"docs":{},"e":{"d":{"df":0,"docs":{},"h":{"a":{"c":{".":{"df":0,"docs":{},"l":{"df":0,"docs":{},"o":{"c":{"a":{"df":0,"docs":{},"l":{".":{"c":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"t":{".":{"df":0,"docs":{},"p":{"df":0,"docs":{},"e":{"df":0,"docs":{},"m":{"df":1,"docs":{"47":{"tf":1.0}}}}}},"df":0,"docs":{}}}}},"df":0,"docs":{}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}},"df":0,"docs":{}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"a":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"df":1,"docs":{"1":{"tf":1.0}}}}},"df":1,"docs":{"17":{"tf":1.0}},"i":{"df":0,"docs":{},"f":{"df":8,"docs":{"17":{"tf":2.23606797749979},"41":{"tf":1.0},"42":{"tf":1.0},"43":{"tf":3.3166247903554},"45":{"tf":3.605551275463989},"46":{"tf":1.0},"47":{"tf":1.0},"48":{"tf":3.1622776601683795}}}}}}},"h":{"a":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{".":{"c":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"t":{".":{"df":0,"docs":{},"p":{"df":0,"docs":{},"e":{"df":0,"docs":{},"m":{"df":2,"docs":{"45":{"tf":2.0},"48":{"tf":2.0}}}}}},"df":0,"docs":{}}}}},"df":0,"docs":{},"p":{"df":0,"docs":{},"e":{"df":0,"docs":{},"m":{"df":2,"docs":{"43":{"tf":1.0},"47":{"tf":1.0}}}}}},"df":2,"docs":{"45":{"tf":1.4142135623730951},"48":{"tf":1.4142135623730951}}}},"n":{"c":{"df":1,"docs":{"22":{"tf":1.0}}},"df":0,"docs":{},"g":{"df":11,"docs":{"0":{"tf":1.0},"1":{"tf":1.4142135623730951},"10":{"tf":1.0},"13":{"tf":1.0},"21":{"tf":1.0},"26":{"tf":1.0},"28":{"tf":1.0},"46":{"tf":1.0},"48":{"tf":1.4142135623730951},"6":{"tf":1.0},"7":{"tf":1.7320508075688772}}},"n":{"df":0,"docs":{},"e":{"df":0,"docs":{},"l":{"df":1,"docs":{"48":{"tf":1.0}}}}}},"p":{"df":0,"docs":{},"t":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":1,"docs":{"17":{"tf":1.0}}}}}},"r":{"a":{"c":{"df":0,"docs":{},"t":{"df":3,"docs":{"12":{"tf":1.4142135623730951},"43":{"tf":1.4142135623730951},"48":{"tf":1.7320508075688772}}}},"df":0,"docs":{}},"df":0,"docs":{},"t":{"df":1,"docs":{"8":{"tf":1.0}}}}},"df":0,"docs":{},"e":{"c":{"df":0,"docs":{},"k":{"df":2,"docs":{"25":{"tf":1.4142135623730951},"48":{"tf":1.0}}}},"df":0,"docs":{}},"i":{"c":{"df":0,"docs":{},"k":{"df":0,"docs":{},"e":{"df":0,"docs":{},"n":{"df":1,"docs":{"13":{"tf":1.0}}}}}},"df":0,"docs":{}},"m":{"df":0,"docs":{},"o":{"d":{"df":1,"docs":{"7":{"tf":2.0}}},"df":0,"docs":{}}},"o":{"df":0,"docs":{},"i":{"c":{"df":1,"docs":{"14":{"tf":1.0}}},"df":0,"docs":{}},"o":{"df":0,"docs":{},"s":{"df":1,"docs":{"1":{"tf":1.0}}}},"s":{"df":0,"docs":{},"e":{"df":0,"docs":{},"n":{"df":2,"docs":{"12":{"tf":1.0},"48":{"tf":1.4142135623730951}}}}},"w":{"df":0,"docs":{},"n":{"df":1,"docs":{"7":{"tf":1.0}}}}}},"l":{"df":0,"docs":{},"e":{"a":{"df":0,"docs":{},"n":{"df":4,"docs":{"2":{"tf":1.0},"34":{"tf":1.0},"43":{"tf":1.0},"48":{"tf":1.4142135623730951}}},"r":{"df":1,"docs":{"2":{"tf":1.0}}}},"df":0,"docs":{}},"i":{"c":{"df":0,"docs":{},"k":{"df":2,"docs":{"21":{"tf":1.0},"29":{"tf":1.0}}}},"df":0,"docs":{},"e":{"df":0,"docs":{},"n":{"df":0,"docs":{},"t":{"df":9,"docs":{"1":{"tf":2.8284271247461903},"2":{"tf":1.4142135623730951},"23":{"tf":1.4142135623730951},"28":{"tf":1.0},"31":{"tf":1.4142135623730951},"36":{"tf":1.0},"43":{"tf":1.0},"45":{"tf":2.6457513110645907},"48":{"tf":3.1622776601683795}}}}}},"o":{"df":0,"docs":{},"s":{"df":0,"docs":{},"e":{"df":2,"docs":{"13":{"tf":1.0},"32":{"tf":1.0}}}}}},"n":{"df":2,"docs":{"45":{"tf":1.0},"48":{"tf":1.0}}},"o":{"d":{"df":0,"docs":{},"e":{"df":3,"docs":{"2":{"tf":1.0},"36":{"tf":1.0},"48":{"tf":1.4142135623730951}}}},"df":0,"docs":{},"l":{"d":{"df":1,"docs":{"48":{"tf":1.0}}},"df":0,"docs":{},"l":{"df":0,"docs":{},"e":{"c":{"df":0,"docs":{},"t":{"df":1,"docs":{"13":{"tf":1.0}}}},"df":0,"docs":{}}},"o":{"df":0,"docs":{},"r":{"df":1,"docs":{"1":{"tf":1.0}}}}},"m":{"b":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"df":3,"docs":{"1":{"tf":1.0},"45":{"tf":1.0},"48":{"tf":1.0}}}}},"df":0,"docs":{},"e":{"df":4,"docs":{"0":{"tf":1.0},"1":{"tf":1.4142135623730951},"2":{"tf":1.7320508075688772},"36":{"tf":1.0}}},"m":{"a":{"df":0,"docs":{},"n":{"d":{"df":4,"docs":{"10":{"tf":1.0},"47":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":2.23606797749979}}},"df":0,"docs":{}}},"df":0,"docs":{},"o":{"df":0,"docs":{},"n":{"df":2,"docs":{"43":{"tf":1.0},"45":{"tf":1.0}}}},"u":{"df":0,"docs":{},"n":{"df":2,"docs":{"13":{"tf":1.0},"48":{"tf":1.0}}}}},"p":{"a":{"df":0,"docs":{},"t":{"df":1,"docs":{"1":{"tf":1.0}}}},"df":0,"docs":{},"l":{"df":0,"docs":{},"i":{"a":{"df":0,"docs":{},"n":{"df":0,"docs":{},"t":{"df":1,"docs":{"1":{"tf":1.0}}}}},"df":0,"docs":{}}},"o":{"df":0,"docs":{},"n":{"df":1,"docs":{"48":{"tf":1.0}}}},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"m":{"df":0,"docs":{},"i":{"df":0,"docs":{},"s":{"df":1,"docs":{"24":{"tf":1.0}}}}}}},"u":{"df":0,"docs":{},"t":{"df":1,"docs":{"24":{"tf":1.0}}}}}},"n":{"c":{"df":0,"docs":{},"u":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"df":1,"docs":{"48":{"tf":1.4142135623730951}}}}}},"d":{"df":0,"docs":{},"i":{"df":0,"docs":{},"t":{"df":1,"docs":{"48":{"tf":1.0}}}}},"df":0,"docs":{},"f":{"df":0,"docs":{},"i":{"df":0,"docs":{},"g":{".":{"df":0,"docs":{},"y":{"a":{"df":0,"docs":{},"m":{"df":0,"docs":{},"l":{"df":3,"docs":{"11":{"tf":1.0},"12":{"tf":1.0},"47":{"tf":1.0}}}}},"df":0,"docs":{}}},"df":21,"docs":{"1":{"tf":1.4142135623730951},"11":{"tf":3.1622776601683795},"12":{"tf":1.0},"13":{"tf":1.7320508075688772},"17":{"tf":1.4142135623730951},"22":{"tf":1.4142135623730951},"24":{"tf":1.7320508075688772},"25":{"tf":1.4142135623730951},"31":{"tf":1.0},"32":{"tf":1.4142135623730951},"37":{"tf":1.0},"39":{"tf":1.0},"42":{"tf":1.0},"44":{"tf":1.7320508075688772},"45":{"tf":1.0},"46":{"tf":1.0},"47":{"tf":1.4142135623730951},"48":{"tf":2.449489742783178},"6":{"tf":1.0},"7":{"tf":3.0},"9":{"tf":1.0}},"m":{"a":{"df":0,"docs":{},"p":{"df":2,"docs":{"11":{"tf":1.0},"13":{"tf":1.0}}}},"df":0,"docs":{}},"u":{"df":0,"docs":{},"r":{"df":13,"docs":{"1":{"tf":1.4142135623730951},"22":{"tf":1.0},"29":{"tf":1.0},"32":{"tf":1.0},"34":{"tf":1.0},"36":{"tf":1.0},"37":{"tf":1.7320508075688772},"39":{"tf":1.0},"45":{"tf":1.0},"46":{"tf":1.0},"47":{"tf":1.4142135623730951},"48":{"tf":1.7320508075688772},"7":{"tf":1.0}}}}}},"l":{"df":0,"docs":{},"i":{"c":{"df":0,"docs":{},"t":{"df":1,"docs":{"48":{"tf":1.0}}}},"df":0,"docs":{}}},"u":{"df":0,"docs":{},"s":{"df":1,"docs":{"2":{"tf":1.0}}}}},"n":{"df":0,"docs":{},"e":{"c":{"df":0,"docs":{},"t":{"df":8,"docs":{"1":{"tf":1.0},"32":{"tf":1.7320508075688772},"36":{"tf":1.0},"39":{"tf":1.0},"41":{"tf":1.0},"43":{"tf":1.0},"45":{"tf":1.4142135623730951},"48":{"tf":2.23606797749979}}}},"df":0,"docs":{}}},"s":{"df":0,"docs":{},"o":{"df":0,"docs":{},"l":{"df":1,"docs":{"19":{"tf":1.0}}}},"t":{"df":0,"docs":{},"r":{"a":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"df":1,"docs":{"24":{"tf":1.0}}}}},"df":0,"docs":{}}}},"t":{"a":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"df":11,"docs":{"11":{"tf":1.0},"12":{"tf":1.4142135623730951},"13":{"tf":2.0},"21":{"tf":1.0},"27":{"tf":1.0},"30":{"tf":1.0},"34":{"tf":1.4142135623730951},"44":{"tf":1.0},"48":{"tf":1.4142135623730951},"6":{"tf":2.449489742783178},"7":{"tf":1.7320508075688772}},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"p":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"df":0,"docs":{},"t":{"df":1,"docs":{"13":{"tf":1.7320508075688772}}}}}}}}}}},"df":0,"docs":{},"e":{"df":0,"docs":{},"n":{"df":0,"docs":{},"t":{"df":3,"docs":{"12":{"tf":1.0},"13":{"tf":1.4142135623730951},"14":{"tf":1.0}}}}},"r":{"df":0,"docs":{},"i":{"b":{"df":0,"docs":{},"u":{"df":0,"docs":{},"t":{"df":1,"docs":{"3":{"tf":1.0}}}}},"df":0,"docs":{}}}}},"o":{"df":0,"docs":{},"k":{"df":0,"docs":{},"i":{"df":4,"docs":{"1":{"tf":1.0},"29":{"tf":1.7320508075688772},"31":{"tf":1.7320508075688772},"48":{"tf":1.7320508075688772}}}}},"p":{"df":0,"docs":{},"i":{"df":2,"docs":{"21":{"tf":1.0},"7":{"tf":1.0}}}},"r":{"df":0,"docs":{},"e":{"df":1,"docs":{"48":{"tf":1.0}}},"r":{"df":0,"docs":{},"e":{"c":{"df":0,"docs":{},"t":{"df":3,"docs":{"12":{"tf":1.0},"13":{"tf":1.4142135623730951},"27":{"tf":1.0}},"l":{"df":0,"docs":{},"i":{"df":3,"docs":{"1":{"tf":1.0},"22":{"tf":1.0},"25":{"tf":1.0}}}}}},"df":0,"docs":{}}}},"s":{"df":0,"docs":{},"t":{"df":0,"docs":{},"l":{"df":0,"docs":{},"i":{"df":1,"docs":{"13":{"tf":1.0}}}}}},"u":{"df":0,"docs":{},"n":{"df":0,"docs":{},"t":{"df":1,"docs":{"48":{"tf":1.0}}}},"r":{"df":0,"docs":{},"s":{"df":2,"docs":{"1":{"tf":1.0},"17":{"tf":1.0}}}}}},"p":{"df":0,"docs":{},"u":{"df":1,"docs":{"13":{"tf":2.0}}}},"r":{"a":{"df":0,"docs":{},"s":{"df":0,"docs":{},"h":{"df":2,"docs":{"13":{"tf":1.0},"24":{"tf":1.0}}}},"t":{"df":0,"docs":{},"e":{"df":1,"docs":{"36":{"tf":1.4142135623730951}}}}},"d":{"df":1,"docs":{"14":{"tf":1.0}}},"df":0,"docs":{},"e":{"a":{"df":0,"docs":{},"t":{"df":16,"docs":{"1":{"tf":1.4142135623730951},"10":{"tf":1.7320508075688772},"11":{"tf":1.7320508075688772},"12":{"tf":1.7320508075688772},"13":{"tf":1.4142135623730951},"14":{"tf":1.0},"19":{"tf":1.0},"36":{"tf":1.7320508075688772},"40":{"tf":1.0},"41":{"tf":1.0},"43":{"tf":1.0},"45":{"tf":1.0},"47":{"tf":2.23606797749979},"48":{"tf":1.4142135623730951},"7":{"tf":2.0},"9":{"tf":2.0}},"i":{"df":0,"docs":{},"o":{"df":0,"docs":{},"n":{"df":1,"docs":{"13":{"tf":1.0}}}}}}},"d":{"df":0,"docs":{},"e":{"df":0,"docs":{},"n":{"df":0,"docs":{},"t":{"df":0,"docs":{},"i":{"df":1,"docs":{"48":{"tf":1.7320508075688772}}}}}}},"df":0,"docs":{}},"i":{"df":0,"docs":{},"t":{"df":0,"docs":{},"i":{"c":{"df":1,"docs":{"48":{"tf":1.0}}},"df":0,"docs":{}}}},"o":{"df":0,"docs":{},"n":{"df":2,"docs":{"34":{"tf":1.0},"48":{"tf":1.0}}}}},"s":{"df":0,"docs":{},"r":{"df":0,"docs":{},"f":{"df":1,"docs":{"48":{"tf":1.0}}}},"s":{"df":1,"docs":{"48":{"tf":1.0}}},"v":{"df":1,"docs":{"48":{"tf":1.0}}}},"u":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"df":0,"docs":{},"e":{"df":0,"docs":{},"n":{"df":0,"docs":{},"t":{"df":7,"docs":{"0":{"tf":1.0},"2":{"tf":1.7320508075688772},"30":{"tf":1.0},"31":{"tf":2.0},"32":{"tf":1.0},"34":{"tf":1.0},"48":{"tf":1.4142135623730951}}}}}}},"s":{"df":0,"docs":{},"t":{"df":0,"docs":{},"o":{"df":0,"docs":{},"m":{"df":4,"docs":{"1":{"tf":1.0},"22":{"tf":1.7320508075688772},"48":{"tf":1.0},"7":{"tf":1.0}},"i":{"df":0,"docs":{},"z":{"df":2,"docs":{"2":{"tf":1.0},"3":{"tf":1.4142135623730951}}}}}}}},"t":{"df":1,"docs":{"12":{"tf":1.0}}}}},"d":{"a":{"df":0,"docs":{},"n":{"df":0,"docs":{},"g":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":1,"docs":{"32":{"tf":1.0}}}}}},"t":{"a":{"b":{"a":{"df":0,"docs":{},"s":{"df":11,"docs":{"1":{"tf":1.0},"12":{"tf":1.0},"19":{"tf":1.0},"2":{"tf":1.0},"21":{"tf":1.0},"32":{"tf":2.8284271247461903},"34":{"tf":2.0},"35":{"tf":1.0},"48":{"tf":2.449489742783178},"6":{"tf":1.4142135623730951},"7":{"tf":1.7320508075688772}},"e":{"_":{"df":0,"docs":{},"m":{"a":{"df":0,"docs":{},"x":{"_":{"c":{"df":0,"docs":{},"o":{"df":0,"docs":{},"n":{"df":0,"docs":{},"n":{"=":{"5":{"df":1,"docs":{"48":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}}}}},"df":0,"docs":{}},"df":0,"docs":{}}},"df":0,"docs":{}},"u":{"df":0,"docs":{},"r":{"df":0,"docs":{},"l":{"=":{"df":0,"docs":{},"p":{"df":0,"docs":{},"o":{"df":0,"docs":{},"s":{"df":0,"docs":{},"t":{"df":0,"docs":{},"g":{"df":0,"docs":{},"r":{"df":0,"docs":{},"e":{"df":0,"docs":{},"s":{"df":0,"docs":{},"q":{"df":0,"docs":{},"l":{":":{"/":{"/":{"df":0,"docs":{},"r":{"a":{"df":0,"docs":{},"u":{"df":0,"docs":{},"t":{"df":0,"docs":{},"h":{"df":0,"docs":{},"y":{":":{"1":{"2":{"3":{"df":0,"docs":{},"s":{"df":0,"docs":{},"u":{"df":0,"docs":{},"p":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"s":{"a":{"df":0,"docs":{},"f":{"df":0,"docs":{},"e":{"@":{"df":0,"docs":{},"l":{"df":0,"docs":{},"o":{"c":{"a":{"df":0,"docs":{},"l":{"df":0,"docs":{},"h":{"df":0,"docs":{},"o":{"df":0,"docs":{},"s":{"df":0,"docs":{},"t":{":":{"5":{"4":{"3":{"2":{"/":{"df":0,"docs":{},"r":{"a":{"df":0,"docs":{},"u":{"df":0,"docs":{},"t":{"df":0,"docs":{},"h":{"df":0,"docs":{},"i":{"df":1,"docs":{"48":{"tf":1.0}}}}}}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}}}},"df":0,"docs":{}},"df":0,"docs":{}}}},"df":0,"docs":{}}}},"df":0,"docs":{}}}}}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}}}}}}}},"s":{"df":0,"docs":{},"q":{"df":0,"docs":{},"l":{"df":0,"docs":{},"i":{"df":0,"docs":{},"t":{"df":0,"docs":{},"e":{":":{":":{"df":0,"docs":{},"m":{"df":0,"docs":{},"e":{"df":0,"docs":{},"m":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"df":0,"docs":{},"i":{"df":1,"docs":{"48":{"tf":1.0}}}}}}}}},"d":{"a":{"df":0,"docs":{},"t":{"a":{"/":{"df":0,"docs":{},"r":{"a":{"df":0,"docs":{},"u":{"df":0,"docs":{},"t":{"df":0,"docs":{},"h":{"df":0,"docs":{},"y":{".":{"d":{"b":{"df":2,"docs":{"48":{"tf":1.0},"6":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}}}}},"df":5,"docs":{"11":{"tf":1.0},"12":{"tf":1.7320508075688772},"13":{"tf":1.4142135623730951},"32":{"tf":1.7320508075688772},"48":{"tf":1.4142135623730951}}}}}},"df":0,"docs":{}}}},"df":0,"docs":{}},"df":11,"docs":{"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.4142135623730951},"19":{"tf":1.0},"30":{"tf":1.0},"31":{"tf":1.4142135623730951},"32":{"tf":1.7320508075688772},"34":{"tf":1.4142135623730951},"48":{"tf":1.7320508075688772},"6":{"tf":1.4142135623730951},"7":{"tf":1.0}}},"df":0,"docs":{}},"y":{"_":{"df":0,"docs":{},"o":{"df":0,"docs":{},"f":{"_":{"df":0,"docs":{},"m":{"df":0,"docs":{},"o":{"df":0,"docs":{},"n":{"df":0,"docs":{},"t":{"df":0,"docs":{},"h":{"df":2,"docs":{"34":{"tf":1.0},"48":{"tf":1.0}}}}}}},"w":{"df":0,"docs":{},"e":{"df":0,"docs":{},"e":{"df":0,"docs":{},"k":{"df":2,"docs":{"34":{"tf":1.0},"48":{"tf":1.0}}}}}}},"df":0,"docs":{}}}},"df":0,"docs":{}}},"b":{"df":3,"docs":{"39":{"tf":1.0},"48":{"tf":1.4142135623730951},"7":{"tf":1.0}}},"c":{"df":3,"docs":{"12":{"tf":1.4142135623730951},"31":{"tf":1.4142135623730951},"40":{"tf":1.0}}},"d":{"df":0,"docs":{},"o":{"df":1,"docs":{"13":{"tf":1.0}}}},"df":3,"docs":{"12":{"tf":1.4142135623730951},"6":{"tf":1.0},"7":{"tf":1.0}},"e":{"a":{"c":{"df":0,"docs":{},"t":{"df":0,"docs":{},"i":{"df":0,"docs":{},"v":{"df":1,"docs":{"1":{"tf":1.0}}}}}},"df":0,"docs":{},"l":{"df":1,"docs":{"8":{"tf":1.0}}}},"b":{"df":0,"docs":{},"u":{"df":0,"docs":{},"g":{"df":2,"docs":{"22":{"tf":1.0},"48":{"tf":2.0}}}}},"c":{"df":0,"docs":{},"i":{"d":{"df":1,"docs":{"13":{"tf":1.7320508075688772}}},"df":0,"docs":{}},"r":{"df":0,"docs":{},"y":{"df":0,"docs":{},"p":{"df":0,"docs":{},"t":{"df":1,"docs":{"30":{"tf":1.0}}}}}}},"d":{"df":0,"docs":{},"i":{"c":{"df":1,"docs":{"43":{"tf":1.0}}},"df":0,"docs":{}}},"df":0,"docs":{},"f":{"a":{"df":0,"docs":{},"u":{"df":0,"docs":{},"l":{"df":0,"docs":{},"t":{"df":16,"docs":{"1":{"tf":2.0},"19":{"tf":1.0},"21":{"tf":1.0},"23":{"tf":1.0},"24":{"tf":1.4142135623730951},"27":{"tf":1.0},"29":{"tf":1.0},"30":{"tf":1.0},"34":{"tf":2.0},"36":{"tf":1.0},"41":{"tf":1.4142135623730951},"45":{"tf":3.0},"46":{"tf":1.7320508075688772},"48":{"tf":7.280109889280518},"6":{"tf":1.0},"7":{"tf":1.4142135623730951}}}}}},"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"df":2,"docs":{"30":{"tf":1.4142135623730951},"48":{"tf":1.4142135623730951}}}}},"g":{"df":0,"docs":{},"r":{"a":{"d":{"df":1,"docs":{"36":{"tf":1.4142135623730951}}},"df":0,"docs":{}},"df":0,"docs":{}}},"l":{"df":0,"docs":{},"e":{"df":0,"docs":{},"t":{"df":4,"docs":{"21":{"tf":1.0},"23":{"tf":1.0},"48":{"tf":1.0},"6":{"tf":1.4142135623730951}}}}},"p":{"df":0,"docs":{},"e":{"df":0,"docs":{},"n":{"d":{"df":4,"docs":{"12":{"tf":1.0},"13":{"tf":1.0},"28":{"tf":1.0},"48":{"tf":1.4142135623730951}}},"df":0,"docs":{}}},"l":{"df":0,"docs":{},"o":{"df":0,"docs":{},"y":{"df":14,"docs":{"1":{"tf":1.0},"10":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"15":{"tf":2.0},"2":{"tf":1.0},"21":{"tf":1.0},"24":{"tf":2.23606797749979},"32":{"tf":1.0},"37":{"tf":1.4142135623730951},"39":{"tf":2.0},"48":{"tf":2.0},"9":{"tf":1.7320508075688772}}}}},"r":{"df":0,"docs":{},"e":{"c":{"df":1,"docs":{"2":{"tf":1.0}}},"df":0,"docs":{}}},"t":{"df":0,"docs":{},"h":{"df":2,"docs":{"6":{"tf":1.0},"7":{"tf":1.0}}}}},"r":{"df":2,"docs":{"46":{"tf":1.4142135623730951},"48":{"tf":1.4142135623730951}}},"s":{"c":{"df":0,"docs":{},"r":{"df":0,"docs":{},"i":{"b":{"df":4,"docs":{"24":{"tf":1.0},"39":{"tf":1.0},"48":{"tf":1.0},"9":{"tf":1.0}}},"df":0,"docs":{}}}},"df":0,"docs":{},"i":{"df":0,"docs":{},"g":{"df":0,"docs":{},"n":{"df":1,"docs":{"1":{"tf":1.0}}}}}},"t":{"a":{"df":0,"docs":{},"i":{"df":0,"docs":{},"l":{"df":2,"docs":{"13":{"tf":1.0},"32":{"tf":1.0}}}}},"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"m":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"df":1,"docs":{"48":{"tf":1.0}}}}}}}},"v":{"/":{"df":0,"docs":{},"u":{"df":0,"docs":{},"r":{"a":{"df":0,"docs":{},"n":{"d":{"df":0,"docs":{},"o":{"df":0,"docs":{},"m":{"df":3,"docs":{"12":{"tf":1.4142135623730951},"31":{"tf":1.4142135623730951},"40":{"tf":1.0}}}}},"df":0,"docs":{}}},"df":0,"docs":{}}}},"df":0,"docs":{},"i":{"c":{"df":4,"docs":{"1":{"tf":1.0},"26":{"tf":1.0},"29":{"tf":1.7320508075688772},"48":{"tf":1.4142135623730951}}},"df":0,"docs":{}}}},"i":{"a":{"df":0,"docs":{},"l":{"df":0,"docs":{},"e":{"c":{"df":0,"docs":{},"t":{"df":1,"docs":{"2":{"tf":1.0}}}},"df":0,"docs":{}}}},"df":0,"docs":{},"f":{"df":0,"docs":{},"f":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":9,"docs":{"2":{"tf":1.0},"32":{"tf":1.0},"34":{"tf":1.4142135623730951},"36":{"tf":1.7320508075688772},"39":{"tf":1.0},"45":{"tf":1.4142135623730951},"48":{"tf":1.4142135623730951},"7":{"tf":1.0},"9":{"tf":1.0}}}}}},"g":{"df":0,"docs":{},"e":{"df":0,"docs":{},"s":{"df":0,"docs":{},"t":{"df":1,"docs":{"13":{"tf":1.0}}}}}},"r":{"df":0,"docs":{},"e":{"c":{"df":0,"docs":{},"t":{"df":3,"docs":{"13":{"tf":1.0},"23":{"tf":1.0},"36":{"tf":1.0}},"l":{"df":0,"docs":{},"i":{"df":5,"docs":{"13":{"tf":1.0},"21":{"tf":1.0},"36":{"tf":1.0},"42":{"tf":1.0},"7":{"tf":1.0}}}},"o":{"df":0,"docs":{},"r":{"df":0,"docs":{},"i":{"df":1,"docs":{"7":{"tf":2.23606797749979}}}}}}},"df":0,"docs":{}}},"s":{"a":{"b":{"df":0,"docs":{},"l":{"df":3,"docs":{"22":{"tf":1.0},"41":{"tf":1.0},"48":{"tf":1.7320508075688772}}}},"df":0,"docs":{}},"df":0,"docs":{},"k":{"df":3,"docs":{"34":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0}}},"t":{"df":0,"docs":{},"r":{"df":0,"docs":{},"i":{"b":{"df":0,"docs":{},"u":{"df":0,"docs":{},"t":{"df":1,"docs":{"1":{"tf":1.0}}}}},"df":0,"docs":{}}}}}},"o":{"c":{"df":0,"docs":{},"k":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":8,"docs":{"17":{"tf":1.0},"20":{"tf":1.7320508075688772},"39":{"tf":1.0},"4":{"tf":1.0},"48":{"tf":1.0},"5":{"tf":1.7320508075688772},"6":{"tf":2.6457513110645907},"7":{"tf":1.4142135623730951}}}}},"u":{"df":0,"docs":{},"m":{"df":0,"docs":{},"e":{"df":0,"docs":{},"n":{"df":0,"docs":{},"t":{"df":5,"docs":{"10":{"tf":1.0},"11":{"tf":1.0},"13":{"tf":1.0},"24":{"tf":1.0},"7":{"tf":1.0}}}}}}}},"df":1,"docs":{"24":{"tf":1.0}},"m":{"a":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{".":{"c":{"df":0,"docs":{},"o":{"df":0,"docs":{},"m":{"df":1,"docs":{"48":{"tf":1.0}}}}},"df":0,"docs":{}},"df":5,"docs":{"26":{"tf":1.0},"27":{"tf":1.0},"43":{"tf":1.0},"45":{"tf":1.4142135623730951},"48":{"tf":2.23606797749979}}}}},"df":0,"docs":{}},"n":{"df":0,"docs":{},"e":{"df":6,"docs":{"24":{"tf":1.0},"31":{"tf":1.0},"32":{"tf":1.0},"34":{"tf":1.0},"48":{"tf":1.4142135623730951},"7":{"tf":1.0}}}},"w":{"df":0,"docs":{},"n":{"df":0,"docs":{},"g":{"df":0,"docs":{},"r":{"a":{"d":{"df":1,"docs":{"29":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}}}}}},"r":{"df":0,"docs":{},"i":{"df":0,"docs":{},"v":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":2,"docs":{"12":{"tf":1.0},"48":{"tf":1.0}}}}}}},"u":{"df":0,"docs":{},"r":{"a":{"df":0,"docs":{},"t":{"df":1,"docs":{"48":{"tf":1.0}}}},"df":0,"docs":{},"e":{"df":3,"docs":{"13":{"tf":1.4142135623730951},"31":{"tf":1.0},"43":{"tf":1.0}}}}},"y":{"df":0,"docs":{},"n":{"a":{"df":0,"docs":{},"m":{"df":1,"docs":{"1":{"tf":1.0}}}},"df":0,"docs":{}}}},"df":0,"docs":{},"e":{"a":{"c":{"df":0,"docs":{},"h":{"df":4,"docs":{"1":{"tf":1.4142135623730951},"36":{"tf":1.7320508075688772},"39":{"tf":1.0},"48":{"tf":2.23606797749979}}}},"df":0,"docs":{},"r":{"df":0,"docs":{},"l":{"df":0,"docs":{},"i":{"df":1,"docs":{"7":{"tf":1.0}}}}},"s":{"df":0,"docs":{},"i":{"df":4,"docs":{"14":{"tf":1.0},"17":{"tf":1.0},"38":{"tf":1.0},"39":{"tf":1.0}},"e":{"df":0,"docs":{},"r":{"df":2,"docs":{"12":{"tf":1.0},"32":{"tf":1.0}}},"s":{"df":0,"docs":{},"t":{"df":1,"docs":{"32":{"tf":1.0}}}}},"l":{"df":0,"docs":{},"i":{"df":5,"docs":{"1":{"tf":1.0},"12":{"tf":1.0},"32":{"tf":1.0},"34":{"tf":1.0},"6":{"tf":1.0}}}}}}},"c":{"df":0,"docs":{},"h":{"df":0,"docs":{},"o":{"df":4,"docs":{"11":{"tf":1.0},"12":{"tf":2.0},"31":{"tf":1.4142135623730951},"40":{"tf":1.0}}}}},"d":{"2":{"5":{"5":{"1":{"9":{"df":1,"docs":{"1":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{},"i":{"df":0,"docs":{},"t":{"df":2,"docs":{"21":{"tf":1.0},"7":{"tf":1.0}},"o":{"df":0,"docs":{},"r":{"df":1,"docs":{"11":{"tf":1.0}}}}}}},"df":7,"docs":{"12":{"tf":1.0},"2":{"tf":1.4142135623730951},"22":{"tf":1.4142135623730951},"29":{"tf":1.0},"48":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0}},"f":{"df":0,"docs":{},"f":{"df":0,"docs":{},"e":{"c":{"df":0,"docs":{},"t":{"df":3,"docs":{"26":{"tf":1.0},"27":{"tf":1.0},"48":{"tf":1.4142135623730951}}}},"df":0,"docs":{}},"i":{"c":{"df":0,"docs":{},"i":{"df":2,"docs":{"1":{"tf":1.7320508075688772},"3":{"tf":1.0}}}},"df":0,"docs":{}}}},"g":{"df":0,"docs":{},"g":{"df":1,"docs":{"13":{"tf":1.0}}}},"l":{"df":0,"docs":{},"e":{"c":{"df":0,"docs":{},"t":{"df":3,"docs":{"36":{"tf":1.0},"39":{"tf":1.4142135623730951},"48":{"tf":1.4142135623730951}}}},"df":0,"docs":{}},"i":{"df":0,"docs":{},"m":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"df":1,"docs":{"39":{"tf":1.0}}}}}}},"m":{"b":{"df":0,"docs":{},"e":{"d":{"df":2,"docs":{"1":{"tf":1.0},"36":{"tf":1.0}}},"df":0,"docs":{}}},"df":0,"docs":{},"p":{"df":0,"docs":{},"t":{"df":0,"docs":{},"i":{"df":3,"docs":{"19":{"tf":1.0},"45":{"tf":1.4142135623730951},"48":{"tf":1.4142135623730951}}}}}},"n":{"a":{"b":{"df":0,"docs":{},"l":{"df":3,"docs":{"45":{"tf":1.0},"48":{"tf":2.0},"9":{"tf":1.0}}}},"df":0,"docs":{}},"c":{"_":{"df":0,"docs":{},"k":{"df":0,"docs":{},"e":{"df":0,"docs":{},"y":{"_":{"a":{"c":{"df":0,"docs":{},"t":{"df":2,"docs":{"30":{"tf":1.4142135623730951},"31":{"tf":1.7320508075688772}},"i":{"df":0,"docs":{},"v":{"df":0,"docs":{},"e":{"=":{"b":{"df":0,"docs":{},"v":{"c":{"df":0,"docs":{},"y":{"df":0,"docs":{},"t":{"df":0,"docs":{},"s":{"df":0,"docs":{},"g":{"a":{"df":0,"docs":{},"g":{"df":0,"docs":{},"g":{"df":0,"docs":{},"v":{"df":0,"docs":{},"y":{"5":{"df":0,"docs":{},"y":{"df":0,"docs":{},"q":{"df":0,"docs":{},"q":{"df":1,"docs":{"48":{"tf":1.0}}}}}},"df":0,"docs":{}}}}}},"df":0,"docs":{}}}}}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{}}}}}},"df":0,"docs":{}},"df":0,"docs":{},"i":{"d":{"df":1,"docs":{"12":{"tf":1.4142135623730951}}},"df":0,"docs":{}}},"df":6,"docs":{"11":{"tf":1.0},"12":{"tf":2.0},"13":{"tf":1.4142135623730951},"30":{"tf":1.7320508075688772},"31":{"tf":2.0},"48":{"tf":1.0}},"s":{"=":{"\"":{"b":{"df":0,"docs":{},"v":{"c":{"df":0,"docs":{},"y":{"df":0,"docs":{},"t":{"df":0,"docs":{},"s":{"df":0,"docs":{},"g":{"a":{"df":0,"docs":{},"g":{"df":0,"docs":{},"g":{"df":0,"docs":{},"v":{"df":0,"docs":{},"y":{"5":{"df":0,"docs":{},"y":{"df":0,"docs":{},"q":{"df":0,"docs":{},"q":{"/":{"df":0,"docs":{},"s":{"9":{"df":0,"docs":{},"n":{"7":{"df":0,"docs":{},"o":{"c":{"df":0,"docs":{},"e":{"df":0,"docs":{},"n":{"5":{"3":{"df":0,"docs":{},"x":{"df":0,"docs":{},"s":{"df":0,"docs":{},"j":{"df":0,"docs":{},"l":{"df":0,"docs":{},"z":{"c":{"df":0,"docs":{},"s":{"df":0,"docs":{},"m":{"df":0,"docs":{},"f":{"d":{"df":0,"docs":{},"n":{"b":{"d":{"df":0,"docs":{},"v":{"df":0,"docs":{},"n":{"df":0,"docs":{},"r":{"df":0,"docs":{},"q":{"df":0,"docs":{},"q":{"6":{"3":{"df":0,"docs":{},"r":{"4":{"df":2,"docs":{"31":{"tf":1.0},"48":{"tf":1.0}}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{}}}}}}},"df":0,"docs":{}},"df":0,"docs":{}}},"df":0,"docs":{}}}}},"df":0,"docs":{}}}}}}},"df":0,"docs":{}},"df":0,"docs":{}}}},"df":0,"docs":{}}},"df":0,"docs":{}}},"df":0,"docs":{}}},"df":0,"docs":{}}}}},"df":0,"docs":{}}}}}},"df":0,"docs":{}}}}}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}}},"a":{"df":0,"docs":{},"p":{"df":0,"docs":{},"s":{"df":0,"docs":{},"u":{"df":0,"docs":{},"l":{"df":1,"docs":{"41":{"tf":1.0}}}}}}},"df":0,"docs":{},"o":{"d":{"df":2,"docs":{"12":{"tf":1.0},"31":{"tf":1.0}}},"df":0,"docs":{},"u":{"df":0,"docs":{},"n":{"df":0,"docs":{},"t":{"df":1,"docs":{"32":{"tf":1.0}}}}}},"r":{"df":0,"docs":{},"y":{"df":0,"docs":{},"p":{"df":0,"docs":{},"t":{"df":8,"docs":{"1":{"tf":1.0},"12":{"tf":1.0},"17":{"tf":1.0},"29":{"tf":1.4142135623730951},"30":{"tf":2.23606797749979},"31":{"tf":3.0},"41":{"tf":1.0},"48":{"tf":1.0}}}}}}},"d":{"df":3,"docs":{"43":{"tf":1.4142135623730951},"46":{"tf":1.0},"48":{"tf":1.0}},"p":{"df":0,"docs":{},"o":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"df":0,"docs":{},"t":{"df":1,"docs":{"48":{"tf":2.6457513110645907}}}}}}}},"df":0,"docs":{},"o":{"df":0,"docs":{},"u":{"df":0,"docs":{},"g":{"df":0,"docs":{},"h":{"df":2,"docs":{"13":{"tf":1.4142135623730951},"31":{"tf":1.0}}}}}},"t":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":2,"docs":{"43":{"tf":1.7320508075688772},"48":{"tf":1.0}}}},"i":{"df":0,"docs":{},"t":{"df":0,"docs":{},"i":{"df":1,"docs":{"43":{"tf":1.4142135623730951}}}}},"r":{"df":0,"docs":{},"i":{"df":2,"docs":{"21":{"tf":1.0},"39":{"tf":1.4142135623730951}}},"y":{"df":0,"docs":{},"p":{"df":0,"docs":{},"o":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"df":0,"docs":{},"t":{"df":2,"docs":{"14":{"tf":1.0},"17":{"tf":1.4142135623730951}}}}}}}}}},"v":{"df":1,"docs":{"13":{"tf":1.0}},"i":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"n":{"df":4,"docs":{"32":{"tf":1.0},"39":{"tf":1.0},"48":{"tf":1.4142135623730951},"7":{"tf":1.7320508075688772}},"m":{"df":1,"docs":{"32":{"tf":1.0}}}}}}}}},"r":{"a":{"df":0,"docs":{},"s":{"df":1,"docs":{"6":{"tf":1.0}}}},"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"df":2,"docs":{"43":{"tf":1.0},"48":{"tf":1.0}}}}}},"s":{"df":0,"docs":{},"p":{"df":0,"docs":{},"e":{"c":{"df":0,"docs":{},"i":{"df":3,"docs":{"24":{"tf":1.0},"39":{"tf":1.0},"48":{"tf":1.0}}}},"df":0,"docs":{}}}},"v":{"a":{"df":0,"docs":{},"l":{"df":0,"docs":{},"u":{"df":2,"docs":{"32":{"tf":1.0},"6":{"tf":1.4142135623730951}}}}},"df":0,"docs":{},"e":{"df":0,"docs":{},"n":{"df":11,"docs":{"0":{"tf":1.0},"1":{"tf":2.0},"2":{"tf":1.4142135623730951},"24":{"tf":1.0},"27":{"tf":1.0},"29":{"tf":1.0},"31":{"tf":1.0},"36":{"tf":1.0},"39":{"tf":1.0},"48":{"tf":1.0},"7":{"tf":1.7320508075688772}}},"r":{"df":0,"docs":{},"y":{"df":0,"docs":{},"o":{"df":0,"docs":{},"n":{"df":1,"docs":{"7":{"tf":1.0}}}},"t":{"df":0,"docs":{},"h":{"df":1,"docs":{"7":{"tf":1.0}}}}}}},"i":{"c":{"df":0,"docs":{},"t":{"df":1,"docs":{"1":{"tf":1.4142135623730951}}}},"df":0,"docs":{}}},"x":{"a":{"c":{"df":0,"docs":{},"t":{"df":2,"docs":{"24":{"tf":1.4142135623730951},"48":{"tf":1.0}},"l":{"df":0,"docs":{},"i":{"df":2,"docs":{"12":{"tf":1.0},"48":{"tf":1.0}}}}}},"df":0,"docs":{},"m":{"df":0,"docs":{},"p":{"df":0,"docs":{},"l":{"df":9,"docs":{"1":{"tf":1.0},"12":{"tf":1.4142135623730951},"13":{"tf":1.7320508075688772},"14":{"tf":1.0},"17":{"tf":1.0},"26":{"tf":1.0},"27":{"tf":1.0},"29":{"tf":1.0},"48":{"tf":1.4142135623730951}}}}}},"c":{"df":0,"docs":{},"e":{"df":2,"docs":{"24":{"tf":1.0},"48":{"tf":1.0}}}},"df":0,"docs":{},"e":{"c":{"df":0,"docs":{},"u":{"df":0,"docs":{},"t":{"df":6,"docs":{"23":{"tf":1.0},"31":{"tf":1.0},"36":{"tf":1.0},"43":{"tf":1.7320508075688772},"6":{"tf":1.0},"7":{"tf":1.0}}}}},"df":0,"docs":{}},"i":{"df":0,"docs":{},"s":{"df":0,"docs":{},"t":{"df":8,"docs":{"1":{"tf":1.0},"17":{"tf":1.0},"2":{"tf":1.4142135623730951},"3":{"tf":1.7320508075688772},"30":{"tf":1.0},"31":{"tf":1.7320508075688772},"32":{"tf":1.0},"43":{"tf":1.0}}}},"t":{"df":2,"docs":{"39":{"tf":1.0},"6":{"tf":1.0}}}},"p":{"df":0,"docs":{},"e":{"c":{"df":0,"docs":{},"t":{"df":4,"docs":{"0":{"tf":1.0},"2":{"tf":1.0},"45":{"tf":1.0},"46":{"tf":1.4142135623730951}}}},"df":0,"docs":{},"n":{"df":0,"docs":{},"s":{"df":1,"docs":{"24":{"tf":1.0}}}},"r":{"df":0,"docs":{},"i":{"df":3,"docs":{"24":{"tf":1.0},"29":{"tf":1.4142135623730951},"43":{"tf":1.0}}}}},"i":{"df":0,"docs":{},"r":{"df":3,"docs":{"29":{"tf":1.0},"31":{"tf":1.0},"48":{"tf":1.0}}}},"l":{"a":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"df":1,"docs":{"17":{"tf":1.0}}}}},"df":0,"docs":{}}},"t":{"df":0,"docs":{},"e":{"df":0,"docs":{},"n":{"d":{"df":2,"docs":{"2":{"tf":1.0},"48":{"tf":1.4142135623730951}}},"df":0,"docs":{},"s":{"df":1,"docs":{"1":{"tf":1.4142135623730951}}}},"r":{"df":0,"docs":{},"n":{"df":4,"docs":{"13":{"tf":1.0},"2":{"tf":1.0},"24":{"tf":1.0},"48":{"tf":1.4142135623730951}}}}},"r":{"a":{"c":{"df":0,"docs":{},"t":{"df":3,"docs":{"12":{"tf":1.0},"39":{"tf":1.4142135623730951},"48":{"tf":1.0}}}},"df":1,"docs":{"48":{"tf":1.0}}},"df":0,"docs":{}}}}},"f":{"1":{"df":1,"docs":{"12":{"tf":1.0}}},"a":{"c":{"df":0,"docs":{},"t":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"df":3,"docs":{"1":{"tf":1.0},"29":{"tf":1.7320508075688772},"48":{"tf":1.4142135623730951}}}}}},"df":0,"docs":{},"i":{"df":0,"docs":{},"l":{"df":1,"docs":{"31":{"tf":1.4142135623730951}}}},"l":{"df":0,"docs":{},"l":{"b":{"a":{"c":{"df":0,"docs":{},"k":{"df":1,"docs":{"22":{"tf":1.0}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":1,"docs":{"31":{"tf":1.0}}},"s":{"df":2,"docs":{"13":{"tf":1.4142135623730951},"48":{"tf":2.6457513110645907}}}},"r":{"df":1,"docs":{"1":{"tf":1.4142135623730951}}},"s":{"df":0,"docs":{},"t":{"df":2,"docs":{"1":{"tf":1.4142135623730951},"3":{"tf":1.0}}}},"v":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"df":0,"docs":{},"i":{"df":0,"docs":{},"t":{"df":1,"docs":{"11":{"tf":1.0}}}}}}}},"df":5,"docs":{"15":{"tf":1.0},"20":{"tf":1.0},"21":{"tf":1.0},"47":{"tf":1.4142135623730951},"6":{"tf":1.0}},"e":{"a":{"df":0,"docs":{},"t":{"df":0,"docs":{},"u":{"df":0,"docs":{},"r":{"df":4,"docs":{"13":{"tf":1.0},"2":{"tf":2.449489742783178},"32":{"tf":1.0},"34":{"tf":1.0}}}}}},"d":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":1,"docs":{"3":{"tf":1.0}}}}},"df":0,"docs":{},"t":{"c":{"df":0,"docs":{},"h":{"df":1,"docs":{"39":{"tf":1.0}}}},"df":0,"docs":{}},"w":{"df":5,"docs":{"17":{"tf":1.0},"2":{"tf":1.0},"3":{"tf":1.0},"30":{"tf":1.0},"31":{"tf":1.0}}}},"i":{"d":{"df":0,"docs":{},"o":{"df":4,"docs":{"1":{"tf":1.4142135623730951},"25":{"tf":1.7320508075688772},"27":{"tf":1.0},"29":{"tf":1.0}}}},"df":0,"docs":{},"l":{"df":0,"docs":{},"e":{"df":13,"docs":{"1":{"tf":1.0},"11":{"tf":1.4142135623730951},"12":{"tf":1.4142135623730951},"13":{"tf":1.4142135623730951},"14":{"tf":1.0},"37":{"tf":1.0},"43":{"tf":2.0},"45":{"tf":2.449489742783178},"46":{"tf":1.7320508075688772},"47":{"tf":1.4142135623730951},"48":{"tf":3.1622776601683795},"7":{"tf":3.1622776601683795},"8":{"tf":1.0}},"n":{"a":{"df":0,"docs":{},"m":{"df":1,"docs":{"48":{"tf":1.0}}}},"df":0,"docs":{}}},"l":{"df":1,"docs":{"29":{"tf":1.0}}}},"n":{"a":{"df":0,"docs":{},"l":{"df":2,"docs":{"12":{"tf":1.0},"31":{"tf":1.0}}}},"d":{"df":4,"docs":{"13":{"tf":1.0},"24":{"tf":1.4142135623730951},"31":{"tf":1.0},"39":{"tf":1.4142135623730951}}},"df":0,"docs":{},"e":{"df":1,"docs":{"36":{"tf":1.0}}},"g":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"p":{"df":0,"docs":{},"r":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"df":0,"docs":{},"t":{"df":1,"docs":{"1":{"tf":1.0}}}}}}}}}},"i":{"df":0,"docs":{},"s":{"df":0,"docs":{},"h":{"df":1,"docs":{"32":{"tf":1.0}}}}}},"r":{"df":0,"docs":{},"e":{"df":0,"docs":{},"f":{"df":0,"docs":{},"o":{"df":0,"docs":{},"x":{"df":3,"docs":{"1":{"tf":1.4142135623730951},"28":{"tf":1.0},"29":{"tf":1.0}}}}}},"s":{"df":0,"docs":{},"t":{"df":13,"docs":{"15":{"tf":1.0},"17":{"tf":1.0},"18":{"tf":1.7320508075688772},"19":{"tf":1.7320508075688772},"2":{"tf":1.0},"20":{"tf":1.0},"21":{"tf":1.0},"22":{"tf":1.7320508075688772},"23":{"tf":1.0},"38":{"tf":1.0},"48":{"tf":1.0},"6":{"tf":1.7320508075688772},"7":{"tf":1.7320508075688772}}}}}},"l":{"df":0,"docs":{},"e":{"df":0,"docs":{},"x":{"df":0,"docs":{},"i":{"b":{"df":0,"docs":{},"l":{"df":1,"docs":{"3":{"tf":1.0}}}},"df":0,"docs":{}}}},"o":{"df":0,"docs":{},"w":{"df":4,"docs":{"1":{"tf":1.7320508075688772},"29":{"tf":1.0},"3":{"tf":1.7320508075688772},"48":{"tf":1.0}}}}},"o":{"df":0,"docs":{},"l":{"d":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":2,"docs":{"11":{"tf":1.0},"43":{"tf":1.0}}}}},"df":0,"docs":{},"l":{"df":0,"docs":{},"o":{"df":0,"docs":{},"w":{"df":11,"docs":{"10":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"21":{"tf":1.0},"32":{"tf":1.0},"37":{"tf":1.0},"45":{"tf":1.0},"47":{"tf":1.4142135623730951},"48":{"tf":1.4142135623730951},"7":{"tf":1.0}}}}}},"o":{"df":0,"docs":{},"t":{"df":0,"docs":{},"p":{"df":0,"docs":{},"r":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"df":0,"docs":{},"t":{"df":1,"docs":{"1":{"tf":1.0}}}}}}}}},"r":{"c":{"df":1,"docs":{"48":{"tf":1.4142135623730951}}},"df":0,"docs":{},"m":{"a":{"df":0,"docs":{},"t":{"df":5,"docs":{"12":{"tf":1.7320508075688772},"31":{"tf":1.0},"45":{"tf":1.0},"46":{"tf":1.4142135623730951},"48":{"tf":2.449489742783178}}}},"df":0,"docs":{}},"w":{"a":{"df":0,"docs":{},"r":{"d":{"df":2,"docs":{"17":{"tf":1.0},"34":{"tf":1.0}}},"df":0,"docs":{}}},"df":0,"docs":{}}},"u":{"df":0,"docs":{},"n":{"d":{"a":{"df":0,"docs":{},"t":{"df":1,"docs":{"2":{"tf":1.0}}}},"df":3,"docs":{"24":{"tf":1.0},"39":{"tf":1.4142135623730951},"43":{"tf":1.0}}},"df":0,"docs":{}}}},"r":{"df":0,"docs":{},"e":{"df":0,"docs":{},"s":{"df":0,"docs":{},"h":{"df":1,"docs":{"39":{"tf":1.0}}}}},"o":{"df":0,"docs":{},"n":{"df":0,"docs":{},"t":{"df":0,"docs":{},"e":{"df":0,"docs":{},"n":{"d":{"df":1,"docs":{"48":{"tf":1.0}}},"df":0,"docs":{}}}}}}},"s":{"df":0,"docs":{},"g":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"u":{"df":0,"docs":{},"p":{"df":1,"docs":{"13":{"tf":1.0}}}}}}}},"u":{"df":0,"docs":{},"l":{"df":0,"docs":{},"l":{"df":3,"docs":{"1":{"tf":1.4142135623730951},"43":{"tf":1.0},"48":{"tf":1.0}},"i":{"df":4,"docs":{"1":{"tf":1.0},"24":{"tf":1.0},"29":{"tf":1.0},"3":{"tf":1.4142135623730951}}}}},"r":{"df":0,"docs":{},"t":{"df":0,"docs":{},"h":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":1,"docs":{"1":{"tf":1.0}}}}}}},"t":{"df":0,"docs":{},"u":{"df":0,"docs":{},"r":{"df":3,"docs":{"1":{"tf":1.4142135623730951},"2":{"tf":1.0},"36":{"tf":1.0}}}}}}},"g":{"a":{"df":0,"docs":{},"r":{"b":{"a":{"df":0,"docs":{},"g":{"df":1,"docs":{"13":{"tf":1.0}}}},"df":0,"docs":{}},"df":0,"docs":{}}},"df":0,"docs":{},"e":{"df":0,"docs":{},"n":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":6,"docs":{"12":{"tf":1.7320508075688772},"19":{"tf":1.7320508075688772},"31":{"tf":1.4142135623730951},"43":{"tf":2.23606797749979},"47":{"tf":1.4142135623730951},"48":{"tf":1.7320508075688772}}}}},"t":{"df":23,"docs":{"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"15":{"tf":1.0},"16":{"tf":1.0},"17":{"tf":1.0},"18":{"tf":1.0},"19":{"tf":1.0},"20":{"tf":1.0},"21":{"tf":1.0},"22":{"tf":1.0},"23":{"tf":1.0},"30":{"tf":1.0},"39":{"tf":1.0},"4":{"tf":1.7320508075688772},"40":{"tf":1.0},"5":{"tf":1.0},"6":{"tf":1.4142135623730951},"7":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}}}},"i":{"df":0,"docs":{},"t":{"df":0,"docs":{},"h":{"df":0,"docs":{},"u":{"b":{"df":2,"docs":{"13":{"tf":1.0},"2":{"tf":1.0}}},"df":0,"docs":{}}}},"v":{"df":0,"docs":{},"e":{"df":0,"docs":{},"n":{"df":4,"docs":{"12":{"tf":1.0},"30":{"tf":1.0},"32":{"tf":1.0},"48":{"tf":1.4142135623730951}}}}}},"o":{"a":{"df":0,"docs":{},"l":{"df":1,"docs":{"1":{"tf":1.0}}}},"df":5,"docs":{"13":{"tf":1.0},"17":{"tf":1.4142135623730951},"48":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0}},"n":{"df":0,"docs":{},"e":{"df":1,"docs":{"31":{"tf":1.0}}}},"o":{"d":{"df":8,"docs":{"22":{"tf":1.0},"23":{"tf":1.0},"24":{"tf":1.0},"29":{"tf":1.4142135623730951},"3":{"tf":1.0},"31":{"tf":1.4142135623730951},"43":{"tf":1.0},"48":{"tf":1.4142135623730951}}},"df":0,"docs":{}}},"r":{"a":{"c":{"df":0,"docs":{},"e":{"df":1,"docs":{"48":{"tf":1.4142135623730951}}}},"df":0,"docs":{},"n":{"df":0,"docs":{},"t":{"df":1,"docs":{"48":{"tf":1.0}}}}},"df":0,"docs":{},"e":{"a":{"df":0,"docs":{},"t":{"df":1,"docs":{"3":{"tf":1.0}}}},"df":0,"docs":{}},"o":{"df":0,"docs":{},"u":{"df":0,"docs":{},"p":{"df":2,"docs":{"23":{"tf":1.0},"7":{"tf":1.0}}}}},"p":{"c":{"df":1,"docs":{"36":{"tf":1.0}}},"df":0,"docs":{}}},"u":{"a":{"df":0,"docs":{},"r":{"a":{"df":0,"docs":{},"n":{"df":0,"docs":{},"t":{"df":0,"docs":{},"e":{"df":1,"docs":{"36":{"tf":1.0}}}}}},"df":0,"docs":{}}},"df":0,"docs":{},"i":{"d":{"df":1,"docs":{"24":{"tf":1.0}}},"df":0,"docs":{}}}},"h":{"a":{"_":{"df":0,"docs":{},"h":{"df":0,"docs":{},"o":{"df":0,"docs":{},"s":{"df":0,"docs":{},"t":{"df":1,"docs":{"39":{"tf":3.0}},"s":{"=":{"\"":{"df":0,"docs":{},"h":{"df":0,"docs":{},"t":{"df":0,"docs":{},"t":{"df":0,"docs":{},"p":{":":{"/":{"/":{"df":0,"docs":{},"r":{"a":{"df":0,"docs":{},"u":{"df":0,"docs":{},"t":{"df":0,"docs":{},"h":{"df":0,"docs":{},"i":{"df":2,"docs":{"39":{"tf":1.0},"48":{"tf":1.0}}}}}}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}}},"df":0,"docs":{}},"df":0,"docs":{}}}}}},"m":{"df":0,"docs":{},"o":{"d":{"df":4,"docs":{"12":{"tf":1.4142135623730951},"37":{"tf":1.0},"38":{"tf":1.4142135623730951},"9":{"tf":1.0}},"e":{"=":{"df":0,"docs":{},"f":{"a":{"df":0,"docs":{},"l":{"df":0,"docs":{},"s":{"df":1,"docs":{"48":{"tf":1.0}}}}},"df":0,"docs":{}},"t":{"df":0,"docs":{},"r":{"df":0,"docs":{},"u":{"df":1,"docs":{"38":{"tf":1.0}}}}}},"df":0,"docs":{}}},"df":0,"docs":{}}}},"df":9,"docs":{"1":{"tf":1.7320508075688772},"13":{"tf":1.4142135623730951},"21":{"tf":1.0},"32":{"tf":1.0},"36":{"tf":2.449489742783178},"39":{"tf":1.4142135623730951},"41":{"tf":1.0},"48":{"tf":2.6457513110645907},"9":{"tf":1.0}},"n":{"d":{"df":0,"docs":{},"l":{"df":1,"docs":{"35":{"tf":1.0}}}},"df":0,"docs":{}},"p":{"df":0,"docs":{},"p":{"df":0,"docs":{},"e":{"df":0,"docs":{},"n":{"df":4,"docs":{"19":{"tf":1.0},"23":{"tf":1.0},"39":{"tf":1.0},"48":{"tf":1.0}}}}}},"r":{"d":{"df":1,"docs":{"32":{"tf":1.0}},"e":{"df":0,"docs":{},"n":{"df":1,"docs":{"7":{"tf":1.0}}}}},"df":0,"docs":{}},"s":{"df":0,"docs":{},"h":{"_":{"a":{"df":0,"docs":{},"w":{"a":{"df":0,"docs":{},"i":{"df":0,"docs":{},"t":{"_":{"df":0,"docs":{},"w":{"a":{"df":0,"docs":{},"r":{"df":0,"docs":{},"n":{"_":{"df":0,"docs":{},"t":{"df":0,"docs":{},"i":{"df":0,"docs":{},"m":{"df":0,"docs":{},"e":{"=":{"5":{"0":{"0":{"df":1,"docs":{"48":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}}},"df":0,"docs":{}}}},"df":0,"docs":{}}},"df":0,"docs":{}}}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":3,"docs":{"13":{"tf":2.23606797749979},"24":{"tf":2.0},"48":{"tf":1.4142135623730951}}}},"v":{"df":0,"docs":{},"e":{"df":2,"docs":{"39":{"tf":1.0},"47":{"tf":1.0}}}}},"df":0,"docs":{},"e":{"a":{"d":{"df":3,"docs":{"12":{"tf":1.4142135623730951},"31":{"tf":1.4142135623730951},"40":{"tf":1.0}},"e":{"df":0,"docs":{},"r":{"df":1,"docs":{"48":{"tf":1.7320508075688772}}}}},"df":0,"docs":{},"v":{"df":0,"docs":{},"i":{"df":1,"docs":{"24":{"tf":1.0}},"l":{"df":0,"docs":{},"i":{"df":1,"docs":{"13":{"tf":1.0}}}}}}},"df":0,"docs":{},"l":{"df":0,"docs":{},"l":{"df":0,"docs":{},"o":{"df":1,"docs":{"48":{"tf":1.0}}}},"m":{"df":1,"docs":{"8":{"tf":1.0}}},"p":{"df":2,"docs":{"24":{"tf":1.0},"31":{"tf":1.4142135623730951}}}},"r":{"df":0,"docs":{},"e":{"df":4,"docs":{"11":{"tf":1.0},"17":{"tf":1.0},"24":{"tf":1.0},"43":{"tf":1.0}}}}},"i":{"df":0,"docs":{},"g":{"df":0,"docs":{},"h":{"df":7,"docs":{"24":{"tf":1.0},"36":{"tf":2.0},"37":{"tf":1.0},"38":{"tf":1.0},"39":{"tf":1.0},"40":{"tf":1.0},"41":{"tf":1.0}},"e":{"df":0,"docs":{},"r":{"df":1,"docs":{"36":{"tf":1.0}}}},"l":{"df":0,"docs":{},"i":{"df":3,"docs":{"1":{"tf":1.0},"13":{"tf":1.0},"41":{"tf":1.0}}}}}},"n":{"df":0,"docs":{},"t":{"df":3,"docs":{"32":{"tf":1.0},"39":{"tf":1.0},"43":{"tf":1.0}}}},"t":{"df":1,"docs":{"48":{"tf":1.7320508075688772}}}},"o":{"df":0,"docs":{},"o":{"d":{"df":1,"docs":{"23":{"tf":1.0}}},"df":0,"docs":{}},"p":{"df":0,"docs":{},"e":{"df":0,"docs":{},"f":{"df":0,"docs":{},"u":{"df":0,"docs":{},"l":{"df":0,"docs":{},"l":{"df":0,"docs":{},"i":{"df":2,"docs":{"31":{"tf":1.0},"48":{"tf":1.0}}}}}}}}},"s":{"df":0,"docs":{},"t":{"(":{"`":{"a":{"df":0,"docs":{},"u":{"df":0,"docs":{},"t":{"df":0,"docs":{},"h":{".":{"df":0,"docs":{},"e":{"df":0,"docs":{},"x":{"a":{"df":0,"docs":{},"m":{"df":0,"docs":{},"p":{"df":0,"docs":{},"l":{"df":0,"docs":{},"e":{".":{"c":{"df":0,"docs":{},"o":{"df":0,"docs":{},"m":{"df":2,"docs":{"14":{"tf":1.0},"17":{"tf":1.4142135623730951}}}}},"df":0,"docs":{}},"df":0,"docs":{}}}}}},"df":0,"docs":{}}}},"df":0,"docs":{}}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":4,"docs":{"1":{"tf":1.4142135623730951},"39":{"tf":1.0},"48":{"tf":1.4142135623730951},"7":{"tf":1.0}},"n":{"a":{"df":0,"docs":{},"m":{"df":2,"docs":{"39":{"tf":2.23606797749979},"48":{"tf":1.4142135623730951}},"e":{"_":{"df":0,"docs":{},"o":{"df":0,"docs":{},"v":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"w":{"df":0,"docs":{},"r":{"df":0,"docs":{},"i":{"df":0,"docs":{},"t":{"df":1,"docs":{"39":{"tf":1.0}},"e":{"=":{"\"":{"df":0,"docs":{},"r":{"a":{"df":0,"docs":{},"u":{"df":0,"docs":{},"t":{"df":0,"docs":{},"h":{"df":0,"docs":{},"i":{"df":1,"docs":{"48":{"tf":1.0}}}}}}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{}}}}}}}}}}},"df":0,"docs":{}}}},"df":0,"docs":{}}}},"u":{"df":0,"docs":{},"r":{"df":4,"docs":{"1":{"tf":1.0},"29":{"tf":1.0},"34":{"tf":1.4142135623730951},"48":{"tf":2.0}}},"s":{"df":0,"docs":{},"e":{"df":0,"docs":{},"k":{"df":0,"docs":{},"e":{"df":0,"docs":{},"e":{"df":0,"docs":{},"p":{"df":1,"docs":{"48":{"tf":1.0}}}}}}}}}},"t":{"df":0,"docs":{},"t":{"df":0,"docs":{},"p":{":":{"/":{"/":{"df":0,"docs":{},"l":{"df":0,"docs":{},"o":{"c":{"a":{"df":0,"docs":{},"l":{"df":0,"docs":{},"h":{"df":0,"docs":{},"o":{"df":0,"docs":{},"s":{"df":0,"docs":{},"t":{":":{"8":{"0":{"8":{"0":{"df":1,"docs":{"48":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}}}},"df":0,"docs":{}},"df":0,"docs":{}}},"r":{"a":{"df":0,"docs":{},"u":{"df":0,"docs":{},"t":{"df":0,"docs":{},"h":{"df":0,"docs":{},"i":{"df":2,"docs":{"39":{"tf":1.4142135623730951},"48":{"tf":1.4142135623730951}}}}}}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{}},"_":{"df":0,"docs":{},"h":{"df":0,"docs":{},"t":{"df":0,"docs":{},"t":{"df":0,"docs":{},"p":{"df":1,"docs":{"48":{"tf":1.4142135623730951}}}}}},"w":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"df":0,"docs":{},"k":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"s":{"=":{"1":{"df":1,"docs":{"48":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}}}}}}}}},"df":6,"docs":{"13":{"tf":3.3166247903554},"14":{"tf":1.0},"17":{"tf":2.449489742783178},"27":{"tf":1.0},"41":{"tf":1.0},"48":{"tf":2.23606797749979}},"g":{"df":0,"docs":{},"e":{"df":0,"docs":{},"t":{"df":1,"docs":{"13":{"tf":1.4142135623730951}}}}},"s":{":":{"/":{"/":{"df":0,"docs":{},"h":{"df":0,"docs":{},"u":{"b":{".":{"d":{"df":0,"docs":{},"o":{"c":{"df":0,"docs":{},"k":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{".":{"c":{"df":0,"docs":{},"o":{"df":0,"docs":{},"m":{"/":{"df":0,"docs":{},"l":{"a":{"df":0,"docs":{},"y":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"s":{"/":{"df":0,"docs":{},"s":{"d":{"df":0,"docs":{},"o":{"b":{"df":0,"docs":{},"e":{"d":{"df":0,"docs":{},"e":{"df":0,"docs":{},"v":{"/":{"df":0,"docs":{},"r":{"a":{"df":0,"docs":{},"u":{"df":0,"docs":{},"t":{"df":0,"docs":{},"h":{"df":0,"docs":{},"y":{"/":{"0":{".":{"1":{"2":{".":{"0":{"/":{"df":0,"docs":{},"i":{"df":0,"docs":{},"m":{"a":{"df":0,"docs":{},"g":{"df":0,"docs":{},"e":{"df":0,"docs":{},"s":{"/":{"df":0,"docs":{},"s":{"df":0,"docs":{},"h":{"a":{"2":{"5":{"6":{"df":1,"docs":{"13":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}},"df":0,"docs":{}}}}},"df":0,"docs":{}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}}},"df":0,"docs":{}}},"df":0,"docs":{}}}},"df":0,"docs":{}}},"df":0,"docs":{}}},"df":0,"docs":{}}},"df":0,"docs":{}}}}}},"df":0,"docs":{}},"r":{"/":{"df":0,"docs":{},"s":{"d":{"df":0,"docs":{},"o":{"b":{"df":0,"docs":{},"e":{"d":{"df":0,"docs":{},"e":{"df":0,"docs":{},"v":{"/":{"df":0,"docs":{},"r":{"a":{"df":0,"docs":{},"u":{"df":0,"docs":{},"t":{"df":0,"docs":{},"h":{"df":0,"docs":{},"i":{"df":1,"docs":{"13":{"tf":1.0}}}}}}},"df":0,"docs":{}}},"df":0,"docs":{}}}},"df":0,"docs":{}}},"df":0,"docs":{}}},"df":0,"docs":{}}},"df":0,"docs":{}}},"df":0,"docs":{}}}},"df":0,"docs":{}},"df":0,"docs":{}}}}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}},"u":{"df":0,"docs":{},"g":{"df":0,"docs":{},"e":{"df":1,"docs":{"48":{"tf":1.0}}}}}},"i":{"d":{"df":6,"docs":{"12":{"tf":1.4142135623730951},"13":{"tf":1.0},"26":{"tf":1.0},"30":{"tf":1.0},"31":{"tf":2.0},"48":{"tf":1.7320508075688772}},"e":{"a":{"df":3,"docs":{"2":{"tf":1.0},"22":{"tf":1.0},"23":{"tf":1.0}}},"df":0,"docs":{},"n":{"df":0,"docs":{},"t":{"df":0,"docs":{},"i":{"df":0,"docs":{},"f":{"df":0,"docs":{},"i":{"df":1,"docs":{"48":{"tf":1.0}}}}}}}}},"df":0,"docs":{},"f":{"df":0,"docs":{},"n":{"df":0,"docs":{},"o":{"df":0,"docs":{},"t":{"df":0,"docs":{},"p":{"df":0,"docs":{},"r":{"df":0,"docs":{},"e":{"df":0,"docs":{},"s":{"df":1,"docs":{"13":{"tf":1.0}}}}}}}}}},"g":{"df":0,"docs":{},"n":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"df":1,"docs":{"1":{"tf":1.0}}}}}},"m":{"a":{"df":0,"docs":{},"g":{"df":2,"docs":{"13":{"tf":2.23606797749979},"6":{"tf":1.0}},"e":{"df":0,"docs":{},"p":{"df":0,"docs":{},"u":{"df":0,"docs":{},"l":{"df":0,"docs":{},"l":{"df":0,"docs":{},"p":{"df":0,"docs":{},"o":{"df":0,"docs":{},"l":{"df":0,"docs":{},"i":{"c":{"df":0,"docs":{},"i":{"df":1,"docs":{"13":{"tf":1.0}}}},"df":0,"docs":{}}}}}}}}}}}},"df":0,"docs":{},"m":{"df":0,"docs":{},"e":{"d":{"df":0,"docs":{},"i":{"df":2,"docs":{"21":{"tf":1.0},"32":{"tf":1.0}}}},"df":0,"docs":{}}},"p":{"df":0,"docs":{},"l":{"df":0,"docs":{},"e":{"df":0,"docs":{},"m":{"df":0,"docs":{},"e":{"df":0,"docs":{},"n":{"df":0,"docs":{},"t":{"df":2,"docs":{"2":{"tf":1.4142135623730951},"3":{"tf":1.0}}}}}}},"i":{"c":{"df":0,"docs":{},"i":{"df":0,"docs":{},"t":{"df":1,"docs":{"3":{"tf":1.0}}}}},"df":0,"docs":{}}},"o":{"df":0,"docs":{},"r":{"df":0,"docs":{},"t":{"df":4,"docs":{"19":{"tf":1.0},"24":{"tf":1.7320508075688772},"27":{"tf":1.0},"48":{"tf":1.0}}}},"s":{"df":0,"docs":{},"s":{"df":1,"docs":{"32":{"tf":1.0}}}}}}},"n":{"c":{"df":0,"docs":{},"l":{"df":0,"docs":{},"u":{"d":{"df":4,"docs":{"11":{"tf":1.4142135623730951},"19":{"tf":1.0},"27":{"tf":1.0},"48":{"tf":2.0}}},"df":0,"docs":{}}},"o":{"df":0,"docs":{},"m":{"df":1,"docs":{"48":{"tf":1.0}}},"n":{"df":0,"docs":{},"s":{"df":0,"docs":{},"i":{"df":0,"docs":{},"s":{"df":0,"docs":{},"t":{"df":2,"docs":{"36":{"tf":1.0},"39":{"tf":1.4142135623730951}}}}}}}}},"d":{"df":0,"docs":{},"e":{"df":0,"docs":{},"n":{"df":0,"docs":{},"t":{"df":1,"docs":{"11":{"tf":1.4142135623730951}}}}},"i":{"c":{"df":1,"docs":{"48":{"tf":1.0}}},"df":0,"docs":{}}},"df":0,"docs":{},"f":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"df":0,"docs":{},"i":{"df":0,"docs":{},"t":{"df":1,"docs":{"36":{"tf":1.0}}}}}},"o":{"df":5,"docs":{"0":{"tf":1.0},"32":{"tf":1.0},"34":{"tf":1.0},"43":{"tf":1.0},"48":{"tf":1.4142135623730951}},"r":{"df":0,"docs":{},"m":{"df":4,"docs":{"11":{"tf":1.0},"12":{"tf":1.0},"19":{"tf":1.0},"48":{"tf":1.4142135623730951}}}}}},"g":{"df":0,"docs":{},"r":{"df":0,"docs":{},"e":{"df":0,"docs":{},"s":{"df":0,"docs":{},"s":{".":{"df":0,"docs":{},"y":{"a":{"df":0,"docs":{},"m":{"df":0,"docs":{},"l":{"df":1,"docs":{"14":{"tf":1.7320508075688772}}}}},"df":0,"docs":{}}},"df":2,"docs":{"13":{"tf":1.0},"14":{"tf":2.0}},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"u":{"df":0,"docs":{},"t":{"df":2,"docs":{"14":{"tf":1.4142135623730951},"17":{"tf":1.7320508075688772}}}}}}}}}}},"i":{"df":0,"docs":{},"t":{"df":0,"docs":{},"i":{"a":{"df":0,"docs":{},"l":{"d":{"df":0,"docs":{},"e":{"df":0,"docs":{},"l":{"a":{"df":0,"docs":{},"y":{"df":0,"docs":{},"s":{"df":0,"docs":{},"e":{"c":{"df":0,"docs":{},"o":{"df":0,"docs":{},"n":{"d":{"df":1,"docs":{"13":{"tf":1.4142135623730951}}},"df":0,"docs":{}}}},"df":0,"docs":{}}}}},"df":0,"docs":{}}}},"df":0,"docs":{}}},"df":3,"docs":{"19":{"tf":1.7320508075688772},"21":{"tf":1.0},"48":{"tf":1.0}}}}},"s":{"df":0,"docs":{},"e":{"c":{"df":0,"docs":{},"u":{"df":0,"docs":{},"r":{"df":1,"docs":{"3":{"tf":1.4142135623730951}}}}},"df":0,"docs":{},"r":{"df":0,"docs":{},"t":{"df":1,"docs":{"36":{"tf":1.0}}}}},"i":{"d":{"df":11,"docs":{"11":{"tf":1.0},"24":{"tf":1.0},"30":{"tf":1.0},"31":{"tf":1.0},"34":{"tf":1.0},"39":{"tf":1.7320508075688772},"4":{"tf":1.0},"45":{"tf":1.0},"48":{"tf":1.4142135623730951},"7":{"tf":1.4142135623730951},"8":{"tf":1.0}}},"df":0,"docs":{}},"p":{"df":0,"docs":{},"i":{"df":0,"docs":{},"r":{"df":1,"docs":{"1":{"tf":1.0}}}}},"t":{"a":{"df":0,"docs":{},"n":{"c":{"df":15,"docs":{"1":{"tf":2.0},"11":{"tf":1.0},"24":{"tf":1.0},"28":{"tf":1.0},"29":{"tf":1.0},"3":{"tf":1.0},"31":{"tf":1.0},"32":{"tf":1.4142135623730951},"36":{"tf":1.4142135623730951},"39":{"tf":1.7320508075688772},"41":{"tf":1.0},"43":{"tf":1.0},"45":{"tf":1.0},"48":{"tf":2.449489742783178},"9":{"tf":1.4142135623730951}}},"df":0,"docs":{}}},"df":0,"docs":{}}},"t":{"df":0,"docs":{},"e":{"df":0,"docs":{},"n":{"df":0,"docs":{},"s":{"df":1,"docs":{"24":{"tf":1.0}}}},"r":{"a":{"c":{"df":0,"docs":{},"t":{"df":1,"docs":{"6":{"tf":1.4142135623730951}}}},"df":0,"docs":{}},"c":{"df":0,"docs":{},"e":{"df":0,"docs":{},"p":{"df":0,"docs":{},"t":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"df":1,"docs":{"48":{"tf":1.0}}}}}}}},"df":0,"docs":{},"m":{"df":0,"docs":{},"e":{"d":{"df":0,"docs":{},"i":{"a":{"df":0,"docs":{},"t":{"df":0,"docs":{},"e":{"/":{"c":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"t":{"df":0,"docs":{},"s":{"/":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"df":0,"docs":{},"t":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"m":{"df":0,"docs":{},"e":{"d":{"df":0,"docs":{},"i":{"a":{"df":0,"docs":{},"t":{"df":0,"docs":{},"e":{".":{"c":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"t":{".":{"df":0,"docs":{},"p":{"df":0,"docs":{},"e":{"df":0,"docs":{},"m":{"df":1,"docs":{"43":{"tf":1.0}}}}}},"df":0,"docs":{}}}}},"df":0,"docs":{}},"df":0,"docs":{}}}},"df":0,"docs":{}}},"df":0,"docs":{}}}}}}}},"r":{"df":0,"docs":{},"e":{"d":{"df":0,"docs":{},"h":{"a":{"c":{".":{"df":0,"docs":{},"l":{"df":0,"docs":{},"o":{"c":{"a":{"df":0,"docs":{},"l":{".":{"c":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"t":{".":{"df":0,"docs":{},"p":{"df":0,"docs":{},"e":{"df":0,"docs":{},"m":{"df":1,"docs":{"43":{"tf":1.0}}}}}},"df":0,"docs":{}}}}},"df":0,"docs":{}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}},"df":0,"docs":{}}}},"df":0,"docs":{}}}}}},"df":0,"docs":{}},"df":0,"docs":{}}}},"df":1,"docs":{"43":{"tf":1.7320508075688772}}}},"df":0,"docs":{}}},"n":{"df":2,"docs":{"13":{"tf":1.0},"17":{"tf":1.0}}},"v":{"df":1,"docs":{"48":{"tf":1.0}}}}},"r":{"df":0,"docs":{},"o":{"d":{"df":0,"docs":{},"u":{"c":{"df":0,"docs":{},"t":{"df":4,"docs":{"0":{"tf":1.7320508075688772},"1":{"tf":1.0},"2":{"tf":1.0},"3":{"tf":1.0}}}},"df":0,"docs":{}}},"df":0,"docs":{}}}},"v":{"a":{"df":0,"docs":{},"l":{"df":0,"docs":{},"i":{"d":{"df":2,"docs":{"1":{"tf":1.0},"39":{"tf":1.7320508075688772}}},"df":0,"docs":{}}}},"df":0,"docs":{}}},"p":{"df":1,"docs":{"48":{"tf":1.0}}},"r":{"df":0,"docs":{},"r":{"df":0,"docs":{},"e":{"df":0,"docs":{},"l":{"df":0,"docs":{},"e":{"df":0,"docs":{},"v":{"df":1,"docs":{"48":{"tf":1.0}}}}}}}},"s":{"df":0,"docs":{},"s":{"df":0,"docs":{},"u":{"df":1,"docs":{"48":{"tf":1.4142135623730951}}}}},"t":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":1,"docs":{"48":{"tf":1.0}}}},"s":{"df":0,"docs":{},"e":{"df":0,"docs":{},"l":{"df":0,"docs":{},"f":{"df":8,"docs":{"12":{"tf":1.0},"2":{"tf":1.0},"23":{"tf":1.0},"24":{"tf":1.0},"34":{"tf":1.4142135623730951},"43":{"tf":1.4142135623730951},"48":{"tf":1.4142135623730951},"6":{"tf":1.0}}}}}}}},"j":{"df":0,"docs":{},"o":{"b":{"df":2,"docs":{"34":{"tf":1.0},"48":{"tf":1.0}}},"df":0,"docs":{}},"s":{"df":1,"docs":{"48":{"tf":1.0}},"o":{"df":0,"docs":{},"n":{"df":1,"docs":{"19":{"tf":1.0}}}}},"w":{"df":0,"docs":{},"k":{"df":2,"docs":{"19":{"tf":1.0},"31":{"tf":1.0}}},"t":{"df":2,"docs":{"31":{"tf":1.0},"48":{"tf":1.0}}}}},"k":{"df":0,"docs":{},"e":{"df":0,"docs":{},"e":{"df":0,"docs":{},"p":{"a":{"df":0,"docs":{},"l":{"df":1,"docs":{"48":{"tf":1.7320508075688772}}}},"df":4,"docs":{"22":{"tf":1.0},"24":{"tf":1.0},"31":{"tf":1.4142135623730951},"48":{"tf":1.0}}}},"y":{"=":{"\"":{".":{".":{"/":{"a":{"df":0,"docs":{},"u":{"df":0,"docs":{},"t":{"df":0,"docs":{},"h":{".":{"df":0,"docs":{},"e":{"df":0,"docs":{},"x":{"a":{"df":0,"docs":{},"m":{"df":0,"docs":{},"p":{"df":0,"docs":{},"l":{"df":0,"docs":{},"e":{".":{"c":{"df":0,"docs":{},"o":{"df":0,"docs":{},"m":{".":{"df":0,"docs":{},"k":{"df":0,"docs":{},"e":{"df":0,"docs":{},"y":{".":{"df":0,"docs":{},"p":{"df":0,"docs":{},"e":{"df":0,"docs":{},"m":{"df":1,"docs":{"47":{"tf":1.0}}}}}},"df":0,"docs":{}}}}},"df":0,"docs":{}}}},"df":0,"docs":{}},"df":0,"docs":{}}}}}},"df":0,"docs":{}}}},"df":0,"docs":{}}}}},"df":0,"docs":{},"r":{"df":0,"docs":{},"e":{"d":{"df":0,"docs":{},"h":{"a":{"c":{".":{"df":0,"docs":{},"l":{"df":0,"docs":{},"o":{"c":{"a":{"df":0,"docs":{},"l":{".":{"df":0,"docs":{},"k":{"df":0,"docs":{},"e":{"df":0,"docs":{},"y":{".":{"df":0,"docs":{},"p":{"df":0,"docs":{},"e":{"df":0,"docs":{},"m":{"df":1,"docs":{"47":{"tf":1.0}}}}}},"df":0,"docs":{}}}}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}},"df":0,"docs":{}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"_":{"df":0,"docs":{},"i":{"d":{"/":{"df":0,"docs":{},"e":{"df":0,"docs":{},"n":{"c":{"_":{"df":0,"docs":{},"k":{"df":0,"docs":{},"e":{"df":0,"docs":{},"y":{"df":2,"docs":{"12":{"tf":1.0},"48":{"tf":1.0}}}}}},"df":0,"docs":{}},"df":0,"docs":{}}}},"df":0,"docs":{}},"df":0,"docs":{}}},"c":{"df":0,"docs":{},"l":{"df":0,"docs":{},"o":{"a":{"df":0,"docs":{},"k":{"df":2,"docs":{"1":{"tf":1.7320508075688772},"3":{"tf":1.0}}}},"df":0,"docs":{}}}},"df":11,"docs":{"12":{"tf":1.0},"13":{"tf":1.7320508075688772},"19":{"tf":1.0},"28":{"tf":1.4142135623730951},"29":{"tf":2.0},"30":{"tf":2.0},"31":{"tf":4.123105625617661},"43":{"tf":2.0},"45":{"tf":1.4142135623730951},"46":{"tf":1.4142135623730951},"48":{"tf":1.7320508075688772}}}},"i":{"df":0,"docs":{},"n":{"d":{"df":7,"docs":{"1":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.4142135623730951},"14":{"tf":1.4142135623730951},"17":{"tf":2.23606797749979},"48":{"tf":1.0}}},"df":0,"docs":{}}},"n":{"df":0,"docs":{},"o":{"df":0,"docs":{},"w":{"df":1,"docs":{"32":{"tf":1.0}}}}},"u":{"b":{"df":0,"docs":{},"e":{"c":{"df":0,"docs":{},"t":{"df":0,"docs":{},"l":{"df":4,"docs":{"10":{"tf":1.0},"15":{"tf":1.4142135623730951},"21":{"tf":1.0},"47":{"tf":2.23606797749979}}}}},"df":0,"docs":{},"r":{"df":0,"docs":{},"n":{"df":0,"docs":{},"e":{"df":0,"docs":{},"t":{"df":19,"docs":{"10":{"tf":1.0},"11":{"tf":1.4142135623730951},"12":{"tf":1.0},"13":{"tf":1.4142135623730951},"14":{"tf":1.4142135623730951},"15":{"tf":1.0},"16":{"tf":1.0},"17":{"tf":1.4142135623730951},"21":{"tf":1.7320508075688772},"24":{"tf":1.0},"31":{"tf":1.4142135623730951},"37":{"tf":1.0},"39":{"tf":1.0},"4":{"tf":1.0},"46":{"tf":1.0},"47":{"tf":2.23606797749979},"48":{"tf":1.4142135623730951},"8":{"tf":2.0},"9":{"tf":1.4142135623730951}}}}}}}},"df":0,"docs":{},"s":{"df":0,"docs":{},"t":{"df":0,"docs":{},"o":{"df":0,"docs":{},"m":{"df":1,"docs":{"8":{"tf":1.0}}}}}}}},"l":{"a":{"b":{"df":0,"docs":{},"e":{"df":0,"docs":{},"l":{"df":1,"docs":{"13":{"tf":1.4142135623730951}}}}},"df":0,"docs":{},"n":{"df":0,"docs":{},"g":{"df":0,"docs":{},"u":{"a":{"df":0,"docs":{},"g":{"df":1,"docs":{"13":{"tf":1.0}}}},"df":0,"docs":{}}}},"r":{"df":0,"docs":{},"g":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":1,"docs":{"13":{"tf":1.0}}}}}},"s":{"df":0,"docs":{},"t":{"df":1,"docs":{"43":{"tf":1.4142135623730951}}}},"t":{"df":0,"docs":{},"e":{"df":0,"docs":{},"n":{"c":{"df":1,"docs":{"48":{"tf":1.0}}},"df":0,"docs":{}},"r":{"df":7,"docs":{"12":{"tf":1.0},"13":{"tf":1.0},"17":{"tf":1.0},"28":{"tf":1.0},"32":{"tf":1.0},"48":{"tf":1.0},"7":{"tf":1.0}}},"s":{"df":0,"docs":{},"t":{"df":1,"docs":{"13":{"tf":1.4142135623730951}}}}}},"y":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":4,"docs":{"13":{"tf":1.0},"36":{"tf":1.4142135623730951},"43":{"tf":1.0},"45":{"tf":1.0}}}}}},"d":{"a":{"df":0,"docs":{},"p":{"df":1,"docs":{"3":{"tf":1.4142135623730951}}}},"df":0,"docs":{}},"df":0,"docs":{},"e":{"a":{"d":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":3,"docs":{"36":{"tf":1.4142135623730951},"39":{"tf":1.4142135623730951},"48":{"tf":1.7320508075688772}}}}},"df":0,"docs":{},"v":{"df":1,"docs":{"48":{"tf":1.0}}}},"df":0,"docs":{},"f":{"df":0,"docs":{},"t":{"df":1,"docs":{"40":{"tf":1.0}},"o":{"df":0,"docs":{},"v":{"df":1,"docs":{"39":{"tf":1.0}}}}}},"t":{"'":{"df":2,"docs":{"17":{"tf":1.0},"32":{"tf":1.0}}},"df":0,"docs":{}},"v":{"df":0,"docs":{},"e":{"df":0,"docs":{},"l":{"df":2,"docs":{"36":{"tf":1.4142135623730951},"48":{"tf":1.4142135623730951}}}}}},"i":{"b":{"df":0,"docs":{},"r":{"a":{"df":0,"docs":{},"r":{"df":0,"docs":{},"i":{"df":1,"docs":{"36":{"tf":1.0}}}}},"df":0,"docs":{}}},"df":0,"docs":{},"f":{"df":0,"docs":{},"e":{"df":0,"docs":{},"t":{"df":0,"docs":{},"i":{"df":0,"docs":{},"m":{"df":2,"docs":{"29":{"tf":1.0},"48":{"tf":3.0}}}}}}},"k":{"df":0,"docs":{},"e":{"df":3,"docs":{"1":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0}}}},"m":{"df":0,"docs":{},"i":{"df":0,"docs":{},"t":{"df":3,"docs":{"13":{"tf":2.449489742783178},"24":{"tf":2.449489742783178},"48":{"tf":1.4142135623730951}}}}},"n":{"df":0,"docs":{},"e":{"df":1,"docs":{"43":{"tf":1.4142135623730951}},"r":{"df":1,"docs":{"11":{"tf":1.0}}}},"k":{"df":4,"docs":{"21":{"tf":1.4142135623730951},"43":{"tf":1.0},"48":{"tf":1.7320508075688772},"7":{"tf":1.0}},"e":{"df":0,"docs":{},"r":{"d":{"df":1,"docs":{"41":{"tf":1.4142135623730951}}},"df":0,"docs":{}}}},"u":{"df":0,"docs":{},"x":{"df":4,"docs":{"1":{"tf":1.0},"12":{"tf":1.0},"29":{"tf":1.0},"7":{"tf":1.0}}}}},"s":{"df":0,"docs":{},"t":{"df":0,"docs":{},"e":{"df":0,"docs":{},"n":{"_":{"a":{"d":{"d":{"df":0,"docs":{},"r":{"df":0,"docs":{},"e":{"df":0,"docs":{},"s":{"df":0,"docs":{},"s":{"=":{"0":{".":{"0":{".":{"0":{".":{"0":{"df":1,"docs":{"48":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{},"p":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"df":0,"docs":{},"t":{"_":{"df":0,"docs":{},"h":{"df":0,"docs":{},"t":{"df":0,"docs":{},"t":{"df":0,"docs":{},"p":{"=":{"8":{"0":{"8":{"0":{"df":1,"docs":{"48":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{},"s":{"=":{"8":{"4":{"4":{"3":{"df":1,"docs":{"48":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}}}},"df":0,"docs":{}}}}},"s":{"c":{"df":0,"docs":{},"h":{"df":0,"docs":{},"e":{"df":0,"docs":{},"m":{"df":1,"docs":{"48":{"tf":1.4142135623730951}},"e":{"=":{"df":0,"docs":{},"h":{"df":0,"docs":{},"t":{"df":0,"docs":{},"t":{"df":0,"docs":{},"p":{"df":1,"docs":{"48":{"tf":1.0}}}}}}},"df":0,"docs":{}}}}}},"df":0,"docs":{}}},"df":1,"docs":{"48":{"tf":1.4142135623730951}}}}}},"v":{"df":0,"docs":{},"e":{"df":1,"docs":{"36":{"tf":1.0}},"n":{"df":0,"docs":{},"e":{"df":0,"docs":{},"s":{"df":0,"docs":{},"s":{"df":0,"docs":{},"p":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"b":{"df":1,"docs":{"13":{"tf":1.0}}},"df":0,"docs":{}}}}}}}}}}},"o":{"a":{"d":{"b":{"a":{"df":0,"docs":{},"l":{"a":{"df":0,"docs":{},"n":{"c":{"df":2,"docs":{"45":{"tf":1.0},"48":{"tf":1.0}}},"df":0,"docs":{}}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"c":{"a":{"df":0,"docs":{},"l":{"df":2,"docs":{"48":{"tf":1.0},"6":{"tf":1.7320508075688772}},"h":{"df":0,"docs":{},"o":{"df":0,"docs":{},"s":{"df":0,"docs":{},"t":{"df":2,"docs":{"48":{"tf":1.0},"6":{"tf":1.0}}}}}}},"t":{"df":2,"docs":{"45":{"tf":1.4142135623730951},"48":{"tf":1.4142135623730951}}}},"df":0,"docs":{},"k":{"df":0,"docs":{},"o":{"df":0,"docs":{},"u":{"df":0,"docs":{},"t":{"df":1,"docs":{"23":{"tf":1.0}}}}}}},"df":0,"docs":{},"g":{"_":{"df":0,"docs":{},"l":{"df":0,"docs":{},"e":{"df":0,"docs":{},"v":{"df":0,"docs":{},"e":{"df":0,"docs":{},"l":{"=":{"d":{"df":0,"docs":{},"e":{"b":{"df":0,"docs":{},"u":{"df":0,"docs":{},"g":{"df":1,"docs":{"22":{"tf":1.0}}}}},"df":0,"docs":{}}},"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"df":0,"docs":{},"f":{"df":0,"docs":{},"o":{"df":1,"docs":{"48":{"tf":1.0}}}}}}},"_":{"a":{"c":{"c":{"df":0,"docs":{},"e":{"df":0,"docs":{},"s":{"df":0,"docs":{},"s":{"=":{"b":{"a":{"df":0,"docs":{},"s":{"df":1,"docs":{"48":{"tf":1.0}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":1,"docs":{"48":{"tf":1.0}}}}}}}},"df":11,"docs":{"1":{"tf":1.4142135623730951},"19":{"tf":1.0},"20":{"tf":1.7320508075688772},"21":{"tf":3.4641016151377544},"22":{"tf":1.4142135623730951},"24":{"tf":1.0},"26":{"tf":1.0},"29":{"tf":1.4142135623730951},"31":{"tf":1.0},"48":{"tf":3.7416573867739413},"6":{"tf":2.0}},"i":{"df":0,"docs":{},"n":{"df":8,"docs":{"1":{"tf":2.449489742783178},"19":{"tf":1.4142135623730951},"2":{"tf":1.4142135623730951},"24":{"tf":1.4142135623730951},"29":{"tf":2.23606797749979},"3":{"tf":1.0},"31":{"tf":1.0},"48":{"tf":2.449489742783178}}}},"o":{"df":1,"docs":{"1":{"tf":1.0}}}},"n":{"df":0,"docs":{},"g":{"df":7,"docs":{"1":{"tf":1.0},"12":{"tf":1.0},"22":{"tf":1.0},"29":{"tf":1.0},"39":{"tf":1.0},"48":{"tf":1.7320508075688772},"6":{"tf":1.0}},"e":{"df":0,"docs":{},"r":{"df":1,"docs":{"48":{"tf":1.0}}}}}},"o":{"df":0,"docs":{},"k":{"df":8,"docs":{"1":{"tf":1.4142135623730951},"13":{"tf":1.4142135623730951},"3":{"tf":1.0},"31":{"tf":1.0},"32":{"tf":1.0},"45":{"tf":1.0},"48":{"tf":1.0},"6":{"tf":1.7320508075688772}}},"s":{"df":1,"docs":{"36":{"tf":1.0}}}},"s":{"df":0,"docs":{},"t":{"df":1,"docs":{"39":{"tf":1.7320508075688772}}}},"t":{"df":4,"docs":{"17":{"tf":1.0},"31":{"tf":1.0},"35":{"tf":1.0},"43":{"tf":1.0}}},"w":{"df":1,"docs":{"24":{"tf":1.7320508075688772}},"e":{"df":0,"docs":{},"r":{"df":2,"docs":{"1":{"tf":1.0},"48":{"tf":1.4142135623730951}}}}}},"t":{"df":1,"docs":{"48":{"tf":1.0}}}},"m":{"_":{"c":{"df":0,"docs":{},"o":{"df":0,"docs":{},"s":{"df":0,"docs":{},"t":{"df":1,"docs":{"48":{"tf":1.0}}}}}},"df":0,"docs":{}},"a":{"c":{"df":3,"docs":{"1":{"tf":1.0},"29":{"tf":1.0},"7":{"tf":1.4142135623730951}},"h":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"df":1,"docs":{"29":{"tf":1.0}}}}}},"d":{"df":0,"docs":{},"e":{"df":1,"docs":{"1":{"tf":1.0}}}},"df":0,"docs":{},"g":{"df":0,"docs":{},"i":{"c":{"df":1,"docs":{"48":{"tf":1.7320508075688772}}},"df":0,"docs":{}}},"i":{"df":0,"docs":{},"l":{"df":5,"docs":{"12":{"tf":1.0},"2":{"tf":1.4142135623730951},"22":{"tf":1.4142135623730951},"29":{"tf":1.0},"48":{"tf":1.0}}},"n":{"df":3,"docs":{"1":{"tf":1.0},"13":{"tf":1.0},"35":{"tf":1.0}}}},"k":{"df":0,"docs":{},"e":{"df":13,"docs":{"1":{"tf":1.4142135623730951},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.7320508075688772},"2":{"tf":1.0},"24":{"tf":1.0},"25":{"tf":1.4142135623730951},"29":{"tf":1.0},"31":{"tf":1.4142135623730951},"34":{"tf":1.4142135623730951},"43":{"tf":1.4142135623730951},"48":{"tf":2.23606797749979},"7":{"tf":2.23606797749979}}}},"l":{"df":0,"docs":{},"i":{"c":{"df":0,"docs":{},"i":{"df":1,"docs":{"13":{"tf":1.0}}}},"df":0,"docs":{}}},"n":{"a":{"df":0,"docs":{},"g":{"df":4,"docs":{"11":{"tf":1.0},"17":{"tf":1.0},"2":{"tf":1.0},"48":{"tf":1.0}}}},"df":0,"docs":{},"i":{"df":3,"docs":{"17":{"tf":1.0},"24":{"tf":1.0},"36":{"tf":1.0}}}},"r":{"df":0,"docs":{},"i":{"a":{"d":{"b":{"df":1,"docs":{"2":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}},"t":{"c":{"df":0,"docs":{},"h":{"df":7,"docs":{"12":{"tf":1.0},"14":{"tf":1.0},"17":{"tf":1.4142135623730951},"2":{"tf":1.0},"39":{"tf":1.0},"48":{"tf":1.4142135623730951},"7":{"tf":1.0}},"l":{"a":{"b":{"df":0,"docs":{},"e":{"df":0,"docs":{},"l":{"df":1,"docs":{"13":{"tf":1.0}}}}},"df":0,"docs":{}},"df":0,"docs":{}}}},"df":0,"docs":{}},"x":{"_":{"df":0,"docs":{},"h":{"a":{"df":0,"docs":{},"s":{"df":0,"docs":{},"h":{"_":{"df":0,"docs":{},"t":{"df":0,"docs":{},"h":{"df":0,"docs":{},"r":{"df":0,"docs":{},"e":{"a":{"d":{"df":3,"docs":{"13":{"tf":1.4142135623730951},"24":{"tf":1.0},"48":{"tf":1.0}},"s":{"=":{"1":{"df":2,"docs":{"24":{"tf":1.0},"48":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{}}}}}},"df":0,"docs":{}}}},"df":0,"docs":{}}},"df":1,"docs":{"48":{"tf":1.0}},"i":{"df":0,"docs":{},"m":{"df":0,"docs":{},"u":{"df":0,"docs":{},"m":{"df":2,"docs":{"24":{"tf":1.4142135623730951},"48":{"tf":1.7320508075688772}}}}}}},"y":{"b":{"df":2,"docs":{"1":{"tf":1.0},"31":{"tf":1.0}}},"df":0,"docs":{}}},"b":{"df":1,"docs":{"48":{"tf":1.0}}},"df":0,"docs":{},"e":{"a":{"df":0,"docs":{},"n":{"df":9,"docs":{"0":{"tf":1.0},"23":{"tf":1.0},"3":{"tf":1.0},"30":{"tf":1.0},"31":{"tf":1.4142135623730951},"34":{"tf":1.0},"36":{"tf":1.4142135623730951},"39":{"tf":1.0},"6":{"tf":1.0}}}},"c":{"df":0,"docs":{},"h":{"a":{"df":0,"docs":{},"n":{"df":5,"docs":{"13":{"tf":1.4142135623730951},"17":{"tf":1.0},"23":{"tf":1.4142135623730951},"3":{"tf":1.0},"39":{"tf":1.0}}}},"df":0,"docs":{}}},"df":0,"docs":{},"m":{"b":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":4,"docs":{"12":{"tf":1.0},"39":{"tf":2.0},"41":{"tf":1.0},"48":{"tf":1.7320508075688772}}}}},"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"df":0,"docs":{},"i":{"df":5,"docs":{"13":{"tf":2.449489742783178},"24":{"tf":2.23606797749979},"36":{"tf":1.0},"48":{"tf":1.7320508075688772},"6":{"tf":1.0}}}}}},"n":{"df":0,"docs":{},"t":{"df":0,"docs":{},"i":{"df":0,"docs":{},"o":{"df":0,"docs":{},"n":{"df":2,"docs":{"24":{"tf":1.0},"43":{"tf":1.4142135623730951}}}}}}},"s":{"df":0,"docs":{},"h":{"df":1,"docs":{"41":{"tf":1.0}}},"s":{"a":{"df":0,"docs":{},"g":{"df":1,"docs":{"21":{"tf":1.0}}}},"df":0,"docs":{}}},"t":{"a":{"d":{"a":{"df":0,"docs":{},"t":{"a":{"df":5,"docs":{"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":2.0},"14":{"tf":1.0},"17":{"tf":1.7320508075688772}}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}},"f":{"a":{"df":9,"docs":{"1":{"tf":1.4142135623730951},"2":{"tf":1.0},"25":{"tf":1.4142135623730951},"26":{"tf":1.0},"27":{"tf":1.0},"28":{"tf":1.0},"29":{"tf":1.7320508075688772},"31":{"tf":1.4142135623730951},"48":{"tf":2.23606797749979}}},"df":0,"docs":{}},"i":{"d":{"d":{"df":0,"docs":{},"l":{"df":0,"docs":{},"e":{"df":0,"docs":{},"w":{"a":{"df":0,"docs":{},"r":{"df":2,"docs":{"17":{"tf":1.4142135623730951},"48":{"tf":1.0}}}},"df":0,"docs":{}}}}},"df":0,"docs":{}},"df":1,"docs":{"13":{"tf":1.4142135623730951}},"g":{"df":0,"docs":{},"r":{"a":{"df":0,"docs":{},"t":{"df":5,"docs":{"12":{"tf":1.0},"31":{"tf":2.8284271247461903},"32":{"tf":2.8284271247461903},"34":{"tf":1.0},"48":{"tf":1.7320508075688772}},"e":{"_":{"d":{"b":{"_":{"df":0,"docs":{},"f":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"m":{"=":{"df":0,"docs":{},"s":{"df":0,"docs":{},"q":{"df":0,"docs":{},"l":{"df":0,"docs":{},"i":{"df":0,"docs":{},"t":{"df":0,"docs":{},"e":{":":{"d":{"a":{"df":0,"docs":{},"t":{"a":{"/":{"df":0,"docs":{},"r":{"a":{"df":0,"docs":{},"u":{"df":0,"docs":{},"t":{"df":0,"docs":{},"h":{"df":0,"docs":{},"y":{".":{"d":{"b":{"df":1,"docs":{"48":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}}}}},"df":1,"docs":{"32":{"tf":2.8284271247461903}}}}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}},"df":0,"docs":{}}},"n":{"d":{"df":2,"docs":{"24":{"tf":1.0},"31":{"tf":1.4142135623730951}}},"df":2,"docs":{"34":{"tf":1.0},"48":{"tf":1.0}},"u":{"df":0,"docs":{},"t":{"df":1,"docs":{"48":{"tf":1.4142135623730951}}}}},"s":{"c":{"df":0,"docs":{},"o":{"df":0,"docs":{},"n":{"df":0,"docs":{},"f":{"df":0,"docs":{},"i":{"df":0,"docs":{},"g":{"df":0,"docs":{},"u":{"df":0,"docs":{},"r":{"df":1,"docs":{"39":{"tf":1.0}}}}}}}}}},"df":0,"docs":{},"s":{"df":2,"docs":{"2":{"tf":1.4142135623730951},"21":{"tf":1.0}}}}},"k":{"d":{"df":0,"docs":{},"i":{"df":0,"docs":{},"r":{"df":2,"docs":{"11":{"tf":1.0},"7":{"tf":1.4142135623730951}}}}},"df":0,"docs":{}},"l":{"_":{"df":0,"docs":{},"l":{"df":0,"docs":{},"t":{"_":{"df":0,"docs":{},"p":{"df":0,"docs":{},"w":{"d":{"_":{"df":0,"docs":{},"f":{"df":0,"docs":{},"i":{"df":0,"docs":{},"r":{"df":0,"docs":{},"s":{"df":0,"docs":{},"t":{"=":{"8":{"6":{"4":{"0":{"0":{"df":1,"docs":{"48":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}}},"r":{"df":0,"docs":{},"e":{"df":0,"docs":{},"s":{"df":0,"docs":{},"e":{"df":0,"docs":{},"t":{"=":{"3":{"0":{"df":1,"docs":{"48":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}}}},"df":0,"docs":{}},"df":0,"docs":{}}}},"df":0,"docs":{}}}},"df":1,"docs":{"48":{"tf":1.0}}},"o":{"d":{"df":0,"docs":{},"e":{"df":6,"docs":{"1":{"tf":1.0},"13":{"tf":1.7320508075688772},"36":{"tf":1.7320508075688772},"39":{"tf":1.0},"48":{"tf":1.0},"6":{"tf":1.4142135623730951}}},"i":{"df":0,"docs":{},"f":{"df":0,"docs":{},"i":{"df":3,"docs":{"1":{"tf":1.0},"47":{"tf":1.0},"48":{"tf":1.7320508075688772}}}}}},"df":0,"docs":{},"m":{"df":0,"docs":{},"e":{"df":0,"docs":{},"n":{"df":0,"docs":{},"t":{"df":1,"docs":{"1":{"tf":1.0}}}}}},"n":{"df":0,"docs":{},"t":{"df":0,"docs":{},"h":{"df":2,"docs":{"34":{"tf":1.0},"48":{"tf":1.0}}}}},"r":{"df":0,"docs":{},"e":{"df":7,"docs":{"1":{"tf":1.0},"17":{"tf":1.0},"3":{"tf":1.4142135623730951},"36":{"tf":1.4142135623730951},"48":{"tf":1.4142135623730951},"6":{"tf":1.0},"7":{"tf":2.23606797749979}}}},"u":{"df":0,"docs":{},"n":{"df":0,"docs":{},"t":{"df":3,"docs":{"34":{"tf":1.0},"47":{"tf":1.0},"7":{"tf":1.7320508075688772}},"p":{"a":{"df":0,"docs":{},"t":{"df":0,"docs":{},"h":{"df":2,"docs":{"13":{"tf":1.4142135623730951},"47":{"tf":1.7320508075688772}}}}},"df":0,"docs":{}}}}}},"s":{"df":1,"docs":{"48":{"tf":1.4142135623730951}}},"t":{"df":0,"docs":{},"l":{"df":4,"docs":{"41":{"tf":1.0},"43":{"tf":1.0},"45":{"tf":2.0},"48":{"tf":1.7320508075688772}}}},"u":{"c":{"df":0,"docs":{},"h":{"df":4,"docs":{"24":{"tf":1.0},"32":{"tf":1.0},"46":{"tf":1.0},"48":{"tf":1.0}}}},"df":0,"docs":{},"l":{"df":0,"docs":{},"t":{"df":0,"docs":{},"i":{"df":0,"docs":{},"p":{"df":0,"docs":{},"l":{"df":3,"docs":{"30":{"tf":1.0},"45":{"tf":1.0},"48":{"tf":1.4142135623730951}}}}}}}},"y":{"df":0,"docs":{},"s":{"df":0,"docs":{},"e":{"df":0,"docs":{},"l":{"df":0,"docs":{},"f":{"df":1,"docs":{"7":{"tf":1.0}}}}},"q":{"df":0,"docs":{},"l":{"df":2,"docs":{"1":{"tf":1.0},"2":{"tf":1.4142135623730951}}}}}}},"n":{"a":{"df":0,"docs":{},"m":{"df":0,"docs":{},"e":{"df":17,"docs":{"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":4.358898943540674},"14":{"tf":1.4142135623730951},"17":{"tf":2.8284271247461903},"2":{"tf":1.7320508075688772},"26":{"tf":1.0},"27":{"tf":1.0},"34":{"tf":1.0},"39":{"tf":1.4142135623730951},"43":{"tf":1.4142135623730951},"45":{"tf":1.4142135623730951},"46":{"tf":1.0},"47":{"tf":2.449489742783178},"48":{"tf":2.449489742783178},"6":{"tf":1.4142135623730951},"7":{"tf":1.0}},"s":{"df":0,"docs":{},"p":{"a":{"c":{"df":7,"docs":{"10":{"tf":1.7320508075688772},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.4142135623730951},"14":{"tf":1.0},"17":{"tf":1.7320508075688772},"9":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}}}}},"v":{"df":0,"docs":{},"i":{"df":0,"docs":{},"g":{"df":2,"docs":{"24":{"tf":1.0},"31":{"tf":1.0}}}}}},"df":3,"docs":{"15":{"tf":1.0},"21":{"tf":1.0},"47":{"tf":1.7320508075688772}},"e":{"a":{"df":0,"docs":{},"r":{"df":1,"docs":{"2":{"tf":1.0}}}},"c":{"df":0,"docs":{},"e":{"df":0,"docs":{},"s":{"df":0,"docs":{},"s":{"a":{"df":0,"docs":{},"r":{"df":0,"docs":{},"i":{"df":4,"docs":{"19":{"tf":1.0},"24":{"tf":1.0},"29":{"tf":1.0},"36":{"tf":1.0}}}}},"df":0,"docs":{}}}}},"df":0,"docs":{},"e":{"d":{"df":23,"docs":{"1":{"tf":1.7320508075688772},"11":{"tf":1.0},"12":{"tf":2.23606797749979},"13":{"tf":2.449489742783178},"14":{"tf":1.0},"17":{"tf":1.4142135623730951},"2":{"tf":1.0},"24":{"tf":1.4142135623730951},"25":{"tf":1.0},"26":{"tf":1.0},"27":{"tf":1.0},"3":{"tf":1.0},"31":{"tf":1.4142135623730951},"36":{"tf":1.0},"37":{"tf":1.0},"39":{"tf":1.0},"40":{"tf":1.0},"43":{"tf":2.0},"45":{"tf":1.4142135623730951},"47":{"tf":1.7320508075688772},"48":{"tf":2.6457513110645907},"6":{"tf":1.0},"7":{"tf":1.4142135623730951}}},"df":0,"docs":{}},"v":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":8,"docs":{"1":{"tf":1.0},"11":{"tf":1.0},"19":{"tf":1.0},"2":{"tf":2.0},"24":{"tf":1.0},"3":{"tf":1.7320508075688772},"36":{"tf":1.0},"48":{"tf":2.0}},"t":{"df":0,"docs":{},"h":{"df":0,"docs":{},"e":{"df":0,"docs":{},"l":{"df":0,"docs":{},"e":{"df":0,"docs":{},"s":{"df":0,"docs":{},"s":{"df":1,"docs":{"14":{"tf":1.0}}}}}}}}}}}},"w":{"df":15,"docs":{"0":{"tf":1.0},"1":{"tf":1.7320508075688772},"12":{"tf":1.0},"2":{"tf":1.0},"21":{"tf":1.7320508075688772},"22":{"tf":1.0},"29":{"tf":1.4142135623730951},"30":{"tf":1.0},"31":{"tf":2.23606797749979},"32":{"tf":1.0},"39":{"tf":1.0},"43":{"tf":1.0},"48":{"tf":2.23606797749979},"6":{"tf":1.0},"7":{"tf":1.7320508075688772}},"l":{"df":0,"docs":{},"i":{"df":4,"docs":{"19":{"tf":1.0},"31":{"tf":1.0},"47":{"tf":1.0},"48":{"tf":1.0}}}}},"x":{"df":0,"docs":{},"t":{"df":2,"docs":{"11":{"tf":1.0},"32":{"tf":1.4142135623730951}}}}},"i":{"c":{"df":0,"docs":{},"e":{"df":4,"docs":{"11":{"tf":1.0},"2":{"tf":1.0},"28":{"tf":1.0},"48":{"tf":1.0}}}},"df":0,"docs":{}},"o":{"d":{"df":0,"docs":{},"e":{"df":2,"docs":{"36":{"tf":1.0},"39":{"tf":1.7320508075688772}}}},"df":0,"docs":{},"n":{"df":2,"docs":{"29":{"tf":1.0},"48":{"tf":1.7320508075688772}}},"r":{"df":0,"docs":{},"m":{"a":{"df":0,"docs":{},"l":{"df":5,"docs":{"11":{"tf":1.0},"31":{"tf":1.0},"32":{"tf":1.0},"34":{"tf":1.0},"48":{"tf":1.0}}}},"df":0,"docs":{}}},"t":{"df":0,"docs":{},"e":{"df":5,"docs":{"21":{"tf":1.4142135623730951},"22":{"tf":1.0},"48":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.4142135623730951}}},"i":{"df":0,"docs":{},"f":{"df":1,"docs":{"2":{"tf":1.0}}}}},"w":{"df":5,"docs":{"15":{"tf":1.4142135623730951},"17":{"tf":1.0},"22":{"tf":1.0},"47":{"tf":1.4142135623730951},"7":{"tf":1.4142135623730951}}}},"s":{"df":1,"docs":{"10":{"tf":1.0}}},"u":{"df":0,"docs":{},"m":{"b":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":2,"docs":{"27":{"tf":1.0},"48":{"tf":1.7320508075688772}}}}},"df":0,"docs":{}}}},"o":{"b":{"df":0,"docs":{},"s":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"v":{"df":1,"docs":{"15":{"tf":1.0}}}}},"o":{"df":0,"docs":{},"l":{"df":0,"docs":{},"e":{"df":0,"docs":{},"t":{"df":1,"docs":{"24":{"tf":1.0}}}}}}}},"d":{"d":{"df":1,"docs":{"37":{"tf":1.0}}},"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":1,"docs":{"1":{"tf":1.0}}}}},"df":0,"docs":{},"f":{"df":0,"docs":{},"f":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":1,"docs":{"36":{"tf":1.0}}}},"l":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"df":1,"docs":{"48":{"tf":1.0}},"e":{"_":{"df":0,"docs":{},"t":{"df":0,"docs":{},"o":{"df":0,"docs":{},"k":{"df":0,"docs":{},"e":{"df":0,"docs":{},"n":{"_":{"df":0,"docs":{},"l":{"df":0,"docs":{},"i":{"df":0,"docs":{},"f":{"df":0,"docs":{},"e":{"df":0,"docs":{},"t":{"df":0,"docs":{},"i":{"df":0,"docs":{},"m":{"df":0,"docs":{},"e":{"=":{"7":{"2":{"0":{"df":1,"docs":{"48":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}}}}}}},"df":0,"docs":{}}}}}}},"df":0,"docs":{}}}}}}},"i":{"d":{"c":{"df":5,"docs":{"1":{"tf":1.7320508075688772},"2":{"tf":1.4142135623730951},"23":{"tf":1.0},"3":{"tf":1.0},"31":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}},"k":{"df":1,"docs":{"43":{"tf":1.4142135623730951}}},"l":{"d":{"df":2,"docs":{"1":{"tf":1.0},"31":{"tf":2.0}},"e":{"df":0,"docs":{},"r":{"df":5,"docs":{"1":{"tf":1.0},"3":{"tf":1.0},"31":{"tf":1.0},"34":{"tf":1.0},"48":{"tf":1.0}}}}},"df":0,"docs":{}},"n":{"c":{"df":7,"docs":{"1":{"tf":1.7320508075688772},"19":{"tf":1.0},"29":{"tf":1.0},"36":{"tf":1.4142135623730951},"39":{"tf":1.0},"48":{"tf":1.0},"7":{"tf":1.0}}},"df":11,"docs":{"13":{"tf":1.0},"2":{"tf":1.0},"24":{"tf":1.4142135623730951},"3":{"tf":1.0},"31":{"tf":1.0},"36":{"tf":1.4142135623730951},"38":{"tf":1.0},"39":{"tf":1.4142135623730951},"43":{"tf":1.4142135623730951},"48":{"tf":1.0},"7":{"tf":1.0}}},"p":{"a":{"df":0,"docs":{},"q":{"df":0,"docs":{},"u":{"df":1,"docs":{"12":{"tf":1.0}}}}},"df":0,"docs":{},"e":{"df":0,"docs":{},"n":{"_":{"df":0,"docs":{},"u":{"df":0,"docs":{},"s":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"_":{"df":0,"docs":{},"r":{"df":0,"docs":{},"e":{"df":0,"docs":{},"g":{"=":{"df":0,"docs":{},"t":{"df":0,"docs":{},"r":{"df":0,"docs":{},"u":{"df":1,"docs":{"48":{"tf":1.4142135623730951}}}}}},"df":0,"docs":{}}}}},"df":0,"docs":{}}}}}},"df":2,"docs":{"1":{"tf":1.0},"11":{"tf":1.0}},"i":{"d":{"df":1,"docs":{"1":{"tf":1.0}}},"df":0,"docs":{}},"s":{"df":0,"docs":{},"s":{"df":0,"docs":{},"l":{"df":3,"docs":{"43":{"tf":1.0},"45":{"tf":1.0},"48":{"tf":1.0}}}}}},"r":{"df":5,"docs":{"24":{"tf":1.7320508075688772},"29":{"tf":1.0},"31":{"tf":1.4142135623730951},"32":{"tf":1.0},"48":{"tf":1.0}}}},"i":{"df":0,"docs":{},"n":{"df":0,"docs":{},"i":{"df":0,"docs":{},"o":{"df":0,"docs":{},"n":{"df":1,"docs":{"29":{"tf":1.0}}}}}}},"t":{"df":0,"docs":{},"i":{"df":0,"docs":{},"m":{"df":2,"docs":{"36":{"tf":1.0},"37":{"tf":1.0}}},"o":{"df":0,"docs":{},"n":{"df":9,"docs":{"1":{"tf":1.4142135623730951},"12":{"tf":1.0},"2":{"tf":1.0},"24":{"tf":1.0},"32":{"tf":1.0},"36":{"tf":1.0},"43":{"tf":1.0},"45":{"tf":1.0},"7":{"tf":1.4142135623730951}}}}}}},"r":{"df":0,"docs":{},"i":{"df":0,"docs":{},"g":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"df":1,"docs":{"48":{"tf":1.4142135623730951}}}}}}},"s":{"df":5,"docs":{"1":{"tf":1.0},"28":{"tf":1.0},"29":{"tf":1.4142135623730951},"39":{"tf":1.0},"7":{"tf":1.4142135623730951}}},"t":{"df":0,"docs":{},"h":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":3,"docs":{"1":{"tf":1.0},"2":{"tf":1.0},"24":{"tf":1.0}},"w":{"df":0,"docs":{},"i":{"df":0,"docs":{},"s":{"df":2,"docs":{"13":{"tf":1.0},"48":{"tf":1.0}}}}}}}},"p":{"df":1,"docs":{"2":{"tf":1.0}}}},"u":{"df":0,"docs":{},"t":{"df":8,"docs":{"1":{"tf":1.0},"2":{"tf":1.0},"21":{"tf":1.0},"32":{"tf":1.0},"35":{"tf":1.0},"40":{"tf":1.0},"43":{"tf":1.0},"48":{"tf":1.4142135623730951}},"p":{"df":0,"docs":{},"u":{"df":0,"docs":{},"t":{"df":1,"docs":{"48":{"tf":1.0}}}}}}},"v":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":2,"docs":{"13":{"tf":1.0},"31":{"tf":1.0}},"l":{"a":{"df":0,"docs":{},"p":{"df":1,"docs":{"36":{"tf":1.0}}}},"df":0,"docs":{}},"r":{"df":0,"docs":{},"i":{"d":{"df":1,"docs":{"2":{"tf":1.4142135623730951}}},"df":0,"docs":{}}},"w":{"df":0,"docs":{},"r":{"df":0,"docs":{},"i":{"df":0,"docs":{},"t":{"df":4,"docs":{"13":{"tf":1.0},"32":{"tf":1.7320508075688772},"45":{"tf":1.0},"48":{"tf":2.0}},"t":{"df":0,"docs":{},"e":{"df":0,"docs":{},"n":{"df":1,"docs":{"48":{"tf":1.0}}}}}}}}}}}},"w":{"df":0,"docs":{},"n":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":2,"docs":{"48":{"tf":1.0},"7":{"tf":1.4142135623730951}}}}}}},"p":{"_":{"c":{"df":0,"docs":{},"o":{"df":0,"docs":{},"s":{"df":0,"docs":{},"t":{"df":1,"docs":{"48":{"tf":1.0}}}}}},"df":0,"docs":{}},"a":{"df":0,"docs":{},"g":{"df":0,"docs":{},"e":{"df":3,"docs":{"1":{"tf":1.7320508075688772},"2":{"tf":1.0},"21":{"tf":1.0}}}},"n":{"df":0,"docs":{},"i":{"c":{"df":1,"docs":{"39":{"tf":1.0}}},"df":0,"docs":{}}},"r":{"a":{"df":0,"docs":{},"l":{"df":0,"docs":{},"l":{"df":0,"docs":{},"e":{"df":0,"docs":{},"l":{"df":2,"docs":{"24":{"tf":1.4142135623730951},"48":{"tf":1.0}}}}}},"m":{"df":0,"docs":{},"e":{"df":0,"docs":{},"t":{"df":1,"docs":{"24":{"tf":1.0}}}}}},"df":0,"docs":{},"s":{"df":1,"docs":{"48":{"tf":1.0}}},"t":{"df":3,"docs":{"36":{"tf":1.0},"39":{"tf":1.0},"45":{"tf":1.0}},"i":{"df":3,"docs":{"0":{"tf":1.0},"26":{"tf":1.0},"48":{"tf":1.0}}}}},"s":{"df":0,"docs":{},"s":{"df":0,"docs":{},"k":{"df":0,"docs":{},"e":{"df":0,"docs":{},"y":{"df":1,"docs":{"1":{"tf":1.4142135623730951}}}}},"w":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"d":{"df":13,"docs":{"1":{"tf":1.7320508075688772},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"19":{"tf":1.7320508075688772},"21":{"tf":2.449489742783178},"22":{"tf":1.4142135623730951},"24":{"tf":1.4142135623730951},"29":{"tf":1.0},"31":{"tf":1.0},"43":{"tf":2.23606797749979},"48":{"tf":2.8284271247461903},"6":{"tf":1.4142135623730951}},"l":{"df":0,"docs":{},"e":{"df":0,"docs":{},"s":{"df":0,"docs":{},"s":{"df":3,"docs":{"1":{"tf":1.0},"29":{"tf":1.0},"48":{"tf":1.4142135623730951}}}}}}},"df":0,"docs":{}}}}},"t":{"df":6,"docs":{"11":{"tf":1.7320508075688772},"12":{"tf":1.7320508075688772},"13":{"tf":1.0},"14":{"tf":1.0},"17":{"tf":1.0},"7":{"tf":1.4142135623730951}},"e":{"df":0,"docs":{},"t":{"df":0,"docs":{},"h":{"df":0,"docs":{},"e":{"df":0,"docs":{},"g":{"df":0,"docs":{},"e":{"df":0,"docs":{},"n":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"a":{"df":0,"docs":{},"t":{"df":0,"docs":{},"e":{"d":{"b":{"a":{"df":0,"docs":{},"s":{"df":0,"docs":{},"e":{"6":{"4":{"df":0,"docs":{},"h":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":1,"docs":{"12":{"tf":1.0}}}}}},"df":0,"docs":{}},"df":0,"docs":{}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}},"df":0,"docs":{}}}}}}}}},"y":{"df":0,"docs":{},"o":{"df":0,"docs":{},"u":{"df":0,"docs":{},"r":{"df":0,"docs":{},"s":{"df":0,"docs":{},"m":{"df":0,"docs":{},"t":{"df":0,"docs":{},"p":{"df":0,"docs":{},"p":{"a":{"df":0,"docs":{},"s":{"df":0,"docs":{},"s":{"df":0,"docs":{},"w":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"d":{"df":0,"docs":{},"h":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":1,"docs":{"12":{"tf":1.0}}}}}},"df":0,"docs":{}}}}}}},"df":0,"docs":{}}}}}}}}}}}}},"t":{"df":0,"docs":{},"h":{"df":5,"docs":{"13":{"tf":1.4142135623730951},"45":{"tf":2.0},"46":{"tf":1.0},"48":{"tf":2.6457513110645907},"7":{"tf":1.0}}}}},"df":2,"docs":{"6":{"tf":1.4142135623730951},"7":{"tf":1.0}},"e":{"df":0,"docs":{},"m":{"df":3,"docs":{"45":{"tf":2.6457513110645907},"46":{"tf":1.0},"48":{"tf":3.0}}},"r":{"df":0,"docs":{},"f":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"df":0,"docs":{},"m":{"df":4,"docs":{"30":{"tf":1.0},"31":{"tf":1.0},"32":{"tf":1.0},"36":{"tf":1.7320508075688772}}}}}},"i":{"df":0,"docs":{},"o":{"d":{"df":0,"docs":{},"s":{"df":0,"docs":{},"e":{"c":{"df":0,"docs":{},"o":{"df":0,"docs":{},"n":{"d":{"df":1,"docs":{"13":{"tf":1.4142135623730951}}},"df":0,"docs":{}}}},"df":0,"docs":{}}}},"df":0,"docs":{}}},"m":{"a":{"df":0,"docs":{},"n":{"df":1,"docs":{"17":{"tf":1.0}}}},"df":0,"docs":{}},"s":{"df":0,"docs":{},"i":{"df":0,"docs":{},"s":{"df":0,"docs":{},"t":{"df":2,"docs":{"6":{"tf":1.0},"7":{"tf":1.0}}}}}}}},"g":{"1":{"5":{"df":1,"docs":{"48":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}},"h":{"df":0,"docs":{},"y":{"df":0,"docs":{},"s":{"df":0,"docs":{},"i":{"c":{"df":1,"docs":{"48":{"tf":1.0}}},"df":0,"docs":{}}}}},"i":{"df":1,"docs":{"1":{"tf":1.0}},"n":{"df":2,"docs":{"1":{"tf":1.0},"29":{"tf":1.4142135623730951}},"g":{"df":1,"docs":{"48":{"tf":1.7320508075688772}}}}},"k":{"c":{"df":0,"docs":{},"e":{"df":1,"docs":{"1":{"tf":1.0}}}},"df":0,"docs":{}},"l":{"a":{"c":{"df":0,"docs":{},"e":{"df":6,"docs":{"1":{"tf":1.0},"11":{"tf":1.0},"2":{"tf":1.4142135623730951},"23":{"tf":1.0},"30":{"tf":1.0},"7":{"tf":1.0}}}},"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"df":1,"docs":{"41":{"tf":1.0}}}},"n":{"df":1,"docs":{"2":{"tf":1.0}}}},"df":0,"docs":{},"e":{"a":{"df":0,"docs":{},"s":{"df":3,"docs":{"24":{"tf":1.0},"31":{"tf":1.0},"32":{"tf":1.0}}}},"df":0,"docs":{}}},"o":{"d":{"df":8,"docs":{"13":{"tf":1.0},"15":{"tf":1.0},"21":{"tf":1.0},"34":{"tf":1.0},"36":{"tf":1.7320508075688772},"39":{"tf":1.0},"41":{"tf":1.4142135623730951},"47":{"tf":1.0}}},"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"df":0,"docs":{},"t":{"df":8,"docs":{"13":{"tf":1.0},"23":{"tf":1.0},"29":{"tf":1.0},"30":{"tf":1.0},"31":{"tf":1.0},"36":{"tf":1.0},"39":{"tf":1.0},"7":{"tf":1.0}}}}},"r":{"df":0,"docs":{},"t":{"df":6,"docs":{"13":{"tf":3.605551275463989},"14":{"tf":1.0},"17":{"tf":1.4142135623730951},"27":{"tf":1.4142135623730951},"39":{"tf":1.4142135623730951},"48":{"tf":2.23606797749979}}}},"s":{"df":0,"docs":{},"s":{"df":0,"docs":{},"i":{"b":{"df":0,"docs":{},"l":{"df":9,"docs":{"1":{"tf":1.7320508075688772},"13":{"tf":1.0},"2":{"tf":1.0},"23":{"tf":1.0},"24":{"tf":1.0},"32":{"tf":1.0},"34":{"tf":1.4142135623730951},"39":{"tf":1.0},"48":{"tf":1.0}}}},"df":0,"docs":{}}},"t":{"df":0,"docs":{},"g":{"df":0,"docs":{},"r":{"df":6,"docs":{"1":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.4142135623730951},"32":{"tf":1.4142135623730951},"35":{"tf":1.7320508075688772},"48":{"tf":1.4142135623730951}},"e":{"df":0,"docs":{},"s":{"1":{"5":{"df":1,"docs":{"48":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{},"q":{"df":0,"docs":{},"l":{":":{"/":{"/":{"df":0,"docs":{},"u":{"df":0,"docs":{},"s":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{":":{"df":0,"docs":{},"p":{"a":{"df":0,"docs":{},"s":{"df":0,"docs":{},"s":{"df":0,"docs":{},"w":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"d":{"df":0,"docs":{},"w":{"df":0,"docs":{},"i":{"df":0,"docs":{},"t":{"df":0,"docs":{},"h":{"df":0,"docs":{},"o":{"df":0,"docs":{},"u":{"df":0,"docs":{},"t":{"df":0,"docs":{},"s":{"df":0,"docs":{},"p":{"df":0,"docs":{},"e":{"c":{"df":0,"docs":{},"i":{"a":{"df":0,"docs":{},"l":{"c":{"df":0,"docs":{},"h":{"a":{"df":0,"docs":{},"r":{"a":{"c":{"df":0,"docs":{},"t":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"s":{"@":{"df":0,"docs":{},"l":{"df":0,"docs":{},"o":{"c":{"a":{"df":0,"docs":{},"l":{"df":0,"docs":{},"h":{"df":0,"docs":{},"o":{"df":0,"docs":{},"s":{"df":0,"docs":{},"t":{":":{"5":{"4":{"3":{"2":{"/":{"d":{"a":{"df":0,"docs":{},"t":{"a":{"b":{"a":{"df":0,"docs":{},"s":{"df":0,"docs":{},"e":{"df":0,"docs":{},"n":{"a":{"df":0,"docs":{},"m":{"df":2,"docs":{"12":{"tf":1.0},"48":{"tf":1.0}}}},"df":0,"docs":{}}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}}}},"df":0,"docs":{}},"df":0,"docs":{}}}},"df":0,"docs":{}}}}}},"df":0,"docs":{}},"df":0,"docs":{}}},"df":0,"docs":{}}},"df":0,"docs":{}}},"df":0,"docs":{}}},"df":0,"docs":{}}}}}}}}}}}},"df":0,"docs":{}}}}}}},"df":0,"docs":{}}},"df":0,"docs":{}}}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}}}}}},"w":{"_":{"df":0,"docs":{},"e":{"df":0,"docs":{},"x":{"df":0,"docs":{},"p":{"=":{"3":{"0":{"0":{"df":1,"docs":{"48":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}},"i":{"df":0,"docs":{},"t":{"=":{"1":{"0":{"0":{"0":{"0":{"0":{"0":{"df":1,"docs":{"48":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}},"df":1,"docs":{"48":{"tf":2.0}}}},"r":{"a":{"c":{"df":0,"docs":{},"t":{"df":0,"docs":{},"i":{"c":{"df":1,"docs":{"31":{"tf":1.0}}},"df":0,"docs":{}}}},"df":0,"docs":{}},"df":0,"docs":{},"e":{"df":3,"docs":{"0":{"tf":1.0},"1":{"tf":1.0},"2":{"tf":1.0}},"s":{"df":0,"docs":{},"e":{"df":0,"docs":{},"n":{"df":0,"docs":{},"t":{"df":1,"docs":{"29":{"tf":1.0}}}}}},"t":{"df":0,"docs":{},"t":{"df":0,"docs":{},"i":{"df":3,"docs":{"1":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.4142135623730951}}}}},"v":{"df":0,"docs":{},"e":{"df":0,"docs":{},"n":{"df":0,"docs":{},"t":{"df":2,"docs":{"13":{"tf":1.0},"23":{"tf":1.0}}}}}}},"i":{"df":0,"docs":{},"m":{"df":0,"docs":{},"e":{"df":1,"docs":{"13":{"tf":1.0}}}},"v":{"a":{"df":0,"docs":{},"t":{"df":2,"docs":{"43":{"tf":2.0},"48":{"tf":1.0}}}},"df":0,"docs":{}}},"o":{"b":{"a":{"b":{"df":0,"docs":{},"l":{"df":1,"docs":{"2":{"tf":1.4142135623730951}}}},"df":0,"docs":{}},"df":0,"docs":{},"l":{"df":0,"docs":{},"e":{"df":0,"docs":{},"m":{"a":{"df":0,"docs":{},"t":{"df":1,"docs":{"48":{"tf":1.0}}}},"df":4,"docs":{"13":{"tf":1.0},"22":{"tf":1.0},"32":{"tf":1.4142135623730951},"48":{"tf":1.0}}}}}},"c":{"df":0,"docs":{},"e":{"d":{"df":0,"docs":{},"u":{"df":0,"docs":{},"r":{"df":1,"docs":{"47":{"tf":1.0}}}}},"df":4,"docs":{"15":{"tf":1.0},"17":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.0}}}},"d":{"df":0,"docs":{},"u":{"c":{"df":0,"docs":{},"t":{"df":9,"docs":{"1":{"tf":1.4142135623730951},"13":{"tf":1.0},"16":{"tf":1.4142135623730951},"17":{"tf":1.4142135623730951},"24":{"tf":1.0},"25":{"tf":1.0},"26":{"tf":1.0},"48":{"tf":2.23606797749979},"7":{"tf":1.7320508075688772}}}},"df":0,"docs":{}}},"df":0,"docs":{},"j":{"df":0,"docs":{},"e":{"c":{"df":0,"docs":{},"t":{"df":3,"docs":{"0":{"tf":1.4142135623730951},"1":{"tf":1.0},"43":{"tf":1.4142135623730951}}}},"df":0,"docs":{}}},"m":{"df":0,"docs":{},"p":{"df":0,"docs":{},"t":{"df":3,"docs":{"29":{"tf":1.0},"31":{"tf":1.0},"48":{"tf":1.4142135623730951}}}}},"o":{"df":0,"docs":{},"f":{"df":1,"docs":{"48":{"tf":1.0}}}},"p":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":1,"docs":{"13":{"tf":1.0}},"l":{"df":0,"docs":{},"i":{"df":1,"docs":{"13":{"tf":1.0}}}},"t":{"df":0,"docs":{},"i":{"df":1,"docs":{"48":{"tf":1.0}}}}}}},"v":{"df":0,"docs":{},"i":{"d":{"df":9,"docs":{"1":{"tf":2.23606797749979},"24":{"tf":1.4142135623730951},"36":{"tf":1.0},"39":{"tf":1.0},"43":{"tf":1.0},"45":{"tf":1.0},"46":{"tf":1.0},"48":{"tf":1.7320508075688772},"7":{"tf":1.7320508075688772}},"e":{"df":0,"docs":{},"i":{"df":0,"docs":{},"f":{"df":0,"docs":{},"y":{"df":0,"docs":{},"o":{"df":0,"docs":{},"u":{"df":0,"docs":{},"h":{"a":{"df":0,"docs":{},"v":{"df":0,"docs":{},"e":{"df":0,"docs":{},"m":{"df":0,"docs":{},"u":{"df":0,"docs":{},"l":{"df":0,"docs":{},"t":{"df":0,"docs":{},"i":{"df":0,"docs":{},"p":{"df":0,"docs":{},"l":{"df":0,"docs":{},"e":{"df":0,"docs":{},"o":{"df":0,"docs":{},"n":{"df":1,"docs":{"13":{"tf":1.0}}}}}}}}}}}}}}},"df":0,"docs":{}}}}}}}}},"df":0,"docs":{}}},"x":{"df":0,"docs":{},"i":{"df":2,"docs":{"13":{"tf":1.0},"48":{"tf":1.4142135623730951}}},"y":{"_":{"df":0,"docs":{},"m":{"df":0,"docs":{},"o":{"d":{"df":0,"docs":{},"e":{"=":{"df":0,"docs":{},"f":{"a":{"df":0,"docs":{},"l":{"df":0,"docs":{},"s":{"df":1,"docs":{"48":{"tf":1.0}}}}},"df":0,"docs":{}}},"df":0,"docs":{}}},"df":0,"docs":{}}}},"df":0,"docs":{}}}}},"u":{"b":{"_":{"df":0,"docs":{},"u":{"df":0,"docs":{},"r":{"df":0,"docs":{},"l":{"=":{"df":0,"docs":{},"l":{"df":0,"docs":{},"o":{"c":{"a":{"df":0,"docs":{},"l":{"df":0,"docs":{},"h":{"df":0,"docs":{},"o":{"df":0,"docs":{},"s":{"df":0,"docs":{},"t":{":":{"8":{"0":{"8":{"0":{"df":1,"docs":{"48":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}}}},"df":0,"docs":{}},"df":0,"docs":{}}}},"df":1,"docs":{"48":{"tf":1.4142135623730951}}}}}},"df":0,"docs":{},"l":{"df":0,"docs":{},"i":{"c":{"df":1,"docs":{"48":{"tf":1.4142135623730951}}},"df":0,"docs":{}}}},"df":0,"docs":{},"r":{"df":0,"docs":{},"p":{"df":0,"docs":{},"o":{"df":0,"docs":{},"s":{"df":4,"docs":{"10":{"tf":1.0},"2":{"tf":1.0},"31":{"tf":1.0},"8":{"tf":1.0}}}}}},"t":{"df":1,"docs":{"36":{"tf":1.0}},"t":{"df":0,"docs":{},"h":{"df":0,"docs":{},"e":{"df":0,"docs":{},"w":{"df":0,"docs":{},"h":{"df":0,"docs":{},"o":{"df":0,"docs":{},"l":{"df":0,"docs":{},"e":{"df":0,"docs":{},"v":{"a":{"df":0,"docs":{},"l":{"df":0,"docs":{},"u":{"df":0,"docs":{},"e":{"df":0,"docs":{},"h":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":1,"docs":{"31":{"tf":1.0}}}}}}}}},"df":0,"docs":{}}}}}}}}}}}},"w":{"d":{")":{"/":{"df":0,"docs":{},"r":{"a":{"df":0,"docs":{},"u":{"df":0,"docs":{},"t":{"df":0,"docs":{},"h":{"df":0,"docs":{},"y":{"/":{"d":{"a":{"df":0,"docs":{},"t":{"a":{":":{"/":{"a":{"df":0,"docs":{},"p":{"df":0,"docs":{},"p":{"/":{"d":{"a":{"df":0,"docs":{},"t":{"a":{"df":1,"docs":{"7":{"tf":1.0}}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{},"r":{"a":{"df":0,"docs":{},"u":{"df":0,"docs":{},"t":{"df":0,"docs":{},"h":{"df":0,"docs":{},"y":{".":{"c":{"df":0,"docs":{},"f":{"df":0,"docs":{},"g":{":":{"/":{"a":{"df":0,"docs":{},"p":{"df":0,"docs":{},"p":{"/":{"df":0,"docs":{},"r":{"a":{"df":0,"docs":{},"u":{"df":0,"docs":{},"t":{"df":0,"docs":{},"h":{"df":0,"docs":{},"y":{".":{"c":{"df":0,"docs":{},"f":{"df":0,"docs":{},"g":{"df":1,"docs":{"7":{"tf":1.0}}}}},"df":0,"docs":{}},"df":0,"docs":{}}}}}},"df":0,"docs":{}}},"df":0,"docs":{}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}},"df":0,"docs":{}},"df":0,"docs":{}}}}}},"df":0,"docs":{}}},"df":0,"docs":{}}}}}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":1,"docs":{"7":{"tf":1.0}}},"df":0,"docs":{}}},"q":{"6":{"df":0,"docs":{},"u":{"2":{"6":{"df":0,"docs":{},"o":{"df":0,"docs":{},"n":{"df":0,"docs":{},"r":{"df":0,"docs":{},"v":{"df":0,"docs":{},"x":{"df":0,"docs":{},"v":{"df":0,"docs":{},"g":{"4":{"4":{"2":{"7":{"/":{"3":{"c":{"df":0,"docs":{},"e":{"c":{"8":{"df":0,"docs":{},"r":{"df":0,"docs":{},"j":{"df":0,"docs":{},"w":{"b":{"c":{"df":0,"docs":{},"m":{"df":0,"docs":{},"k":{"df":0,"docs":{},"r":{"b":{"df":0,"docs":{},"m":{"df":0,"docs":{},"k":{"df":0,"docs":{},"r":{"df":0,"docs":{},"x":{"df":0,"docs":{},"g":{"df":0,"docs":{},"x":{"6":{"5":{"a":{"df":0,"docs":{},"m":{"df":0,"docs":{},"j":{"df":0,"docs":{},"s":{"df":0,"docs":{},"n":{"df":0,"docs":{},"t":{"df":0,"docs":{},"g":{"df":0,"docs":{},"h":{"df":0,"docs":{},"s":{"a":{"df":2,"docs":{"31":{"tf":1.0},"48":{"tf":1.0}}},"df":0,"docs":{}}}}}}}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}}}}},"df":0,"docs":{}}}}},"df":0,"docs":{}},"df":0,"docs":{}}}}},"df":0,"docs":{}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}}}}}},"df":0,"docs":{}},"df":0,"docs":{}}},"df":0,"docs":{},"u":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"i":{"df":1,"docs":{"2":{"tf":1.0}}}}},"i":{"c":{"df":0,"docs":{},"k":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":1,"docs":{"32":{"tf":1.0}}}},"l":{"df":0,"docs":{},"i":{"df":1,"docs":{"24":{"tf":1.0}}}}}},"df":0,"docs":{},"t":{"df":1,"docs":{"1":{"tf":1.0}}}},"o":{"df":0,"docs":{},"r":{"df":0,"docs":{},"u":{"df":0,"docs":{},"m":{"df":3,"docs":{"36":{"tf":1.4142135623730951},"39":{"tf":1.4142135623730951},"48":{"tf":1.0}}}}}}}},"r":{"a":{"c":{"df":0,"docs":{},"e":{"df":1,"docs":{"48":{"tf":1.0}}}},"df":0,"docs":{},"n":{"d":{"df":0,"docs":{},"o":{"df":0,"docs":{},"m":{"df":2,"docs":{"12":{"tf":1.0},"48":{"tf":1.0}}}}},"df":0,"docs":{}},"s":{"df":0,"docs":{},"p":{"b":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"r":{"df":0,"docs":{},"i":{"df":1,"docs":{"1":{"tf":1.0}}}}}}},"df":0,"docs":{}}},"t":{"df":0,"docs":{},"e":{"df":2,"docs":{"13":{"tf":1.0},"24":{"tf":1.0}}}},"u":{"df":0,"docs":{},"t":{"df":0,"docs":{},"h":{"df":0,"docs":{},"i":{"df":32,"docs":{"1":{"tf":2.6457513110645907},"10":{"tf":1.7320508075688772},"11":{"tf":2.23606797749979},"12":{"tf":1.4142135623730951},"13":{"tf":4.242640687119285},"14":{"tf":1.7320508075688772},"15":{"tf":1.0},"17":{"tf":2.6457513110645907},"19":{"tf":1.4142135623730951},"2":{"tf":2.6457513110645907},"20":{"tf":1.0},"21":{"tf":2.0},"22":{"tf":1.4142135623730951},"23":{"tf":1.4142135623730951},"24":{"tf":1.4142135623730951},"27":{"tf":1.0},"29":{"tf":1.0},"3":{"tf":1.4142135623730951},"31":{"tf":1.0},"32":{"tf":1.0},"34":{"tf":1.4142135623730951},"35":{"tf":1.0},"36":{"tf":1.4142135623730951},"39":{"tf":2.0},"4":{"tf":1.0},"43":{"tf":1.7320508075688772},"46":{"tf":1.0},"47":{"tf":2.8284271247461903},"48":{"tf":4.0},"6":{"tf":2.449489742783178},"7":{"tf":2.6457513110645907},"9":{"tf":1.0}}},"y":{"'":{"df":4,"docs":{"2":{"tf":1.0},"32":{"tf":1.0},"48":{"tf":1.0},"7":{"tf":1.0}}},".":{"c":{"df":0,"docs":{},"f":{"df":0,"docs":{},"g":{"df":2,"docs":{"11":{"tf":1.0},"13":{"tf":1.0}}}}},"df":0,"docs":{}},"/":{"d":{"a":{"df":0,"docs":{},"t":{"a":{"df":1,"docs":{"7":{"tf":2.0}}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{},"r":{"a":{"df":0,"docs":{},"u":{"df":0,"docs":{},"t":{"df":0,"docs":{},"h":{"df":0,"docs":{},"y":{".":{"c":{"df":0,"docs":{},"f":{"df":0,"docs":{},"g":{"df":1,"docs":{"7":{"tf":1.4142135623730951}}}}},"df":0,"docs":{}},"df":0,"docs":{}}}}}},"df":0,"docs":{}}},"@":{"df":0,"docs":{},"l":{"df":0,"docs":{},"o":{"c":{"a":{"df":0,"docs":{},"l":{"df":0,"docs":{},"h":{"df":0,"docs":{},"o":{"df":0,"docs":{},"s":{"df":0,"docs":{},"t":{".":{"d":{"df":1,"docs":{"48":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}}}}}}},"df":0,"docs":{}},"df":0,"docs":{}}}},"_":{"a":{"d":{"df":0,"docs":{},"m":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"df":1,"docs":{"23":{"tf":2.0}}}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}}},"df":1,"docs":{"7":{"tf":1.7320508075688772}},"e":{"a":{"c":{"df":0,"docs":{},"h":{"df":3,"docs":{"36":{"tf":1.0},"39":{"tf":1.0},"48":{"tf":1.0}}}},"d":{"df":1,"docs":{"7":{"tf":1.4142135623730951}},"e":{"df":0,"docs":{},"r":{"df":1,"docs":{"1":{"tf":1.0}}}},"i":{"df":1,"docs":{"15":{"tf":1.0}},"n":{"df":0,"docs":{},"e":{"df":0,"docs":{},"s":{"df":0,"docs":{},"s":{"df":0,"docs":{},"p":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"b":{"df":1,"docs":{"13":{"tf":1.0}}},"df":0,"docs":{}}}}}}}}},"o":{"df":0,"docs":{},"n":{"df":0,"docs":{},"l":{"df":0,"docs":{},"i":{"df":2,"docs":{"13":{"tf":1.4142135623730951},"47":{"tf":1.7320508075688772}}}}}},"w":{"df":0,"docs":{},"r":{"df":0,"docs":{},"i":{"df":0,"docs":{},"t":{"df":0,"docs":{},"e":{"df":0,"docs":{},"o":{"df":0,"docs":{},"n":{"c":{"df":1,"docs":{"13":{"tf":1.0}}},"df":0,"docs":{}}}}}}}}},"df":0,"docs":{},"l":{"df":4,"docs":{"24":{"tf":1.0},"29":{"tf":1.0},"36":{"tf":1.0},"43":{"tf":1.0}},"l":{"df":0,"docs":{},"i":{"df":5,"docs":{"13":{"tf":1.0},"14":{"tf":1.0},"24":{"tf":1.7320508075688772},"36":{"tf":1.4142135623730951},"39":{"tf":1.0}}}}},"s":{"df":0,"docs":{},"o":{"df":0,"docs":{},"n":{"df":6,"docs":{"1":{"tf":1.4142135623730951},"29":{"tf":1.0},"36":{"tf":1.0},"39":{"tf":1.4142135623730951},"7":{"tf":1.0},"9":{"tf":1.0}}}}}},"c":{"df":0,"docs":{},"e":{"df":0,"docs":{},"i":{"df":0,"docs":{},"v":{"df":1,"docs":{"22":{"tf":1.4142135623730951}}}}},"o":{"df":0,"docs":{},"g":{"df":0,"docs":{},"n":{"df":1,"docs":{"31":{"tf":1.0}}}},"m":{"df":0,"docs":{},"m":{"df":0,"docs":{},"e":{"df":0,"docs":{},"n":{"d":{"df":2,"docs":{"13":{"tf":1.0},"41":{"tf":1.0}}},"df":0,"docs":{}}}}},"n":{"df":0,"docs":{},"n":{"df":0,"docs":{},"e":{"c":{"df":0,"docs":{},"t":{"df":1,"docs":{"48":{"tf":1.0}}}},"df":0,"docs":{}}}}}},"d":{"df":0,"docs":{},"h":{"a":{"c":{".":{"df":0,"docs":{},"l":{"df":0,"docs":{},"o":{"c":{"a":{"df":0,"docs":{},"l":{".":{"c":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"t":{".":{"df":0,"docs":{},"p":{"df":0,"docs":{},"e":{"df":0,"docs":{},"m":{"df":1,"docs":{"43":{"tf":1.0}}}}}},"df":0,"docs":{}}}}},"df":0,"docs":{},"k":{"df":0,"docs":{},"e":{"df":0,"docs":{},"y":{".":{"df":0,"docs":{},"p":{"df":0,"docs":{},"e":{"df":0,"docs":{},"m":{"df":1,"docs":{"43":{"tf":1.0}}}}}},"df":0,"docs":{}}}}},"df":0,"docs":{}}},"df":3,"docs":{"43":{"tf":1.0},"45":{"tf":1.4142135623730951},"48":{"tf":1.0}}},"df":0,"docs":{}}}},"df":4,"docs":{"1":{"tf":1.0},"36":{"tf":1.0},"45":{"tf":1.0},"47":{"tf":3.3166247903554}}},"df":0,"docs":{}},"df":0,"docs":{}},"i":{"df":0,"docs":{},"r":{"df":0,"docs":{},"e":{"c":{"df":0,"docs":{},"t":{"df":1,"docs":{"17":{"tf":1.0}},"s":{"c":{"df":0,"docs":{},"h":{"df":0,"docs":{},"e":{"df":0,"docs":{},"m":{"df":1,"docs":{"17":{"tf":1.0}}}}}},"df":0,"docs":{}}}},"df":0,"docs":{}}}},"u":{"c":{"df":1,"docs":{"1":{"tf":1.0}}},"df":0,"docs":{}}},"df":1,"docs":{"31":{"tf":1.4142135623730951}},"f":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":4,"docs":{"11":{"tf":1.4142135623730951},"44":{"tf":1.0},"48":{"tf":1.7320508075688772},"7":{"tf":1.0}}}},"r":{"df":0,"docs":{},"e":{"df":0,"docs":{},"s":{"df":0,"docs":{},"h":{"_":{"df":0,"docs":{},"t":{"df":0,"docs":{},"o":{"df":0,"docs":{},"k":{"df":0,"docs":{},"e":{"df":0,"docs":{},"n":{"_":{"df":0,"docs":{},"g":{"df":0,"docs":{},"r":{"a":{"c":{"df":0,"docs":{},"e":{"_":{"df":0,"docs":{},"t":{"df":0,"docs":{},"i":{"df":0,"docs":{},"m":{"df":0,"docs":{},"e":{"=":{"5":{"df":1,"docs":{"48":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}}}}}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{}}}},"df":0,"docs":{}}}}}}},"df":1,"docs":{"48":{"tf":1.4142135623730951}}}}}}},"g":{"a":{"df":0,"docs":{},"r":{"d":{"df":1,"docs":{"3":{"tf":1.0}}},"df":0,"docs":{}}},"df":0,"docs":{},"i":{"df":0,"docs":{},"s":{"df":0,"docs":{},"t":{"df":4,"docs":{"1":{"tf":1.0},"26":{"tf":1.0},"28":{"tf":1.0},"48":{"tf":1.0}},"r":{"df":2,"docs":{"22":{"tf":1.0},"48":{"tf":2.0}},"i":{"df":1,"docs":{"13":{"tf":1.0}}}}}}}},"l":{"a":{"df":0,"docs":{},"y":{"df":2,"docs":{"26":{"tf":1.0},"48":{"tf":1.0}}}},"df":0,"docs":{},"e":{"a":{"df":0,"docs":{},"s":{"df":0,"docs":{},"e":{"df":0,"docs":{},"s":{"]":{"(":{"df":0,"docs":{},"h":{"df":0,"docs":{},"t":{"df":0,"docs":{},"t":{"df":0,"docs":{},"p":{"df":0,"docs":{},"s":{":":{"/":{"/":{"df":0,"docs":{},"g":{"df":0,"docs":{},"i":{"df":0,"docs":{},"t":{"df":0,"docs":{},"h":{"df":0,"docs":{},"u":{"b":{".":{"c":{"df":0,"docs":{},"o":{"df":0,"docs":{},"m":{"/":{"df":0,"docs":{},"s":{"df":0,"docs":{},"e":{"b":{"a":{"d":{"df":0,"docs":{},"o":{"b":{"/":{"df":0,"docs":{},"r":{"a":{"df":0,"docs":{},"u":{"df":0,"docs":{},"t":{"df":0,"docs":{},"h":{"df":0,"docs":{},"y":{"/":{"df":0,"docs":{},"r":{"df":0,"docs":{},"e":{"df":0,"docs":{},"l":{"df":0,"docs":{},"e":{"a":{"df":0,"docs":{},"s":{"df":1,"docs":{"13":{"tf":1.0}}}},"df":0,"docs":{}}}}}},"df":0,"docs":{}}}}}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}},"df":0,"docs":{}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}}}},"df":0,"docs":{}},"df":0,"docs":{}}}}},"df":0,"docs":{}}},"m":{"df":0,"docs":{},"o":{"df":0,"docs":{},"t":{"df":3,"docs":{"1":{"tf":1.0},"48":{"tf":1.0},"7":{"tf":1.0}}},"v":{"df":2,"docs":{"31":{"tf":2.23606797749979},"32":{"tf":1.7320508075688772}}}}},"n":{"a":{"df":0,"docs":{},"m":{"df":2,"docs":{"46":{"tf":1.0},"47":{"tf":1.0}}}},"df":0,"docs":{}},"p":{"df":0,"docs":{},"l":{"a":{"c":{"df":2,"docs":{"31":{"tf":1.4142135623730951},"7":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{},"i":{"c":{"a":{"df":4,"docs":{"13":{"tf":1.4142135623730951},"36":{"tf":2.449489742783178},"39":{"tf":1.4142135623730951},"9":{"tf":1.0}}},"df":1,"docs":{"3":{"tf":1.0}}},"df":0,"docs":{}}},"o":{"df":0,"docs":{},"s":{"df":0,"docs":{},"i":{"df":0,"docs":{},"t":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"df":0,"docs":{},"i":{"df":1,"docs":{"43":{"tf":1.0}}}}}}}}},"r":{"df":0,"docs":{},"o":{"d":{"df":0,"docs":{},"u":{"c":{"df":1,"docs":{"32":{"tf":1.0}}},"df":0,"docs":{}}},"df":0,"docs":{}}}},"q":{"df":0,"docs":{},"u":{"df":0,"docs":{},"e":{"df":0,"docs":{},"s":{"df":0,"docs":{},"t":{"df":6,"docs":{"1":{"tf":1.0},"13":{"tf":2.23606797749979},"28":{"tf":1.0},"36":{"tf":1.0},"39":{"tf":1.0},"48":{"tf":3.4641016151377544}}}}},"i":{"df":0,"docs":{},"r":{"df":1,"docs":{"32":{"tf":1.0}}}}}},"s":{"df":0,"docs":{},"e":{"df":0,"docs":{},"t":{"df":3,"docs":{"12":{"tf":1.0},"22":{"tf":1.0},"48":{"tf":1.4142135623730951}}}},"i":{"df":0,"docs":{},"l":{"df":0,"docs":{},"i":{"df":1,"docs":{"36":{"tf":1.0}}}}},"o":{"df":0,"docs":{},"u":{"df":0,"docs":{},"r":{"c":{"df":5,"docs":{"1":{"tf":1.0},"13":{"tf":2.0},"14":{"tf":1.0},"24":{"tf":1.7320508075688772},"36":{"tf":1.0}}},"df":0,"docs":{}}}},"s":{"df":0,"docs":{},"o":{"df":0,"docs":{},"u":{"df":0,"docs":{},"r":{"c":{"df":1,"docs":{"24":{"tf":1.0}}},"df":0,"docs":{}}}}},"t":{"a":{"df":0,"docs":{},"r":{"df":0,"docs":{},"t":{"df":6,"docs":{"21":{"tf":1.0},"22":{"tf":1.0},"24":{"tf":1.0},"32":{"tf":1.4142135623730951},"47":{"tf":1.0},"6":{"tf":1.0}}}}},"df":3,"docs":{"13":{"tf":1.0},"46":{"tf":1.0},"47":{"tf":2.0}},"r":{"df":0,"docs":{},"i":{"c":{"df":0,"docs":{},"t":{"df":3,"docs":{"24":{"tf":1.0},"48":{"tf":1.0},"7":{"tf":1.0}}}},"df":0,"docs":{}}}}},"v":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"s":{"df":2,"docs":{"13":{"tf":1.0},"48":{"tf":1.4142135623730951}}}}}},"w":{"df":0,"docs":{},"r":{"df":0,"docs":{},"i":{"df":0,"docs":{},"t":{"df":0,"docs":{},"t":{"df":0,"docs":{},"e":{"df":0,"docs":{},"n":{"df":1,"docs":{"2":{"tf":1.0}}}}}}}}}},"i":{"df":0,"docs":{},"g":{"df":0,"docs":{},"h":{"df":0,"docs":{},"t":{"df":2,"docs":{"22":{"tf":1.0},"7":{"tf":1.7320508075688772}}}}},"s":{"df":0,"docs":{},"k":{"df":2,"docs":{"0":{"tf":1.0},"39":{"tf":1.0}}}}},"m":{"df":1,"docs":{"6":{"tf":1.4142135623730951}}},"o":{"df":0,"docs":{},"l":{"df":0,"docs":{},"e":{"df":1,"docs":{"23":{"tf":2.449489742783178}}}},"t":{"a":{"df":0,"docs":{},"t":{"df":2,"docs":{"30":{"tf":1.0},"31":{"tf":1.7320508075688772}}}},"df":0,"docs":{}},"u":{"df":0,"docs":{},"g":{"df":0,"docs":{},"h":{"df":1,"docs":{"1":{"tf":1.0}}}},"t":{"df":2,"docs":{"14":{"tf":1.0},"17":{"tf":1.4142135623730951}}}}},"p":{"_":{"b":{"df":0,"docs":{},"n":{"a":{"df":0,"docs":{},"e":{"df":1,"docs":{"28":{"tf":1.0}}}},"df":0,"docs":{}}},"df":0,"docs":{},"i":{"d":{"=":{"a":{"df":0,"docs":{},"u":{"df":0,"docs":{},"t":{"df":0,"docs":{},"h":{".":{"df":0,"docs":{},"e":{"df":0,"docs":{},"x":{"a":{"df":0,"docs":{},"m":{"df":0,"docs":{},"p":{"df":0,"docs":{},"l":{"df":0,"docs":{},"e":{".":{"c":{"df":0,"docs":{},"o":{"df":0,"docs":{},"m":{"df":1,"docs":{"26":{"tf":1.0}}}}},"df":0,"docs":{}},"df":0,"docs":{}}}}}},"df":0,"docs":{}}}},"df":0,"docs":{}}}}},"df":0,"docs":{},"l":{"df":0,"docs":{},"o":{"c":{"a":{"df":0,"docs":{},"l":{"df":0,"docs":{},"h":{"df":0,"docs":{},"o":{"df":0,"docs":{},"s":{"df":0,"docs":{},"t":{"df":1,"docs":{"48":{"tf":1.0}}}}}}}},"df":0,"docs":{}},"df":0,"docs":{}}}},"df":1,"docs":{"26":{"tf":1.7320508075688772}}},"df":0,"docs":{}},"n":{"a":{"df":0,"docs":{},"m":{"df":0,"docs":{},"e":{"=":{"'":{"df":0,"docs":{},"r":{"a":{"df":0,"docs":{},"u":{"df":0,"docs":{},"t":{"df":0,"docs":{},"h":{"df":0,"docs":{},"i":{"df":1,"docs":{"48":{"tf":1.0}}}}}}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":1,"docs":{"28":{"tf":1.7320508075688772}}}}},"df":0,"docs":{}},"o":{"df":0,"docs":{},"r":{"df":0,"docs":{},"i":{"df":0,"docs":{},"g":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"=":{"df":0,"docs":{},"h":{"df":0,"docs":{},"t":{"df":0,"docs":{},"t":{"df":0,"docs":{},"p":{":":{"/":{"/":{"df":0,"docs":{},"l":{"df":0,"docs":{},"o":{"c":{"a":{"df":0,"docs":{},"l":{"df":0,"docs":{},"h":{"df":0,"docs":{},"o":{"df":0,"docs":{},"s":{"df":0,"docs":{},"t":{":":{"8":{"0":{"8":{"0":{"df":1,"docs":{"48":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}}}},"df":0,"docs":{}},"df":0,"docs":{}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{},"s":{":":{"/":{"/":{"a":{"df":0,"docs":{},"u":{"df":0,"docs":{},"t":{"df":0,"docs":{},"h":{".":{"df":0,"docs":{},"e":{"df":0,"docs":{},"x":{"a":{"df":0,"docs":{},"m":{"df":0,"docs":{},"p":{"df":0,"docs":{},"l":{"df":0,"docs":{},"e":{".":{"c":{"df":0,"docs":{},"o":{"df":0,"docs":{},"m":{":":{"4":{"4":{"3":{"df":1,"docs":{"27":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}},"df":0,"docs":{}},"df":0,"docs":{}}}}}},"df":0,"docs":{}}}},"df":0,"docs":{}}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}}}},"df":1,"docs":{"27":{"tf":2.0}}}}}}}}},"df":2,"docs":{"26":{"tf":1.0},"48":{"tf":1.4142135623730951}}},"u":{"df":0,"docs":{},"l":{"df":0,"docs":{},"e":{"df":3,"docs":{"14":{"tf":1.0},"17":{"tf":1.4142135623730951},"24":{"tf":1.0}}}},"n":{"a":{"df":0,"docs":{},"s":{"df":0,"docs":{},"g":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"u":{"df":0,"docs":{},"p":{"df":1,"docs":{"13":{"tf":1.0}}}}}}},"u":{"df":0,"docs":{},"s":{"df":1,"docs":{"13":{"tf":1.0}}}}}},"df":11,"docs":{"1":{"tf":1.7320508075688772},"13":{"tf":1.0},"14":{"tf":1.0},"24":{"tf":1.4142135623730951},"36":{"tf":1.0},"39":{"tf":1.0},"4":{"tf":1.0},"48":{"tf":1.4142135623730951},"6":{"tf":1.4142135623730951},"7":{"tf":1.4142135623730951},"8":{"tf":1.0}},"t":{"df":0,"docs":{},"i":{"df":0,"docs":{},"m":{"df":4,"docs":{"12":{"tf":1.0},"13":{"tf":1.0},"48":{"tf":1.0},"6":{"tf":1.0}}}}}},"s":{"df":0,"docs":{},"t":{"df":3,"docs":{"1":{"tf":1.0},"13":{"tf":1.0},"36":{"tf":1.0}}}}}},"s":{"2":{"5":{"6":{"df":1,"docs":{"1":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}},"a":{"df":0,"docs":{},"f":{"df":0,"docs":{},"e":{"df":2,"docs":{"19":{"tf":1.0},"48":{"tf":1.0}},"r":{"df":1,"docs":{"48":{"tf":1.0}}},"s":{"df":0,"docs":{},"t":{"df":2,"docs":{"29":{"tf":1.0},"7":{"tf":1.0}}}},"t":{"df":0,"docs":{},"i":{"df":1,"docs":{"36":{"tf":1.4142135623730951}}}}}},"m":{"df":0,"docs":{},"e":{"df":11,"docs":{"17":{"tf":1.0},"23":{"tf":1.0},"24":{"tf":1.4142135623730951},"32":{"tf":1.0},"36":{"tf":1.0},"37":{"tf":1.0},"39":{"tf":1.0},"40":{"tf":1.0},"43":{"tf":1.0},"48":{"tf":2.0},"7":{"tf":1.0}}},"l":{"df":1,"docs":{"3":{"tf":1.4142135623730951}}}},"v":{"df":0,"docs":{},"e":{"df":2,"docs":{"34":{"tf":1.0},"48":{"tf":1.4142135623730951}}}}},"b":{"c":{"df":1,"docs":{"1":{"tf":1.0}}},"df":0,"docs":{}},"c":{"a":{"df":0,"docs":{},"l":{"df":0,"docs":{},"e":{"df":3,"docs":{"13":{"tf":1.0},"36":{"tf":1.7320508075688772},"9":{"tf":1.0}}}}},"df":0,"docs":{},"e":{"df":0,"docs":{},"n":{"a":{"df":0,"docs":{},"r":{"df":0,"docs":{},"i":{"df":0,"docs":{},"o":{"df":2,"docs":{"1":{"tf":1.0},"48":{"tf":1.0}}}}}},"df":0,"docs":{}}},"h":{"df":0,"docs":{},"e":{"d":{"_":{"d":{"df":0,"docs":{},"i":{"df":0,"docs":{},"s":{"a":{"b":{"df":0,"docs":{},"l":{"df":0,"docs":{},"e":{"=":{"df":0,"docs":{},"t":{"df":0,"docs":{},"r":{"df":0,"docs":{},"u":{"df":1,"docs":{"48":{"tf":1.0}}}}}},"df":0,"docs":{}}}},"df":0,"docs":{}},"df":0,"docs":{}}}},"df":0,"docs":{}},"df":0,"docs":{},"u":{"df":0,"docs":{},"l":{"df":1,"docs":{"48":{"tf":1.0}}}}},"df":0,"docs":{},"m":{"a":{"df":2,"docs":{"19":{"tf":1.0},"48":{"tf":1.7320508075688772}}},"df":0,"docs":{},"e":{":":{"/":{"/":{"df":0,"docs":{},"h":{"df":0,"docs":{},"o":{"df":0,"docs":{},"s":{"df":0,"docs":{},"t":{"df":0,"docs":{},"n":{"a":{"df":0,"docs":{},"m":{"df":0,"docs":{},"e":{":":{"df":0,"docs":{},"p":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"df":0,"docs":{},"t":{"df":1,"docs":{"48":{"tf":1.0}}}}}}},"df":0,"docs":{}}}},"df":0,"docs":{}}}}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":3,"docs":{"13":{"tf":2.0},"17":{"tf":1.0},"48":{"tf":1.0}}}}}},"r":{"df":0,"docs":{},"i":{"df":0,"docs":{},"p":{"df":0,"docs":{},"t":{"df":1,"docs":{"43":{"tf":1.4142135623730951}}}}}}},"d":{"df":1,"docs":{"1":{"tf":1.0}},"o":{"b":{"df":0,"docs":{},"e":{"d":{"df":0,"docs":{},"e":{"df":0,"docs":{},"v":{"/":{"df":0,"docs":{},"r":{"a":{"df":0,"docs":{},"u":{"df":0,"docs":{},"t":{"df":0,"docs":{},"h":{"df":0,"docs":{},"i":{"df":2,"docs":{"6":{"tf":1.4142135623730951},"7":{"tf":1.0}}},"y":{":":{"0":{".":{"1":{"3":{".":{"1":{"df":1,"docs":{"13":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}}},"df":0,"docs":{}}},"df":0,"docs":{}}}},"df":0,"docs":{}}},"df":0,"docs":{}}},"df":0,"docs":{},"e":{"c":{"df":2,"docs":{"34":{"tf":1.0},"48":{"tf":1.0}},"o":{"df":0,"docs":{},"n":{"d":{"df":7,"docs":{"27":{"tf":1.0},"29":{"tf":1.4142135623730951},"31":{"tf":1.0},"34":{"tf":1.0},"48":{"tf":3.3166247903554},"6":{"tf":1.0},"7":{"tf":1.0}}},"df":0,"docs":{}}},"r":{"df":0,"docs":{},"e":{"df":0,"docs":{},"t":{"df":13,"docs":{"11":{"tf":1.0},"12":{"tf":3.0},"13":{"tf":1.7320508075688772},"17":{"tf":1.4142135623730951},"19":{"tf":1.4142135623730951},"30":{"tf":1.0},"31":{"tf":2.6457513110645907},"40":{"tf":1.4142135623730951},"46":{"tf":1.0},"47":{"tf":3.3166247903554},"48":{"tf":1.7320508075688772},"7":{"tf":1.0},"9":{"tf":1.0}},"k":{"df":0,"docs":{},"e":{"df":0,"docs":{},"y":{"df":0,"docs":{},"r":{"df":0,"docs":{},"e":{"df":0,"docs":{},"f":{"df":1,"docs":{"13":{"tf":1.7320508075688772}}}}}}}},"n":{"a":{"df":0,"docs":{},"m":{"df":2,"docs":{"17":{"tf":1.0},"47":{"tf":1.7320508075688772}}}},"df":0,"docs":{}},"s":{".":{"df":0,"docs":{},"y":{"a":{"df":0,"docs":{},"m":{"df":0,"docs":{},"l":{"df":1,"docs":{"12":{"tf":1.7320508075688772}}}}},"df":0,"docs":{}}},"df":0,"docs":{}}}}},"t":{"df":0,"docs":{},"i":{"df":0,"docs":{},"o":{"df":0,"docs":{},"n":{"df":2,"docs":{"44":{"tf":1.0},"47":{"tf":1.4142135623730951}}}}}},"u":{"df":0,"docs":{},"r":{"df":13,"docs":{"0":{"tf":1.0},"1":{"tf":1.7320508075688772},"12":{"tf":1.0},"13":{"tf":1.0},"19":{"tf":1.0},"24":{"tf":1.7320508075688772},"28":{"tf":1.0},"29":{"tf":1.0},"3":{"tf":1.0},"31":{"tf":1.0},"39":{"tf":1.0},"48":{"tf":1.4142135623730951},"7":{"tf":1.0}},"i":{"df":0,"docs":{},"t":{"df":0,"docs":{},"y":{"c":{"df":0,"docs":{},"o":{"df":0,"docs":{},"n":{"df":0,"docs":{},"t":{"df":0,"docs":{},"e":{"df":0,"docs":{},"x":{"df":0,"docs":{},"t":{"df":1,"docs":{"13":{"tf":1.4142135623730951}}}}}}}}},"df":0,"docs":{}}}}}}},"df":0,"docs":{},"e":{"df":5,"docs":{"13":{"tf":1.0},"2":{"tf":1.0},"31":{"tf":1.0},"43":{"tf":1.4142135623730951},"6":{"tf":1.4142135623730951}},"m":{"df":1,"docs":{"37":{"tf":1.0}}},"n":{"df":1,"docs":{"23":{"tf":1.0}}}},"l":{"df":0,"docs":{},"e":{"c":{"df":0,"docs":{},"t":{"df":1,"docs":{"31":{"tf":1.0}},"o":{"df":0,"docs":{},"r":{"df":1,"docs":{"13":{"tf":1.4142135623730951}}}}}},"df":0,"docs":{}}},"n":{"d":{"df":2,"docs":{"12":{"tf":1.0},"48":{"tf":1.0}}},"df":0,"docs":{},"s":{"df":2,"docs":{"13":{"tf":1.0},"48":{"tf":1.0}},"i":{"df":0,"docs":{},"s":{"df":0,"docs":{},"t":{"df":1,"docs":{"48":{"tf":1.0}}}},"t":{"df":4,"docs":{"11":{"tf":1.0},"12":{"tf":1.0},"19":{"tf":1.0},"48":{"tf":1.0}}}}},"t":{"df":1,"docs":{"48":{"tf":1.0}}}},"r":{"df":0,"docs":{},"v":{"df":1,"docs":{"2":{"tf":1.0}},"e":{"df":0,"docs":{},"r":{"df":7,"docs":{"36":{"tf":1.0},"39":{"tf":1.0},"43":{"tf":1.0},"45":{"tf":2.449489742783178},"46":{"tf":1.4142135623730951},"47":{"tf":2.8284271247461903},"48":{"tf":3.1622776601683795}}}},"i":{"c":{"df":4,"docs":{"13":{"tf":1.0},"14":{"tf":1.0},"17":{"tf":1.4142135623730951},"41":{"tf":1.0}},"e":{"df":0,"docs":{},"n":{"a":{"df":0,"docs":{},"m":{"df":1,"docs":{"13":{"tf":1.0}}}},"df":0,"docs":{}}}},"df":0,"docs":{}}}},"s":{"df":0,"docs":{},"s":{"df":0,"docs":{},"i":{"df":0,"docs":{},"o":{"df":0,"docs":{},"n":{"_":{"df":0,"docs":{},"l":{"df":0,"docs":{},"i":{"df":0,"docs":{},"f":{"df":0,"docs":{},"e":{"df":0,"docs":{},"t":{"df":0,"docs":{},"i":{"df":0,"docs":{},"m":{"df":1,"docs":{"48":{"tf":1.0}},"e":{"=":{"1":{"4":{"4":{"0":{"0":{"df":1,"docs":{"48":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}}}}}},"r":{"df":0,"docs":{},"e":{"df":0,"docs":{},"n":{"df":0,"docs":{},"e":{"df":0,"docs":{},"w":{"_":{"df":0,"docs":{},"m":{"df":0,"docs":{},"f":{"a":{"=":{"df":0,"docs":{},"f":{"a":{"df":0,"docs":{},"l":{"df":0,"docs":{},"s":{"df":1,"docs":{"48":{"tf":1.0}}}}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{}}}},"df":0,"docs":{}}}}}},"t":{"df":0,"docs":{},"i":{"df":0,"docs":{},"m":{"df":0,"docs":{},"e":{"df":0,"docs":{},"o":{"df":0,"docs":{},"u":{"df":0,"docs":{},"t":{"=":{"5":{"4":{"0":{"0":{"df":1,"docs":{"48":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}}}}}},"df":1,"docs":{"48":{"tf":3.1622776601683795}}}}}}},"t":{"df":22,"docs":{"1":{"tf":1.0},"13":{"tf":1.7320508075688772},"19":{"tf":1.0},"2":{"tf":1.0},"21":{"tf":1.4142135623730951},"22":{"tf":1.4142135623730951},"24":{"tf":1.7320508075688772},"25":{"tf":1.0},"27":{"tf":1.0},"28":{"tf":1.0},"30":{"tf":1.0},"31":{"tf":1.4142135623730951},"32":{"tf":1.4142135623730951},"38":{"tf":1.0},"39":{"tf":1.0},"40":{"tf":1.0},"41":{"tf":1.0},"43":{"tf":1.4142135623730951},"44":{"tf":1.0},"45":{"tf":1.4142135623730951},"48":{"tf":3.7416573867739413},"9":{"tf":1.0}},"u":{"df":0,"docs":{},"p":{"df":10,"docs":{"13":{"tf":1.0},"16":{"tf":1.4142135623730951},"22":{"tf":1.0},"24":{"tf":1.4142135623730951},"32":{"tf":1.0},"43":{"tf":1.0},"45":{"tf":1.0},"47":{"tf":1.0},"7":{"tf":1.4142135623730951},"8":{"tf":1.0}}}}},"v":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":1,"docs":{"1":{"tf":1.0}}}}}},"h":{"a":{"2":{"5":{"6":{"df":1,"docs":{"13":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":1,"docs":{"13":{"tf":1.7320508075688772}},"r":{"df":0,"docs":{},"e":{"df":1,"docs":{"36":{"tf":1.0}}}}},"df":0,"docs":{},"e":{"df":0,"docs":{},"l":{"df":0,"docs":{},"l":{"df":2,"docs":{"12":{"tf":1.0},"43":{"tf":1.0}}}}},"o":{"df":0,"docs":{},"w":{"df":2,"docs":{"28":{"tf":1.0},"48":{"tf":1.0}},"n":{"df":3,"docs":{"13":{"tf":1.0},"28":{"tf":1.4142135623730951},"7":{"tf":1.0}}}}},"u":{"df":0,"docs":{},"t":{"d":{"df":0,"docs":{},"o":{"df":0,"docs":{},"w":{"df":0,"docs":{},"n":{"df":1,"docs":{"6":{"tf":1.0}}}}}},"df":0,"docs":{}}}},"i":{"d":{"df":0,"docs":{},"e":{"df":1,"docs":{"48":{"tf":1.0}}}},"df":0,"docs":{},"g":{"df":0,"docs":{},"n":{"df":3,"docs":{"1":{"tf":1.4142135623730951},"19":{"tf":1.0},"43":{"tf":1.4142135623730951}}}},"m":{"df":0,"docs":{},"p":{"df":0,"docs":{},"l":{"df":6,"docs":{"1":{"tf":1.4142135623730951},"14":{"tf":1.0},"24":{"tf":1.0},"34":{"tf":1.0},"8":{"tf":1.0},"9":{"tf":1.0}},"e":{"df":0,"docs":{},"r":{"df":1,"docs":{"46":{"tf":1.0}}}}}}},"n":{"df":0,"docs":{},"g":{"df":1,"docs":{"31":{"tf":1.0}},"l":{"df":6,"docs":{"1":{"tf":1.7320508075688772},"29":{"tf":1.4142135623730951},"32":{"tf":1.0},"36":{"tf":1.0},"48":{"tf":1.4142135623730951},"9":{"tf":1.7320508075688772}}}}},"t":{"df":0,"docs":{},"u":{"a":{"df":0,"docs":{},"t":{"df":2,"docs":{"36":{"tf":1.4142135623730951},"39":{"tf":1.0}}}},"df":0,"docs":{}}},"z":{"df":0,"docs":{},"e":{"df":1,"docs":{"48":{"tf":1.4142135623730951}}}}},"k":{"df":0,"docs":{},"i":{"df":0,"docs":{},"p":{"df":2,"docs":{"42":{"tf":1.0},"48":{"tf":1.0}}}}},"l":{"df":0,"docs":{},"o":{"df":0,"docs":{},"w":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":1,"docs":{"1":{"tf":1.0}}}}}}},"m":{"a":{"df":0,"docs":{},"l":{"df":0,"docs":{},"l":{"df":3,"docs":{"13":{"tf":1.0},"31":{"tf":1.0},"48":{"tf":1.4142135623730951}},"e":{"df":0,"docs":{},"r":{"df":1,"docs":{"24":{"tf":1.0}}}}}}},"df":0,"docs":{},"t":{"df":0,"docs":{},"p":{"_":{"df":0,"docs":{},"f":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"m":{"df":1,"docs":{"48":{"tf":1.0}}}}}},"p":{"a":{"df":0,"docs":{},"s":{"df":0,"docs":{},"s":{"df":0,"docs":{},"w":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"d":{"df":3,"docs":{"12":{"tf":1.4142135623730951},"13":{"tf":1.4142135623730951},"48":{"tf":1.0}}},"df":0,"docs":{}}}}}}},"df":0,"docs":{}},"u":{"df":0,"docs":{},"r":{"df":0,"docs":{},"l":{"df":1,"docs":{"48":{"tf":1.0}}}},"s":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"n":{"a":{"df":0,"docs":{},"m":{"df":1,"docs":{"48":{"tf":1.0}}}},"df":0,"docs":{}}}}}}},"df":1,"docs":{"22":{"tf":1.4142135623730951}}}}},"n":{"df":0,"docs":{},"i":{"df":2,"docs":{"45":{"tf":1.4142135623730951},"48":{"tf":1.0}}}},"o":{"df":0,"docs":{},"f":{"df":0,"docs":{},"t":{"df":0,"docs":{},"w":{"a":{"df":0,"docs":{},"r":{"df":3,"docs":{"0":{"tf":1.0},"2":{"tf":1.0},"3":{"tf":1.0}}}},"df":0,"docs":{}}}},"l":{"df":0,"docs":{},"u":{"df":0,"docs":{},"t":{"df":5,"docs":{"1":{"tf":1.4142135623730951},"2":{"tf":1.0},"3":{"tf":1.0},"32":{"tf":1.0},"7":{"tf":1.0}}}}},"m":{"df":0,"docs":{},"e":{"df":0,"docs":{},"o":{"df":0,"docs":{},"n":{"df":2,"docs":{"13":{"tf":1.0},"3":{"tf":1.0}}}},"t":{"df":0,"docs":{},"h":{"df":4,"docs":{"1":{"tf":1.0},"13":{"tf":1.4142135623730951},"17":{"tf":1.0},"31":{"tf":1.4142135623730951}}},"i":{"df":0,"docs":{},"m":{"df":1,"docs":{"48":{"tf":1.0}}}}},"w":{"df":0,"docs":{},"h":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":1,"docs":{"37":{"tf":1.0}}}}}}}},"u":{"df":0,"docs":{},"r":{"c":{"df":2,"docs":{"1":{"tf":1.0},"42":{"tf":1.0}}},"df":0,"docs":{}}}},"p":{"df":0,"docs":{},"e":{"c":{".":{"df":0,"docs":{},"t":{"df":0,"docs":{},"e":{"df":0,"docs":{},"m":{"df":0,"docs":{},"p":{"df":0,"docs":{},"l":{"a":{"df":0,"docs":{},"t":{"df":0,"docs":{},"e":{".":{"df":0,"docs":{},"s":{"df":0,"docs":{},"p":{"df":0,"docs":{},"e":{"c":{".":{"c":{"df":0,"docs":{},"o":{"df":0,"docs":{},"n":{"df":0,"docs":{},"t":{"a":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"s":{".":{"[":{"df":0,"docs":{},"r":{"a":{"df":0,"docs":{},"u":{"df":0,"docs":{},"t":{"df":0,"docs":{},"h":{"df":0,"docs":{},"y":{"]":{".":{"df":0,"docs":{},"v":{"df":0,"docs":{},"o":{"df":0,"docs":{},"l":{"df":0,"docs":{},"u":{"df":0,"docs":{},"m":{"df":0,"docs":{},"e":{"df":0,"docs":{},"m":{"df":0,"docs":{},"o":{"df":0,"docs":{},"u":{"df":0,"docs":{},"n":{"df":0,"docs":{},"t":{"df":1,"docs":{"47":{"tf":1.0}}}}}}}}}}}}}},"df":0,"docs":{}},"df":0,"docs":{}}}}}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{}}}}}}},"df":0,"docs":{}}}}},"df":0,"docs":{},"v":{"df":0,"docs":{},"o":{"df":0,"docs":{},"l":{"df":0,"docs":{},"u":{"df":0,"docs":{},"m":{"df":1,"docs":{"47":{"tf":1.0}}}}}}}},"df":0,"docs":{}},"df":0,"docs":{}}}}},"df":0,"docs":{}}}},"df":0,"docs":{}}}}}}},"df":3,"docs":{"13":{"tf":2.0},"14":{"tf":1.0},"17":{"tf":1.7320508075688772}},"i":{"a":{"df":0,"docs":{},"l":{"df":4,"docs":{"1":{"tf":1.0},"12":{"tf":1.0},"36":{"tf":1.0},"48":{"tf":1.7320508075688772}}}},"df":0,"docs":{},"f":{"df":4,"docs":{"2":{"tf":1.0},"32":{"tf":1.0},"43":{"tf":1.0},"48":{"tf":1.0}},"i":{"df":5,"docs":{"32":{"tf":1.0},"34":{"tf":1.0},"39":{"tf":1.0},"45":{"tf":1.4142135623730951},"48":{"tf":2.0}}}}}},"df":0,"docs":{},"e":{"d":{"df":1,"docs":{"1":{"tf":1.0}}},"df":0,"docs":{}}}},"q":{"df":0,"docs":{},"l":{"df":1,"docs":{"2":{"tf":1.0}},"i":{"df":0,"docs":{},"t":{"df":0,"docs":{},"e":{":":{":":{"df":0,"docs":{},"m":{"df":0,"docs":{},"e":{"df":0,"docs":{},"m":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"df":0,"docs":{},"i":{"df":2,"docs":{"12":{"tf":1.0},"48":{"tf":1.0}}}}}}}}},"d":{"a":{"df":0,"docs":{},"t":{"a":{"/":{"df":0,"docs":{},"r":{"a":{"df":0,"docs":{},"u":{"df":0,"docs":{},"t":{"df":0,"docs":{},"h":{"df":0,"docs":{},"y":{".":{"d":{"b":{"df":3,"docs":{"12":{"tf":1.4142135623730951},"48":{"tf":1.0},"7":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":9,"docs":{"1":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.4142135623730951},"13":{"tf":1.0},"32":{"tf":1.4142135623730951},"34":{"tf":2.0},"48":{"tf":1.4142135623730951},"6":{"tf":1.0},"7":{"tf":2.0}}}}}}},"s":{"df":0,"docs":{},"o":{"df":1,"docs":{"1":{"tf":1.4142135623730951}}}},"t":{"a":{"df":0,"docs":{},"n":{"d":{"a":{"df":0,"docs":{},"l":{"df":0,"docs":{},"o":{"df":0,"docs":{},"n":{"df":1,"docs":{"48":{"tf":1.0}}}}},"r":{"d":{"df":1,"docs":{"48":{"tf":1.0}}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{}},"r":{"df":0,"docs":{},"t":{"df":26,"docs":{"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":2.0},"14":{"tf":1.0},"15":{"tf":1.4142135623730951},"16":{"tf":1.0},"17":{"tf":1.4142135623730951},"18":{"tf":2.0},"19":{"tf":2.23606797749979},"20":{"tf":1.4142135623730951},"21":{"tf":1.4142135623730951},"22":{"tf":1.4142135623730951},"23":{"tf":1.7320508075688772},"30":{"tf":1.0},"32":{"tf":1.4142135623730951},"39":{"tf":1.0},"4":{"tf":1.7320508075688772},"40":{"tf":1.0},"43":{"tf":1.4142135623730951},"48":{"tf":1.4142135623730951},"5":{"tf":1.0},"6":{"tf":2.23606797749979},"7":{"tf":2.0},"8":{"tf":1.0},"9":{"tf":1.0}},"u":{"df":0,"docs":{},"p":{"df":2,"docs":{"32":{"tf":1.0},"7":{"tf":1.0}}}}}},"t":{"df":0,"docs":{},"e":{"df":2,"docs":{"13":{"tf":1.4142135623730951},"9":{"tf":1.0}},"f":{"df":0,"docs":{},"u":{"df":0,"docs":{},"l":{"df":0,"docs":{},"s":{"df":0,"docs":{},"e":{"df":0,"docs":{},"t":{"df":2,"docs":{"13":{"tf":1.0},"39":{"tf":2.0}}}}}}}}},"i":{"c":{"df":2,"docs":{"1":{"tf":1.0},"30":{"tf":1.0}}},"df":0,"docs":{}}}},"d":{".":{"df":0,"docs":{},"y":{"a":{"df":0,"docs":{},"m":{"df":0,"docs":{},"l":{"df":1,"docs":{"47":{"tf":1.0}}}}},"df":0,"docs":{}}},"df":0,"docs":{},"o":{"df":0,"docs":{},"u":{"df":0,"docs":{},"t":{"df":1,"docs":{"48":{"tf":1.0}}}}}},"df":0,"docs":{},"e":{"df":0,"docs":{},"p":{"df":8,"docs":{"11":{"tf":1.0},"12":{"tf":1.4142135623730951},"15":{"tf":1.0},"17":{"tf":1.7320508075688772},"24":{"tf":1.0},"43":{"tf":1.4142135623730951},"7":{"tf":1.4142135623730951},"9":{"tf":1.0}}}},"i":{"df":0,"docs":{},"l":{"df":0,"docs":{},"l":{"df":4,"docs":{"1":{"tf":1.0},"24":{"tf":1.0},"36":{"tf":1.0},"48":{"tf":1.4142135623730951}}}}},"o":{"df":0,"docs":{},"n":{"df":0,"docs":{},"e":{"df":1,"docs":{"2":{"tf":1.0}}}},"p":{"df":4,"docs":{"26":{"tf":1.0},"31":{"tf":1.0},"48":{"tf":1.0},"6":{"tf":1.0}}},"r":{"a":{"df":0,"docs":{},"g":{"df":1,"docs":{"13":{"tf":1.0}},"e":{"c":{"df":0,"docs":{},"l":{"a":{"df":0,"docs":{},"s":{"df":0,"docs":{},"s":{"df":0,"docs":{},"n":{"a":{"df":0,"docs":{},"m":{"df":1,"docs":{"13":{"tf":1.0}}}},"df":0,"docs":{}}}}},"df":0,"docs":{}}},"df":0,"docs":{}}}},"df":0,"docs":{},"e":{"df":2,"docs":{"34":{"tf":1.4142135623730951},"48":{"tf":1.4142135623730951}}}}},"r":{"a":{"df":0,"docs":{},"i":{"df":0,"docs":{},"g":{"df":0,"docs":{},"h":{"df":0,"docs":{},"t":{"df":2,"docs":{"17":{"tf":1.0},"34":{"tf":1.0}}}}}},"t":{"df":0,"docs":{},"e":{"df":0,"docs":{},"g":{"df":0,"docs":{},"i":{"df":1,"docs":{"34":{"tf":1.0}}}}}}},"df":0,"docs":{},"e":{"a":{"df":0,"docs":{},"m":{"df":1,"docs":{"48":{"tf":1.0}}}},"df":0,"docs":{}},"i":{"df":0,"docs":{},"n":{"df":0,"docs":{},"g":{"df":2,"docs":{"12":{"tf":1.0},"48":{"tf":1.4142135623730951}}}}},"o":{"df":0,"docs":{},"n":{"df":0,"docs":{},"g":{"df":2,"docs":{"1":{"tf":1.0},"29":{"tf":1.4142135623730951}}}}}},"s":{".":{"df":0,"docs":{},"y":{"a":{"df":0,"docs":{},"m":{"df":0,"docs":{},"l":{"df":2,"docs":{"13":{"tf":1.4142135623730951},"47":{"tf":1.4142135623730951}}}}},"df":0,"docs":{}}},"df":0,"docs":{}},"u":{"df":0,"docs":{},"f":{"df":0,"docs":{},"f":{"df":1,"docs":{"43":{"tf":1.0}}}}},"y":{"df":0,"docs":{},"l":{"df":0,"docs":{},"i":{"df":0,"docs":{},"z":{"df":1,"docs":{"1":{"tf":1.0}}}}}}},"u":{"b":{"df":1,"docs":{"7":{"tf":1.0}},"j":{"df":0,"docs":{},"e":{"c":{"df":0,"docs":{},"t":{"df":2,"docs":{"45":{"tf":1.0},"48":{"tf":1.0}}}},"df":0,"docs":{}}},"p":{"a":{"df":0,"docs":{},"t":{"df":0,"docs":{},"h":{"df":1,"docs":{"13":{"tf":1.0}}}}},"df":0,"docs":{}}},"c":{"c":{"df":0,"docs":{},"e":{"df":0,"docs":{},"s":{"df":0,"docs":{},"s":{"df":2,"docs":{"31":{"tf":1.4142135623730951},"43":{"tf":1.4142135623730951}},"f":{"df":0,"docs":{},"u":{"df":0,"docs":{},"l":{"df":0,"docs":{},"l":{"df":0,"docs":{},"i":{"df":1,"docs":{"29":{"tf":1.0}}}}}}}}}}},"df":0,"docs":{}},"d":{"df":0,"docs":{},"o":{"df":1,"docs":{"7":{"tf":2.449489742783178}}}},"df":0,"docs":{},"f":{"df":0,"docs":{},"f":{"df":0,"docs":{},"i":{"c":{"df":0,"docs":{},"i":{"df":1,"docs":{"6":{"tf":1.0}}}},"df":0,"docs":{}}}},"g":{"df":0,"docs":{},"g":{"df":0,"docs":{},"e":{"df":0,"docs":{},"s":{"df":0,"docs":{},"t":{"df":1,"docs":{"17":{"tf":1.0}}}}}}},"p":{"df":0,"docs":{},"p":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"df":0,"docs":{},"t":{"df":3,"docs":{"1":{"tf":2.0},"2":{"tf":1.0},"29":{"tf":1.0}}}}}}},"r":{"df":0,"docs":{},"e":{"df":7,"docs":{"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.4142135623730951},"25":{"tf":1.4142135623730951},"31":{"tf":1.4142135623730951},"48":{"tf":1.4142135623730951},"7":{"tf":1.7320508075688772}}}}},"y":{"df":0,"docs":{},"n":{"c":{"df":1,"docs":{"36":{"tf":1.4142135623730951}}},"df":0,"docs":{}},"s":{"df":0,"docs":{},"t":{"df":0,"docs":{},"e":{"df":0,"docs":{},"m":{"df":6,"docs":{"1":{"tf":1.0},"24":{"tf":1.0},"29":{"tf":1.0},"43":{"tf":1.0},"48":{"tf":1.4142135623730951},"7":{"tf":1.0}}}}}}}},"t":{"_":{"c":{"df":0,"docs":{},"o":{"df":0,"docs":{},"s":{"df":0,"docs":{},"t":{"df":1,"docs":{"48":{"tf":1.0}}}}}},"df":0,"docs":{}},"a":{"df":0,"docs":{},"g":{"df":1,"docs":{"13":{"tf":2.0}}},"i":{"df":0,"docs":{},"l":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"df":1,"docs":{"43":{"tf":1.0}}}}}},"k":{"df":0,"docs":{},"e":{"df":7,"docs":{"13":{"tf":1.4142135623730951},"3":{"tf":1.0},"31":{"tf":1.0},"39":{"tf":1.0},"45":{"tf":1.0},"48":{"tf":1.0},"6":{"tf":1.4142135623730951}},"n":{"df":2,"docs":{"1":{"tf":1.0},"24":{"tf":1.0}}}}},"r":{"df":0,"docs":{},"g":{"df":0,"docs":{},"e":{"df":0,"docs":{},"t":{"df":1,"docs":{"32":{"tf":1.4142135623730951}},"p":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"df":0,"docs":{},"t":{"df":1,"docs":{"13":{"tf":1.7320508075688772}}}}}}}}}},"s":{"df":0,"docs":{},"k":{"df":1,"docs":{"35":{"tf":1.0}}}}},"df":0,"docs":{},"e":{"c":{"df":0,"docs":{},"h":{"df":0,"docs":{},"n":{"df":0,"docs":{},"i":{"c":{"df":1,"docs":{"24":{"tf":1.0}}},"df":0,"docs":{}}}}},"df":0,"docs":{},"m":{"df":0,"docs":{},"p":{"df":0,"docs":{},"l":{"a":{"df":0,"docs":{},"t":{"df":2,"docs":{"13":{"tf":1.0},"2":{"tf":1.0}}}},"df":0,"docs":{}}}},"r":{"df":0,"docs":{},"m":{"df":1,"docs":{"36":{"tf":1.0}}},"r":{"df":0,"docs":{},"i":{"b":{"df":0,"docs":{},"l":{"df":1,"docs":{"43":{"tf":1.0}}}},"df":0,"docs":{}}}},"s":{"df":0,"docs":{},"t":{"df":7,"docs":{"22":{"tf":1.0},"24":{"tf":1.0},"36":{"tf":1.0},"43":{"tf":1.4142135623730951},"48":{"tf":1.0},"6":{"tf":2.23606797749979},"7":{"tf":1.7320508075688772}}}}},"h":{"df":0,"docs":{},"e":{"df":0,"docs":{},"m":{"df":0,"docs":{},"e":{"df":2,"docs":{"1":{"tf":1.0},"3":{"tf":1.0}}},"s":{"df":0,"docs":{},"e":{"df":0,"docs":{},"l":{"df":0,"docs":{},"v":{"df":1,"docs":{"31":{"tf":1.0}}}}}}}},"i":{"df":0,"docs":{},"n":{"df":0,"docs":{},"g":{"df":8,"docs":{"1":{"tf":1.4142135623730951},"12":{"tf":1.0},"17":{"tf":1.4142135623730951},"2":{"tf":1.4142135623730951},"29":{"tf":1.0},"3":{"tf":1.7320508075688772},"31":{"tf":1.0},"7":{"tf":1.4142135623730951}}},"k":{"df":1,"docs":{"24":{"tf":1.0}}}},"r":{"d":{"df":1,"docs":{"0":{"tf":1.0}}},"df":0,"docs":{}}},"o":{"df":0,"docs":{},"u":{"df":0,"docs":{},"g":{"df":0,"docs":{},"h":{"df":6,"docs":{"0":{"tf":1.0},"1":{"tf":1.4142135623730951},"2":{"tf":1.0},"24":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0}}}}}},"r":{"df":0,"docs":{},"e":{"a":{"d":{"df":1,"docs":{"24":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}},"o":{"df":0,"docs":{},"w":{"df":1,"docs":{"43":{"tf":1.0}}}}}},"i":{"df":0,"docs":{},"m":{"df":0,"docs":{},"e":{"df":15,"docs":{"1":{"tf":1.0},"13":{"tf":1.0},"2":{"tf":1.0},"24":{"tf":1.4142135623730951},"28":{"tf":1.0},"31":{"tf":1.0},"32":{"tf":1.0},"36":{"tf":1.0},"37":{"tf":1.0},"39":{"tf":1.0},"4":{"tf":1.0},"43":{"tf":1.7320508075688772},"48":{"tf":2.8284271247461903},"7":{"tf":1.0},"8":{"tf":1.0}},"o":{"df":0,"docs":{},"u":{"df":0,"docs":{},"t":{"df":1,"docs":{"48":{"tf":3.0}}}}},"s":{"df":0,"docs":{},"t":{"a":{"df":0,"docs":{},"m":{"df":0,"docs":{},"p":{"df":2,"docs":{"34":{"tf":1.0},"48":{"tf":1.0}}}}},"df":0,"docs":{}}}}}},"l":{"df":9,"docs":{"17":{"tf":2.23606797749979},"41":{"tf":2.0},"42":{"tf":2.0},"43":{"tf":2.449489742783178},"44":{"tf":1.4142135623730951},"45":{"tf":2.23606797749979},"46":{"tf":1.7320508075688772},"47":{"tf":3.4641016151377544},"48":{"tf":3.0}},"s":{"/":{"c":{"a":{"df":2,"docs":{"45":{"tf":1.4142135623730951},"48":{"tf":1.4142135623730951}}},"df":0,"docs":{}},"df":0,"docs":{},"r":{"df":0,"docs":{},"e":{"d":{"df":0,"docs":{},"h":{"a":{"c":{".":{"df":0,"docs":{},"l":{"df":0,"docs":{},"o":{"c":{"a":{"df":0,"docs":{},"l":{".":{"c":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"t":{".":{"df":0,"docs":{},"p":{"df":0,"docs":{},"e":{"df":0,"docs":{},"m":{"df":2,"docs":{"45":{"tf":1.4142135623730951},"48":{"tf":1.4142135623730951}}}}}},"df":0,"docs":{}}}}},"df":0,"docs":{},"k":{"df":0,"docs":{},"e":{"df":0,"docs":{},"y":{".":{"df":0,"docs":{},"p":{"df":0,"docs":{},"e":{"df":0,"docs":{},"m":{"df":2,"docs":{"45":{"tf":1.4142135623730951},"48":{"tf":1.4142135623730951}}}}}},"df":0,"docs":{}}}}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}},"df":0,"docs":{}}},"t":{"df":0,"docs":{},"l":{"df":0,"docs":{},"s":{".":{"c":{"df":0,"docs":{},"r":{"df":0,"docs":{},"t":{"df":1,"docs":{"48":{"tf":1.0}}}}},"df":0,"docs":{},"k":{"df":0,"docs":{},"e":{"df":0,"docs":{},"y":{"df":1,"docs":{"48":{"tf":1.0}}}}}},"df":0,"docs":{}}}}},"_":{"c":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"t":{"=":{"df":0,"docs":{},"t":{"df":0,"docs":{},"l":{"df":0,"docs":{},"s":{"/":{"df":0,"docs":{},"t":{"df":0,"docs":{},"l":{"df":0,"docs":{},"s":{".":{"c":{"df":0,"docs":{},"r":{"df":0,"docs":{},"t":{"df":1,"docs":{"48":{"tf":1.0}}}}},"df":0,"docs":{}},"df":0,"docs":{}}}}},"df":0,"docs":{}}}}},"df":1,"docs":{"46":{"tf":1.0}}}}}},"df":0,"docs":{},"k":{"df":0,"docs":{},"e":{"df":0,"docs":{},"y":{"=":{"df":0,"docs":{},"t":{"df":0,"docs":{},"l":{"df":0,"docs":{},"s":{"/":{"df":0,"docs":{},"t":{"df":0,"docs":{},"l":{"df":0,"docs":{},"s":{".":{"df":0,"docs":{},"k":{"df":0,"docs":{},"e":{"df":0,"docs":{},"y":{"df":1,"docs":{"48":{"tf":1.0}}}}}},"df":0,"docs":{}}}}},"df":0,"docs":{}}}}},"df":1,"docs":{"46":{"tf":1.0}}}}}},"df":0,"docs":{}}},"o":{"d":{"df":0,"docs":{},"o":{"df":1,"docs":{"43":{"tf":1.0}}}},"df":0,"docs":{},"k":{"df":0,"docs":{},"e":{"df":0,"docs":{},"n":{"df":5,"docs":{"1":{"tf":1.0},"12":{"tf":1.0},"19":{"tf":1.0},"31":{"tf":1.0},"48":{"tf":2.8284271247461903}}}}},"o":{"df":0,"docs":{},"l":{"df":8,"docs":{"12":{"tf":1.0},"17":{"tf":1.0},"24":{"tf":1.0},"31":{"tf":1.4142135623730951},"35":{"tf":1.0},"43":{"tf":2.0},"45":{"tf":1.0},"48":{"tf":1.0}}}},"p":{"df":1,"docs":{"13":{"tf":1.0}}},"t":{"a":{"df":0,"docs":{},"l":{"df":1,"docs":{"48":{"tf":1.0}}}},"df":0,"docs":{}},"u":{"c":{"df":0,"docs":{},"h":{"df":5,"docs":{"1":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0},"14":{"tf":1.0},"48":{"tf":1.0}}}},"df":0,"docs":{}}},"r":{"a":{"c":{"df":0,"docs":{},"e":{"df":1,"docs":{"48":{"tf":1.0}}}},"d":{"df":0,"docs":{},"e":{"df":0,"docs":{},"o":{"df":0,"docs":{},"f":{"df":0,"docs":{},"f":{"df":1,"docs":{"1":{"tf":1.0}}}}}}},"df":0,"docs":{},"e":{"df":0,"docs":{},"f":{"df":0,"docs":{},"i":{"df":0,"docs":{},"k":{".":{"c":{"df":0,"docs":{},"o":{"df":0,"docs":{},"n":{"df":0,"docs":{},"t":{"a":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"df":0,"docs":{},"o":{".":{"df":0,"docs":{},"u":{"df":0,"docs":{},"s":{"/":{"df":0,"docs":{},"v":{"1":{"a":{"df":0,"docs":{},"l":{"df":0,"docs":{},"p":{"df":0,"docs":{},"h":{"a":{"1":{"df":2,"docs":{"14":{"tf":1.0},"17":{"tf":1.7320508075688772}}},"df":0,"docs":{}},"df":0,"docs":{}}}}},"df":0,"docs":{}},"df":0,"docs":{}}},"df":0,"docs":{}}}},"df":0,"docs":{}}}}},"df":0,"docs":{}}}}},"df":0,"docs":{}},"df":2,"docs":{"14":{"tf":1.0},"17":{"tf":1.0}}}}}},"f":{"df":0,"docs":{},"f":{"df":0,"docs":{},"i":{"c":{"df":1,"docs":{"41":{"tf":1.0}}},"df":0,"docs":{}}}},"n":{"df":0,"docs":{},"s":{"df":0,"docs":{},"l":{"a":{"df":0,"docs":{},"t":{"df":1,"docs":{"2":{"tf":1.7320508075688772}}}},"df":0,"docs":{}}}}},"df":3,"docs":{"12":{"tf":1.4142135623730951},"31":{"tf":1.4142135623730951},"40":{"tf":1.0}},"i":{"df":3,"docs":{"1":{"tf":1.0},"21":{"tf":1.0},"3":{"tf":1.0}},"g":{"df":0,"docs":{},"g":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":1,"docs":{"31":{"tf":1.0}}}}}}},"u":{"df":0,"docs":{},"e":{"df":6,"docs":{"12":{"tf":1.4142135623730951},"13":{"tf":1.0},"17":{"tf":1.0},"39":{"tf":1.0},"47":{"tf":1.7320508075688772},"48":{"tf":2.6457513110645907}},"|":{"df":0,"docs":{},"f":{"a":{"df":0,"docs":{},"l":{"df":0,"docs":{},"s":{"df":1,"docs":{"48":{"tf":1.0}}}}},"df":0,"docs":{}}}}}},"u":{"df":0,"docs":{},"n":{"df":0,"docs":{},"e":{"df":2,"docs":{"13":{"tf":1.0},"24":{"tf":1.7320508075688772}}}},"t":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"df":0,"docs":{},"i":{"df":1,"docs":{"43":{"tf":1.0}}}}}}},"y":{"df":0,"docs":{},"p":{"df":0,"docs":{},"e":{"df":2,"docs":{"12":{"tf":1.0},"43":{"tf":1.4142135623730951}}},"i":{"c":{"df":1,"docs":{"1":{"tf":1.0}}},"df":0,"docs":{}}}}},"u":{"df":0,"docs":{},"i":{"df":8,"docs":{"1":{"tf":1.0},"2":{"tf":1.7320508075688772},"21":{"tf":1.0},"22":{"tf":1.0},"23":{"tf":1.4142135623730951},"24":{"tf":2.0},"31":{"tf":2.0},"48":{"tf":1.0}}},"n":{"c":{"df":0,"docs":{},"o":{"df":0,"docs":{},"m":{"df":1,"docs":{"13":{"tf":1.0}}}}},"d":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":3,"docs":{"13":{"tf":1.0},"23":{"tf":1.0},"26":{"tf":1.0}}}}},"df":0,"docs":{},"s":{"df":0,"docs":{},"u":{"df":0,"docs":{},"r":{"df":1,"docs":{"2":{"tf":1.0}}}}},"t":{"df":0,"docs":{},"i":{"df":0,"docs":{},"l":{"df":2,"docs":{"29":{"tf":1.0},"48":{"tf":1.4142135623730951}}}}}},"p":{"d":{"a":{"df":0,"docs":{},"t":{"df":1,"docs":{"31":{"tf":1.0}}}},"df":0,"docs":{}},"df":9,"docs":{"13":{"tf":1.0},"2":{"tf":1.0},"29":{"tf":1.4142135623730951},"30":{"tf":1.0},"34":{"tf":1.0},"36":{"tf":1.7320508075688772},"43":{"tf":1.0},"48":{"tf":1.4142135623730951},"9":{"tf":1.0}}},"r":{"df":0,"docs":{},"l":{"df":3,"docs":{"27":{"tf":1.0},"48":{"tf":1.4142135623730951},"6":{"tf":1.0}}}},"s":{"a":{"df":0,"docs":{},"g":{"df":2,"docs":{"24":{"tf":1.0},"48":{"tf":1.0}}}},"df":27,"docs":{"0":{"tf":1.0},"1":{"tf":2.23606797749979},"11":{"tf":1.4142135623730951},"12":{"tf":1.7320508075688772},"13":{"tf":2.8284271247461903},"14":{"tf":1.0},"17":{"tf":2.0},"2":{"tf":1.0},"21":{"tf":1.0},"23":{"tf":1.0},"24":{"tf":1.4142135623730951},"25":{"tf":1.0},"28":{"tf":1.0},"29":{"tf":1.4142135623730951},"30":{"tf":1.7320508075688772},"31":{"tf":2.0},"32":{"tf":1.7320508075688772},"34":{"tf":1.7320508075688772},"35":{"tf":1.0},"36":{"tf":1.0},"39":{"tf":2.0},"41":{"tf":2.0},"43":{"tf":1.7320508075688772},"45":{"tf":1.0},"48":{"tf":3.3166247903554},"6":{"tf":1.0},"9":{"tf":1.0}},"e":{"df":0,"docs":{},"l":{"df":0,"docs":{},"e":{"df":0,"docs":{},"s":{"df":0,"docs":{},"s":{"df":1,"docs":{"48":{"tf":1.0}}}}}},"r":{"'":{"df":1,"docs":{"19":{"tf":1.0}}},":":{"df":0,"docs":{},"g":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"u":{"df":0,"docs":{},"p":{"df":1,"docs":{"7":{"tf":1.0}}}}}}}},"@":{"df":0,"docs":{},"g":{"df":0,"docs":{},"m":{"a":{"df":0,"docs":{},"i":{"df":0,"docs":{},"l":{".":{"c":{"df":0,"docs":{},"o":{"df":0,"docs":{},"m":{"df":1,"docs":{"48":{"tf":1.0}}}}},"df":0,"docs":{}},"df":0,"docs":{}}}},"df":0,"docs":{}}}},"_":{"df":0,"docs":{},"r":{"df":0,"docs":{},"e":{"df":0,"docs":{},"g":{"_":{"d":{"df":0,"docs":{},"o":{"df":0,"docs":{},"m":{"a":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"_":{"df":0,"docs":{},"r":{"df":0,"docs":{},"e":{"df":0,"docs":{},"s":{"df":0,"docs":{},"t":{"df":0,"docs":{},"r":{"df":0,"docs":{},"i":{"c":{"df":0,"docs":{},"t":{"df":0,"docs":{},"i":{"df":0,"docs":{},"o":{"df":0,"docs":{},"n":{"=":{"df":0,"docs":{},"g":{"df":0,"docs":{},"m":{"a":{"df":0,"docs":{},"i":{"df":0,"docs":{},"l":{".":{"c":{"df":0,"docs":{},"o":{"df":0,"docs":{},"m":{"df":1,"docs":{"48":{"tf":1.0}}}}},"df":0,"docs":{}},"df":0,"docs":{}}}},"df":0,"docs":{}}},"s":{"df":0,"docs":{},"o":{"df":0,"docs":{},"m":{"df":1,"docs":{"48":{"tf":1.0}}}}}},"df":0,"docs":{}}}}}},"df":0,"docs":{}}}}}}}},"df":0,"docs":{}}}},"df":0,"docs":{}}}},"df":0,"docs":{}},"df":0,"docs":{}}}}},"df":14,"docs":{"1":{"tf":1.0},"13":{"tf":1.0},"2":{"tf":1.0},"22":{"tf":2.23606797749979},"23":{"tf":2.0},"24":{"tf":1.4142135623730951},"26":{"tf":1.0},"28":{"tf":1.0},"29":{"tf":2.23606797749979},"3":{"tf":1.0},"31":{"tf":1.0},"43":{"tf":1.0},"48":{"tf":3.4641016151377544},"7":{"tf":1.0}},"n":{"a":{"df":0,"docs":{},"m":{"df":2,"docs":{"1":{"tf":1.0},"48":{"tf":1.0}}}},"df":0,"docs":{}}}},"u":{"a":{"df":0,"docs":{},"l":{"df":1,"docs":{"26":{"tf":1.0}}}},"df":0,"docs":{}}},"t":{"df":0,"docs":{},"i":{"df":0,"docs":{},"l":{"df":1,"docs":{"24":{"tf":1.4142135623730951}}}}}},"v":{"1":{".":{"0":{"df":2,"docs":{"0":{"tf":1.0},"2":{"tf":1.0}}},"df":0,"docs":{}},"1":{"4":{"df":1,"docs":{"1":{"tf":1.0}}},"df":0,"docs":{}},"df":3,"docs":{"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0}}},"a":{"c":{"df":0,"docs":{},"u":{"df":0,"docs":{},"u":{"df":0,"docs":{},"m":{"df":1,"docs":{"34":{"tf":1.0}}}}}},"df":0,"docs":{},"l":{"df":0,"docs":{},"i":{"d":{"df":5,"docs":{"17":{"tf":1.0},"28":{"tf":1.0},"43":{"tf":1.0},"45":{"tf":2.0},"48":{"tf":3.0}}},"df":0,"docs":{}},"u":{"df":12,"docs":{"13":{"tf":1.0},"21":{"tf":1.0},"24":{"tf":2.23606797749979},"29":{"tf":1.0},"30":{"tf":1.0},"31":{"tf":1.7320508075688772},"36":{"tf":1.4142135623730951},"37":{"tf":1.0},"39":{"tf":1.7320508075688772},"44":{"tf":1.0},"48":{"tf":3.4641016151377544},"7":{"tf":1.0}},"e":{"df":0,"docs":{},"f":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"df":0,"docs":{},"m":{"df":1,"docs":{"13":{"tf":1.7320508075688772}}}}}}}}},"r":{"df":0,"docs":{},"i":{"a":{"b":{"df":0,"docs":{},"l":{"df":10,"docs":{"24":{"tf":1.4142135623730951},"25":{"tf":1.0},"27":{"tf":1.0},"28":{"tf":1.0},"32":{"tf":1.4142135623730951},"39":{"tf":1.4142135623730951},"45":{"tf":1.0},"46":{"tf":1.0},"48":{"tf":1.4142135623730951},"7":{"tf":1.4142135623730951}}}},"df":0,"docs":{}},"df":0,"docs":{}}}},"df":1,"docs":{"7":{"tf":1.4142135623730951}},"e":{"df":0,"docs":{},"r":{"b":{"df":0,"docs":{},"o":{"df":0,"docs":{},"s":{"df":1,"docs":{"48":{"tf":1.4142135623730951}}}}},"df":0,"docs":{},"i":{"df":9,"docs":{"13":{"tf":1.0},"14":{"tf":1.0},"19":{"tf":1.4142135623730951},"22":{"tf":1.4142135623730951},"26":{"tf":1.0},"29":{"tf":1.4142135623730951},"32":{"tf":1.0},"34":{"tf":1.0},"43":{"tf":1.4142135623730951}},"f":{"df":1,"docs":{"1":{"tf":1.0}},"i":{"df":2,"docs":{"43":{"tf":1.4142135623730951},"48":{"tf":1.4142135623730951}}}}},"s":{"df":0,"docs":{},"i":{"df":0,"docs":{},"o":{"df":0,"docs":{},"n":{"df":6,"docs":{"0":{"tf":1.0},"13":{"tf":1.4142135623730951},"2":{"tf":1.0},"36":{"tf":1.0},"7":{"tf":1.0},"9":{"tf":1.0}}}}}}}},"i":{"a":{"df":5,"docs":{"1":{"tf":1.4142135623730951},"23":{"tf":1.4142135623730951},"31":{"tf":1.4142135623730951},"48":{"tf":1.0},"7":{"tf":1.0}}},"df":0,"docs":{},"m":{"df":1,"docs":{"7":{"tf":1.0}}}},"o":{"df":0,"docs":{},"l":{"df":0,"docs":{},"u":{"df":0,"docs":{},"m":{"df":6,"docs":{"13":{"tf":1.0},"21":{"tf":1.0},"34":{"tf":1.0},"39":{"tf":1.0},"47":{"tf":1.0},"7":{"tf":1.7320508075688772}},"e":{"c":{"df":0,"docs":{},"l":{"a":{"df":0,"docs":{},"i":{"df":0,"docs":{},"m":{"df":0,"docs":{},"t":{"df":0,"docs":{},"e":{"df":0,"docs":{},"m":{"df":0,"docs":{},"p":{"df":0,"docs":{},"l":{"df":1,"docs":{"13":{"tf":1.0}}}}}}}}}},"df":0,"docs":{}}},"df":0,"docs":{},"m":{"df":0,"docs":{},"o":{"df":0,"docs":{},"u":{"df":0,"docs":{},"n":{"df":0,"docs":{},"t":{"df":1,"docs":{"13":{"tf":1.0}}}}}}}}}}}}},"w":{"a":{"df":0,"docs":{},"i":{"df":0,"docs":{},"t":{"df":1,"docs":{"48":{"tf":1.0}}}},"n":{"df":0,"docs":{},"t":{"df":11,"docs":{"17":{"tf":1.4142135623730951},"24":{"tf":1.4142135623730951},"26":{"tf":1.0},"3":{"tf":1.0},"30":{"tf":1.0},"31":{"tf":1.7320508075688772},"32":{"tf":1.0},"39":{"tf":1.4142135623730951},"48":{"tf":1.0},"6":{"tf":1.0},"7":{"tf":1.4142135623730951}}}},"r":{"df":0,"docs":{},"n":{"df":1,"docs":{"48":{"tf":1.0}}}},"t":{"c":{"df":0,"docs":{},"h":{"df":2,"docs":{"11":{"tf":1.4142135623730951},"22":{"tf":1.0}}}},"df":0,"docs":{}},"y":{"df":12,"docs":{"1":{"tf":1.4142135623730951},"12":{"tf":1.0},"23":{"tf":1.0},"24":{"tf":1.4142135623730951},"28":{"tf":1.0},"3":{"tf":1.0},"32":{"tf":1.0},"35":{"tf":1.0},"37":{"tf":1.0},"39":{"tf":1.7320508075688772},"40":{"tf":1.0},"48":{"tf":1.0}}}},"df":1,"docs":{"15":{"tf":1.0}},"e":{"b":{"a":{"df":0,"docs":{},"u":{"df":0,"docs":{},"t":{"df":0,"docs":{},"h":{"df":0,"docs":{},"n":{"_":{"d":{"a":{"df":0,"docs":{},"t":{"a":{"_":{"df":0,"docs":{},"e":{"df":0,"docs":{},"x":{"df":0,"docs":{},"p":{"=":{"9":{"0":{"df":1,"docs":{"48":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}},"df":0,"docs":{}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{},"r":{"df":0,"docs":{},"e":{"df":0,"docs":{},"n":{"df":0,"docs":{},"e":{"df":0,"docs":{},"w":{"_":{"df":0,"docs":{},"e":{"df":0,"docs":{},"x":{"df":0,"docs":{},"p":{"=":{"2":{"1":{"6":{"0":{"df":1,"docs":{"48":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"df":1,"docs":{"29":{"tf":1.7320508075688772}}}}}},"df":0,"docs":{}}}},"q":{"_":{"df":0,"docs":{},"e":{"df":0,"docs":{},"x":{"df":0,"docs":{},"p":{"=":{"6":{"0":{"df":1,"docs":{"48":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":1,"docs":{"48":{"tf":1.0}}}}}},"df":0,"docs":{}}}}},"df":5,"docs":{"1":{"tf":1.0},"2":{"tf":1.0},"25":{"tf":1.4142135623730951},"29":{"tf":1.4142135623730951},"48":{"tf":3.1622776601683795}}}}}}},"df":2,"docs":{"17":{"tf":1.0},"19":{"tf":1.0}},"s":{"df":0,"docs":{},"e":{"c":{"df":0,"docs":{},"u":{"df":0,"docs":{},"r":{"df":2,"docs":{"14":{"tf":1.0},"17":{"tf":1.0}}}}},"df":0,"docs":{}}}},"df":0,"docs":{},"l":{"df":0,"docs":{},"l":{"df":2,"docs":{"17":{"tf":1.0},"2":{"tf":1.0}}}},"r":{"d":{"df":1,"docs":{"1":{"tf":1.0}}},"df":0,"docs":{}}},"h":{"df":0,"docs":{},"o":{"df":0,"docs":{},"l":{"df":0,"docs":{},"e":{"df":6,"docs":{"1":{"tf":1.0},"29":{"tf":1.4142135623730951},"31":{"tf":1.0},"48":{"tf":1.0},"7":{"tf":1.0},"8":{"tf":1.0}}}}}},"i":{"df":0,"docs":{},"n":{"d":{"df":0,"docs":{},"o":{"df":0,"docs":{},"w":{"df":3,"docs":{"43":{"tf":1.0},"48":{"tf":1.0},"7":{"tf":1.4142135623730951}}}}},"df":0,"docs":{}},"s":{"df":0,"docs":{},"e":{"df":1,"docs":{"24":{"tf":1.0}}}},"t":{"df":0,"docs":{},"h":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"df":1,"docs":{"48":{"tf":1.0}}}},"o":{"df":0,"docs":{},"u":{"df":0,"docs":{},"t":{"df":10,"docs":{"1":{"tf":1.0},"13":{"tf":1.4142135623730951},"28":{"tf":1.0},"30":{"tf":1.0},"36":{"tf":1.0},"39":{"tf":1.0},"48":{"tf":2.0},"6":{"tf":1.0},"7":{"tf":1.0},"9":{"tf":1.0}}}}}}}},"o":{"df":0,"docs":{},"r":{"df":0,"docs":{},"k":{"df":10,"docs":{"1":{"tf":2.0},"17":{"tf":1.0},"25":{"tf":1.4142135623730951},"26":{"tf":1.0},"29":{"tf":1.4142135623730951},"32":{"tf":1.0},"36":{"tf":1.0},"39":{"tf":2.0},"48":{"tf":2.23606797749979},"7":{"tf":1.4142135623730951}},"f":{"df":0,"docs":{},"l":{"df":0,"docs":{},"o":{"df":0,"docs":{},"w":{"df":1,"docs":{"43":{"tf":1.0}}}}}}}}},"r":{"df":0,"docs":{},"i":{"df":0,"docs":{},"t":{"df":0,"docs":{},"e":{"a":{"b":{"df":0,"docs":{},"l":{"df":1,"docs":{"7":{"tf":1.0}}}},"df":0,"docs":{}},"df":5,"docs":{"2":{"tf":1.0},"28":{"tf":1.0},"36":{"tf":1.0},"4":{"tf":1.0},"8":{"tf":1.0}}},"t":{"df":0,"docs":{},"e":{"df":0,"docs":{},"n":{"df":2,"docs":{"1":{"tf":1.0},"34":{"tf":1.0}}}}}}}}},"x":{"5":{"0":{"9":{"df":0,"docs":{},"v":{"3":{"df":2,"docs":{"45":{"tf":1.0},"48":{"tf":1.0}}},"df":0,"docs":{}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}},"y":{"df":1,"docs":{"43":{"tf":1.0}},"e":{"a":{"df":0,"docs":{},"r":{"df":2,"docs":{"34":{"tf":1.0},"48":{"tf":1.0}}}},"df":1,"docs":{"32":{"tf":1.0}}},"u":{"b":{"df":0,"docs":{},"i":{"df":0,"docs":{},"k":{"df":0,"docs":{},"e":{"df":0,"docs":{},"y":{"df":1,"docs":{"48":{"tf":1.0}}}}}}},"df":0,"docs":{}}},"z":{"0":{"df":4,"docs":{"12":{"tf":1.7320508075688772},"31":{"tf":1.4142135623730951},"40":{"tf":1.0},"48":{"tf":1.0}}},"a":{"df":4,"docs":{"12":{"tf":1.7320508075688772},"31":{"tf":1.4142135623730951},"40":{"tf":1.0},"48":{"tf":1.0}}},"df":0,"docs":{}}}},"title":{"root":{"2":{"df":2,"docs":{"24":{"tf":1.0},"25":{"tf":1.0}}},"a":{"d":{"df":0,"docs":{},"m":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"df":2,"docs":{"19":{"tf":1.0},"22":{"tf":1.0}}}}}},"df":0,"docs":{},"p":{"df":0,"docs":{},"p":{"df":0,"docs":{},"l":{"df":0,"docs":{},"i":{"df":3,"docs":{"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0}}}}}},"r":{"df":0,"docs":{},"g":{"df":0,"docs":{},"o":{"df":0,"docs":{},"n":{"df":1,"docs":{"24":{"tf":1.0}}}}}},"v":{"a":{"df":0,"docs":{},"i":{"df":0,"docs":{},"l":{"df":1,"docs":{"36":{"tf":1.0}}}}},"df":0,"docs":{}}},"b":{"a":{"c":{"df":0,"docs":{},"k":{"df":0,"docs":{},"u":{"df":0,"docs":{},"p":{"df":1,"docs":{"33":{"tf":1.0}}}}}},"df":0,"docs":{}},"df":0,"docs":{}},"c":{"a":{"c":{"df":0,"docs":{},"h":{"df":1,"docs":{"45":{"tf":1.0}},"e":{"_":{"a":{"df":0,"docs":{},"u":{"df":0,"docs":{},"t":{"df":0,"docs":{},"h":{"_":{"df":0,"docs":{},"t":{"df":0,"docs":{},"o":{"df":0,"docs":{},"k":{"df":0,"docs":{},"e":{"df":0,"docs":{},"n":{"df":1,"docs":{"40":{"tf":1.0}}}}}}}},"df":0,"docs":{}}}}},"df":0,"docs":{}},"df":0,"docs":{}}}},"df":0,"docs":{}},"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"t":{"df":0,"docs":{},"i":{"df":0,"docs":{},"f":{"df":1,"docs":{"43":{"tf":1.0}}}}}}},"o":{"df":0,"docs":{},"n":{"df":0,"docs":{},"f":{"df":0,"docs":{},"i":{"df":0,"docs":{},"g":{"df":4,"docs":{"11":{"tf":1.0},"17":{"tf":1.0},"44":{"tf":1.0},"48":{"tf":1.0}},"u":{"df":0,"docs":{},"r":{"df":1,"docs":{"37":{"tf":1.0}}}}}}}}},"r":{"df":0,"docs":{},"e":{"a":{"df":0,"docs":{},"t":{"df":4,"docs":{"10":{"tf":1.0},"11":{"tf":1.0},"12":{"tf":1.0},"13":{"tf":1.0}}}},"df":0,"docs":{}}},"u":{"df":0,"docs":{},"s":{"df":0,"docs":{},"t":{"df":0,"docs":{},"o":{"df":0,"docs":{},"m":{"df":1,"docs":{"22":{"tf":1.0}}}}}}}},"d":{"a":{"df":0,"docs":{},"t":{"a":{"b":{"a":{"df":0,"docs":{},"s":{"df":1,"docs":{"32":{"tf":1.0}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}},"df":0,"docs":{},"e":{"df":0,"docs":{},"p":{"df":0,"docs":{},"l":{"df":0,"docs":{},"o":{"df":0,"docs":{},"y":{"df":1,"docs":{"15":{"tf":1.0}}}}}}},"o":{"c":{"df":0,"docs":{},"k":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":2,"docs":{"20":{"tf":1.0},"5":{"tf":1.0}}}}}},"df":0,"docs":{}}},"df":0,"docs":{},"e":{"df":0,"docs":{},"n":{"c":{"df":0,"docs":{},"r":{"df":0,"docs":{},"y":{"df":0,"docs":{},"p":{"df":0,"docs":{},"t":{"df":1,"docs":{"30":{"tf":1.0}}}}}}},"df":0,"docs":{}},"v":{"a":{"df":0,"docs":{},"l":{"df":0,"docs":{},"u":{"df":1,"docs":{"6":{"tf":1.0}}}}},"df":0,"docs":{}}},"f":{"df":0,"docs":{},"i":{"d":{"df":0,"docs":{},"o":{"df":1,"docs":{"25":{"tf":1.0}}}},"df":0,"docs":{},"r":{"df":0,"docs":{},"s":{"df":0,"docs":{},"t":{"df":1,"docs":{"18":{"tf":1.0}}}}}}},"g":{"df":0,"docs":{},"e":{"df":0,"docs":{},"n":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":1,"docs":{"43":{"tf":1.0}}}}},"t":{"df":1,"docs":{"4":{"tf":1.0}}}}},"h":{"a":{"_":{"df":0,"docs":{},"h":{"df":0,"docs":{},"o":{"df":0,"docs":{},"s":{"df":0,"docs":{},"t":{"df":1,"docs":{"39":{"tf":1.0}}}}}},"m":{"df":0,"docs":{},"o":{"d":{"df":1,"docs":{"38":{"tf":1.0}}},"df":0,"docs":{}}}},"df":0,"docs":{}},"df":0,"docs":{},"i":{"df":0,"docs":{},"g":{"df":0,"docs":{},"h":{"df":1,"docs":{"36":{"tf":1.0}}}}}},"i":{"df":0,"docs":{},"n":{"df":0,"docs":{},"g":{"df":0,"docs":{},"r":{"df":0,"docs":{},"e":{"df":0,"docs":{},"s":{"df":0,"docs":{},"s":{"df":1,"docs":{"14":{"tf":1.0}}}}}}},"i":{"df":0,"docs":{},"t":{"df":0,"docs":{},"i":{"df":1,"docs":{"19":{"tf":1.0}}}}},"s":{"df":0,"docs":{},"t":{"a":{"df":0,"docs":{},"n":{"c":{"df":1,"docs":{"9":{"tf":1.0}}},"df":0,"docs":{}}},"df":0,"docs":{}}},"t":{"df":0,"docs":{},"r":{"df":0,"docs":{},"o":{"d":{"df":0,"docs":{},"u":{"c":{"df":0,"docs":{},"t":{"df":1,"docs":{"0":{"tf":1.0}}}},"df":0,"docs":{}}},"df":0,"docs":{}}}}}},"k":{"df":0,"docs":{},"e":{"df":0,"docs":{},"y":{"df":1,"docs":{"31":{"tf":1.0}}}},"u":{"b":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":0,"docs":{},"n":{"df":0,"docs":{},"e":{"df":0,"docs":{},"t":{"df":3,"docs":{"21":{"tf":1.0},"47":{"tf":1.0},"8":{"tf":1.0}}}}}}}},"df":0,"docs":{}}},"l":{"df":0,"docs":{},"o":{"c":{"a":{"df":0,"docs":{},"l":{"df":1,"docs":{"6":{"tf":1.0}}}},"df":0,"docs":{}},"df":0,"docs":{},"g":{"df":2,"docs":{"20":{"tf":1.0},"21":{"tf":1.0}},"i":{"df":0,"docs":{},"n":{"df":1,"docs":{"19":{"tf":1.0}}}}}}},"m":{"df":0,"docs":{},"i":{"df":0,"docs":{},"g":{"df":0,"docs":{},"r":{"a":{"df":0,"docs":{},"t":{"df":1,"docs":{"32":{"tf":1.0}}}},"df":0,"docs":{}}}}},"n":{"a":{"df":0,"docs":{},"m":{"df":0,"docs":{},"e":{"df":0,"docs":{},"s":{"df":0,"docs":{},"p":{"a":{"c":{"df":1,"docs":{"10":{"tf":1.0}}},"df":0,"docs":{}},"df":0,"docs":{}}}}}},"df":0,"docs":{},"e":{"df":0,"docs":{},"v":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":1,"docs":{"3":{"tf":1.0}}}}}}},"p":{"a":{"df":0,"docs":{},"s":{"df":0,"docs":{},"s":{"df":0,"docs":{},"w":{"df":0,"docs":{},"o":{"df":0,"docs":{},"r":{"d":{"df":1,"docs":{"19":{"tf":1.0}}},"df":0,"docs":{}}}}}}},"df":0,"docs":{},"o":{"df":0,"docs":{},"s":{"df":0,"docs":{},"t":{"df":0,"docs":{},"g":{"df":0,"docs":{},"r":{"df":1,"docs":{"35":{"tf":1.0}}}}}}},"r":{"df":0,"docs":{},"o":{"d":{"df":0,"docs":{},"u":{"c":{"df":0,"docs":{},"t":{"df":2,"docs":{"16":{"tf":1.0},"7":{"tf":1.0}}}},"df":0,"docs":{}}},"df":0,"docs":{}}}},"r":{"a":{"df":0,"docs":{},"u":{"df":0,"docs":{},"t":{"df":0,"docs":{},"h":{"df":0,"docs":{},"i":{"df":1,"docs":{"22":{"tf":1.0}}},"y":{"_":{"a":{"d":{"df":0,"docs":{},"m":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"df":1,"docs":{"23":{"tf":1.0}}}}}},"df":0,"docs":{}},"df":0,"docs":{}},"df":0,"docs":{}}}}}},"df":0,"docs":{},"e":{"df":0,"docs":{},"f":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":1,"docs":{"48":{"tf":1.0}}}}}},"o":{"df":0,"docs":{},"l":{"df":0,"docs":{},"e":{"df":1,"docs":{"23":{"tf":1.0}}}},"t":{"a":{"df":0,"docs":{},"t":{"df":1,"docs":{"31":{"tf":1.0}}}},"df":0,"docs":{}}},"p":{"_":{"df":0,"docs":{},"i":{"d":{"df":1,"docs":{"26":{"tf":1.0}}},"df":0,"docs":{}},"n":{"a":{"df":0,"docs":{},"m":{"df":0,"docs":{},"e":{"df":1,"docs":{"28":{"tf":1.0}}}}},"df":0,"docs":{}},"o":{"df":0,"docs":{},"r":{"df":0,"docs":{},"i":{"df":0,"docs":{},"g":{"df":0,"docs":{},"i":{"df":0,"docs":{},"n":{"df":1,"docs":{"27":{"tf":1.0}}}}}}}}},"df":0,"docs":{}}},"s":{"df":0,"docs":{},"e":{"c":{"df":0,"docs":{},"r":{"df":0,"docs":{},"e":{"df":0,"docs":{},"t":{"df":1,"docs":{"12":{"tf":1.0}}}}}},"df":0,"docs":{},"r":{"df":0,"docs":{},"v":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":1,"docs":{"46":{"tf":1.0}}}}}},"t":{"df":1,"docs":{"13":{"tf":1.0}},"u":{"df":0,"docs":{},"p":{"df":3,"docs":{"16":{"tf":1.0},"24":{"tf":1.0},"7":{"tf":1.0}}}}}},"i":{"df":0,"docs":{},"n":{"df":0,"docs":{},"g":{"df":0,"docs":{},"l":{"df":1,"docs":{"9":{"tf":1.0}}}}}},"q":{"df":0,"docs":{},"l":{"df":0,"docs":{},"i":{"df":0,"docs":{},"t":{"df":0,"docs":{},"e":{"df":1,"docs":{"34":{"tf":1.0}}}}}}},"t":{"a":{"df":0,"docs":{},"r":{"df":0,"docs":{},"t":{"df":2,"docs":{"18":{"tf":1.0},"4":{"tf":1.0}}}},"t":{"df":0,"docs":{},"e":{"df":1,"docs":{"13":{"tf":1.0}}}}},"df":0,"docs":{}}},"t":{"df":0,"docs":{},"e":{"df":0,"docs":{},"s":{"df":0,"docs":{},"t":{"df":1,"docs":{"6":{"tf":1.0}}}}},"l":{"df":2,"docs":{"41":{"tf":1.0},"42":{"tf":1.0}}}},"u":{"df":0,"docs":{},"s":{"df":0,"docs":{},"e":{"df":0,"docs":{},"r":{"df":2,"docs":{"22":{"tf":1.0},"23":{"tf":1.0}}}}}},"w":{"df":0,"docs":{},"e":{"b":{"a":{"df":0,"docs":{},"u":{"df":0,"docs":{},"t":{"df":0,"docs":{},"h":{"df":0,"docs":{},"n":{"_":{"df":0,"docs":{},"r":{"df":0,"docs":{},"e":{"df":0,"docs":{},"n":{"df":0,"docs":{},"e":{"df":0,"docs":{},"w":{"_":{"df":0,"docs":{},"e":{"df":0,"docs":{},"x":{"df":0,"docs":{},"p":{"df":1,"docs":{"29":{"tf":1.0}}}}}},"df":0,"docs":{}}}}}}},"df":1,"docs":{"25":{"tf":1.0}}}}}}},"df":0,"docs":{}},"df":0,"docs":{}}}}}},"lang":"English","pipeline":["trimmer","stopWordFilter","stemmer"],"ref":"id","version":"0.9.5"},"results_options":{"limit_results":30,"teaser_word_count":30},"search_options":{"bool":"OR","expand":true,"fields":{"body":{"boost":1},"breadcrumbs":{"boost":1},"title":{"boost":2}}}});